-- Version: 7.2 SP2 7.2.3.2

library ieee;
use ieee.std_logic_1164.all;
library fusion;

entity VR_INT is 
    port(PUB, VRPU : in std_logic;  FPGAGOOD, PUCORE : out 
        std_logic) ;
end VR_INT;


architecture DEF_ARCH of  VR_INT is

    component VRPSM
        port(PUB, VRPU, VRINITSTATE, RTCPSMMATCH : in std_logic := 
        'U'; FPGAGOOD, PUCORE : out std_logic) ;
    end component;

    component VCC
        port( Y : out std_logic);
    end component;

    component GND
        port( Y : out std_logic);
    end component;

    signal VCC_1_net, GND_1_net, SOC_GND_NET, SOC_VCC_NET_IOCNTL, 
        SOC_GND_NET_VRFPD : std_logic ;
    begin   

    SOC_GND_NET <= GND_1_net;
    SOC_VCC_NET_IOCNTL <= VCC_1_net;
    SOC_GND_NET_VRFPD <= GND_1_net;
    VCC_2_net : VCC port map(Y => VCC_1_net);
    GND_2_net : GND port map(Y => GND_1_net);
    VRPSM1 : VRPSM
      port map(PUB => PUB, VRPU => VRPU, VRINITSTATE => VCC_1_net, 
        RTCPSMMATCH => GND_1_net, FPGAGOOD => FPGAGOOD, PUCORE => 
        PUCORE);
end DEF_ARCH;

-- _Disclaimer: Please leave the following comments in the file, they are for internal purposes only._


-- _GEN_File_Contents_

-- Version:7.2.3.2
-- ACTGENU_CALL:1
-- BATCH:T
-- FAM:Fusion
-- OUTFORMAT:VHDL
-- LPMTYPE:LPM_VRPSM
-- LPM_HINT:NONE
-- INSERT_PAD:NO
-- INSERT_IOREG:NO
-- GEN_BHV_VHDL_VAL:F
-- GEN_BHV_VERILOG_VAL:F
-- MGNTIMER:F
-- MGNCMPL:F
-- "DESDIR:D:/Fusion/CM/smartgen\VR_INT"
-- GEN_BEHV_MODULE:T
-- SMARTGEN_DIE:IR4X4M1
-- SMARTGEN_PACKAGE:fg256
-- INIT_VALUE:1
-- USE_RTC_MATCH:0

-- _End_Comments_

