-- Generated by WaveFormer Lite Version 10.04a at 14:48:49 on 12/5/2006
-- Stimulator for stimulus

-- Generation Settings:
--   Export type: Stimulus only (reactive export not enabled)

-- Clock Domains:

--   Unclocked
--   ---------
--     Signals:
--       RESETn
--       INIT_DONE
--       ADC_CHNUMBER
--       ADC_RESULT

library ieee, std;
use ieee.std_logic_1164.all;
library syncad_vhdl_lib;
use syncad_vhdl_lib.TBDefinitions.all;
-- Additional libraries used by Model Under Test.
library fusion;
library ieee;
-- End Additional libraries used by Model Under Test.

entity stimulus is
  port (
    SYSCLK : inout std_logic := '0';
    RESETn : inout std_logic := '0';
    DATAVALID : inout std_logic := '0';
    INIT_DONE : inout std_logic := '0';
    ADC_CHNUMBER : inout std_logic_vector(4 downto 0) := "00001";
    ADC_RESULT : inout std_logic_vector(11 downto 0) := x"0AB";
    Current_0 : in std_logic_vector(11 downto 0) := "ZZZZZZZZZZZZ";
    Current_1 : in std_logic_vector(11 downto 0) := "ZZZZZZZZZZZZ";
    Current_2 : in std_logic_vector(11 downto 0) := "ZZZZZZZZZZZZ";
    Current_3 : in std_logic_vector(11 downto 0) := "ZZZZZZZZZZZZ";
    Current_4 : in std_logic_vector(11 downto 0) := "ZZZZZZZZZZZZ";
    Current_5 : in std_logic_vector(11 downto 0) := "ZZZZZZZZZZZZ";
    Latest_Update : in std_logic_vector(2 downto 0) := "ZZZ");

end stimulus;

architecture STIMULATOR of stimulus is

  -- Control Signal Declarations
  signal tb_status : TStatus;
  signal tb_ParameterInitFlag : boolean := false;

  -- Parm Declarations
  signal DATAVALID_MinHL : time := 0 ns;
  signal DATAVALID_MaxHL : time := 0 ns;
  signal DATAVALID_MinLH : time := 0 ns;
  signal DATAVALID_MaxLH : time := 0 ns;
  signal DATAVALID_JFall : time := 0 ns;
  signal DATAVALID_JRise : time := 0 ns;
  signal DATAVALID_Duty : real := 0.0;
  signal DATAVALID_Period : time := 0 ns;
  signal DATAVALID_Offset : time := 0 ns;
  signal SYSCLK_MinHL : time := 0 ns;
  signal SYSCLK_MaxHL : time := 0 ns;
  signal SYSCLK_MinLH : time := 0 ns;
  signal SYSCLK_MaxLH : time := 0 ns;
  signal SYSCLK_JFall : time := 0 ns;
  signal SYSCLK_JRise : time := 0 ns;
  signal SYSCLK_Duty : real := 0.0;
  signal SYSCLK_Period : time := 0 ns;
  signal SYSCLK_Offset : time := 0 ns;

  -- Status Control block.

begin

  process
    variable good : boolean;
  begin
    wait until tb_ParameterInitFlag;
    tb_status <= TB_ONCE;
    wait for 12222 ns;
    tb_status <= TB_DONE;
    wait;
  end process;

  -- Parm Assignment Block
  AssignParms : process
    variable DATAVALID_MinHL_real : real;
    variable DATAVALID_MaxHL_real : real;
    variable DATAVALID_MinLH_real : real;
    variable DATAVALID_MaxLH_real : real;
    variable DATAVALID_JFall_real : real;
    variable DATAVALID_JRise_real : real;
    variable DATAVALID_Duty_real : real;
    variable DATAVALID_Period_real : real;
    variable DATAVALID_Offset_real : real;
    variable SYSCLK_MinHL_real : real;
    variable SYSCLK_MaxHL_real : real;
    variable SYSCLK_MinLH_real : real;
    variable SYSCLK_MaxLH_real : real;
    variable SYSCLK_JFall_real : real;
    variable SYSCLK_JRise_real : real;
    variable SYSCLK_Duty_real : real;
    variable SYSCLK_Period_real : real;
    variable SYSCLK_Offset_real : real;
  begin
    DATAVALID_MinHL_real := 0.0;
    DATAVALID_MinHL <= DATAVALID_MinHL_real * 1 ns;
    DATAVALID_MaxHL_real := 0.0;
    DATAVALID_MaxHL <= DATAVALID_MaxHL_real * 1 ns;
    DATAVALID_MinLH_real := 0.0;
    DATAVALID_MinLH <= DATAVALID_MinLH_real * 1 ns;
    DATAVALID_MaxLH_real := 0.0;
    DATAVALID_MaxLH <= DATAVALID_MaxLH_real * 1 ns;
    DATAVALID_JFall_real := 0.0;
    DATAVALID_JFall <= DATAVALID_JFall_real * 1 ns;
    DATAVALID_JRise_real := 0.0;
    DATAVALID_JRise <= DATAVALID_JRise_real * 1 ns;
    DATAVALID_Duty_real := 10.0;
    DATAVALID_Duty <= DATAVALID_Duty_real;
    DATAVALID_Period_real := 1000.0;
    DATAVALID_Period <= DATAVALID_Period_real * 1 ns;
    DATAVALID_Offset_real := 500.0;
    DATAVALID_Offset <= DATAVALID_Offset_real * 1 ns;
    SYSCLK_MinHL_real := 0.0;
    SYSCLK_MinHL <= SYSCLK_MinHL_real * 1 ns;
    SYSCLK_MaxHL_real := 0.0;
    SYSCLK_MaxHL <= SYSCLK_MaxHL_real * 1 ns;
    SYSCLK_MinLH_real := 0.0;
    SYSCLK_MinLH <= SYSCLK_MinLH_real * 1 ns;
    SYSCLK_MaxLH_real := 0.0;
    SYSCLK_MaxLH <= SYSCLK_MaxLH_real * 1 ns;
    SYSCLK_JFall_real := 0.0;
    SYSCLK_JFall <= SYSCLK_JFall_real * 1 ns;
    SYSCLK_JRise_real := 0.0;
    SYSCLK_JRise <= SYSCLK_JRise_real * 1 ns;
    SYSCLK_Duty_real := 50.0;
    SYSCLK_Duty <= SYSCLK_Duty_real;
    SYSCLK_Period_real := 100.0;
    SYSCLK_Period <= SYSCLK_Period_real * 1 ns;
    SYSCLK_Offset_real := 0.0;
    SYSCLK_Offset <= SYSCLK_Offset_real * 1 ns;
    tb_ParameterInitFlag <= true;
    wait;
  end process;

  -- Clocks

  -- Clock Instantiation
  tb_SYSCLK : entity syncad_vhdl_lib.tb_clock_minmax
    generic map (name => "tb_SYSCLK",
                initialize => true,
                state1 => '1',
                state2 => '0')
    port map (tb_status,
              SYSCLK,
              SYSCLK_MinLH,
              SYSCLK_MaxLH,
              SYSCLK_MinHL,
              SYSCLK_MaxHL,
              SYSCLK_Offset,
              SYSCLK_Period,
              SYSCLK_Duty,
              SYSCLK_JRise,
              SYSCLK_JFall);

  -- Clock Instantiation
  tb_DATAVALID : entity syncad_vhdl_lib.tb_clock_minmax
    generic map (name => "tb_DATAVALID",
                initialize => true,
                state1 => '1',
                state2 => '0')
    port map (tb_status,
              DATAVALID,
              DATAVALID_MinLH,
              DATAVALID_MaxLH,
              DATAVALID_MinHL,
              DATAVALID_MaxHL,
              DATAVALID_Offset,
              DATAVALID_Period,
              DATAVALID_Duty,
              DATAVALID_JRise,
              DATAVALID_JFall);

  -- Clocked Sequences

  -- Sequence: Unclocked
  Unclocked : process
  begin
    wait for 164 ns;
    INIT_DONE <= '1';
    wait for 164 ns;
    RESETn <= '1';
    wait for 417 ns;
    ADC_RESULT <= x"0AA";
    wait for 153 ns;
    ADC_CHNUMBER <= "00010";
    wait for 1034 ns;
    ADC_RESULT <= x"085";
    wait for 80 ns;
    ADC_CHNUMBER <= "00100";
    wait for 1010 ns;
    ADC_RESULT <= x"083";
    wait for 48 ns;
    ADC_CHNUMBER <= "00101";
    wait for 1042 ns;
    ADC_CHNUMBER <= "10000";
    wait for 8 ns;
    ADC_RESULT <= x"037";
    wait for 1066 ns;
    ADC_RESULT <= x"034";
    wait for 8 ns;
    ADC_CHNUMBER <= "10001";
    wait for 938 ns;
    ADC_CHNUMBER <= "10000";
    wait for 8 ns;
    ADC_RESULT <= x"056";
    wait for 1033 ns;
    ADC_CHNUMBER <= "10001";
    wait for 8 ns;
    ADC_RESULT <= x"052";
    wait for 898 ns;
    ADC_RESULT <= x"043";
    wait for 8 ns;
    ADC_CHNUMBER <= "01101";
    wait for 1114 ns;
    ADC_RESULT <= x"038";
    wait for 8 ns;
    ADC_CHNUMBER <= "01110";
    wait for 890 ns;
    ADC_CHNUMBER <= "11001";
    ADC_RESULT <= x"02C";
    wait for 986 ns;
    ADC_CHNUMBER <= "11010";
    ADC_RESULT <= x"01B";
    wait for 1137 ns;
    wait;
  end process;
end STIMULATOR;

-- Test Bench wrapper for stimulus and Model Under Test
library ieee, std;
use ieee.std_logic_1164.all;
library syncad_vhdl_lib;
use syncad_vhdl_lib.TBDefinitions.all;
-- Additional libraries used by Model Under Test.
library fusion;
library ieee;
-- End Additional libraries used by Model Under Test.

entity testbench is
end testbench;
architecture tbGeneratedCode of testbench is
  signal SYSCLK : std_logic;
  signal RESETn : std_logic;
  signal DATAVALID : std_logic;
  signal INIT_DONE : std_logic;
  signal ADC_CHNUMBER : std_logic_vector(4 downto 0);
  signal ADC_RESULT : std_logic_vector(11 downto 0);
  signal Current_0 : std_logic_vector(11 downto 0);
  signal Current_1 : std_logic_vector(11 downto 0);
  signal Current_2 : std_logic_vector(11 downto 0);
  signal Current_3 : std_logic_vector(11 downto 0);
  signal Current_4 : std_logic_vector(11 downto 0);
  signal Current_5 : std_logic_vector(11 downto 0);
  signal Latest_Update : std_logic_vector(2 downto 0);

  -- Stimulator instance

begin

  stimulus_0 : entity work.stimulus
    port map (SYSCLK => SYSCLK,
              RESETn => RESETn,
              DATAVALID => DATAVALID,
              INIT_DONE => INIT_DONE,
              ADC_CHNUMBER => ADC_CHNUMBER,
              ADC_RESULT => ADC_RESULT,
              Current_0 => Current_0,
              Current_1 => Current_1,
              Current_2 => Current_2,
              Current_3 => Current_3,
              Current_4 => Current_4,
              Current_5 => Current_5,
              Latest_Update => Latest_Update);

  -- Instantiation of Model Under Test.
  Current_Calc_0 : entity work.Current_Calc
    port map (SYSCLK => SYSCLK,
              RESETn => RESETn,
              DATAVALID => DATAVALID,
              INIT_DONE => INIT_DONE,
              ADC_CHNUMBER => ADC_CHNUMBER,
              ADC_RESULT => ADC_RESULT,
              Current_0 => Current_0,
              Current_1 => Current_1,
              Current_2 => Current_2,
              Current_3 => Current_3,
              Current_4 => Current_4,
              Current_5 => Current_5,
              Latest_Update => Latest_Update);
end tbGeneratedCode;
