-- Generated by WaveFormer Lite Version 11.11d at 17:1:57 on 12/6/2006
-- Stimulator for stimulus

-- Generation Settings:
--   Export type: Stimulus only (reactive export not enabled)
--                Delays, Samples, Markers, etc will not generate code.

-- Clock Domains:

--   Unclocked
--   ---------
--     Signals:
--       SYSRSTn
--       AV0
--       AC0
--       AV1
--       AC1
--       AV2
--       AC2
--       AV3
--       AC3
--       AV4
--       AC4
--       AV5
--       AC5
--       PUB

library ieee, std;
use ieee.std_logic_1164.all;
library syncad_vhdl_lib;
use syncad_vhdl_lib.TBDefinitions.all;
library fusion;
use fusion.analog_io.all;
-- Additional libraries used by Model Under Test.
library ieee;
-- End Additional libraries used by Model Under Test.

entity stimulus is
  port (
    SYSCLK : inout std_logic := '0';
    SYSRSTn : inout std_logic := '0';
    VAREF : inout std_logic := 'Z';
    AV0 : inout std_logic := 'Z';
    AC0 : inout std_logic := 'Z';
    AV1 : inout std_logic := 'Z';
    AC1 : inout std_logic := 'Z';
    AV2 : inout std_logic := 'Z';
    AC2 : inout std_logic := 'Z';
    AV3 : inout std_logic := 'Z';
    AC3 : inout std_logic := 'Z';
    AV4 : inout std_logic := 'Z';
    AC4 : inout std_logic := 'Z';
    AV5 : inout std_logic := 'Z';
    AC5 : inout std_logic := 'Z';
    Current0 : in std_logic_vector(11 downto 0) := "ZZZZZZZZZZZZ";
    Current1 : in std_logic_vector(11 downto 0) := "ZZZZZZZZZZZZ";
    Current2 : in std_logic_vector(11 downto 0) := "ZZZZZZZZZZZZ";
    Current3 : in std_logic_vector(11 downto 0) := "ZZZZZZZZZZZZ";
    Current4 : in std_logic_vector(11 downto 0) := "ZZZZZZZZZZZZ";
    Current5 : in std_logic_vector(11 downto 0) := "ZZZZZZZZZZZZ";
    Latest_Update : in std_logic_vector(2 downto 0) := "ZZZ";
    PUB : inout std_logic := '0';
    SPARE : in std_logic := 'Z';
    INIT_DONE_Test : in std_logic := 'Z';
    ASSC_DONE_Test : in std_logic := 'Z');

end stimulus;

architecture STIMULATOR of stimulus is

  -- Control Signal Declarations
  signal tb_status : TStatus;
  signal tb_ParameterInitFlag : boolean := false;
  signal AV0_driver : real;
  signal AC0_driver : real;
  signal AV1_driver : real;
  signal AC1_driver : real;
  signal AV2_driver : real;
  signal AC2_driver : real;
  signal AV3_driver : real;
  signal AC3_driver : real;
  signal AV4_driver : real;
  signal AC4_driver : real;
  signal AV5_driver : real;
  signal AC5_driver : real;

  -- Parm Declarations
  signal SYSCLK_MinHL : time := 0 ns;
  signal SYSCLK_MaxHL : time := 0 ns;
  signal SYSCLK_MinLH : time := 0 ns;
  signal SYSCLK_MaxLH : time := 0 ns;
  signal SYSCLK_JFall : time := 0 ns;
  signal SYSCLK_JRise : time := 0 ns;
  signal SYSCLK_Duty : real := 0.0;
  signal SYSCLK_Period : time := 0 ns;
  signal SYSCLK_Offset : time := 0 ns;

  -- Status Control block.

begin

  process
    variable good : boolean;
  begin
    wait until tb_ParameterInitFlag;
    tb_status <= TB_ONCE;
    wait for 2067889 ns;
    tb_status <= TB_DONE;
    wait;
  end process;

  -- Actel Analog Drivers Block
  drive_analog_input(AV0_driver, AV0);
  drive_analog_input(AC0_driver, AC0);
  drive_analog_input(AV1_driver, AV1);
  drive_analog_input(AC1_driver, AC1);
  drive_analog_input(AV2_driver, AV2);
  drive_analog_input(AC2_driver, AC2);
  drive_analog_input(AV3_driver, AV3);
  drive_analog_input(AC3_driver, AC3);
  drive_analog_input(AV4_driver, AV4);
  drive_analog_input(AC4_driver, AC4);
  drive_analog_input(AV5_driver, AV5);
  drive_analog_input(AC5_driver, AC5);

  -- Parm Assignment Block
  AssignParms : process
    variable SYSCLK_MinHL_real : real;
    variable SYSCLK_MaxHL_real : real;
    variable SYSCLK_MinLH_real : real;
    variable SYSCLK_MaxLH_real : real;
    variable SYSCLK_JFall_real : real;
    variable SYSCLK_JRise_real : real;
    variable SYSCLK_Duty_real : real;
    variable SYSCLK_Period_real : real;
    variable SYSCLK_Offset_real : real;
  begin
    SYSCLK_MinHL_real := 0.0;
    SYSCLK_MinHL <= SYSCLK_MinHL_real * 1 ns;
    SYSCLK_MaxHL_real := 0.0;
    SYSCLK_MaxHL <= SYSCLK_MaxHL_real * 1 ns;
    SYSCLK_MinLH_real := 0.0;
    SYSCLK_MinLH <= SYSCLK_MinLH_real * 1 ns;
    SYSCLK_MaxLH_real := 0.0;
    SYSCLK_MaxLH <= SYSCLK_MaxLH_real * 1 ns;
    SYSCLK_JFall_real := 0.0;
    SYSCLK_JFall <= SYSCLK_JFall_real * 1 ns;
    SYSCLK_JRise_real := 0.0;
    SYSCLK_JRise <= SYSCLK_JRise_real * 1 ns;
    SYSCLK_Duty_real := 50.0;
    SYSCLK_Duty <= SYSCLK_Duty_real;
    SYSCLK_Period_real := 100.0;
    SYSCLK_Period <= SYSCLK_Period_real * 1 ns;
    SYSCLK_Offset_real := 0.0;
    SYSCLK_Offset <= SYSCLK_Offset_real * 1 ns;
    tb_ParameterInitFlag <= true;
    wait;
  end process;

  -- Clocks

  -- Clock Instantiation
  tb_SYSCLK : entity syncad_vhdl_lib.tb_clock_minmax
    generic map (name => "tb_SYSCLK",
                initialize => true,
                state1 => '1',
                state2 => '0')
    port map (tb_status,
              SYSCLK,
              SYSCLK_MinLH,
              SYSCLK_MaxLH,
              SYSCLK_MinHL,
              SYSCLK_MaxHL,
              SYSCLK_Offset,
              SYSCLK_Period,
              SYSCLK_Duty,
              SYSCLK_JRise,
              SYSCLK_JFall);

  -- Clocked Sequences

  -- Sequence: Unclocked
  Unclocked : process
  begin
    AV0_driver <= 3.3;
    AC0_driver <= 2.9;
    AV1_driver <= 2.2;
    AC1_driver <= 1.8;
    AV2_driver <= 1.2;
    AC2_driver <= 0.3;
    AV3_driver <= 3.3;
    AC3_driver <= 0.3;
    AV4_driver <= 2.0;
    AC4_driver <= 0.5;
    AV5_driver <= 1.0;
    AC5_driver <= 1.0;
    wait for 279 ns;
    SYSRSTn <= '1';
    wait for 146300 ns;
    AC1_driver <= 1.5;
    wait for 10591 ns;
    AV1_driver <= 2.0;
    wait for 132382 ns;
    AV0_driver <= 3.1;
    wait for 1765 ns;
    AC0_driver <= 2.5;
    wait for 139443 ns;
    AC4_driver <= 1.0;
    wait for 3530 ns;
    AV5_driver <= 2.0;
    wait for 40597 ns;
    AV1_driver <= 1.8;
    wait for 1765 ns;
    AC1_driver <= 1.3;
    wait for 21182 ns;
    AV3_driver <= 1.5;
    AC3_driver <= 0.7;
    wait for 162389 ns;
    AV0_driver <= 3.2;
    wait for 1765 ns;
    AC0_driver <= 2.0;
    wait for 125322 ns;
    AV2_driver <= 1.0;
    wait for 1765 ns;
    AC2_driver <= 0.5;
    wait for 35302 ns;
    AV4_driver <= 3.0;
    wait for 35302 ns;
    AV1_driver <= 1.6;
    wait for 7060 ns;
    AC1_driver <= 1.1;
    wait for 171215 ns;
    AV0_driver <= 2.8;
    wait for 1765 ns;
    AC0_driver <= 2.5;
    wait for 100611 ns;
    AC4_driver <= 1.5;
    wait for 12355 ns;
    AV5_driver <= 3.0;
    wait for 109436 ns;
    AV1_driver <= 1.7;
    AC1_driver <= 1.6;
    wait for 112967 ns;
    AV3_driver <= 2.0;
    wait for 3530 ns;
    AC3_driver <= 1.0;
    wait for 93550 ns;
    AV0_driver <= 2.7;
    wait for 7061 ns;
    AC0_driver <= 1.5;
    wait for 181805 ns;
    AV1_driver <= 2.0;
    wait for 3530 ns;
    AC1_driver <= 0.5;
    wait for 403325 ns;
    wait;
  end process;
end STIMULATOR;

-- Test Bench wrapper for stimulus and Model Under Test
library ieee, std;
use ieee.std_logic_1164.all;
library syncad_vhdl_lib;
use syncad_vhdl_lib.TBDefinitions.all;
library fusion;
use fusion.analog_io.all;
-- Additional libraries used by Model Under Test.
library ieee;
-- End Additional libraries used by Model Under Test.

entity testbench is
end testbench;
architecture tbGeneratedCode of testbench is
  signal SYSCLK : std_logic;
  signal SYSRSTn : std_logic;
  signal VAREF : std_logic;
  signal AV0 : std_logic;
  signal AC0 : std_logic;
  signal AV1 : std_logic;
  signal AC1 : std_logic;
  signal AV2 : std_logic;
  signal AC2 : std_logic;
  signal AV3 : std_logic;
  signal AC3 : std_logic;
  signal AV4 : std_logic;
  signal AC4 : std_logic;
  signal AV5 : std_logic;
  signal AC5 : std_logic;
  signal Current0 : std_logic_vector(11 downto 0);
  signal Current1 : std_logic_vector(11 downto 0);
  signal Current2 : std_logic_vector(11 downto 0);
  signal Current3 : std_logic_vector(11 downto 0);
  signal Current4 : std_logic_vector(11 downto 0);
  signal Current5 : std_logic_vector(11 downto 0);
  signal Latest_Update : std_logic_vector(2 downto 0);
  signal PUB : std_logic;
  signal SPARE : std_logic;
  signal INIT_DONE_Test : std_logic;
  signal ASSC_DONE_Test : std_logic;

  -- Stimulator instance

begin

  stimulus_0 : entity work.stimulus
    port map (SYSCLK => SYSCLK,
              SYSRSTn => SYSRSTn,
              VAREF => VAREF,
              AV0 => AV0,
              AC0 => AC0,
              AV1 => AV1,
              AC1 => AC1,
              AV2 => AV2,
              AC2 => AC2,
              AV3 => AV3,
              AC3 => AC3,
              AV4 => AV4,
              AC4 => AC4,
              AV5 => AV5,
              AC5 => AC5,
              Current0 => Current0,
              Current1 => Current1,
              Current2 => Current2,
              Current3 => Current3,
              Current4 => Current4,
              Current5 => Current5,
              Latest_Update => Latest_Update,
              PUB => PUB,
              SPARE => SPARE,
              INIT_DONE_Test => INIT_DONE_Test,
              ASSC_DONE_Test => ASSC_DONE_Test);

  -- Instantiation of Model Under Test.
  TOP_CM_0 : entity work.TOP_CM
    port map (Current0 => Current0,
              Current1 => Current1,
              Current2 => Current2,
              Current3 => Current3,
              Current4 => Current4,
              Current5 => Current5,
              Latest_Update => Latest_Update,
              SYSCLK => SYSCLK,
              SYSRSTn => SYSRSTn,
              VAREF => VAREF,
              AV0 => AV0,
              AC0 => AC0,
              AV1 => AV1,
              AC1 => AC1,
              AV2 => AV2,
              AC2 => AC2,
              AV3 => AV3,
              AC3 => AC3,
              AV4 => AV4,
              AC4 => AC4,
              AV5 => AV5,
              AC5 => AC5,
              PUB => PUB,
              SPARE => SPARE,
              INIT_DONE_Test => INIT_DONE_Test,
              ASSC_DONE_Test => ASSC_DONE_Test);
end tbGeneratedCode;
