-- Version: 7.2 SP2 7.2.3.2
-- File used only for Simulation

library ieee;
use ieee.std_logic_1164.all;
library fusion;

entity TOP_CM is

    port(Diff0 : out std_logic_vector(11 downto 0); Diff1 : 
        out std_logic_vector(11 downto 0); Diff2 : 
        out std_logic_vector(11 downto 0); Diff3 : 
        out std_logic_vector(11 downto 0); Diff4 : 
        out std_logic_vector(11 downto 0); Diff5 : 
        out std_logic_vector(11 downto 0); Latest_Update : 
        out std_logic_vector(2 downto 0); SYSCLK, SYSRSTn : in
         std_logic; VAREF : inout std_logic := 'Z'; AV0, AC0, AV1, 
        AC1, AV2, AC2, AV3, AC3, AV4, AC4, AV5, AC5 : in
         std_logic; New_Measurement : out std_logic; PUB : in
         std_logic; SPARE : out std_logic);

end TOP_CM;

architecture DEF_ARCH of TOP_CM is 

  component DFN1E1C0
    port(D, CLK, CLR, E : in std_logic := 'U'; Q : out std_logic);
        
  end component;

  component XNOR3
    port(A, B, C : in std_logic := 'U'; Y : out std_logic);
  end component;

  component BUFF
    port(A : in std_logic := 'U'; Y : out std_logic);
  end component;

  component MX2
    port(A, B, S : in std_logic := 'U'; Y : out std_logic);
  end component;

  component AOI1B
    port(A, B, C : in std_logic := 'U'; Y : out std_logic);
  end component;

  component DFN1C0
    port(D, CLK, CLR : in std_logic := 'U'; Q : out std_logic);
  end component;

  component OR2A
    port(A, B : in std_logic := 'U'; Y : out std_logic);
  end component;

  component AX1C
    port(A, B, C : in std_logic := 'U'; Y : out std_logic);
  end component;

  component NOR3
    port(A, B, C : in std_logic := 'U'; Y : out std_logic);
  end component;

  component IOPAD_TRI
    port(D, E : in std_logic := 'U'; PAD : out std_logic);
  end component;

  component NOR2A
    port(A, B : in std_logic := 'U'; Y : out std_logic);
  end component;

  component NOR3B
    port(A, B, C : in std_logic := 'U'; Y : out std_logic);
  end component;

  component NOR2B
    port(A, B : in std_logic := 'U'; Y : out std_logic);
  end component;

  component XNOR2
    port(A, B : in std_logic := 'U'; Y : out std_logic);
  end component;

  component OAI1
    port(A, B, C : in std_logic := 'U'; Y : out std_logic);
  end component;

  component NOR2
    port(A, B : in std_logic := 'U'; Y : out std_logic);
  end component;

  component NOR3A
    port(A, B, C : in std_logic := 'U'; Y : out std_logic);
  end component;

  component OR3
    port(A, B, C : in std_logic := 'U'; Y : out std_logic);
  end component;

  component OA1B
    port(A, B, C : in std_logic := 'U'; Y : out std_logic);
  end component;

  component OR3B
    port(A, B, C : in std_logic := 'U'; Y : out std_logic);
  end component;

  component XOR3
    port(A, B, C : in std_logic := 'U'; Y : out std_logic);
  end component;

  component IOTRI_OB_EB
    port(D, E : in std_logic := 'U'; DOUT, EOUT : out std_logic);

          end component;

  component AO1
    port(A, B, C : in std_logic := 'U'; Y : out std_logic);
  end component;

  component MX2C
    port(A, B, S : in std_logic := 'U'; Y : out std_logic);
  end component;

  component RAM4K9
    generic (MEMORYFILE:string := "");

    port(ADDRA11, ADDRA10, ADDRA9, ADDRA8, ADDRA7, ADDRA6, ADDRA5, 
        ADDRA4, ADDRA3, ADDRA2, ADDRA1, ADDRA0, ADDRB11, ADDRB10, 
        ADDRB9, ADDRB8, ADDRB7, ADDRB6, ADDRB5, ADDRB4, ADDRB3, 
        ADDRB2, ADDRB1, ADDRB0, DINA8, DINA7, DINA6, DINA5, DINA4, 
        DINA3, DINA2, DINA1, DINA0, DINB8, DINB7, DINB6, DINB5, 
        DINB4, DINB3, DINB2, DINB1, DINB0, WIDTHA0, WIDTHA1, 
        WIDTHB0, WIDTHB1, PIPEA, PIPEB, WMODEA, WMODEB, BLKA, 
        BLKB, WENA, WENB, CLKA, CLKB, RESET : in std_logic := 'U'; 
        DOUTA8, DOUTA7, DOUTA6, DOUTA5, DOUTA4, DOUTA3, DOUTA2, 
        DOUTA1, DOUTA0, DOUTB8, DOUTB7, DOUTB6, DOUTB5, DOUTB4, 
        DOUTB3, DOUTB2, DOUTB1, DOUTB0 : out std_logic);
  end component;

  component OR2
    port(A, B : in std_logic := 'U'; Y : out std_logic);
  end component;

  component OR3C
    port(A, B, C : in std_logic := 'U'; Y : out std_logic);
  end component;

  component DFN1P0
    port(D, CLK, PRE : in std_logic := 'U'; Q : out std_logic);
  end component;

  component AX1D
    port(A, B, C : in std_logic := 'U'; Y : out std_logic);
  end component;

  component XAI1
    port(A, B, C : in std_logic := 'U'; Y : out std_logic);
  end component;

  component OR2B
    port(A, B : in std_logic := 'U'; Y : out std_logic);
  end component;

  component OR3A
    port(A, B, C : in std_logic := 'U'; Y : out std_logic);
  end component;

  component ZOR3
    port(A, B, C : in std_logic := 'U'; Y : out std_logic);
  end component;

  component OA1C
    port(A, B, C : in std_logic := 'U'; Y : out std_logic);
  end component;

  component DFN1E0C0
    port(D, CLK, CLR, E : in std_logic := 'U'; Q : out std_logic);
        
  end component;

  component IOPAD_A_IN
    port(PAD : in std_logic := 'U'; Y : out std_logic);
  end component;

  component AND3
    port(A, B, C : in std_logic := 'U'; Y : out std_logic);
  end component;

  component XOR2
    port(A, B : in std_logic := 'U'; Y : out std_logic);
  end component;

  component NVM
    generic (MEMORYFILE:string := "");

    port(RD : out std_logic_vector(31 downto 0); BUSY : out
         std_logic; STATUS : out std_logic_vector(1 downto 0); 
        ADDR : 
        in std_logic_vector(17 downto 0) := (others => 'U'); WD
         : in std_logic_vector(31 downto 0) := (others => 'U'); 
        DATAWIDTH : 
        in std_logic_vector(1 downto 0) := (others => 'U'); REN, 
        WEN, PROGRAM, SPAREPAGE, AUXBLOCK, READNEXT, ERASEPAGE, 
        UNPROTECTPAGE, DISCARDPAGE, OVERWRITEPROTECT, 
        PAGELOSSPROTECT, CLK, RESET, PAGESTATUS, OVERWRITEPAGE, 
        PIPE, LOCKREQUEST : in std_logic := 'U');
  end component;

  component XA1
    port(A, B, C : in std_logic := 'U'; Y : out std_logic);
  end component;

  component AO1D
    port(A, B, C : in std_logic := 'U'; Y : out std_logic);
  end component;

  component AO13
    port(A, B, C : in std_logic := 'U'; Y : out std_logic);
  end component;

  component AO1B
    port(A, B, C : in std_logic := 'U'; Y : out std_logic);
  end component;

  component AO1C
    port(A, B, C : in std_logic := 'U'; Y : out std_logic);
  end component;

  component NOR3C
    port(A, B, C : in std_logic := 'U'; Y : out std_logic);
  end component;

  component AOI1A
    port(A, B, C : in std_logic := 'U'; Y : out std_logic);
  end component;

  component MX2A
    port(A, B, S : in std_logic := 'U'; Y : out std_logic);
  end component;

  component XA1B
    port(A, B, C : in std_logic := 'U'; Y : out std_logic);
  end component;

  component AND2
    port(A, B : in std_logic := 'U'; Y : out std_logic);
  end component;

  component AOI1
    port(A, B, C : in std_logic := 'U'; Y : out std_logic);
  end component;

  component MX2B
    port(A, B, S : in std_logic := 'U'; Y : out std_logic);
  end component;

  component AX1E
    port(A, B, C : in std_logic := 'U'; Y : out std_logic);
  end component;

  component XO1A
    port(A, B, C : in std_logic := 'U'; Y : out std_logic);
  end component;

  component AO18
    port(A, B, C : in std_logic := 'U'; Y : out std_logic);
  end component;

  component AND2A
    port(A, B : in std_logic := 'U'; Y : out std_logic);
  end component;

  component AND3C
    port(A, B, C : in std_logic := 'U'; Y : out std_logic);
  end component;

  component OA1A
    port(A, B, C : in std_logic := 'U'; Y : out std_logic);
  end component;

  component ZOR3I
    port(A, B, C : in std_logic := 'U'; Y : out std_logic);
  end component;

  component OA1
    port(A, B, C : in std_logic := 'U'; Y : out std_logic);
  end component;

  component XA1A
    port(A, B, C : in std_logic := 'U'; Y : out std_logic);
  end component;

  component CLKSRC
    port(A : in std_logic := 'U'; Y : out std_logic);
  end component;

  component AXOI3
    port(A, B, C : in std_logic := 'U'; Y : out std_logic);
  end component;

  component AX1A
    port(A, B, C : in std_logic := 'U'; Y : out std_logic);
  end component;

  component AO1A
    port(A, B, C : in std_logic := 'U'; Y : out std_logic);
  end component;

  component XAI1A
    port(A, B, C : in std_logic := 'U'; Y : out std_logic);
  end component;

  component AB
    port(DAVOUT0, DACOUT0, DATOUT0, DAVOUT1, DACOUT1, DATOUT1, 
        DAVOUT2, DACOUT2, DATOUT2, DAVOUT3, DACOUT3, DATOUT3, 
        DAVOUT4, DACOUT4, DATOUT4, DAVOUT5, DACOUT5, DATOUT5, 
        DAVOUT6, DACOUT6, DATOUT6, DAVOUT7, DACOUT7, DATOUT7, 
        DAVOUT8, DACOUT8, DATOUT8, DAVOUT9, DACOUT9, DATOUT9 : 
        out std_logic; DENAV0, DENAC0, DENAT0, DENAV1, DENAC1, 
        DENAT1, DENAV2, DENAC2, DENAT2, DENAV3, DENAC3, DENAT3, 
        DENAV4, DENAC4, DENAT4, DENAV5, DENAC5, DENAT5, DENAV6, 
        DENAC6, DENAT6, DENAV7, DENAC7, DENAT7, DENAV8, DENAC8, 
        DENAT8, DENAV9, DENAC9, DENAT9, AV0, AC0, AT0 : in
         std_logic := 'U'; AG0 : out std_logic; AV1, AC1, AT1 : 
        in std_logic := 'U'; AG1 : out std_logic; AV2, AC2, AT2 : 
        in std_logic := 'U'; AG2 : out std_logic; AV3, AC3, AT3 : 
        in std_logic := 'U'; AG3 : out std_logic; AV4, AC4, AT4 : 
        in std_logic := 'U'; AG4 : out std_logic; AV5, AC5, AT5 : 
        in std_logic := 'U'; AG5 : out std_logic; AV6, AC6, AT6 : 
        in std_logic := 'U'; AG6 : out std_logic; AV7, AC7, AT7 : 
        in std_logic := 'U'; AG7 : out std_logic; AV8, AC8, AT8 : 
        in std_logic := 'U'; AG8 : out std_logic; AV9, AC9, AT9 : 
        in std_logic := 'U'; AG9 : out std_logic; ATRETURN01, 
        ATRETURN23, ATRETURN45, ATRETURN67, ATRETURN89 : in
         std_logic := 'U'; VAREF : inout std_logic; GNDREF, GDON0, 
        GDON1, GDON2, GDON3, GDON4, GDON5, GDON6, GDON7, GDON8, 
        GDON9, CMSTB0, CMSTB1, CMSTB2, CMSTB3, CMSTB4, CMSTB5, 
        CMSTB6, CMSTB7, CMSTB8, CMSTB9, TMSTB0, TMSTB1, TMSTB2, 
        TMSTB3, TMSTB4, TMSTB5, TMSTB6, TMSTB7, TMSTB8, TMSTB9, 
        TMSTBINT : in std_logic := 'U'; RESULT : 
        out std_logic_vector(11 downto 0); ACMRDATA : 
        out std_logic_vector(7 downto 0); ACMWDATA : 
        in std_logic_vector(7 downto 0) := (others => 'U'); 
        ACMADDR : 
        in std_logic_vector(7 downto 0) := (others => 'U'); STC
         : in std_logic_vector(7 downto 0) := (others => 'U'); 
        TVC : in std_logic_vector(7 downto 0) := (others => 'U'); 
        CHNUMBER : 
        in std_logic_vector(4 downto 0) := (others => 'U'); MODE
         : in std_logic_vector(3 downto 0) := (others => 'U'); 
        RTCXTLMODE : out std_logic_vector(1 downto 0); ACMRESET, 
        ACMCLK, ACMWEN, VAREFSEL : in std_logic := 'U'; DATAVALID, 
        CALIBRATE, SAMPLE, BUSY : out std_logic; PWRDWN, SYSCLK, 
        ADCRESET, ADCSTART : in std_logic := 'U'; RTCMATCH, 
        RTCPSMMATCH, RTCXTLSEL : out std_logic; RTCCLK : in
         std_logic := 'U');
  end component;

  component VRPSM
    port(PUB, VRPU, VRINITSTATE, RTCPSMMATCH : in
         std_logic := 'U'; FPGAGOOD, PUCORE : out std_logic);
  end component;

  component DFN1E1P0
    port(D, CLK, PRE, E : in std_logic := 'U'; Q : out std_logic);
        
  end component;

  component AXOI5
    port(A, B, C : in std_logic := 'U'; Y : out std_logic);
  end component;

  component AX1B
    port(A, B, C : in std_logic := 'U'; Y : out std_logic);
  end component;

  component MAJ3
    port(A, B, C : in std_logic := 'U'; Y : out std_logic);
  end component;

  component INV
    port(A : in std_logic := 'U'; Y : out std_logic);
  end component;

  component AOI1D
    port(A, B, C : in std_logic := 'U'; Y : out std_logic);
  end component;

  component IOPAD_IN
    port(PAD : in std_logic := 'U'; Y : out std_logic);
  end component;

  component AND3B
    port(A, B, C : in std_logic := 'U'; Y : out std_logic);
  end component;

  component DLN1C0
    port(D, G, CLR : in std_logic := 'U'; Q : out std_logic);
  end component;

  component AO15
    port(A, B, C : in std_logic := 'U'; Y : out std_logic);
  end component;

  component GND
    port(Y : out std_logic); 
  end component;

  component VCC
    port(Y : out std_logic); 
  end component;

    signal 
        \AB_CM_inst.AB_CM_smev_wrapper_inst.U0.u_nbnjbfrkqwq.rdgwgtpkbgc[3]\, 
        \rdgwgtpkbgc[3]\, INIT_DONE, hrgmtcpsdzr, SYSRSTn_c, 
        SYSCLK_c, SPARE_c, New_Measurement_c, 
        \Latest_Update_c[2]\, \Latest_Update_c[1]\, 
        \Latest_Update_c[0]\, \Diff5_c[11]\, \Diff5_c[10]\, 
        \Diff5_c[9]\, \Diff5_c[8]\, \Diff5_c[7]\, \Diff5_c[6]\, 
        \Diff5_c[5]\, \Diff5_c[4]\, \Diff5_c[3]\, \Diff5_c[2]\, 
        \Diff5_c[1]\, \Diff5_c[0]\, \Diff4_c[11]\, \Diff4_c[10]\, 
        \Diff4_c[9]\, \Diff4_c[8]\, \Diff4_c[7]\, \Diff4_c[6]\, 
        \Diff4_c[5]\, \Diff4_c[4]\, \Diff4_c[3]\, \Diff4_c[2]\, 
        \Diff4_c[1]\, \Diff4_c[0]\, \Diff3_c[11]\, \Diff3_c[10]\, 
        \Diff3_c[9]\, \Diff3_c[8]\, \Diff3_c[7]\, \Diff3_c[6]\, 
        \Diff3_c[5]\, \Diff3_c[4]\, \Diff3_c[3]\, \Diff3_c[2]\, 
        \Diff3_c[1]\, \Diff3_c[0]\, \Diff2_c[11]\, \Diff2_c[10]\, 
        \Diff2_c[9]\, \Diff2_c[8]\, \Diff2_c[7]\, \Diff2_c[6]\, 
        \Diff2_c[5]\, \Diff2_c[4]\, \Diff2_c[3]\, \Diff2_c[2]\, 
        \Diff2_c[1]\, \Diff2_c[0]\, \Diff1_c[11]\, \Diff1_c[10]\, 
        \Diff1_c[9]\, \Diff1_c[8]\, \Diff1_c[7]\, \Diff1_c[6]\, 
        \Diff1_c[5]\, \Diff1_c[4]\, \Diff1_c[3]\, \Diff1_c[2]\, 
        \Diff1_c[1]\, \Diff1_c[0]\, \Diff0_c[11]\, \Diff0_c[10]\, 
        \Diff0_c[9]\, \Diff0_c[8]\, \Diff0_c[7]\, \Diff0_c[6]\, 
        \Diff0_c[5]\, \Diff0_c[4]\, \Diff0_c[3]\, \Diff0_c[2]\, 
        \Diff0_c[1]\, \Diff0_c[0]\, \ADC_CHNUMBER[0]\, 
        \ADC_CHNUMBER[1]\, \ADC_CHNUMBER[2]\, \ADC_CHNUMBER[3]\, 
        \ADC_CHNUMBER[4]\, \INIT_DATA[0]\, \INIT_DATA[1]\, 
        \INIT_DATA[2]\, \INIT_DATA[3]\, \INIT_DATA[4]\, 
        \INIT_DATA[5]\, \INIT_DATA[6]\, \INIT_DATA[7]\, 
        \INIT_DATA[8]\, \INIT_ADDR[0]\, \INIT_ADDR[1]\, 
        \INIT_ADDR[2]\, \INIT_ADDR[3]\, \INIT_ADDR[4]\, 
        \INIT_ADDR[5]\, \INIT_ADDR[6]\, \INIT_ADDR[7]\, 
        \INIT_ADDR[8]\, \ADC_RESULT[0]\, \ADC_RESULT[1]\, 
        \ADC_RESULT[2]\, \ADC_RESULT[3]\, \ADC_RESULT[4]\, 
        \ADC_RESULT[5]\, \ADC_RESULT[6]\, \ADC_RESULT[7]\, 
        \ADC_RESULT[8]\, \ADC_RESULT[9]\, \ADC_RESULT[10]\, 
        \ADC_RESULT[11]\, INIT_ASSC_WEN, 
        \NVM_CM_inst.NVM_CM_init_wrapper_inst.U0.u_grwzcnqmqzm.valid_client.u_gpbdjfttbjd.N_10\, 
        \NVM_CM_inst.NVM_CM_init_wrapper_inst.U0.u_grwzcnqmqzm.valid_client.u_gpbdjfttbjd.N_12\, 
        INIT_EV_WEN, ASSC_DONE, \NVM_CM_inst/NVM_BUSY_net\, 
        \NVM_CM_inst/srdtcqsfmmm_i[0]\, 
        \NVM_CM_inst/srdtcqsfmmm_i[1]\, 
        \NVM_CM_inst/srdtcqsfmmm_i[2]\, 
        \NVM_CM_inst/srdtcqsfmmm_i[3]\, 
        \NVM_CM_inst/srdtcqsfmmm_i[4]\, 
        \NVM_CM_inst/srdtcqsfmmm_i[5]\, 
        \NVM_CM_inst/srdtcqsfmmm_i[6]\, 
        \NVM_CM_inst/srdtcqsfmmm_i[12]\, 
        \NVM_CM_inst/srdtcqsfmmm_i[13]\, 
        \NVM_CM_inst/srdtcqsfmmm_i[14]\, 
        \NVM_CM_inst/srdtcqsfmmm_i[15]\, 
        \NVM_CM_inst/srdtcqsfmmm_i[16]\, 
        \NVM_CM_inst/hbqjhzzrbnr_i[0]\, 
        \NVM_CM_inst/un1_wxqqqsndpvg_i_0\, 
        \NVM_CM_inst/twxmgvvpbgm_iv_0_a2_0\, 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/mwtvnzdkmwm[4]\, 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/gpbbjwsprsj[0]\, 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/gpbbjwsprsj[1]\, 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/N_42\, 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/xbkjkgdsbfh\, 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/dxpbcqjpxtw\, 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/mhxwcfnvbgt\, 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/qdvwjxmzbpf\, 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/bfcqzvtnrcn\, 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/vvpkfmmpprk[0]\, 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/vvpkfmmpprk[1]\, 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/N_51\, 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/npgnwznthhx\, 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/fhpsqkqvwpw\, 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/ggsxvgncrgz[0]\, 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/bqhrfdzctjc_i_0[13]\, 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/ggfvvjbkdws[1]\, 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/ggfvvjbkdws[2]\, 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/ggfvvjbkdws[3]\, 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/ggfvvjbkdws[4]\, 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/ggfvvjbkdws[5]\, 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/ggfvvjbkdws[6]\, 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/ggfvvjbkdws[7]\, 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/mmsccbknsvn[12]\, 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/bdhvhfjwtxd_i_0[5]\, 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/N_2358\, 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/N_2340\, 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/wtjtwqjkqbd\, 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/N222\, 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/ADD_13x13_fast_I87_Y_0\, 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/I33_un1_Y\, 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/N189\, 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/qdgqbvgcnzn\, 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/N_1838\, 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/N_2324\, 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/N_1839\, 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/N_2357\, 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/N_2174\, 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/N246\, 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/user_clk_sel/u_jhmkpjjmdkx/crmctgwbctb_net_1\, 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/init_fsm/u_stnpfdkggvx/mwtvnzdkmwm[6]_net_1\, 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/init_fsm/u_stnpfdkggvx/mwtvnzdkmwm[5]_net_1\, 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/init_fsm/u_stnpfdkggvx/mwtvnzdkmwm_ns[2]_net_1\, 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/init_fsm/u_stnpfdkggvx/mwtvnzdkmwm_ns[4]_net_1\, 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/init_fsm/u_stnpfdkggvx/mwtvnzdkmwm_ns[5]\, 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/init_fsm/u_stnpfdkggvx/mwtvnzdkmwm_ns[3]_net_1\, 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/init_fsm/u_stnpfdkggvx/mwtvnzdkmwm_ns_i_a2[7]_net_1\, 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/init_fsm/u_stnpfdkggvx/mwtvnzdkmwm[1]_net_1\, 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/init_fsm/u_stnpfdkggvx/mwtvnzdkmwm_ns[0]\, 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/init_fsm/u_stnpfdkggvx/mwtvnzdkmwm[7]_net_1\, 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/init_fsm/u_stnpfdkggvx/mwtvnzdkmwm_ns[1]_net_1\, 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/init_fsm/u_stnpfdkggvx/N_45\, 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/init_fsm/u_stnpfdkggvx/mwtvnzdkmwm_ns[6]\, 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/init_fsm/u_stnpfdkggvx/mwtvnzdkmwm[2]_net_1\, 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/init_fsm/u_stnpfdkggvx/DWACT_ADD_CI_0_partial_sum[0]\, 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/init_fsm/u_stnpfdkggvx/I_10\, 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/address_gen/u_dxwqxgdccxc/DWACT_ADD_CI_0_g_array_2[0]\, 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/address_gen/u_dxwqxgdccxc/DWACT_ADD_CI_0_g_array_1[0]\, 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/address_gen/u_dxwqxgdccxc/DWACT_ADD_CI_0_g_array_3[0]\, 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/address_gen/u_dxwqxgdccxc/DWACT_ADD_CI_0_g_array_11[0]\, 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/address_gen/u_dxwqxgdccxc/DWACT_ADD_CI_0_pog_array_1_1[0]\, 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/address_gen/u_dxwqxgdccxc/DWACT_ADD_CI_0_TMP[0]\, 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/address_gen/u_dxwqxgdccxc/DWACT_ADD_CI_0_g_array_12_1[0]\, 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/address_gen/u_dxwqxgdccxc/DWACT_ADD_CI_0_g_array_12[0]\, 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/address_gen/u_dxwqxgdccxc/ggfvvjbkdws[9]_net_1\, 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/address_gen/u_dxwqxgdccxc/ADD_13x13_fast_I35_un1_Y_0\, 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/address_gen/u_dxwqxgdccxc/ggfvvjbkdws[8]_net_1\, 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/address_gen/u_dxwqxgdccxc/un10_gnmdxrqrdgs_NE_6\, 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/address_gen/u_dxwqxgdccxc/un10_gnmdxrqrdgs_NE_3\, 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/address_gen/u_dxwqxgdccxc/un10_gnmdxrqrdgs_NE_2\, 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/address_gen/u_dxwqxgdccxc/un10_gnmdxrqrdgs_0_i\, 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/address_gen/u_dxwqxgdccxc/un10_gnmdxrqrdgs_NE_5\, 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/address_gen/u_dxwqxgdccxc/un10_gnmdxrqrdgs_7\, 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/address_gen/u_dxwqxgdccxc/un10_gnmdxrqrdgs_NE_0\, 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/address_gen/u_dxwqxgdccxc/un10_gnmdxrqrdgs_8_i\, 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/address_gen/u_dxwqxgdccxc/un10_gnmdxrqrdgs_5\, 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/address_gen/u_dxwqxgdccxc/N190\, 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/address_gen/u_dxwqxgdccxc/un10_gnmdxrqrdgs_NE\, 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/address_gen/u_dxwqxgdccxc/I35_un1_Y\, 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/address_gen/u_dxwqxgdccxc/I13_un1_Y\, 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/address_gen/u_dxwqxgdccxc/gnmdxrqrdgs_3[8]\, 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/address_gen/u_dxwqxgdccxc/gnmdxrqrdgs_3[7]\, 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/address_gen/u_dxwqxgdccxc/I_34_1\, 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/address_gen/u_dxwqxgdccxc/gnmdxrqrdgs_3[6]\, 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/address_gen/u_dxwqxgdccxc/gnmdxrqrdgs_3[5]\, 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/address_gen/u_dxwqxgdccxc/gnmdxrqrdgs_3[4]\, 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/address_gen/u_dxwqxgdccxc/gnmdxrqrdgs_3[3]\, 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/address_gen/u_dxwqxgdccxc/gnmdxrqrdgs_3[2]\, 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/address_gen/u_dxwqxgdccxc/gnmdxrqrdgs_3[1]\, 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/address_gen/u_dxwqxgdccxc/gnmdxrqrdgs_3[0]\, 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/address_gen/u_dxwqxgdccxc/un2_tnjvgqqhdkd\, 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/address_gen/u_dxwqxgdccxc/DWACT_ADD_CI_0_pog_array_1_2[0]\, 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/valid_client/u_gpbdjfttbjd/fpppnnsbksx_0_a3_0_0[3]_net_1\, 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/valid_client/u_gpbdjfttbjd/N_23\, 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/valid_client/u_gpbdjfttbjd/N_22\, 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/valid_client/u_gpbdjfttbjd/N_18\, 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/valid_client/u_gpbdjfttbjd/N_19\, 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/valid_client/u_gpbdjfttbjd/N_20\, 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/valid_client/u_gpbdjfttbjd/N_21\, 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/valid_client/u_gpbdjfttbjd/N_24\, 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/user_control/u_ffppvfwnggt/un1_wxqqqsndpvg_i_0_0\, 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/user_control/u_ffppvfwnggt/hcmmkfggqvf_13[12]\, 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/user_control/u_ffppvfwnggt/N_2183_i_i_0\, 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/user_control/u_ffppvfwnggt/N_2342\, 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/user_control/u_ffppvfwnggt/N_2334\, 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/save_fsm/u_wbsfnwwctpn/crpwsdfhcqq[7]_net_1\, 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/save_fsm/u_wbsfnwwctpn/crpwsdfhcqq[3]_net_1\, 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/save_fsm/u_wbsfnwwctpn/crpwsdfhcqq_ns_a3[1]_net_1\, 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/save_fsm/u_wbsfnwwctpn/crpwsdfhcqq_ns_a3[4]_net_1\, 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/save_fsm/u_wbsfnwwctpn/crpwsdfhcqq_ns[7]_net_1\, 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/save_fsm/u_wbsfnwwctpn/mfwjfgrqchd\, 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/save_fsm/u_wbsfnwwctpn/crpwsdfhcqq[1]_net_1\, 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/save_fsm/u_wbsfnwwctpn/crpwsdfhcqq_ns[6]_net_1\, 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/save_fsm/u_wbsfnwwctpn/N_60\, 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/save_fsm/u_wbsfnwwctpn/crpwsdfhcqq_ns[5]_net_1\, 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/save_fsm/u_wbsfnwwctpn/crpwsdfhcqq[0]_net_1\, 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/save_fsm/u_wbsfnwwctpn/crpwsdfhcqq_ns[3]_net_1\, 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/save_fsm/u_wbsfnwwctpn/crpwsdfhcqq_ns_a3[8]_net_1\, 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/save_fsm/u_wbsfnwwctpn/jspcghhzwmg\, 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/save_fsm/u_wbsfnwwctpn/DWACT_ADD_CI_0_partial_sum[0]\, 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/save_fsm/u_wbsfnwwctpn/I_10_0\, 
        \COMP_SM_inst/pres_state_0[3]_net_1\, 
        \COMP_SM_inst/un2_resetn\, 
        \COMP_SM_inst/pres_state_ns[1]\, 
        \COMP_SM_inst/pres_state_0[2]_net_1\, 
        \COMP_SM_inst/pres_state_ns[2]\, 
        \COMP_SM_inst/Latest_Update_2_sqmuxa_0\, 
        \COMP_SM_inst/N_419\, \COMP_SM_inst/Latest_Update_9[1]\, 
        \COMP_SM_inst/pres_state_ns_a5_0_a4_2[1]_net_1\, 
        \COMP_SM_inst/pres_state_ns_a5_0_a4_1[1]_net_1\, 
        \COMP_SM_inst/pres_state[1]_net_1\, 
        \COMP_SM_inst/un1_completed_sync_7_i_0_net_1\, 
        \COMP_SM_inst/un1_completed_sync_7_i_a4_0_1_net_1\, 
        \COMP_SM_inst/valid_8_0_0_a4_1_net_1\, 
        \COMP_SM_inst/prev_channel[0]_net_1\, 
        \COMP_SM_inst/prev_channel[2]_net_1\, 
        \COMP_SM_inst/valid_8_0_0_a4_1_3_net_1\, 
        \COMP_SM_inst/valid_8_0_0_a4_1_1_net_1\, 
        \COMP_SM_inst/N_424\, 
        \COMP_SM_inst/prev_channel[4]_net_1\, 
        \COMP_SM_inst/prev_channel[1]_net_1\, 
        \COMP_SM_inst/valid_8_0_0_a2_4_1_net_1\, 
        \COMP_SM_inst/prev_channel[3]_net_1\, 
        \COMP_SM_inst/valid_8_0_0_a4_0_3_net_1\, 
        \COMP_SM_inst/valid_8_0_0_a4_0_1_net_1\, 
        \COMP_SM_inst/N_407\, 
        \COMP_SM_inst/valid_8_0_0_a2_3_0_net_1\, 
        \COMP_SM_inst/un1_completed_sync_7_i_a4_0_0_net_1\, 
        \COMP_SM_inst/valid_8_0_0_a2_1_0_net_1\, 
        \COMP_SM_inst/N_416\, \COMP_SM_inst/N_417\, 
        \COMP_SM_inst/N_376\, \COMP_SM_inst/valid_net_1\, 
        \COMP_SM_inst/Latest_Update_2_sqmuxa\, 
        \COMP_SM_inst/Latest_Update_0_sqmuxa\, 
        \COMP_SM_inst/N_423\, 
        \COMP_SM_inst/Latest_Update_4_sqmuxa\, 
        \COMP_SM_inst/N_425\, \COMP_SM_inst/N_409\, 
        \COMP_SM_inst/N_415\, \COMP_SM_inst/valid_8\, 
        \COMP_SM_inst/N_403_i\, \COMP_SM_inst/N_402_i\, 
        \COMP_SM_inst/N_401\, \COMP_SM_inst/N_421\, 
        \COMP_SM_inst/N_422\, \COMP_SM_inst/N_414\, 
        \COMP_SM_inst/N_410\, \COMP_SM_inst/N_421_1\, 
        \COMP_SM_inst/N_421_2\, \COMP_SM_inst/N_418\, 
        \COMP_SM_inst/N_364\, \COMP_SM_inst/N_372\, 
        \COMP_SM_inst/N_420\, \COMP_SM_inst/pres_state_ns[3]\, 
        \COMP_SM_inst/Latest_Update_1_sqmuxa\, 
        \COMP_SM_inst/N_413\, 
        \COMP_SM_inst/Latest_Update_5_sqmuxa\, 
        \COMP_SM_inst/N_406\, \COMP_SM_inst/Latest_Update_9[2]\, 
        \COMP_SM_inst/completed_sync_net_1\, 
        \COMP_SM_inst/Latest_Update_3_sqmuxa\, 
        \COMP_SM_inst/pres_state[3]_net_1\, 
        \COMP_SM_inst/pres_state[2]_net_1\, \COMP_SM_inst/N139\, 
        \COMP_SM_inst/Result[1]\, \COMP_SM_inst/Result[2]\, 
        \COMP_SM_inst/Result[3]\, \COMP_SM_inst/Result[4]\, 
        \COMP_SM_inst/Result[5]\, \COMP_SM_inst/Result[6]\, 
        \COMP_SM_inst/Result[7]\, \COMP_SM_inst/Result[8]\, 
        \COMP_SM_inst/Result[9]\, \COMP_SM_inst/Result[10]\, 
        \COMP_SM_inst/Result[11]\, \COMP_SM_inst/R2[0]_net_1\, 
        \COMP_SM_inst/R2[1]_net_1\, \COMP_SM_inst/R2[2]_net_1\, 
        \COMP_SM_inst/R2[3]_net_1\, \COMP_SM_inst/R2[4]_net_1\, 
        \COMP_SM_inst/R2[5]_net_1\, \COMP_SM_inst/R2[6]_net_1\, 
        \COMP_SM_inst/R2[7]_net_1\, \COMP_SM_inst/R2[8]_net_1\, 
        \COMP_SM_inst/R2[9]_net_1\, \COMP_SM_inst/R2[10]_net_1\, 
        \COMP_SM_inst/R2[11]_net_1\, \COMP_SM_inst/R1[0]_net_1\, 
        \COMP_SM_inst/R1[1]_net_1\, \COMP_SM_inst/R1[2]_net_1\, 
        \COMP_SM_inst/R1[3]_net_1\, \COMP_SM_inst/R1[4]_net_1\, 
        \COMP_SM_inst/R1[5]_net_1\, \COMP_SM_inst/R1[6]_net_1\, 
        \COMP_SM_inst/R1[7]_net_1\, \COMP_SM_inst/R1[8]_net_1\, 
        \COMP_SM_inst/R1[9]_net_1\, \COMP_SM_inst/R1[10]_net_1\, 
        \COMP_SM_inst/R1[11]_net_1\, 
        \COMP_SM_inst/Subtract_inst/SUB_12x12_medium_area_I47_Y_1\, 
        \COMP_SM_inst/Subtract_inst/N164\, 
        \COMP_SM_inst/Subtract_inst/N196\, 
        \COMP_SM_inst/Subtract_inst/SUB_12x12_medium_area_I47_Y_0\, 
        \COMP_SM_inst/Subtract_inst/N158\, 
        \COMP_SM_inst/Subtract_inst/SUB_12x12_medium_area_I47_un1_Y_0\, 
        \COMP_SM_inst/Subtract_inst/N197\, 
        \COMP_SM_inst/Subtract_inst/SUB_12x12_medium_area_I40_Y_1\, 
        \COMP_SM_inst/Subtract_inst/N168\, 
        \COMP_SM_inst/Subtract_inst/N206\, 
        \COMP_SM_inst/Subtract_inst/SUB_12x12_medium_area_I40_Y_0\, 
        \COMP_SM_inst/Subtract_inst/N150\, 
        \COMP_SM_inst/Subtract_inst/SUB_12x12_medium_area_I40_un1_Y_0\, 
        \COMP_SM_inst/Subtract_inst/N207\, 
        \COMP_SM_inst/Subtract_inst/SUB_12x12_medium_area_I39_Y_0\, 
        \COMP_SM_inst/Subtract_inst/N142\, 
        \COMP_SM_inst/Subtract_inst/N200\, 
        \COMP_SM_inst/Subtract_inst/N210\, 
        \COMP_SM_inst/Subtract_inst/N192\, 
        \COMP_SM_inst/Subtract_inst/I39_un1_Y\, 
        \COMP_SM_inst/Subtract_inst/N141\, 
        \COMP_SM_inst/Subtract_inst/N143\, 
        \COMP_SM_inst/Subtract_inst/N173\, 
        \COMP_SM_inst/Subtract_inst/N145\, 
        \COMP_SM_inst/Subtract_inst/N146\, 
        \COMP_SM_inst/Subtract_inst/N147\, 
        \COMP_SM_inst/Subtract_inst/N149\, 
        \COMP_SM_inst/Subtract_inst/N151\, 
        \COMP_SM_inst/Subtract_inst/I61_un1_Y\, 
        \COMP_SM_inst/Subtract_inst/I64_un1_Y\, 
        \COMP_SM_inst/Subtract_inst/SUB_12x12_medium_area_I65_un1_Y\, 
        \COMP_SM_inst/Subtract_inst/N214_i\, 
        \COMP_SM_inst/Subtract_inst/N202\, 
        \COMP_SM_inst/Subtract_inst/N157\, 
        \COMP_SM_inst/Subtract_inst/N216_i\, 
        \COMP_SM_inst/Subtract_inst/N153\, 
        \COMP_SM_inst/Subtract_inst/I66_un1_Y\, 
        \COMP_SM_inst/Subtract_inst/N154\, \AB_CM_inst/AC4_net\, 
        \AB_CM_inst/AV4_net\, \AB_CM_inst/AC0_net\, 
        \AB_CM_inst/AV0_net\, \AB_CM_inst/INIT_ACM_WEN_OR_net\, 
        \AB_CM_inst/AC2_net\, \AB_CM_inst/AV2_net\, 
        \AB_CM_inst/ADC_BUSY_net\, \AB_CM_inst/ADC_CALIBRATE_net\, 
        \AB_CM_inst/AC1_net\, \AB_CM_inst/AC3_net\, 
        \AB_CM_inst/AC5_net\, \AB_CM_inst/ADC_RESET_net\, 
        \AB_CM_inst/ADC_START_net\, \AB_CM_inst/AV1_net\, 
        \AB_CM_inst/AV3_net\, \AB_CM_inst/AV5_net\, 
        \AB_CM_inst/ADC_MODE_net_net_2\, 
        \AB_CM_inst/ADC_MODE_net_net_1\, 
        \AB_CM_inst/Z\\\\ADC_MODE_net\\\\\, 
        \AB_CM_inst/ADC_MODE_net[3]\, \AB_CM_inst/ADC_PDOWN_net\, 
        \AB_CM_inst/ADC_STC_net_net_6\, 
        \AB_CM_inst/ADC_STC_net_net_5\, 
        \AB_CM_inst/ADC_STC_net_net_4\, 
        \AB_CM_inst/ADC_STC_net_net_3\, 
        \AB_CM_inst/ADC_STC_net_net_2\, 
        \AB_CM_inst/ADC_STC_net_net_1\, 
        \AB_CM_inst/Z\\\\ADC_STC_net\\\\\, 
        \AB_CM_inst/ADC_STC_net[7]\, 
        \AB_CM_inst/ADC_TVC_net_net_6\, 
        \AB_CM_inst/ADC_TVC_net_net_5\, 
        \AB_CM_inst/ADC_TVC_net_net_4\, 
        \AB_CM_inst/ADC_TVC_net_net_3\, 
        \AB_CM_inst/ADC_TVC_net_net_2\, 
        \AB_CM_inst/ADC_TVC_net_net_1\, 
        \AB_CM_inst/Z\\\\ADC_TVC_net\\\\\, 
        \AB_CM_inst/ADC_TVC_net[7]\, 
        \AB_CM_inst/TR_RAM_DI_B_net[8]\, 
        \AB_CM_inst/TR_RAM_ADDR_B_net[8]\, 
        \AB_CM_inst/TR_RAM_DO_B_net[8]\, 
        \AB_CM_inst/TR_RAM_DO_B_net_0[8]\, 
        \AB_CM_inst/Z\\\\TR_RAM_DI_B_net\\\\\, 
        \AB_CM_inst/TR_RAM_DI_B_net_net_1\, 
        \AB_CM_inst/TR_RAM_DI_B_net_net_2\, 
        \AB_CM_inst/TR_RAM_DI_B_net_net_3\, 
        \AB_CM_inst/TR_RAM_DI_B_net_net_4\, 
        \AB_CM_inst/TR_RAM_DI_B_net_net_5\, 
        \AB_CM_inst/TR_RAM_DI_B_net_net_6\, 
        \AB_CM_inst/TR_RAM_DI_B_net_net_7\, 
        \AB_CM_inst/xgnmbzmtzbb_0\, \AB_CM_inst/TR_RAM_CSN_B_net\, 
        \AB_CM_inst/TR_RAM_RW_A_net\, 
        \AB_CM_inst/Z\\\\TR_RAM_ADDR_B_net\\\\\, 
        \AB_CM_inst/TR_RAM_ADDR_B_net_net_1\, 
        \AB_CM_inst/TR_RAM_ADDR_B_net_net_2\, 
        \AB_CM_inst/TR_RAM_ADDR_B_net_net_3\, 
        \AB_CM_inst/TR_RAM_ADDR_B_net_net_4\, 
        \AB_CM_inst/TR_RAM_ADDR_B_net_net_5\, 
        \AB_CM_inst/TR_RAM_ADDR_B_net_net_6\, 
        \AB_CM_inst/TR_RAM_ADDR_B_net_net_7\, 
        \AB_CM_inst/Z\\\\TR_RAM_DO_B_net\\\\\, 
        \AB_CM_inst/TR_RAM_DO_B_net_net_2\, 
        \AB_CM_inst/TR_RAM_DO_B_net_net_3\, 
        \AB_CM_inst/TR_RAM_DO_B_net_net_4\, 
        \AB_CM_inst/TR_RAM_DO_B_net_net_5\, 
        \AB_CM_inst/TR_RAM_DO_B_net_net_6\, 
        \AB_CM_inst/TR_RAM_DO_B_net_net_7\, 
        \AB_CM_inst/TR_RAM_DO_B_net_net_1\, 
        \AB_CM_inst/TR_RAM_DO_B_net_net_1_0\, 
        \AB_CM_inst/EV_RAM_ADDR_B_net[8]\, 
        \AB_CM_inst/ASSC_SEQOUT_net[5]\, 
        \AB_CM_inst/EV_ASSCADDR_net[8]\, 
        \AB_CM_inst/TR_EV_ADDR_net[8]\, 
        \AB_CM_inst/EV_RAM_ADDR_A_net[8]\, 
        \AB_CM_inst/ASSC_RAM_DO_A_net[8]\, 
        \AB_CM_inst/EV_CHHOLD_net[4]\, 
        \AB_CM_inst/EV_RAM_DO_B_net[8]\, 
        \AB_CM_inst/EV_RAM_DI_B_net[8]\, 
        \AB_CM_inst/Z\\\\EV_RAM_ADDR_B_net\\\\\, 
        \AB_CM_inst/EV_RAM_ADDR_B_net_net_2\, 
        \AB_CM_inst/EV_RAM_ADDR_B_net_net_4\, 
        \AB_CM_inst/EV_RAM_ADDR_B_net_net_7\, 
        \AB_CM_inst/Z\\\\ASSC_SEQOUT_net\\\\\, 
        \AB_CM_inst/Z\\\\EV_ASSCADDR_net\\\\\, 
        \AB_CM_inst/ASSC_SEQOUT_net_net_1\, 
        \AB_CM_inst/EV_ASSCADDR_net_net_1\, 
        \AB_CM_inst/ASSC_SEQOUT_net_net_2\, 
        \AB_CM_inst/EV_ASSCADDR_net_net_2\, 
        \AB_CM_inst/ASSC_SEQOUT_net_net_3\, 
        \AB_CM_inst/EV_ASSCADDR_net_net_3\, 
        \AB_CM_inst/ASSC_SEQOUT_net_net_4\, 
        \AB_CM_inst/EV_ASSCADDR_net_net_4\, 
        \AB_CM_inst/EV_EVFLAG_net\, \AB_CM_inst/EV_DONE_net\, 
        \AB_CM_inst/EV_RAM_WR_BUSY_B_net\, 
        \AB_CM_inst/EV_RAM_DI_B_net_net_1\, 
        \AB_CM_inst/Z\\\\EV_RAM_DI_B_net\\\\\, 
        \AB_CM_inst/ASSC_SAMPFLAG_net\, \AB_CM_inst/ktwrhqstzjg\, 
        \AB_CM_inst/N_266\, \AB_CM_inst/EV_RAM_RW_A_net\, 
        \AB_CM_inst/Z\\\\EV_CHHOLD_net\\\\\, 
        \AB_CM_inst/TR_EV_ADDR_net_net_7\, 
        \AB_CM_inst/EV_RAM_ADDR_A_net_net_7\, 
        \AB_CM_inst/TR_EV_ADDR_net_net_5\, 
        \AB_CM_inst/EV_RAM_ADDR_A_net_net_5\, 
        \AB_CM_inst/TR_EV_ADDR_net_net_4\, 
        \AB_CM_inst/EV_RAM_ADDR_A_net_net_4\, 
        \AB_CM_inst/TR_EV_ADDR_net_net_3\, 
        \AB_CM_inst/EV_RAM_ADDR_A_net_net_3\, 
        \AB_CM_inst/TR_EV_ADDR_net_net_2\, 
        \AB_CM_inst/EV_RAM_ADDR_A_net_net_2\, 
        \AB_CM_inst/TR_EV_ADDR_net_net_1\, 
        \AB_CM_inst/EV_RAM_ADDR_A_net_net_1\, 
        \AB_CM_inst/Z\\\\TR_EV_ADDR_net\\\\\, 
        \AB_CM_inst/Z\\\\EV_RAM_ADDR_A_net\\\\\, 
        \AB_CM_inst/TR_EV_ADDR_net_net_6\, 
        \AB_CM_inst/EV_RAM_ADDR_A_net_net_6\, 
        \AB_CM_inst/Z\\\\ASSC_RAM_DO_A_net\\\\\, 
        \AB_CM_inst/ASSC_RAM_DO_A_net_net_1\, 
        \AB_CM_inst/ASSC_RAM_DO_A_net_net_2\, 
        \AB_CM_inst/ASSC_RAM_DO_A_net_net_3\, 
        \AB_CM_inst/ASSC_RAM_DO_A_net_net_4\, 
        \AB_CM_inst/ASSC_RAM_DO_A_net_net_5\, 
        \AB_CM_inst/ASSC_RAM_DO_A_net_net_6\, 
        \AB_CM_inst/ASSC_RAM_DO_A_net_net_7\, 
        \AB_CM_inst/Z\\\\EV_RAM_DO_B_net\\\\\, 
        \AB_CM_inst/EV_RAM_DO_B_net_net_3\, 
        \AB_CM_inst/EV_RAM_DO_B_net_net_4\, 
        \AB_CM_inst/TR_EV_RD_net\, \AB_CM_inst/EV_RAM_CSN_A_net\, 
        \AB_CM_inst/EV_RAM_DI_B_net_net_2\, 
        \AB_CM_inst/EV_RAM_DI_B_net_net_4\, 
        \AB_CM_inst/EV_RAM_DI_B_net_net_5\, 
        \AB_CM_inst/EV_RAM_CSN_B_net\, 
        \AB_CM_inst/EV_ASSCADDR_net_net_5\, 
        \AB_CM_inst/EV_RAM_DO_B_net_net_2\, 
        \AB_CM_inst/EV_CHHOLD_net_net_3\, 
        \AB_CM_inst/EV_CHHOLD_net_net_2\, 
        \AB_CM_inst/EV_CHHOLD_net_net_1\, 
        \AB_CM_inst/EV_RAM_DO_B_net_net_1\, 
        \AB_CM_inst/EV_RAM_ADDR_B_net_net_1\, 
        \AB_CM_inst/EV_RAM_ADDR_B_net_net_5\, 
        \AB_CM_inst/EV_RAM_ADDR_B_net_net_3\, 
        \AB_CM_inst/EV_RAM_ADDR_B_net_net_6\, 
        \AB_CM_inst/bskrjhjvqpf_1_sqmuxa\, 
        \AB_CM_inst/EV_RAM_DO_B_net_net_5\, 
        \AB_CM_inst/EV_RAM_DO_B_net_net_6\, 
        \AB_CM_inst/EV_RAM_DO_B_net_net_7\, 
        \AB_CM_inst/EV_DONE_net_0\, 
        \AB_CM_inst/Z\\\\EV_RAM_DO_B_net\\\\_0\, 
        \AB_CM_inst/EV_RAM_DI_B_net_net_7\, 
        \AB_CM_inst/EV_RAM_DI_B_net_net_6\, 
        \AB_CM_inst/EV_RAM_DI_B_net_net_3\, 
        \AB_CM_inst/EV_RAM_DO_A_net_net_7\, 
        \AB_CM_inst/ASSC_RAM_DI_B_net[8]\, 
        \AB_CM_inst/ASSC_RAM_ADDR_A_net[8]\, 
        \AB_CM_inst/ASSC_RAM_DO_B_net[8]\, 
        \AB_CM_inst/Z\\\\ASSC_RAM_DI_B_net\\\\\, 
        \AB_CM_inst/ASSC_RAM_DI_B_net_net_1\, 
        \AB_CM_inst/ASSC_RAM_DI_B_net_net_2\, 
        \AB_CM_inst/ASSC_RAM_DI_B_net_net_3\, 
        \AB_CM_inst/ASSC_RAM_DI_B_net_net_4\, 
        \AB_CM_inst/ASSC_RAM_DI_B_net_net_5\, 
        \AB_CM_inst/ASSC_RAM_DI_B_net_net_6\, 
        \AB_CM_inst/ASSC_RAM_DI_B_net_net_7\, 
        \AB_CM_inst/ASSC_RAM_WR_BUSY_B_net\, 
        \AB_CM_inst/ddvbdtxtbpx_i\, 
        \AB_CM_inst/ASSC_RAM_RW_A_net\, 
        \AB_CM_inst/ASSC_RAM_CSN_A_net\, 
        \AB_CM_inst/ASSC_RAM_ADDR_B_net_net_5\, 
        \AB_CM_inst/ASSC_RAM_ADDR_B_net_net_6\, 
        \AB_CM_inst/ASSC_RAM_ADDR_B_net_net_7\, 
        \AB_CM_inst/Z\\\\ASSC_RAM_ADDR_A_net\\\\\, 
        \AB_CM_inst/ASSC_RAM_ADDR_A_net_net_1\, 
        \AB_CM_inst/ASSC_RAM_ADDR_A_net_net_2\, 
        \AB_CM_inst/ASSC_RAM_ADDR_A_net_net_3\, 
        \AB_CM_inst/ASSC_RAM_ADDR_A_net_net_4\, 
        \AB_CM_inst/ASSC_RAM_ADDR_A_net_net_5\, 
        \AB_CM_inst/ASSC_RAM_ADDR_A_net_net_6\, 
        \AB_CM_inst/ASSC_RAM_ADDR_A_net_net_7\, 
        \AB_CM_inst/Z\\\\ASSC_RAM_DO_B_net\\\\\, 
        \AB_CM_inst/ASSC_RAM_DO_B_net_net_1\, 
        \AB_CM_inst/ASSC_RAM_DO_B_net_net_2\, 
        \AB_CM_inst/ASSC_RAM_DO_B_net_net_3\, 
        \AB_CM_inst/ASSC_RAM_DO_B_net_net_4\, 
        \AB_CM_inst/ASSC_RAM_DO_B_net_net_5\, 
        \AB_CM_inst/ASSC_RAM_DO_B_net_net_6\, 
        \AB_CM_inst/ASSC_RAM_DO_B_net_net_7\, 
        \AB_CM_inst/TR_TRFLAG_net\, \AB_CM_inst/TR_DONE_net_i_0\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/gjkdbmpgrtc_12[8]_net_1\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_514\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/gjkdbmpgrtc_11[8]_net_1\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rdgwgtpkbgc_1[2]_net_1\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N293\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N253\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_282\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_278\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_265\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ftbkrvpxdbp[4]_net_1\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc_12[4]_net_1\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ADD_18x18_medium_I70_un1_Y\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N297\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ADD_18x18_medium_I62_un1_Y_0\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N311\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc_11_d[6]_net_1\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnvtvdkcnpp[6]_net_1\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc_11_d_d[6]_net_1\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc_11_d_s[4]_net_1\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_546\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/gjkdbmpgrtc_11_d[8]_net_1\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc_11_s[6]_net_1\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc[8]\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnvtvdkcnpp_0[2]_net_1\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx[5]_net_1\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/fqkdsnjfpdb[10]\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc[6]\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_716\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc_11[6]_net_1\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rdgwgtpkbgc_2[2]_net_1\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ADD_18x18_medium_I87_un1_Y\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/G_128_0_net_1\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ADD_18x18_medium_I9_P0N_0\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N349\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N310\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/I59_un1_Y\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ADD_18x18_medium_I47_un1_Y\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ADD_18x18_medium_I30_Y\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N295\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N306\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N289\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N290\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N288\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N250\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ADD_18x18_medium_I5_P0N\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ADD_18x18_medium_I9_G0N\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N262\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N261\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_287\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_283\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_260\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ftbkrvpxdbp[3]_net_1\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc[3]\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc_11_d_d[3]_net_1\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnvtvdkcnpp[1]_net_1\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc_11_d[3]_net_1\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc_11_d_s[3]_net_1\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rdgwgtpkbgc_0[1]_net_1\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_748\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc_11[8]_net_1\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_750\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc_11_d[8]_net_1\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_653\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc_12_d[3]_net_1\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc_12_s[4]_net_1\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc_12_d_d[3]_net_1\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc_12_d_s[3]_net_1\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc_12_d_0[8]_net_1\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rdgwgtpkbgc_0[2]_net_1\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_272\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_270\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/G_113_0_net_1\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ADD_18x18_medium_I102_Y_0\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/gjkdbmpgrtc[6]\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnvtvdkcnpp[0]_net_1\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ADD_18x18_medium_I68_Y_0\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N307\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/zbqggxmnpbs_0_iv[4]_net_1\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/zbqggxmnpbs_0_iv_0[4]_net_1\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_196\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/fqkdsnjfpdb_m[5]_net_1\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/fqkdsnjfpdb_m[14]_net_1\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ADD_18x18_medium_I4_P0N_0\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_262\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N345\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N354\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ADD_18x18_medium_I68_un1_Y_0\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/gjkdbmpgrtc[4]\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/fqkdsnjfpdb_i[14]\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ADD_18x18_medium_I85_Y\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc_12_d_0[4]_net_1\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc_11[4]_net_1\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc_11_d[4]_net_1\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc_11_d_d[4]_net_1\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rdgwgtpkbgc_0[0]_net_1\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc_11_s[4]_net_1\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/G_103_0_net_1\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N241\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N298\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ADD_18x18_medium_I62_un1_Y\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N271\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N270\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/I67_un1_Y\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ADD_18x18_medium_I67_Y_1\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ADD_18x18_medium_I84_un1_Y\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N277\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/zbqggxmnpbs_0_iv_1[0]_net_1\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/un2_pbzxzjhqhwz_m\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tddhwjzbsrj_m_net_1\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/fqkdsnjfpdb_m[6]_net_1\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N351\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_267\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/gjkdbmpgrtc[5]\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ftbkrvpxdbp[5]_net_1\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc[5]\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/fqkdsnjfpdb[6]\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ADD_18x18_medium_I89_Y\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/fqkdsnjfpdb[16]\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N276\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ADD_18x18_medium_I108_Y_0\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx_0[4]_net_1\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/zbqggxmnpbs_0_iv_0[1]_net_1\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/zbqggxmnpbs_0_iv[0]_net_1\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/fqkdsnjfpdb[15]\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/G_108_0_net_1\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc_11_d[5]_net_1\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnvtvdkcnpp[3]_net_1\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc_11_d_d[5]_net_1\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc_11[5]_net_1\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_749\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ADD_18x18_medium_I30_un1_Y\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N240\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N243\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N312\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N294\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/I61_un1_Y_i\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N246\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_715\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_206\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_209\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bskrjhjvqpf_1_sqmuxa_0\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_240\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bskrjhjvqpf_6_sqmuxa\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rdgwgtpkbgc_2[0]_net_1\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rdgwgtpkbgc_1[0]_net_1\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rdgwgtpkbgc_2[1]_net_1\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rdgwgtpkbgc_1[1]_net_1\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rgmpzqrbghh_0_net_1\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/hmzcpnxsdwg_net_1\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx_1[4]_net_1\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx_ns_i[13]_net_1\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx_0[8]_net_1\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx_ns_i[9]_net_1\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnvtvdkcnpp_9[2]_net_1\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/DWACT_ADD_CI_0_g_array_2[0]\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/DWACT_ADD_CI_0_g_array_1[0]\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/DWACT_ADD_CI_0_pog_array_2[0]\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/DWACT_ADD_CI_0_g_array_11[0]\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/DWACT_ADD_CI_0_pog_array_1_1[0]\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/DWACT_ADD_CI_0_TMP[0]\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/DWACT_ADD_CI_0_g_array_12[0]\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/G_158_0_net_1\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ADD_18x18_medium_I11_P0N_0\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/G_138_0_net_1\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N268\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_298\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_302\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_318\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_322\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N285\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/fqkdsnjfpdb[7]\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ckghxwbsztp_m[0]_net_1\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/zbqggxmnpbs_0_iv_0[2]_net_1\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/fqkdsnjfpdb[17]\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ckghxwbsztp_m[1]_net_1\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/fqkdsnjfpdb[1]\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ckghxwbsztp_m[3]_net_1\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/zbqggxmnpbs_0_iv_0[3]_net_1\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/fqkdsnjfpdb[0]\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ckghxwbsztp_m[2]_net_1\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_312\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_308\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ADD_18x18_medium_I109_Y_1\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_323_i\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnvtvdkcnpp[11]_net_1\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rqrqhcwpqdn[11]_net_1\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/gjkdbmpgrtc75\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/G_133_0_net_1\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_290\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_292\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ADD_18x18_medium_I107_Y_0\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_315\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_317\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ADD_18x18_medium_I104_Y_0\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N305\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N308\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ADD_18x18_medium_I67_Y_0\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N287\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N286\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ADD_18x18_medium_I75_Y_3\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N322\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ADD_18x18_medium_I75_un1_Y_0\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ADD_18x18_medium_I75_Y_2\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N303\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ADD_18x18_medium_I75_Y_1\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ADD_18x18_medium_I75_Y_0\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_268\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ADD_18x18_medium_I103_Y_0\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_295\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_297\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N309\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ADD_18x18_medium_I97_Y_0\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ADD_18x18_medium_I96_Y_0\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ADD_18x18_medium_I95_Y_0\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/G_99_0_net_1\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_253\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ADD_18x18_medium_I69_un1_Y_0\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/dhzrwbnrbpw_7_iv_0[7]\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_199_i_0\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/qrbxknbdvjj_m[7]_net_1\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/dhzrwbnrbpw_7_iv_0[6]\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/qrbxknbdvjj_m[6]_net_1\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N235\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N238\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N300\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/dhzrwbnrbpw_7_iv_0[8]\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/qrbxknbdvjj_m[8]_net_1\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/dhzrwbnrbpw_7_iv_0[5]\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/qrbxknbdvjj_m[5]_net_1\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/dhzrwbnrbpw_7_iv_1[4]\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/qrbxknbdvjj_m[4]_net_1\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/mtbjcfqsbqf_m[3]_net_1\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/jrgzmrqhbkv_m[4]_net_1\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_252\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_248\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/dhzrwbnrbpw_7_iv_0[3]\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/qrbxknbdvjj_m[3]_net_1\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ADD_18x18_medium_I93_Y_0\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/gjkdbmpgrtc[1]\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/G_89_0_net_1\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc[1]\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/dhzrwbnrbpw_7_iv_0[2]\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/qrbxknbdvjj_m[2]_net_1\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ADD_18x18_medium_I3_P0N_0\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ftbkrvpxdbp[2]_net_1\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/gjkdbmpgrtc[2]\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc[2]\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/dhzrwbnrbpw_7_iv_0[1]\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/qrbxknbdvjj_m[1]_net_1\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/gjkdbmpgrtc[3]\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ftbkrvpxdbp[1]_net_1\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ftbkrvpxdbp[0]_net_1\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnvtvdkcnpp[8]_net_1\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/gjkdbmpgrtc[14]\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnvtvdkcnpp[10]_net_1\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/gjkdbmpgrtc[16]\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/dhzrwbnrbpw_7_iv_0[0]\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/qrbxknbdvjj_m[0]_net_1\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx_ns_0[4]_net_1\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_239\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx_ns_a3_0_0[4]_net_1\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_228\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/kkjrqmngvjc_0_0_net_1\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx[1]_net_1\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_191_2\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/gjkdbmpgrtc75_0_a3_0_0_net_1\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bskrjhjvqpf_i_0_net_1\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx[15]_net_1\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx[9]_net_1\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_227_1\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx_ns_a3_0[6]_net_1\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_205\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/gpjgkmhxbkn_NE_2_net_1\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/gpjgkmhxbkn_1_i\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/gpjgkmhxbkn_2_i\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/gpjgkmhxbkn_0_i\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/gpjgkmhxbkn_NE_0_net_1\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rqrqhcwpqdn[5]_net_1\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/gpjgkmhxbkn_3_i\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/wqpbnjzjqsx_NE_2_net_1\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/wqpbnjzjqsx_3_i\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/wqpbnjzjqsx_4_i\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/wqpbnjzjqsx_0_i\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/wqpbnjzjqsx_NE_1_net_1\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rqrqhcwpqdn[3]_net_1\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/wqpbnjzjqsx_1_i\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bskrjhjvqpf_i_2_1_net_1\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx[6]_net_1\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx[17]_net_1\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_307\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_305\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/G_148_0_net_1\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/I49_un1_Y\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx_ns[14]\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_241\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx_ns[4]_net_1\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_216\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/I69_un1_Y\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N316\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N347\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/I57_un1_Y\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N363\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/I65_un1_Y\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/dhzrwbnrbpw_7[5]\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/jrgzmrqhbkv_m[5]_net_1\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/un1_dhzrwbnrbpw_m[6]_net_1\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/dhzrwbnrbpw_7[3]\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/jrgzmrqhbkv_m[3]_net_1\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/un1_dhzrwbnrbpw_m[4]_net_1\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/dhzrwbnrbpw_7[2]\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/jrgzmrqhbkv_m[2]_net_1\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/un1_dhzrwbnrbpw_m[3]_net_1\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/dhzrwbnrbpw_7[1]\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/jrgzmrqhbkv_m[1]_net_1\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/un1_dhzrwbnrbpw_m[2]_net_1\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_215\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bskrjhjvqpf_i_net_1\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_234\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx_ns[6]\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx[12]_net_1\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_277\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/gjkdbmpgrtc[7]\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc[7]\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/gjkdbmpgrtc[9]\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc[9]\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/gjkdbmpgrtc[10]\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnvtvdkcnpp[4]_net_1\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc[10]\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/gjkdbmpgrtc[11]\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnvtvdkcnpp[5]_net_1\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc[11]\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/gjkdbmpgrtc[13]\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnvtvdkcnpp[7]_net_1\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc[13]\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc[14]\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/gjkdbmpgrtc[15]\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnvtvdkcnpp[9]_net_1\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc[15]\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc[16]\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/dhzrwbnrbpw_7[8]\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_201_i_0\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/I_36\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/dhzrwbnrbpw_7[7]\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/I_34\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/dhzrwbnrbpw_7[6]\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/I_38\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/dhzrwbnrbpw_7[0]\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/DWACT_ADD_CI_0_partial_sum[0]\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/gjkdbmpgrtc[0]\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc[0]\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/fqkdsnjfpdb[2]\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N403_i\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/fqkdsnjfpdb[3]\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/fqkdsnjfpdb[4]\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ADD_18x18_medium_I90_un1_Y\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/fqkdsnjfpdb_i[5]\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_273\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/fqkdsnjfpdb_i[9]\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/fqkdsnjfpdb[13]\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_303\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/gjkdbmpgrtc[12]\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc[12]\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx_ns_i[1]_net_1\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/dhzrwbnrbpw_7[4]\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/I_30\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/fqkdsnjfpdb[12]\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/I86_un1_Y_i\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N264\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/fqkdsnjfpdb[11]\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/fqkdsnjfpdb[8]\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N397_i\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/fqkdsnjfpdb_m[2]_net_1\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ckghxwbsztp_m[4]_net_1\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/fqkdsnjfpdb_m[11]_net_1\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx[0]_net_1\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx[3]_net_1\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_275\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/G_118_0_net_1\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_787\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_753\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc_11_d[9]_net_1\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_751\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_788\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_752\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc_11_d[10]_net_1\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_754\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_650\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_966\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/gjkdbmpgrtc75_0_a3_0_1_net_1\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_789\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc_11_d[11]_net_1\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_967\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_584\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_548\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/gjkdbmpgrtc_11_d[10]_net_1\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_550\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rqrqhcwpqdn[4]_net_1\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rqrqhcwpqdn[2]_net_1\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_580\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/gjkdbmpgrtc_11_d[6]_net_1\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_544\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rqrqhcwpqdn[0]_net_1\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc_12_d_d[0]_net_1\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_625\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc_12_d_d_d[0]_net_1\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc_11_s[2]_net_1\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_608\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_654\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_646\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_645\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_747\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc_12_d[0]_net_1\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc_12_d_s[0]_net_1\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx_ns[16]\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx_ns_1[16]\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_237\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx_ns[15]\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_785\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc_11_d[7]_net_1\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_780\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc_11_d_0[2]_net_1\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc_11_s_0[2]_net_1\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/mvnkctvqsgp_net_1\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rfrdbqfdrhx[1]_net_1\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rfrdbqfdrhx[0]_net_1\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/kkgccghmrzf_net_1\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/un1_mvnkctvqsgp_net_1\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/un1_xkwrgrspmcf_net_1\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/un1_kkgccghmrzf_net_1\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/un1_qvqqfftqsfc_net_1\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/un3_qvqqfftqsfc_net_1\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx_ns[10]\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx_ns_i[3]_net_1\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx_ns_i[7]_net_1\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx[11]_net_1\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx_ns_i[12]_net_1\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx[14]_net_1\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_207\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx[2]_net_1\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N234\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N249\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N252\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N291\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N292\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ckghxwbsztp[3]_net_1\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnvtvdkcnpp_5[0]_net_1\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnvtvdkcnpp_5[1]_net_1\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnvtvdkcnpp_5[3]_net_1\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnvtvdkcnpp_5[4]_net_1\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnvtvdkcnpp_5[5]_net_1\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnvtvdkcnpp_5[7]_net_1\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnvtvdkcnpp_5[8]_net_1\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_450\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_510\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_884\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_511\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_443\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_451\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_512\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_444\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_452\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_446\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_968\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_515\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_447\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_939\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_540\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rqrqhcwpqdn[1]_net_1\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_541\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_542\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_543\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_545\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rqrqhcwpqdn[6]_net_1\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rqrqhcwpqdn[7]_net_1\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_547\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rqrqhcwpqdn[8]_net_1\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rqrqhcwpqdn[9]_net_1\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_549\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rqrqhcwpqdn[10]_net_1\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_583\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_585\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_453\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_586\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_587\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_888\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_947\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_890\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_948\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_892\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_949\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_951\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_952\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_940\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_941\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_942\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_943\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_944\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_910\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_945\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_589\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_946\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_590\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_609\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_626\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_643\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_644\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_727\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_728\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_651\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_652\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_656\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_711\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_712\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_648\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_647\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_655\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_717\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_649\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_657\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_719\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_953\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_744\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_745\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnvtvdkcnpp[2]_net_1\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_746\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rdgwgtpkbgc[0]_net_1\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_779\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_790\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_791\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_954\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_955\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_956\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rdgwgtpkbgc[2]_net_1\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_957\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_958\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_792\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_959\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_793\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_960\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_794\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_814\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_815\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_816\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_817\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_818\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_819\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_820\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_821\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_822\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_823\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_835\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_836\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_837\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_838\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/qrbxknbdvjj[0]_net_1\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/qrbxknbdvjj[1]_net_1\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/qrbxknbdvjj[2]_net_1\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx[8]_net_1\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/qrbxknbdvjj[3]_net_1\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rgmpzqrbghh_net_1\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/qrbxknbdvjj[5]_net_1\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/I_33\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/qrbxknbdvjj[6]_net_1\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/qrbxknbdvjj[7]_net_1\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/qrbxknbdvjj[8]_net_1\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ftbkrvpxdbp_5[0]_net_1\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ftbkrvpxdbp_5[1]_net_1\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ftbkrvpxdbp_5[2]_net_1\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ftbkrvpxdbp_5[3]_net_1\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ftbkrvpxdbp_5[4]_net_1\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ftbkrvpxdbp_5[5]_net_1\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnvtvdkcnpp_9[4]_net_1\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnvtvdkcnpp_9[8]_net_1\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_448\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_449\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_965\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_969\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_924\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bskrjhjvqpf_0_sqmuxa\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/dbdctxjdvkp_2_sqmuxa\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_938\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_901\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_950\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_445\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_513\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_581\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_509\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rdgwgtpkbgc[1]_net_1\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx_ns_i[11]_net_1\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx_ns_i[8]_net_1\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx[10]_net_1\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/un1_bskrjhjvqpf_6_sqmuxa_1_net_1\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_211\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/qmmwhjxxxmv_net_1\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/qrbxknbdvjj[4]_net_1\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx_ns_i[5]_net_1\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx[13]_net_1\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx_ns_i[2]_net_1\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx[16]_net_1\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx_ns[0]_net_1\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_923\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/spbznmtdmpd_net_1\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/gcqsptsqnzg\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ckghxwbsztp_3[4]\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ckghxwbsztp_3[3]\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ckghxwbsztp_3[2]\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/I_9\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ckghxwbsztp_3[1]\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ckghxwbsztp_3[0]\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnvtvdkcnpp_8[11]_net_1\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnvtvdkcnpp_8[10]_net_1\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnvtvdkcnpp_8[9]_net_1\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnvtvdkcnpp_9[11]_net_1\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnvtvdkcnpp_9[10]_net_1\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnvtvdkcnpp_9[9]_net_1\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnvtvdkcnpp_9[7]_net_1\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnvtvdkcnpp_9[6]_net_1\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnvtvdkcnpp_5[6]_net_1\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnvtvdkcnpp_9[5]_net_1\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx[4]_net_1\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnvtvdkcnpp_9[3]_net_1\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnvtvdkcnpp_5[2]_net_1\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnvtvdkcnpp_9[1]_net_1\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnvtvdkcnpp_9[0]_net_1\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/fqkdsnjfpdb_m[13]_net_1\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/fqkdsnjfpdb_m[3]_net_1\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ckghxwbsztp[4]_net_1\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ckghxwbsztp[2]_net_1\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ckghxwbsztp[1]_net_1\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ckghxwbsztp[0]_net_1\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tddhwjzbsrj_net_1\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/un2_pbzxzjhqhwz\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_203\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx_ns_i[17]_net_1\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ftbkrvpxdbp_1_sqmuxa_net_1\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_4\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/DWACT_FINC_E[0]\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_9\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/DWACT_COMP0_E[1]\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/DWACT_COMP0_E[2]\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/DWACT_COMP0_E[0]\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/DWACT_CMPLE_PO2_DWACT_COMP0_E[1]\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/DWACT_CMPLE_PO2_DWACT_COMP0_E[2]\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/DWACT_CMPLE_PO2_DWACT_COMP0_E[0]\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ACT_LT4_E[3]\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ACT_LT4_E[6]\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ACT_LT4_E[10]\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ACT_LT4_E[7]\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ACT_LT4_E[8]\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ACT_LT4_E[5]\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ACT_LT4_E[0]\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ACT_LT4_E[1]\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ACT_LT4_E[2]\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ACT_LT3_E[3]\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ACT_LT3_E[4]\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ACT_LT3_E[5]\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ACT_LT3_E[0]\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ACT_LT3_E[1]\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ACT_LT3_E[2]\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/DWACT_BL_EQUAL_0_E[2]\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/DWACT_BL_EQUAL_0_E[1]\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/DWACT_BL_EQUAL_0_E[0]\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_37\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_36\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_35\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_32\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_34\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_33\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_31\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_28\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_29\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_30\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/DWACT_BL_EQUAL_0_DWACT_ANDTREE_E[1]\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/DWACT_BL_EQUAL_0_DWACT_ANDTREE_E[0]\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/DWACT_BL_EQUAL_0_E[4]\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/DWACT_BL_EQUAL_0_E_0[0]\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/DWACT_BL_EQUAL_0_E_0[1]\, 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/DWACT_BL_EQUAL_0_E_0[2]\, 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/frcskdnwvmx_0[0]_net_1\, 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/frcskdnwvmx_ns_i[11]_net_1\, 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/frcskdnwvmx_0[8]_net_1\, 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/frcskdnwvmx_ns_i[3]_net_1\, 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/DWACT_ADD_CI_0_g_array_2[0]\, 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/DWACT_ADD_CI_0_g_array_1[0]\, 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/DWACT_ADD_CI_0_g_array_3[0]\, 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/DWACT_ADD_CI_0_g_array_11[0]\, 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/DWACT_ADD_CI_0_pog_array_1_1[0]\, 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/DWACT_ADD_CI_0_TMP[0]\, 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/frcskdnwvmx_i[0]_net_1\, 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/N_234_i\, 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/N_274\, 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/N_282\, 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/N_434\, 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/N_434_1\, 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/znjtscvsvcs\, 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/N_433\, 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/cpwfrthtnfr_13_sqmuxa_1\, 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/qxzrwpjhcww_m[0]\, 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/N_388\, 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/jnfrmfqggmk_net_1\, 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/N_385_i_i_0\, 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/hnbsspwxkpd_net_1\, 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/N_287\, 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/qgnzcpmbksd_7_0_iv_0[5]\, 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/N_310\, 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/tpxkpvnpvvn_m_0[5]_net_1\, 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/qgnzcpmbksd_7_0_iv_0[4]\, 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/tpxkpvnpvvn_m_0[4]_net_1\, 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/qgnzcpmbksd_7_0_iv_0[3]\, 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/tpxkpvnpvvn_m_0[3]_net_1\, 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/qgnzcpmbksd_7_0_iv_0[2]\, 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/tpxkpvnpvvn_m_0[2]_net_1\, 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/qgnzcpmbksd_7_0_iv_0[1]\, 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/tpxkpvnpvvn_m_0[1]_net_1\, 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/qgnzcpmbksd_7_iv_0[0]\, 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/N_288\, 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/tpxkpvnpvvn_m_0[0]_net_1\, 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/dttrrgvsnmg_iv_1_net_1\, 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/vmpskspphnb_m_net_1\, 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/vgdscntczht_m_net_1\, 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/un1_xjrbtnwdszs_1_sqmuxa_1\, 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/cpwfrthtnfr_11_sqmuxa\, 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/xjrbtnwdszs_1_sqmuxa_net_1\, 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/cpwfrthtnfr_10_sqmuxa\, 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/un1_xjrbtnwdszs_0_sqmuxa_0\, 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/dvqzjxhqhrh_net_1\, 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/frcskdnwvmx[2]_net_1\, 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/svpbmqwvncp_0_1_net_1\, 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/frcskdnwvmx[11]_net_1\, 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/jvxfmjbzjmc_i_a3_0_0_net_1\, 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/frcskdnwvmx[10]_net_1\, 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/frcskdnwvmx_ns_a3_4[0]_net_1\, 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/frcskdnwvmx_ns_a3_2[0]_net_1\, 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/un1_wjpccrvpdms\, 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/frcskdnwvmx[4]_net_1\, 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/frcskdnwvmx_ns_a3_1[0]_net_1\, 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/frcskdnwvmx[9]_net_1\, 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/frcskdnwvmx[6]_net_1\, 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/cvpkmgjqwzb_0_a2_0_o2_1_net_1\, 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/frcskdnwvmx[5]_net_1\, 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/frcskdnwvmx[7]_net_1\, 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/dttrrgvsnmg\, 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/sxrhkdkngbh_m_net_1\, 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/hnbsspwxkpd_m_net_1\, 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/un1_xjrbtnwdszs_1_sqmuxa\, 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/cpwfrthtnfr_13_sqmuxa_net_1\, 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/cpwfrthtnfr_14_sqmuxa\, 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/qgnzcpmbksd_7[5]\, 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/N_230_i_0\, 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/I_33_0\, 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/qgnzcpmbksd_7[3]\, 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/I_37_0\, 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/qgnzcpmbksd_7[2]\, 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/I_35_0\, 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/qgnzcpmbksd_7[1]\, 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/I_32_0\, 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/qgnzcpmbksd_7[0]\, 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/DWACT_ADD_CI_0_partial_sum[0]\, 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/N_272\, 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/N_233\, 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/frcskdnwvmx_ns_i[4]_net_1\, 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/N_271\, 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/N_264\, 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/qgnzcpmbksd_7[4]\, 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/I_30_0\, 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/N_247\, 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/frcskdnwvmx_ns[6]\, 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/N_289\, 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/un1_xjrbtnwdszs_0_sqmuxa\, 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/cpwfrthtnfr_12_sqmuxa\, 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/N_368\, 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/N_500\, 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/frcskdnwvmx_ns_i[5]_net_1\, 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/N_273\, 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/N_269_i\, 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/cpwfrthtnfr_10_sqmuxa_0_a3_0\, 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/frcskdnwvmx_ns_i[8]_net_1\, 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/frcskdnwvmx_ns_i[9]_net_1\, 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/frcskdnwvmx[1]_net_1\, 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/frcskdnwvmx[8]_net_1\, 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/tpxkpvnpvvn_m_0[7]_net_1\, 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/qgnzcpmbksd_7[7]\, 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/I_34_0\, 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/tpxkpvnpvvn_m[8]_net_1\, 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/qgnzcpmbksd_7[8]\, 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/I_36_0\, 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/N_235\, 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/N_236\, 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/cpwfrthtnfr_7_sqmuxa\, 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/N_285\, 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/frcskdnwvmx_ns[10]\, 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/frcskdnwvmx_ns[7]\, 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/qgnzcpmbksd_7[6]\, 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/I_38_0\, 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/tpxkpvnpvvn_m_0[6]_net_1\, 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/N_243\, 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/frcskdnwvmx_ns[0]_net_1\, 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/un1_frcskdnwvmx_3\, 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/N_248\, 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/frcskdnwvmx_ns_i[2]_net_1\, 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/frcskdnwvmx_ns_i[1]_net_1\, 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/jvxfmjbzjmc_i_net_1\, 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/N_262\, 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/frcskdnwvmx[0]_net_1\, 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/DWACT_ADD_CI_0_pog_array_1_2[0]\, 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/un1_AB_CM_inst_2_0\, 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/jzzdfrmzwdj_ns_i_1[3]_net_1\, 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/jzzdfrmzwdj_0[14]_net_1\, 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/N_200_i_0\, 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/jzzdfrmzwdj_0[4]_net_1\, 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/jzzdfrmzwdj_ns_i_1[11]_net_1\, 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/jdhgstfqkjm_2_i_net_1\, 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/jdhgstfqkjm_2_net_1\, 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/jzzdfrmzwdj_ns_1_0[0]_net_1\, 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/N_310\, 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/N_253\, 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/N_256\, 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/ddvbdtxtbpx_i_0_net_1\, 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/bksczsjcvgb_net_1\, 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/jzzdfrmzwdj[15]_net_1\, 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/wwhrbsjdjpn_net_1\, 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/jzzdfrmzwdj_ns_i_2[2]_net_1\, 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/jzzdfrmzwdj[13]_net_1\, 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/jzzdfrmzwdj_ns_i_0[2]_net_1\, 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/N_250\, 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/jzzdfrmzwdj_ns_i_0[15]_net_1\, 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/znbkwkbspdc_net_1\, 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/jzzdfrmzwdj_ns_i_a3_0[14]_net_1\, 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/jzzdfrmzwdj_i[1]\, 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/ddvbdtxtbpx_i_2_0_net_1\, 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/jzzdfrmzwdj[5]_net_1\, 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/znbkwkbspdc_1_i_a3_0_net_1\, 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/un1_sgbwkmbvtjw_0_a3_0_net_1\, 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/jzzdfrmzwdj_ns_i_0[13]_net_1\, 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/un6_bdbpcvshhqt_1_net_1\, 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/N_248\, 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/un1_AB_CM_assc_wrapper_inst\, 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/N_202_i_0\, 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/N_278\, 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/N_232_1\, 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/N_232_2\, 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/N_226_i_0\, 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/N_305\, 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/N_303\, 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/N_254_i_0\, 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/un1_bksnhfwfshc_1_sqmuxa\, 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/un1_cfxfrwgjccr_1_net_1\, 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/jzzdfrmzwdj_ns[0]\, 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/bksnhfwfshc_6_sqmuxa\, 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/N_317\, 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/bksnhfwfshc\, 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/N_184_m_net_1\, 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/un1_znbmnfdbzvr_m_net_1\, 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/N_228_i_0\, 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/N_262\, 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/jzzdfrmzwdj[0]_net_1\, 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/N_267\, 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/N_224_i_0\, 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/N_318\, 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/jzzdfrmzwdj_ns_i_1[10]_net_1\, 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/jzzdfrmzwdj[6]_net_1\, 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/N_311\, 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/N_272\, 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/jzzdfrmzwdj_ns_i_0_tz[9]_net_1\, 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/jzzdfrmzwdj_ns_i[9]_net_1\, 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/jzzdfrmzwdj[7]_net_1\, 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/jzzdfrmzwdj_ns_i_1[5]_net_1\, 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/jzzdfrmzwdj[11]_net_1\, 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/wkpfnwqwgcb_net_1\, 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/un4_wkpfnwqwgcb_net_1\, 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/un1_cfxfrwgjccr_6_net_1\, 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/znbmnfdbzvr_net_1\, 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/un1_bksnhfwfshc_1_sqmuxa_0_a3_net_1\, 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/znbmnfdbzvr_38_net_1\, 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/bcmkdjqtngz_1_net_1\, 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/jzzdfrmzwdj_ns_i_1[4]_net_1\, 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/N_314\, 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/N_315\, 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/bnrsdrtmtsg_5[0]_net_1\, 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/N_353\, 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/bnrsdrtmtsg_5[1]_net_1\, 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/N_354\, 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/bnrsdrtmtsg_5[2]_net_1\, 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/N_355\, 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/bnrsdrtmtsg_5[3]_net_1\, 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/N_356\, 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/bnrsdrtmtsg_5[4]_net_1\, 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/N_357\, 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/bnrsdrtmtsg_5[5]_net_1\, 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/N_358\, 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/hgqdwrxvgzm_3[0]_net_1\, 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/trnwxjxxrbp[0]_net_1\, 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/N_345\, 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/hgqdwrxvgzm_3[1]_net_1\, 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/trnwxjxxrbp[1]_net_1\, 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/hgqdwrxvgzm_3[2]_net_1\, 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/trnwxjxxrbp[2]_net_1\, 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/hgqdwrxvgzm_3[3]_net_1\, 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/trnwxjxxrbp[3]_net_1\, 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/hgqdwrxvgzm_3[4]_net_1\, 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/trnwxjxxrbp[4]_net_1\, 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/hgqdwrxvgzm_3[5]_net_1\, 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/trnwxjxxrbp[5]_net_1\, 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/jzzdfrmzwdj_ns_i_1[6]_net_1\, 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/jzzdfrmzwdj_i[10]\, 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/un1_cfxfrwgjccr_9_net_1\, 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/hgqdwrxvgzm[0]_net_1\, 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/hgqdwrxvgzm[1]_net_1\, 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/hgqdwrxvgzm[2]_net_1\, 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/hgqdwrxvgzm[3]_net_1\, 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/hgqdwrxvgzm[4]_net_1\, 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/hgqdwrxvgzm[5]_net_1\, 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/jzzdfrmzwdj[14]_net_1\, 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/jzzdfrmzwdj_i_0[3]\, 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/jzzdfrmzwdj_i_0[2]\, 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/N_263\, 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/hdxtpkktfvz\, 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/N_251\, 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/un1_cfxfrwgjccr_7\, 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/jzzdfrmzwdj_ns_i_1[7]_net_1\, 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/jzzdfrmzwdj[9]_net_1\, 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/jzzdfrmzwdj_ns_i_1[8]_net_1\, 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/jzzdfrmzwdj_ns_i_1[12]_net_1\, 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/jzzdfrmzwdj[4]_net_1\, 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/jzzdfrmzwdj[12]_net_1\, 
        \Diff2_pad[0]/U0/NET1\, \Diff2_pad[0]/U0/NET2\, 
        \Diff4_pad[2]/U0/NET1\, \Diff4_pad[2]/U0/NET2\, 
        \Diff3_pad[9]/U0/NET1\, \Diff3_pad[9]/U0/NET2\, 
        \Diff4_pad[1]/U0/NET1\, \Diff4_pad[1]/U0/NET2\, 
        \Diff2_pad[10]/U0/NET1\, \Diff2_pad[10]/U0/NET2\, 
        \Latest_Update_pad[2]/U0/NET1\, 
        \Latest_Update_pad[2]/U0/NET2\, \Diff3_pad[0]/U0/NET1\, 
        \Diff3_pad[0]/U0/NET2\, \Diff4_pad[6]/U0/NET1\, 
        \Diff4_pad[6]/U0/NET2\, \Diff0_pad[6]/U0/NET1\, 
        \Diff0_pad[6]/U0/NET2\, \Diff3_pad[8]/U0/NET1\, 
        \Diff3_pad[8]/U0/NET2\, \Diff0_pad[5]/U0/NET1\, 
        \Diff0_pad[5]/U0/NET2\, \Diff5_pad[0]/U0/NET1\, 
        \Diff5_pad[0]/U0/NET2\, \Diff5_pad[2]/U0/NET1\, 
        \Diff5_pad[2]/U0/NET2\, \Diff3_pad[6]/U0/NET1\, 
        \Diff3_pad[6]/U0/NET2\, \Diff2_pad[6]/U0/NET1\, 
        \Diff2_pad[6]/U0/NET2\, \Diff4_pad[11]/U0/NET1\, 
        \Diff4_pad[11]/U0/NET2\, \Diff3_pad[1]/U0/NET1\, 
        \Diff3_pad[1]/U0/NET2\, \Diff5_pad[10]/U0/NET1\, 
        \Diff5_pad[10]/U0/NET2\, \Diff2_pad[2]/U0/NET1\, 
        \Diff2_pad[2]/U0/NET2\, \SPARE_pad/U0/NET1\, 
        \SPARE_pad/U0/NET2\, \Diff0_pad[10]/U0/NET1\, 
        \Diff0_pad[10]/U0/NET2\, \Diff3_pad[10]/U0/NET1\, 
        \Diff3_pad[10]/U0/NET2\, \Diff4_pad[5]/U0/NET1\, 
        \Diff4_pad[5]/U0/NET2\, \Diff1_pad[0]/U0/NET1\, 
        \Diff1_pad[0]/U0/NET2\, \Diff1_pad[1]/U0/NET1\, 
        \Diff1_pad[1]/U0/NET2\, \Diff2_pad[11]/U0/NET1\, 
        \Diff2_pad[11]/U0/NET2\, \Diff4_pad[4]/U0/NET1\, 
        \Diff4_pad[4]/U0/NET2\, \Diff4_pad[9]/U0/NET1\, 
        \Diff4_pad[9]/U0/NET2\, \New_Measurement_pad/U0/NET1\, 
        \New_Measurement_pad/U0/NET2\, \Diff0_pad[7]/U0/NET1\, 
        \Diff0_pad[7]/U0/NET2\, \Diff5_pad[3]/U0/NET1\, 
        \Diff5_pad[3]/U0/NET2\, \Diff1_pad[5]/U0/NET1\, 
        \Diff1_pad[5]/U0/NET2\, \Diff2_pad[8]/U0/NET1\, 
        \Diff2_pad[8]/U0/NET2\, \Diff3_pad[3]/U0/NET1\, 
        \Diff3_pad[3]/U0/NET2\, \Diff1_pad[8]/U0/NET1\, 
        \Diff1_pad[8]/U0/NET2\, \Diff1_pad[10]/U0/NET1\, 
        \Diff1_pad[10]/U0/NET2\, \Diff5_pad[8]/U0/NET1\, 
        \Diff5_pad[8]/U0/NET2\, \Diff5_pad[7]/U0/NET1\, 
        \Diff5_pad[7]/U0/NET2\, \Diff5_pad[6]/U0/NET1\, 
        \Diff5_pad[6]/U0/NET2\, \Diff2_pad[7]/U0/NET1\, 
        \Diff2_pad[7]/U0/NET2\, \Diff0_pad[3]/U0/NET1\, 
        \Diff0_pad[3]/U0/NET2\, \SYSRSTn_pad/U0/NET1\, 
        \Diff4_pad[7]/U0/NET1\, \Diff4_pad[7]/U0/NET2\, 
        \Diff5_pad[11]/U0/NET1\, \Diff5_pad[11]/U0/NET2\, 
        \Diff5_pad[1]/U0/NET1\, \Diff5_pad[1]/U0/NET2\, 
        \Diff4_pad[0]/U0/NET1\, \Diff4_pad[0]/U0/NET2\, 
        \Diff4_pad[8]/U0/NET1\, \Diff4_pad[8]/U0/NET2\, 
        \Diff0_pad[4]/U0/NET1\, \Diff0_pad[4]/U0/NET2\, 
        \Diff0_pad[1]/U0/NET1\, \Diff0_pad[1]/U0/NET2\, 
        \Diff2_pad[1]/U0/NET1\, \Diff2_pad[1]/U0/NET2\, 
        \Diff2_pad[9]/U0/NET1\, \Diff2_pad[9]/U0/NET2\, 
        \Diff0_pad[11]/U0/NET1\, \Diff0_pad[11]/U0/NET2\, 
        \Diff1_pad[6]/U0/NET1\, \Diff1_pad[6]/U0/NET2\, 
        \Diff2_pad[3]/U0/NET1\, \Diff2_pad[3]/U0/NET2\, 
        \Diff3_pad[11]/U0/NET1\, \Diff3_pad[11]/U0/NET2\, 
        \Diff1_pad[9]/U0/NET1\, \Diff1_pad[9]/U0/NET2\, 
        \Diff0_pad[8]/U0/NET1\, \Diff0_pad[8]/U0/NET2\, 
        \Diff5_pad[9]/U0/NET1\, \Diff5_pad[9]/U0/NET2\, 
        \Diff3_pad[4]/U0/NET1\, \Diff3_pad[4]/U0/NET2\, 
        \Latest_Update_pad[1]/U0/NET1\, 
        \Latest_Update_pad[1]/U0/NET2\, \Diff3_pad[2]/U0/NET1\, 
        \Diff3_pad[2]/U0/NET2\, \Latest_Update_pad[0]/U0/NET1\, 
        \Latest_Update_pad[0]/U0/NET2\, \Diff5_pad[5]/U0/NET1\, 
        \Diff5_pad[5]/U0/NET2\, \Diff0_pad[9]/U0/NET1\, 
        \Diff0_pad[9]/U0/NET2\, \Diff0_pad[2]/U0/NET1\, 
        \Diff0_pad[2]/U0/NET2\, \Diff1_pad[11]/U0/NET1\, 
        \Diff1_pad[11]/U0/NET2\, \Diff5_pad[4]/U0/NET1\, 
        \Diff5_pad[4]/U0/NET2\, \Diff1_pad[7]/U0/NET1\, 
        \Diff1_pad[7]/U0/NET2\, \Diff1_pad[2]/U0/NET1\, 
        \Diff1_pad[2]/U0/NET2\, \Diff2_pad[4]/U0/NET1\, 
        \Diff2_pad[4]/U0/NET2\, \Diff0_pad[0]/U0/NET1\, 
        \Diff0_pad[0]/U0/NET2\, \SYSCLK_pad/U0/NET1\, 
        \Diff4_pad[10]/U0/NET1\, \Diff4_pad[10]/U0/NET2\, 
        \Diff2_pad[5]/U0/NET1\, \Diff2_pad[5]/U0/NET2\, 
        \Diff1_pad[4]/U0/NET1\, \Diff1_pad[4]/U0/NET2\, 
        \Diff4_pad[3]/U0/NET1\, \Diff4_pad[3]/U0/NET2\, 
        \Diff3_pad[5]/U0/NET1\, \Diff3_pad[5]/U0/NET2\, 
        \Diff1_pad[3]/U0/NET1\, \Diff1_pad[3]/U0/NET2\, 
        \Diff3_pad[7]/U0/NET1\, \Diff3_pad[7]/U0/NET2\, 
        SOC_VCC_NET, \GND\, AFLSDF_VCC, AFLSDF_GND : std_logic;
    signal GND_power_net1 : std_logic;
    signal VCC_power_net1 : std_logic;
    signal nc34, nc9, nc13, nc23, nc33, nc16, nc26, nc27, nc17, 
        nc5, nc4, nc25, nc15, nc35, nc28, nc18, nc1, nc2, nc22, 
        nc12, nc21, nc11, nc3, nc32, nc31, nc7, nc6, nc19, nc29, 
        nc8, nc20, nc10, nc24, nc14, nc30 : std_logic;

begin 

    AFLSDF_GND <= GND_power_net1;
    \GND\ <= GND_power_net1;
    AFLSDF_VCC <= VCC_power_net1;
    SOC_VCC_NET <= VCC_power_net1;

    \COMP_SM_inst/Diff_5[7]\ : DFN1E1C0
      port map(D => \COMP_SM_inst/Result[7]\, CLK => SYSCLK_c, 
        CLR => SYSRSTn_c, E => 
        \COMP_SM_inst/Latest_Update_5_sqmuxa\, Q => \Diff5_c[7]\);
    
    \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/G_94\ : 
        XNOR3
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/gjkdbmpgrtc[2]\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ftbkrvpxdbp[2]_net_1\, 
        C => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc[2]\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_252\);
    
    \COMP_SM_inst/Diff_4[6]\ : DFN1E1C0
      port map(D => \COMP_SM_inst/Result[6]\, CLK => SYSCLK_c, 
        CLR => SYSRSTn_c, E => 
        \COMP_SM_inst/Latest_Update_4_sqmuxa\, Q => \Diff4_c[6]\);
    
    \AB_CM_inst/AB_CM_smtr_ram_inst/AB_CM_smtr_ram_R0C0_0_0\ : 
        BUFF
      port map(A => \AB_CM_inst/TR_RAM_DO_B_net_net_1\, Y => 
        \AB_CM_inst/TR_RAM_DO_B_net_net_1_0\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rqrqhcwpqdn_5_0[7]\ : 
        MX2
      port map(A => \AB_CM_inst/Z\\\\ASSC_RAM_DO_A_net\\\\\, B
         => \AB_CM_inst/Z\\\\EV_RAM_DO_B_net\\\\\, S => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/un1_xkwrgrspmcf_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_821\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/pptwzsjcmcz_dhzrwbnrbpw_7_iv_0[8]\ : 
        AOI1B
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_199_i_0\, 
        B => \AB_CM_inst/EV_RAM_DO_B_net[8]\, C => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/qrbxknbdvjj_m[8]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/dhzrwbnrbpw_7_iv_0[8]\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx[9]\ : 
        DFN1C0
      port map(D => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx_ns_i[8]_net_1\, 
        CLK => SYSCLK_c, CLR => SYSRSTn_c, Q => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx[9]_net_1\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/gjkdbmpgrtc_12[14]\ : 
        MX2
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_944\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_910\, 
        S => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rdgwgtpkbgc_2[2]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/gjkdbmpgrtc[14]\);
    
    \COMP_SM_inst/pres_state_ns_a5_0_a2_0[1]\ : OR2A
      port map(A => \COMP_SM_inst/N_372\, B => \ADC_CHNUMBER[0]\, 
        Y => \COMP_SM_inst/N_417\);
    
    \COMP_SM_inst/Diff_0[8]\ : DFN1E1C0
      port map(D => \COMP_SM_inst/Result[8]\, CLK => SYSCLK_c, 
        CLR => SYSRSTn_c, E => 
        \COMP_SM_inst/Latest_Update_0_sqmuxa\, Q => \Diff0_c[8]\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/dhzrwbnrbpw[7]\ : 
        DFN1C0
      port map(D => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/dhzrwbnrbpw_7[7]\, 
        CLK => SYSCLK_c, CLR => SYSRSTn_c, Q => 
        \AB_CM_inst/Z\\\\EV_RAM_ADDR_B_net\\\\\);
    
    
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/jngpzgpmcms\ : 
        OR2A
      port map(A => INIT_ASSC_WEN, B => INIT_DONE, Y => 
        \AB_CM_inst/ASSC_RAM_RW_A_net\);
    
    
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/init_fsm/u_stnpfdkggvx/un1_rhjctqnqzsn_I_10\ : 
        AX1C
      port map(A => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/gpbbjwsprsj[0]\, 
        B => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/init_fsm/u_stnpfdkggvx/mwtvnzdkmwm[2]_net_1\, 
        C => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/gpbbjwsprsj[1]\, 
        Y => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/init_fsm/u_stnpfdkggvx/I_10\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/gjkdbmpgrtc_11[13]\ : 
        MX2
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_939\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rqrqhcwpqdn[7]_net_1\, 
        S => 
        \AB_CM_inst.AB_CM_smev_wrapper_inst.U0.u_nbnjbfrkqwq.rdgwgtpkbgc[3]\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_587\);
    
    
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/jvxfmjbzjmc_i_a3\ : 
        NOR3
      port map(A => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/N_287\, 
        B => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/frcskdnwvmx[10]_net_1\, 
        C => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/N_236\, 
        Y => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/N_262\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc_11[9]\ : 
        MX2
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_753\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc_11_d[9]_net_1\, 
        S => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc_11_s[4]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_787\);
    
    \Diff2_pad[7]/U0/U0\ : IOPAD_TRI
      port map(D => \Diff2_pad[7]/U0/NET1\, E => 
        \Diff2_pad[7]/U0/NET2\, PAD => Diff2(7));
    
    
        \COMP_SM_inst/Subtract_inst/sumAux_0_0_SUB_12x12_medium_area_I13_CO1\ : 
        NOR2A
      port map(A => \COMP_SM_inst/R1[1]_net_1\, B => 
        \COMP_SM_inst/R2[1]_net_1\, Y => 
        \COMP_SM_inst/Subtract_inst/N142\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/gjkdbmpgrtc_7[7]\ : 
        MX2
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_445\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_453\, 
        S => 
        \AB_CM_inst.AB_CM_smev_wrapper_inst.U0.u_nbnjbfrkqwq.rdgwgtpkbgc[3]\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_513\);
    
    
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/jzzdfrmzwdj_ns_i_1[10]\ : 
        NOR3B
      port map(A => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/jzzdfrmzwdj[6]_net_1\, 
        B => INIT_DONE, C => \AB_CM_inst/ADC_BUSY_net\, Y => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/jzzdfrmzwdj_ns_i_1[10]_net_1\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/dhzrwbnrbpw[3]\ : 
        DFN1C0
      port map(D => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/dhzrwbnrbpw_7[3]\, 
        CLK => SYSCLK_c, CLR => SYSRSTn_c, Q => 
        \AB_CM_inst/EV_RAM_ADDR_B_net_net_4\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx_ns_i[9]\ : 
        NOR2B
      port map(A => INIT_DONE, B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx[9]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx_ns_i[9]_net_1\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc_7[2]\ : 
        MX2
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_644\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_648\, 
        S => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rdgwgtpkbgc_2[2]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_712\);
    
    \COMP_SM_inst/Diff_0[2]\ : DFN1E1C0
      port map(D => \COMP_SM_inst/Result[2]\, CLK => SYSCLK_c, 
        CLR => SYSRSTn_c, E => 
        \COMP_SM_inst/Latest_Update_0_sqmuxa\, Q => \Diff0_c[2]\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/qrbxknbdvjj[8]\ : 
        DFN1E1C0
      port map(D => \AB_CM_inst/EV_RAM_ADDR_B_net[8]\, CLK => 
        SYSCLK_c, CLR => SYSRSTn_c, E => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx[11]_net_1\, 
        Q => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/qrbxknbdvjj[8]_net_1\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/wqpbnjzjqsx_1\ : 
        XNOR2
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rqrqhcwpqdn[2]_net_1\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnvtvdkcnpp[2]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/wqpbnjzjqsx_1_i\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/un1_dhzrwbnrbpw_I_36\ : 
        AX1C
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/DWACT_ADD_CI_0_g_array_2[0]\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/DWACT_ADD_CI_0_pog_array_2[0]\, 
        C => \AB_CM_inst/EV_RAM_ADDR_B_net[8]\, Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/I_36\);
    
    \COMP_SM_inst/Diff_1[2]\ : DFN1E1C0
      port map(D => \COMP_SM_inst/Result[2]\, CLK => SYSCLK_c, 
        CLR => SYSRSTn_c, E => 
        \COMP_SM_inst/Latest_Update_1_sqmuxa\, Q => \Diff1_c[2]\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/fqkdsnjfpdb_0_0_ADD_18x18_medium_I21_Y\ : 
        OAI1
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_312\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_308\, 
        C => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N271\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N287\);
    
    \COMP_SM_inst/New_Measurement\ : DFN1C0
      port map(D => \COMP_SM_inst/completed_sync_net_1\, CLK => 
        SYSCLK_c, CLR => SYSRSTn_c, Q => New_Measurement_c);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx_ns_a3_0_0[4]\ : 
        NOR2B
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_227_1\, 
        B => INIT_DONE, Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx_ns_a3_0_0[4]_net_1\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx[12]\ : 
        DFN1C0
      port map(D => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx_ns_i[5]_net_1\, 
        CLK => SYSCLK_c, CLR => SYSRSTn_c, Q => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx[12]_net_1\);
    
    
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/brxxctcvrmh_un1_wjpccrvpdms_0_o3\ : 
        NOR2
      port map(A => \AB_CM_inst/EV_DONE_net\, B => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/frcskdnwvmx[1]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/un1_wjpccrvpdms\);
    
    \COMP_SM_inst/valid_8_0_0_a4_0_1\ : NOR3A
      port map(A => \COMP_SM_inst/prev_channel[0]_net_1\, B => 
        \COMP_SM_inst/prev_channel[3]_net_1\, C => 
        \COMP_SM_inst/prev_channel[4]_net_1\, Y => 
        \COMP_SM_inst/valid_8_0_0_a4_0_1_net_1\);
    
    
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/svpqbbcnvqz[2]\ : 
        OR3
      port map(A => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/jzzdfrmzwdj_0[4]_net_1\, 
        B => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/un1_AB_CM_inst_2_0\, 
        C => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/N_267\, 
        Y => \AB_CM_inst/ASSC_RAM_ADDR_B_net_net_5\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx_ns_i[3]\ : 
        NOR2B
      port map(A => INIT_DONE, B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx[15]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx_ns_i[3]_net_1\);
    
    
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/address_gen/u_dxwqxgdccxc/un1_gnmdxrqrdgs_I_47\ : 
        NOR2B
      port map(A => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/address_gen/u_dxwqxgdccxc/DWACT_ADD_CI_0_g_array_2[0]\, 
        B => \INIT_ADDR[4]\, Y => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/address_gen/u_dxwqxgdccxc/DWACT_ADD_CI_0_g_array_12_1[0]\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/gjkdbmpgrtc_12[7]\ : 
        MX2
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_513\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_581\, 
        S => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rdgwgtpkbgc[2]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/gjkdbmpgrtc[7]\);
    
    
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/pfkhhxxsrzp[3]\ : 
        DFN1E1C0
      port map(D => \AB_CM_inst/ASSC_RAM_DO_B_net[8]\, CLK => 
        SYSCLK_c, CLR => SYSRSTn_c, E => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/jzzdfrmzwdj[12]_net_1\, 
        Q => \AB_CM_inst/ADC_MODE_net[3]\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/fqkdsnjfpdb_0_0_ADD_18x18_medium_I59_un1_Y\ : 
        OA1B
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ADD_18x18_medium_I47_un1_Y\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ADD_18x18_medium_I30_Y\, 
        C => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N311\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/I59_un1_Y\);
    
    
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/tpxkpvnpvvn_m_0[4]\ : 
        OR3B
      port map(A => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/frcskdnwvmx[8]_net_1\, 
        B => \AB_CM_inst/TR_RAM_DO_B_net_net_3\, C => 
        \AB_CM_inst/EV_DONE_net\, Y => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/tpxkpvnpvvn_m_0[4]_net_1\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/gjkdbmpgrtc_7_i[1]\ : 
        NOR2B
      port map(A => 
        \AB_CM_inst.AB_CM_smev_wrapper_inst.U0.u_nbnjbfrkqwq.rdgwgtpkbgc[3]\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_447\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_890\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/fqkdsnjfpdb_0_0_ADD_18x18_medium_I106_Y\ : 
        XOR3
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_312\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_308\, 
        C => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ADD_18x18_medium_I85_Y\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/fqkdsnjfpdb_i[14]\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc_7_0_a3[12]\ : 
        NOR2A
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_654\, 
        B => 
        \AB_CM_inst.AB_CM_smev_wrapper_inst.U0.u_nbnjbfrkqwq.rdgwgtpkbgc[3]\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_956\);
    
    \Diff4_pad[10]/U0/U0\ : IOPAD_TRI
      port map(D => \Diff4_pad[10]/U0/NET1\, E => 
        \Diff4_pad[10]/U0/NET2\, PAD => Diff4(10));
    
    \Diff0_pad[1]/U0/U1\ : IOTRI_OB_EB
      port map(D => \Diff0_c[1]\, E => SOC_VCC_NET, DOUT => 
        \Diff0_pad[1]/U0/NET1\, EOUT => \Diff0_pad[1]/U0/NET2\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/fqkdsnjfpdb_0_0_ADD_18x18_medium_I67_Y_1\ : 
        AO1
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N305\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N308\, 
        C => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ADD_18x18_medium_I67_Y_0\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ADD_18x18_medium_I67_Y_1\);
    
    
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/address_gen/u_dxwqxgdccxc/un1_gnmdxrqrdgs_I_42\ : 
        NOR2B
      port map(A => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/address_gen/u_dxwqxgdccxc/DWACT_ADD_CI_0_g_array_2[0]\, 
        B => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/address_gen/u_dxwqxgdccxc/DWACT_ADD_CI_0_pog_array_1_1[0]\, 
        Y => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/address_gen/u_dxwqxgdccxc/DWACT_ADD_CI_0_g_array_11[0]\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/fqkdsnjfpdb_m[5]\ : 
        OR2A
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx_0[4]_net_1\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/fqkdsnjfpdb_i[5]\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/fqkdsnjfpdb_m[5]_net_1\);
    
    
        \COMP_SM_inst/Subtract_inst/sumAux_0_0_SUB_12x12_medium_area_I61_un1_Y\ : 
        NOR2B
      port map(A => \COMP_SM_inst/Subtract_inst/N210\, B => 
        \COMP_SM_inst/Subtract_inst/N207\, Y => 
        \COMP_SM_inst/Subtract_inst/I61_un1_Y\);
    
    \COMP_SM_inst/Diff_1[8]\ : DFN1E1C0
      port map(D => \COMP_SM_inst/Result[8]\, CLK => SYSCLK_c, 
        CLR => SYSRSTn_c, E => 
        \COMP_SM_inst/Latest_Update_1_sqmuxa\, Q => \Diff1_c[8]\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc_7_0_a3[14]\ : 
        NOR2A
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_656\, 
        B => 
        \AB_CM_inst.AB_CM_smev_wrapper_inst.U0.u_nbnjbfrkqwq.rdgwgtpkbgc[3]\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_958\);
    
    
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/address_gen/u_dxwqxgdccxc/ggfvvjbkdws[3]\ : 
        MX2C
      port map(A => \INIT_ADDR[3]\, B => \INIT_ADDR[2]\, S => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/ggsxvgncrgz[0]\, 
        Y => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/ggfvvjbkdws[3]\);
    
    \AB_CM_inst/AB_CM_assc_ram_inst/AB_CM_assc_ram_R0C0\ : RAM4K9
      port map(ADDRA11 => AFLSDF_GND, ADDRA10 => AFLSDF_GND, 
        ADDRA9 => AFLSDF_GND, ADDRA8 => 
        \AB_CM_inst/ASSC_RAM_ADDR_A_net[8]\, ADDRA7 => 
        \AB_CM_inst/Z\\\\ASSC_RAM_ADDR_A_net\\\\\, ADDRA6 => 
        \AB_CM_inst/ASSC_RAM_ADDR_A_net_net_1\, ADDRA5 => 
        \AB_CM_inst/ASSC_RAM_ADDR_A_net_net_2\, ADDRA4 => 
        \AB_CM_inst/ASSC_RAM_ADDR_A_net_net_3\, ADDRA3 => 
        \AB_CM_inst/ASSC_RAM_ADDR_A_net_net_4\, ADDRA2 => 
        \AB_CM_inst/ASSC_RAM_ADDR_A_net_net_5\, ADDRA1 => 
        \AB_CM_inst/ASSC_RAM_ADDR_A_net_net_6\, ADDRA0 => 
        \AB_CM_inst/ASSC_RAM_ADDR_A_net_net_7\, ADDRB11 => 
        AFLSDF_GND, ADDRB10 => AFLSDF_GND, ADDRB9 => AFLSDF_GND, 
        ADDRB8 => \AB_CM_inst/ASSC_SEQOUT_net[5]\, ADDRB7 => 
        \AB_CM_inst/Z\\\\ASSC_SEQOUT_net\\\\\, ADDRB6 => 
        \AB_CM_inst/ASSC_SEQOUT_net_net_1\, ADDRB5 => 
        \AB_CM_inst/ASSC_SEQOUT_net_net_2\, ADDRB4 => 
        \AB_CM_inst/ASSC_SEQOUT_net_net_3\, ADDRB3 => 
        \AB_CM_inst/ASSC_SEQOUT_net_net_4\, ADDRB2 => 
        \AB_CM_inst/ASSC_RAM_ADDR_B_net_net_5\, ADDRB1 => 
        \AB_CM_inst/ASSC_RAM_ADDR_B_net_net_6\, ADDRB0 => 
        \AB_CM_inst/ASSC_RAM_ADDR_B_net_net_7\, DINA8 => 
        \INIT_DATA[8]\, DINA7 => \INIT_DATA[7]\, DINA6 => 
        \INIT_DATA[6]\, DINA5 => \INIT_DATA[5]\, DINA4 => 
        \INIT_DATA[4]\, DINA3 => \INIT_DATA[3]\, DINA2 => 
        \INIT_DATA[2]\, DINA1 => \INIT_DATA[1]\, DINA0 => 
        \INIT_DATA[0]\, DINB8 => 
        \AB_CM_inst/ASSC_RAM_DI_B_net[8]\, DINB7 => 
        \AB_CM_inst/Z\\\\ASSC_RAM_DI_B_net\\\\\, DINB6 => 
        \AB_CM_inst/ASSC_RAM_DI_B_net_net_1\, DINB5 => 
        \AB_CM_inst/ASSC_RAM_DI_B_net_net_2\, DINB4 => 
        \AB_CM_inst/ASSC_RAM_DI_B_net_net_3\, DINB3 => 
        \AB_CM_inst/ASSC_RAM_DI_B_net_net_4\, DINB2 => 
        \AB_CM_inst/ASSC_RAM_DI_B_net_net_5\, DINB1 => 
        \AB_CM_inst/ASSC_RAM_DI_B_net_net_6\, DINB0 => 
        \AB_CM_inst/ASSC_RAM_DI_B_net_net_7\, WIDTHA0 => 
        SOC_VCC_NET, WIDTHA1 => SOC_VCC_NET, WIDTHB0 => 
        SOC_VCC_NET, WIDTHB1 => SOC_VCC_NET, PIPEA => \GND\, 
        PIPEB => \GND\, WMODEA => SOC_VCC_NET, WMODEB => 
        SOC_VCC_NET, BLKA => \AB_CM_inst/ASSC_RAM_CSN_A_net\, 
        BLKB => \AB_CM_inst/ddvbdtxtbpx_i\, WENA => 
        \AB_CM_inst/ASSC_RAM_RW_A_net\, WENB => 
        \AB_CM_inst/ASSC_RAM_WR_BUSY_B_net\, CLKA => SYSCLK_c, 
        CLKB => SYSCLK_c, RESET => SYSRSTn_c, DOUTA8 => 
        \AB_CM_inst/ASSC_RAM_DO_A_net[8]\, DOUTA7 => 
        \AB_CM_inst/Z\\\\ASSC_RAM_DO_A_net\\\\\, DOUTA6 => 
        \AB_CM_inst/ASSC_RAM_DO_A_net_net_1\, DOUTA5 => 
        \AB_CM_inst/ASSC_RAM_DO_A_net_net_2\, DOUTA4 => 
        \AB_CM_inst/ASSC_RAM_DO_A_net_net_3\, DOUTA3 => 
        \AB_CM_inst/ASSC_RAM_DO_A_net_net_4\, DOUTA2 => 
        \AB_CM_inst/ASSC_RAM_DO_A_net_net_5\, DOUTA1 => 
        \AB_CM_inst/ASSC_RAM_DO_A_net_net_6\, DOUTA0 => 
        \AB_CM_inst/ASSC_RAM_DO_A_net_net_7\, DOUTB8 => 
        \AB_CM_inst/ASSC_RAM_DO_B_net[8]\, DOUTB7 => 
        \AB_CM_inst/Z\\\\ASSC_RAM_DO_B_net\\\\\, DOUTB6 => 
        \AB_CM_inst/ASSC_RAM_DO_B_net_net_1\, DOUTB5 => 
        \AB_CM_inst/ASSC_RAM_DO_B_net_net_2\, DOUTB4 => 
        \AB_CM_inst/ASSC_RAM_DO_B_net_net_3\, DOUTB3 => 
        \AB_CM_inst/ASSC_RAM_DO_B_net_net_4\, DOUTB2 => 
        \AB_CM_inst/ASSC_RAM_DO_B_net_net_5\, DOUTB1 => 
        \AB_CM_inst/ASSC_RAM_DO_B_net_net_6\, DOUTB0 => 
        \AB_CM_inst/ASSC_RAM_DO_B_net_net_7\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/gjkdbmpgrtc_7[5]\ : 
        MX2
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_443\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_451\, 
        S => 
        \AB_CM_inst.AB_CM_smev_wrapper_inst.U0.u_nbnjbfrkqwq.rdgwgtpkbgc[3]\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_511\);
    
    
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/dbcvwwhvvwh[5]\ : 
        DFN1E1C0
      port map(D => \AB_CM_inst/ASSC_RAM_DO_B_net_net_2\, CLK => 
        SYSCLK_c, CLR => SYSRSTn_c, E => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/jzzdfrmzwdj[13]_net_1\, 
        Q => \AB_CM_inst/ADC_TVC_net_net_1\);
    
    
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/tpxkpvnpvvn_m_0[0]\ : 
        OR3B
      port map(A => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/frcskdnwvmx_0[8]_net_1\, 
        B => \AB_CM_inst/TR_RAM_DO_B_net_net_7\, C => 
        \AB_CM_inst/EV_DONE_net_0\, Y => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/tpxkpvnpvvn_m_0[0]_net_1\);
    
    \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/G_118\ : 
        OR2
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_275\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/G_118_0_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_273\);
    
    \COMP_SM_inst/valid_8_0_0_a2_4_1\ : NOR3B
      port map(A => \COMP_SM_inst/prev_channel[3]_net_1\, B => 
        \COMP_SM_inst/prev_channel[1]_net_1\, C => 
        \COMP_SM_inst/prev_channel[4]_net_1\, Y => 
        \COMP_SM_inst/valid_8_0_0_a2_4_1_net_1\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/un1_dhzrwbnrbpw_I_33\ : 
        AX1C
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/DWACT_ADD_CI_0_g_array_2[0]\, 
        B => \AB_CM_inst/EV_RAM_ADDR_B_net_net_3\, C => 
        \AB_CM_inst/EV_RAM_ADDR_B_net_net_2\, Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/I_33\);
    
    \Diff4_pad[4]/U0/U0\ : IOPAD_TRI
      port map(D => \Diff4_pad[4]/U0/NET1\, E => 
        \Diff4_pad[4]/U0/NET2\, PAD => Diff4(4));
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/pptwzsjcmcz_dhzrwbnrbpw_7_iv[3]\ : 
        OR3C
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/jrgzmrqhbkv_m[3]_net_1\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/dhzrwbnrbpw_7_iv_0[3]\, 
        C => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/un1_dhzrwbnrbpw_m[4]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/dhzrwbnrbpw_7[3]\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/gjkdbmpgrtc_7[9]\ : 
        MX2
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_447\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_939\, 
        S => 
        \AB_CM_inst.AB_CM_smev_wrapper_inst.U0.u_nbnjbfrkqwq.rdgwgtpkbgc[3]\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_515\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/fqkdsnjfpdb_0_0_ADD_18x18_medium_I52_Y\ : 
        NOR2A
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N307\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N303\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N322\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ckghxwbsztp[0]\ : 
        DFN1E1C0
      port map(D => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ckghxwbsztp_3[0]\, 
        CLK => SYSCLK_c, CLR => SYSRSTn_c, E => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx[1]_net_1\, 
        Q => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ckghxwbsztp[0]_net_1\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc_3[15]\ : 
        MX2
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_753\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_967\, 
        S => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rdgwgtpkbgc_2[1]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_657\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc_12_s[4]\ : 
        OR2A
      port map(A => 
        \AB_CM_inst.AB_CM_smev_wrapper_inst.U0.u_nbnjbfrkqwq.rdgwgtpkbgc[3]\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rdgwgtpkbgc_0[2]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc_12_s[4]_net_1\);
    
    \Diff1_pad[1]/U0/U1\ : IOTRI_OB_EB
      port map(D => \Diff1_c[1]\, E => SOC_VCC_NET, DOUT => 
        \Diff1_pad[1]/U0/NET1\, EOUT => \Diff1_pad[1]/U0/NET2\);
    
    
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/save_fsm/u_wbsfnwwctpn/un1_bzcdnkppzhj_I_10\ : 
        AX1C
      port map(A => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/vvpkfmmpprk[0]\, 
        B => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/save_fsm/u_wbsfnwwctpn/crpwsdfhcqq[3]_net_1\, 
        C => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/vvpkfmmpprk[1]\, 
        Y => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/save_fsm/u_wbsfnwwctpn/I_10_0\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc_12_d[3]\ : 
        MX2C
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc_12_d_d[3]_net_1\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc_11_d[3]_net_1\, 
        S => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc_12_d_s[3]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc_12_d[3]_net_1\);
    
    
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/pfkhhxxsrzp[1]\ : 
        DFN1E1C0
      port map(D => \AB_CM_inst/ASSC_RAM_DO_B_net_net_1\, CLK => 
        SYSCLK_c, CLR => SYSRSTn_c, E => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/jzzdfrmzwdj[12]_net_1\, 
        Q => \AB_CM_inst/ADC_MODE_net_net_1\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/qrbxknbdvjj[3]\ : 
        DFN1E1C0
      port map(D => \AB_CM_inst/EV_RAM_ADDR_B_net_net_4\, CLK => 
        SYSCLK_c, CLR => SYSRSTn_c, E => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx[11]_net_1\, 
        Q => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/qrbxknbdvjj[3]_net_1\);
    
    
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/jzzdfrmzwdj[10]\ : 
        DFN1P0
      port map(D => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/jzzdfrmzwdj_ns_i_1[5]_net_1\, 
        CLK => SYSCLK_c, PRE => SYSRSTn_c, Q => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/jzzdfrmzwdj_i[10]\);
    
    
        \COMP_SM_inst/Subtract_inst/sumAux_0_0_SUB_12x12_medium_area_I40_un1_Y_0\ : 
        NOR2B
      port map(A => \COMP_SM_inst/Subtract_inst/N207\, B => 
        \COMP_SM_inst/Subtract_inst/N168\, Y => 
        \COMP_SM_inst/Subtract_inst/SUB_12x12_medium_area_I40_un1_Y_0\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/pvtdpmmqdpp_un2_pbzxzjhqhwz_0_I_72\ : 
        AO1
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/DWACT_CMPLE_PO2_DWACT_COMP0_E[1]\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/DWACT_CMPLE_PO2_DWACT_COMP0_E[2]\, 
        C => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/DWACT_CMPLE_PO2_DWACT_COMP0_E[0]\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/DWACT_COMP0_E[2]\);
    
    
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/address_gen/u_dxwqxgdccxc/gnmdxrqrdgs[8]\ : 
        DFN1C0
      port map(D => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/address_gen/u_dxwqxgdccxc/gnmdxrqrdgs_3[8]\, 
        CLK => SYSCLK_c, CLR => SYSRSTn_c, Q => \INIT_ADDR[8]\);
    
    
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/rjhhzsggrtr[7]\ : 
        DFN1E1C0
      port map(D => \AB_CM_inst/Z\\\\TR_RAM_DO_B_net\\\\\, CLK
         => SYSCLK_c, CLR => SYSRSTn_c, E => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/frcskdnwvmx[4]_net_1\, 
        Q => \AB_CM_inst/Z\\\\TR_EV_ADDR_net\\\\\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/fqkdsnjfpdb_0_0_ADD_18x18_medium_I9_P0N_0\ : 
        AO1
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnvtvdkcnpp_0[2]_net_1\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc[8]\, 
        C => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_287\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ADD_18x18_medium_I9_P0N_0\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/fqkdsnjfpdb_0_0_ADD_18x18_medium_I75_un1_Y_0_1\ : 
        OR3
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N297\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ADD_18x18_medium_I62_un1_Y_0\, 
        C => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N311\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ADD_18x18_medium_I75_un1_Y_0\);
    
    
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/bnrsdrtmtsg_5[3]\ : 
        MX2
      port map(A => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/hgqdwrxvgzm_3[3]_net_1\, 
        B => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/trnwxjxxrbp[3]_net_1\, 
        S => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/N_345\, 
        Y => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/N_356\);
    
    
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/jzzdfrmzwdj[3]\ : 
        DFN1P0
      port map(D => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/jzzdfrmzwdj_ns_i_1[12]_net_1\, 
        CLK => SYSCLK_c, PRE => SYSRSTn_c, Q => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/jzzdfrmzwdj_i_0[3]\);
    
    \COMP_SM_inst/Latest_Update_1_sqmuxa_0_a2_1\ : NOR2A
      port map(A => \ADC_CHNUMBER[2]\, B => \ADC_CHNUMBER[4]\, Y
         => \COMP_SM_inst/N_424\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx[15]\ : 
        DFN1C0
      port map(D => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx_ns_i[2]_net_1\, 
        CLK => SYSCLK_c, CLR => SYSRSTn_c, Q => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx[15]_net_1\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/fqkdsnjfpdb_0_0_ADD_18x18_medium_I94_Y\ : 
        XNOR3
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_252\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_248\, 
        C => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N403_i\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/fqkdsnjfpdb[2]\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc_1[1]\ : 
        MX2
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ftbkrvpxdbp[1]_net_1\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ftbkrvpxdbp[2]_net_1\, 
        S => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rdgwgtpkbgc_1[0]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_609\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc_7[6]\ : 
        MX2
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_648\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_656\, 
        S => 
        \AB_CM_inst.AB_CM_smev_wrapper_inst.U0.u_nbnjbfrkqwq.rdgwgtpkbgc[3]\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_716\);
    
    
        \COMP_SM_inst/Subtract_inst/sumAux_0_0_SUB_12x12_medium_area_I69_Y\ : 
        AX1D
      port map(A => \COMP_SM_inst/Subtract_inst/I66_un1_Y\, B => 
        \COMP_SM_inst/Subtract_inst/N142\, C => 
        \COMP_SM_inst/Subtract_inst/N143\, Y => 
        \COMP_SM_inst/Result[2]\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx_ns_i[2]\ : 
        NOR2B
      port map(A => INIT_DONE, B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx[16]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx_ns_i[2]_net_1\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/un1_dhzrwbnrbpw_m[4]\ : 
        XAI1
      port map(A => \AB_CM_inst/EV_RAM_ADDR_B_net_net_4\, B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/DWACT_ADD_CI_0_g_array_12[0]\, 
        C => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_201_i_0\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/un1_dhzrwbnrbpw_m[4]_net_1\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx[5]\ : 
        DFN1C0
      port map(D => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx_ns_i[12]_net_1\, 
        CLK => SYSCLK_c, CLR => SYSRSTn_c, Q => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx[5]_net_1\);
    
    \COMP_SM_inst/Diff_1[11]\ : DFN1E1C0
      port map(D => \COMP_SM_inst/Result[11]\, CLK => SYSCLK_c, 
        CLR => SYSRSTn_c, E => 
        \COMP_SM_inst/Latest_Update_1_sqmuxa\, Q => \Diff1_c[11]\);
    
    
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/dvqzjxhqhrh\ : 
        DFN1E1C0
      port map(D => \AB_CM_inst/TR_RAM_DO_B_net_net_3\, CLK => 
        SYSCLK_c, CLR => SYSRSTn_c, E => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/cpwfrthtnfr_7_sqmuxa\, 
        Q => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/dvqzjxhqhrh_net_1\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/pvtdpmmqdpp_un2_pbzxzjhqhwz_0_I_18\ : 
        OR2A
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnvtvdkcnpp[9]_net_1\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rqrqhcwpqdn[9]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_29\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/kkjrqmngvjc_0_0\ : 
        OR2
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx[1]_net_1\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_191_2\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/kkjrqmngvjc_0_0_net_1\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc_12[6]\ : 
        MX2
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_716\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc_11[6]_net_1\, 
        S => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rdgwgtpkbgc_2[2]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc[6]\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc_3[3]\ : 
        MX2
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_626\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_728\, 
        S => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rdgwgtpkbgc_0[1]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_645\);
    
    
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/save_fsm/u_wbsfnwwctpn/crpwsdfhcqq_ns_a3[4]\ : 
        NOR2A
      port map(A => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/npgnwznthhx\, 
        B => \NVM_CM_inst/NVM_BUSY_net\, Y => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/save_fsm/u_wbsfnwwctpn/crpwsdfhcqq_ns_a3[4]_net_1\);
    
    
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/svpqbbcnvqz[0]\ : 
        OR2B
      port map(A => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/jzzdfrmzwdj_i[10]\, 
        B => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/N_232_2\, 
        Y => \AB_CM_inst/ASSC_RAM_ADDR_B_net_net_7\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/qrbxknbdvjj_m[1]\ : 
        OR3B
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx_0[8]_net_1\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/qrbxknbdvjj[1]_net_1\, 
        C => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rgmpzqrbghh_0_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/qrbxknbdvjj_m[1]_net_1\);
    
    \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/G_119\ : 
        XNOR3
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/gjkdbmpgrtc[7]\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnvtvdkcnpp[1]_net_1\, 
        C => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc[7]\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_277\);
    
    \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/G_116\ : 
        NOR2A
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnvtvdkcnpp[0]_net_1\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc[6]\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_275\);
    
    
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/save_fsm/u_wbsfnwwctpn/un6_zvnnzqsskfv_0_a3\ : 
        OA1B
      port map(A => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/save_fsm/u_wbsfnwwctpn/jspcghhzwmg\, 
        B => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/save_fsm/u_wbsfnwwctpn/crpwsdfhcqq[0]_net_1\, 
        C => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/mhxwcfnvbgt\, 
        Y => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/fhpsqkqvwpw\);
    
    
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/save_fsm/u_wbsfnwwctpn/bzcdnkppzhj[1]\ : 
        DFN1C0
      port map(D => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/save_fsm/u_wbsfnwwctpn/I_10_0\, 
        CLK => SYSCLK_c, CLR => SYSRSTn_c, Q => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/vvpkfmmpprk[1]\);
    
    \Diff2_pad[11]/U0/U1\ : IOTRI_OB_EB
      port map(D => \Diff2_c[11]\, E => SOC_VCC_NET, DOUT => 
        \Diff2_pad[11]/U0/NET1\, EOUT => \Diff2_pad[11]/U0/NET2\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rqrqhcwpqdn[7]\ : 
        DFN1E1C0
      port map(D => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_821\, 
        CLK => SYSCLK_c, CLR => SYSRSTn_c, E => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_823\, 
        Q => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rqrqhcwpqdn[7]_net_1\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/fqkdsnjfpdb_0_0_ADD_18x18_medium_I62_Y\ : 
        OR3A
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ADD_18x18_medium_I62_un1_Y\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ADD_18x18_medium_I47_un1_Y\, 
        C => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ADD_18x18_medium_I30_Y\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N354\);
    
    \Diff5_pad[1]/U0/U1\ : IOTRI_OB_EB
      port map(D => \Diff5_c[1]\, E => SOC_VCC_NET, DOUT => 
        \Diff5_pad[1]/U0/NET1\, EOUT => \Diff5_pad[1]/U0/NET2\);
    
    
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/address_gen/u_dxwqxgdccxc/jvbvzqvvxpc_un10_gnmdxrqrdgs_NE_5\ : 
        ZOR3
      port map(A => \INIT_ADDR[2]\, B => \INIT_ADDR[1]\, C => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/ggsxvgncrgz[0]\, 
        Y => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/address_gen/u_dxwqxgdccxc/un10_gnmdxrqrdgs_NE_5\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/pvtdpmmqdpp_un2_pbzxzjhqhwz_0_I_56\ : 
        OR2A
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rqrqhcwpqdn[1]_net_1\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnvtvdkcnpp[1]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ACT_LT4_E[1]\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc_11[2]\ : 
        MX2
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc_11_d_0[2]_net_1\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_748\, 
        S => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc_11_s_0[2]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_780\);
    
    
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/ddvbdtxtbpx_i_2\ : 
        OA1C
      port map(A => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/N_250\, 
        B => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/un1_sgbwkmbvtjw_0_a3_0_net_1\, 
        C => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/ddvbdtxtbpx_i_2_0_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/N_232_2\);
    
    \COMP_SM_inst/Diff_1[9]\ : DFN1E1C0
      port map(D => \COMP_SM_inst/Result[9]\, CLK => SYSCLK_c, 
        CLR => SYSRSTn_c, E => 
        \COMP_SM_inst/Latest_Update_1_sqmuxa\, Q => \Diff1_c[9]\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx_ns_i[13]\ : 
        NOR2B
      port map(A => INIT_DONE, B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx[5]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx_ns_i[13]_net_1\);
    
    
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/ksbhwjctscp[8]\ : 
        MX2
      port map(A => \INIT_ADDR[8]\, B => 
        \AB_CM_inst/EV_ASSCADDR_net[8]\, S => INIT_DONE, Y => 
        \AB_CM_inst/ASSC_RAM_ADDR_A_net[8]\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ftbkrvpxdbp[3]\ : 
        DFN1E0C0
      port map(D => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ftbkrvpxdbp_5[3]_net_1\, 
        CLK => SYSCLK_c, CLR => SYSRSTn_c, E => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ftbkrvpxdbp_1_sqmuxa_net_1\, 
        Q => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ftbkrvpxdbp[3]_net_1\);
    
    \COMP_SM_inst/R2[4]\ : DFN1E1C0
      port map(D => \ADC_RESULT[4]\, CLK => SYSCLK_c, CLR => 
        SYSRSTn_c, E => \COMP_SM_inst/pres_state_0[2]_net_1\, Q
         => \COMP_SM_inst/R2[4]_net_1\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bskrjhjvqpf_6_sqmuxa_0_a2\ : 
        OR2B
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx[12]_net_1\, 
        B => \AB_CM_inst/Z\\\\EV_RAM_DO_B_net\\\\_0\, Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_241\);
    
    
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/address_gen/u_dxwqxgdccxc/un1_gnmdxrqrdgs_I_34\ : 
        AX1C
      port map(A => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/address_gen/u_dxwqxgdccxc/DWACT_ADD_CI_0_g_array_11[0]\, 
        B => \INIT_ADDR[6]\, C => \INIT_ADDR[7]\, Y => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/address_gen/u_dxwqxgdccxc/I_34_1\);
    
    \Diff5_pad[7]/U0/U1\ : IOTRI_OB_EB
      port map(D => \Diff5_c[7]\, E => SOC_VCC_NET, DOUT => 
        \Diff5_pad[7]/U0/NET1\, EOUT => \Diff5_pad[7]/U0/NET2\);
    
    \Diff0_pad[5]/U0/U0\ : IOPAD_TRI
      port map(D => \Diff0_pad[5]/U0/NET1\, E => 
        \Diff0_pad[5]/U0/NET2\, PAD => Diff0(5));
    
    \COMP_SM_inst/pres_state_ns_a5_0_a4_1[1]\ : NOR2
      port map(A => \COMP_SM_inst/pres_state_0[3]_net_1\, B => 
        \COMP_SM_inst/pres_state_0[2]_net_1\, Y => 
        \COMP_SM_inst/pres_state_ns_a5_0_a4_1[1]_net_1\);
    
    \AB_CM_inst/AV4_PAD\ : IOPAD_A_IN
      port map(PAD => AV4, Y => \AB_CM_inst/AV4_net\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnvtvdkcnpp_5[6]\ : 
        MX2
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnvtvdkcnpp[6]_net_1\, 
        B => \AB_CM_inst/EV_RAM_DO_B_net_net_1\, S => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/un3_qvqqfftqsfc_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnvtvdkcnpp_5[6]_net_1\);
    
    \Diff0_pad[2]/U0/U0\ : IOPAD_TRI
      port map(D => \Diff0_pad[2]/U0/NET1\, E => 
        \Diff0_pad[2]/U0/NET2\, PAD => Diff0(2));
    
    \COMP_SM_inst/Diff_5[3]\ : DFN1E1C0
      port map(D => \COMP_SM_inst/Result[3]\, CLK => SYSCLK_c, 
        CLR => SYSRSTn_c, E => 
        \COMP_SM_inst/Latest_Update_5_sqmuxa\, Q => \Diff5_c[3]\);
    
    \COMP_SM_inst/Diff_3[9]\ : DFN1E1C0
      port map(D => \COMP_SM_inst/Result[9]\, CLK => SYSCLK_c, 
        CLR => SYSRSTn_c, E => 
        \COMP_SM_inst/Latest_Update_3_sqmuxa\, Q => \Diff3_c[9]\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/fqkdsnjfpdb_m[14]\ : 
        OR2A
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx[5]_net_1\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/fqkdsnjfpdb_i[14]\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/fqkdsnjfpdb_m[14]_net_1\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc_11[12]\ : 
        MX2
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_966\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnvtvdkcnpp[6]_net_1\, 
        S => 
        \AB_CM_inst.AB_CM_smev_wrapper_inst.U0.u_nbnjbfrkqwq.rdgwgtpkbgc[3]\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_790\);
    
    
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/address_gen/u_dxwqxgdccxc/ggfvvjbkdws[7]\ : 
        MX2C
      port map(A => \INIT_ADDR[7]\, B => \INIT_ADDR[6]\, S => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/ggsxvgncrgz[0]\, 
        Y => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/ggfvvjbkdws[7]\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/fqkdsnjfpdb_0_0_ADD_18x18_medium_I10_G0N\ : 
        OAI1
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/G_133_0_net_1\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_290\, 
        C => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_292\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N261\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc_8[1]\ : 
        MX2
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ftbkrvpxdbp[5]_net_1\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnvtvdkcnpp[0]_net_1\, 
        S => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rdgwgtpkbgc_1[0]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_728\);
    
    
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/jnfrmfqggmk\ : 
        DFN1E1C0
      port map(D => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/dttrrgvsnmg\, 
        CLK => SYSCLK_c, CLR => SYSRSTn_c, E => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/un1_xjrbtnwdszs_1_sqmuxa\, 
        Q => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/jnfrmfqggmk_net_1\);
    
    
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/vnjtgtptszx_un1_xjrbtnwdszs_1_sqmuxa\ : 
        OR3B
      port map(A => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/cpwfrthtnfr_13_sqmuxa_net_1\, 
        B => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/un1_xjrbtnwdszs_1_sqmuxa_1\, 
        C => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/cpwfrthtnfr_14_sqmuxa\, 
        Y => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/un1_xjrbtnwdszs_1_sqmuxa\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/un3_ckghxwbsztp_I_16\ : 
        AND3
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rqrqhcwpqdn[1]_net_1\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rqrqhcwpqdn[2]_net_1\, 
        C => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rqrqhcwpqdn[3]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/DWACT_FINC_E[0]\);
    
    \Diff2_pad[5]/U0/U0\ : IOPAD_TRI
      port map(D => \Diff2_pad[5]/U0/NET1\, E => 
        \Diff2_pad[5]/U0/NET2\, PAD => Diff2(5));
    
    
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/znjtscvsvcs_iv_0_a2\ : 
        OR3B
      port map(A => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/N_388\, 
        B => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/jnfrmfqggmk_net_1\, 
        C => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/cpwfrthtnfr_13_sqmuxa_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/N_433\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/un1_dhzrwbnrbpw_m[3]\ : 
        XAI1
      port map(A => \AB_CM_inst/EV_RAM_ADDR_B_net_net_5\, B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/DWACT_ADD_CI_0_g_array_1[0]\, 
        C => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_201_i_0\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/un1_dhzrwbnrbpw_m[3]_net_1\);
    
    
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/jzzdfrmzwdj_ns_i_a3_0[14]\ : 
        NOR2A
      port map(A => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/jzzdfrmzwdj_i[1]\, 
        B => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/jzzdfrmzwdj[15]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/jzzdfrmzwdj_ns_i_a3_0[14]_net_1\);
    
    
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/save_fsm/u_wbsfnwwctpn/un1_bzcdnkppzhj_I_8\ : 
        XOR2
      port map(A => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/vvpkfmmpprk[0]\, 
        B => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/save_fsm/u_wbsfnwwctpn/crpwsdfhcqq[3]_net_1\, 
        Y => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/save_fsm/u_wbsfnwwctpn/DWACT_ADD_CI_0_partial_sum[0]\);
    
    
        \COMP_SM_inst/Subtract_inst/sumAux_0_0_SUB_12x12_medium_area_I21_CO1\ : 
        NOR2A
      port map(A => \COMP_SM_inst/R1[9]_net_1\, B => 
        \COMP_SM_inst/R2[9]_net_1\, Y => 
        \COMP_SM_inst/Subtract_inst/N158\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/gjkdbmpgrtc_9[7]\ : 
        MX2
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rqrqhcwpqdn[7]_net_1\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rqrqhcwpqdn[8]_net_1\, 
        S => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rdgwgtpkbgc_1[0]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_547\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc_11_d_0[2]\ : 
        MX2
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_750\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ftbkrvpxdbp[2]_net_1\, 
        S => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc_11_s[2]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc_11_d_0[2]_net_1\);
    
    \NVM_CM_inst/NVM_INST\ : NVM
      generic map(MEMORYFILE => "NVM_CM.mem")

      port map(RD(31) => nc34, RD(30) => nc9, RD(29) => nc13, 
        RD(28) => nc23, RD(27) => nc33, RD(26) => nc16, RD(25)
         => nc26, RD(24) => nc27, RD(23) => nc17, RD(22) => nc5, 
        RD(21) => nc4, RD(20) => nc25, RD(19) => nc15, RD(18) => 
        nc35, RD(17) => nc28, RD(16) => nc18, RD(15) => nc1, 
        RD(14) => nc2, RD(13) => nc22, RD(12) => nc12, RD(11) => 
        nc21, RD(10) => nc11, RD(9) => nc3, RD(8) => 
        \INIT_DATA[8]\, RD(7) => \INIT_DATA[7]\, RD(6) => 
        \INIT_DATA[6]\, RD(5) => \INIT_DATA[5]\, RD(4) => 
        \INIT_DATA[4]\, RD(3) => \INIT_DATA[3]\, RD(2) => 
        \INIT_DATA[2]\, RD(1) => \INIT_DATA[1]\, RD(0) => 
        \INIT_DATA[0]\, BUSY => \NVM_CM_inst/NVM_BUSY_net\, 
        STATUS(1) => nc32, STATUS(0) => nc31, ADDR(17) => \GND\, 
        ADDR(16) => \NVM_CM_inst/srdtcqsfmmm_i[16]\, ADDR(15) => 
        \NVM_CM_inst/srdtcqsfmmm_i[15]\, ADDR(14) => 
        \NVM_CM_inst/srdtcqsfmmm_i[14]\, ADDR(13) => 
        \NVM_CM_inst/srdtcqsfmmm_i[13]\, ADDR(12) => 
        \NVM_CM_inst/srdtcqsfmmm_i[12]\, ADDR(11) => \GND\, 
        ADDR(10) => \GND\, ADDR(9) => \GND\, ADDR(8) => \GND\, 
        ADDR(7) => \GND\, ADDR(6) => 
        \NVM_CM_inst/srdtcqsfmmm_i[6]\, ADDR(5) => 
        \NVM_CM_inst/srdtcqsfmmm_i[5]\, ADDR(4) => 
        \NVM_CM_inst/srdtcqsfmmm_i[4]\, ADDR(3) => 
        \NVM_CM_inst/srdtcqsfmmm_i[3]\, ADDR(2) => 
        \NVM_CM_inst/srdtcqsfmmm_i[2]\, ADDR(1) => 
        \NVM_CM_inst/srdtcqsfmmm_i[1]\, ADDR(0) => 
        \NVM_CM_inst/srdtcqsfmmm_i[0]\, WD(31) => \GND\, WD(30)
         => \GND\, WD(29) => \GND\, WD(28) => \GND\, WD(27) => 
        \GND\, WD(26) => \GND\, WD(25) => \GND\, WD(24) => \GND\, 
        WD(23) => \GND\, WD(22) => \GND\, WD(21) => \GND\, WD(20)
         => \GND\, WD(19) => \GND\, WD(18) => \GND\, WD(17) => 
        \GND\, WD(16) => \GND\, WD(15) => \GND\, WD(14) => \GND\, 
        WD(13) => \GND\, WD(12) => \GND\, WD(11) => \GND\, WD(10)
         => \GND\, WD(9) => \GND\, WD(8) => \GND\, WD(7) => \GND\, 
        WD(6) => \GND\, WD(5) => \GND\, WD(4) => \GND\, WD(3) => 
        \GND\, WD(2) => \GND\, WD(1) => \GND\, WD(0) => \GND\, 
        DATAWIDTH(1) => \GND\, DATAWIDTH(0) => 
        \NVM_CM_inst/hbqjhzzrbnr_i[0]\, REN => 
        \NVM_CM_inst/twxmgvvpbgm_iv_0_a2_0\, WEN => \GND\, 
        PROGRAM => \GND\, SPAREPAGE => 
        \NVM_CM_inst/un1_wxqqqsndpvg_i_0\, AUXBLOCK => \GND\, 
        READNEXT => \NVM_CM_inst/twxmgvvpbgm_iv_0_a2_0\, 
        ERASEPAGE => \GND\, UNPROTECTPAGE => \GND\, DISCARDPAGE
         => \GND\, OVERWRITEPROTECT => \GND\, PAGELOSSPROTECT => 
        \GND\, CLK => SYSCLK_c, RESET => SYSRSTn_c, PAGESTATUS
         => \GND\, OVERWRITEPAGE => \GND\, PIPE => \GND\, 
        LOCKREQUEST => \NVM_CM_inst/un1_wxqqqsndpvg_i_0\);
    
    
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/jfkkdmfhcdn[2]\ : 
        NOR2A
      port map(A => \AB_CM_inst/TR_RAM_DO_B_net_net_5\, B => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/frcskdnwvmx[0]_net_1\, 
        Y => \AB_CM_inst/TR_RAM_DI_B_net_net_5\);
    
    
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/address_gen/u_dxwqxgdccxc/un1_dkjzqmrkvwb_ADD_13x13_fast_I33_un1_Y\ : 
        OR3C
      port map(A => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/address_gen/u_dxwqxgdccxc/N190\, 
        B => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/bdhvhfjwtxd_i_0[5]\, 
        C => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/N222\, 
        Y => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/I33_un1_Y\);
    
    \COMP_SM_inst/pres_state_0[2]\ : DFN1C0
      port map(D => \COMP_SM_inst/pres_state_ns[2]\, CLK => 
        SYSCLK_c, CLR => \COMP_SM_inst/un2_resetn\, Q => 
        \COMP_SM_inst/pres_state_0[2]_net_1\);
    
    
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/frcskdnwvmx_ns_a3_4[0]\ : 
        NOR3B
      port map(A => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/frcskdnwvmx_ns_a3_2[0]_net_1\, 
        B => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/un1_wjpccrvpdms\, 
        C => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/frcskdnwvmx[4]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/frcskdnwvmx_ns_a3_4[0]_net_1\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/fqkdsnjfpdb_0_0_ADD_18x18_medium_I75_un1_Y_0_0\ : 
        OR3C
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N235\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N238\, 
        C => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N300\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ADD_18x18_medium_I62_un1_Y_0\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/kkkmkxwwscv[1]\ : 
        DFN1E1C0
      port map(D => \AB_CM_inst/ASSC_SEQOUT_net_net_3\, CLK => 
        SYSCLK_c, CLR => SYSRSTn_c, E => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/qmmwhjxxxmv_net_1\, 
        Q => \AB_CM_inst/EV_ASSCADDR_net_net_3\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnvtvdkcnpp[6]\ : 
        DFN1C0
      port map(D => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnvtvdkcnpp_9[6]_net_1\, 
        CLK => SYSCLK_c, CLR => SYSRSTn_c, Q => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnvtvdkcnpp[6]_net_1\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc_9[1]\ : 
        MX2
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnvtvdkcnpp[1]_net_1\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnvtvdkcnpp[2]_net_1\, 
        S => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rdgwgtpkbgc_2[0]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_745\);
    
    \Diff4_pad[5]/U0/U1\ : IOTRI_OB_EB
      port map(D => \Diff4_c[5]\, E => SOC_VCC_NET, DOUT => 
        \Diff4_pad[5]/U0/NET1\, EOUT => \Diff4_pad[5]/U0/NET2\);
    
    \Diff3_pad[9]/U0/U0\ : IOPAD_TRI
      port map(D => \Diff3_pad[9]/U0/NET1\, E => 
        \Diff3_pad[9]/U0/NET2\, PAD => Diff3(9));
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/mkmkbnghgkd[3]\ : 
        MX2
      port map(A => \INIT_ADDR[3]\, B => 
        \AB_CM_inst/TR_EV_ADDR_net_net_4\, S => INIT_DONE, Y => 
        \AB_CM_inst/EV_RAM_ADDR_A_net_net_4\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bskrjhjvqpf_i_2_1\ : 
        OR3
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx[6]_net_1\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx[17]_net_1\, 
        C => \AB_CM_inst/EV_ASSCADDR_net_net_5\, Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bskrjhjvqpf_i_2_1_net_1\);
    
    
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/user_control/u_ffppvfwnggt/srdtcqsfmmm_i[15]\ : 
        XA1
      port map(A => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/N246\, 
        B => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/bdhvhfjwtxd_i_0[5]\, 
        C => \NVM_CM_inst/un1_wxqqqsndpvg_i_0\, Y => 
        \NVM_CM_inst/srdtcqsfmmm_i[15]\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/gjkdbmpgrtc_11_0_a3[4]\ : 
        NOR2A
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_446\, 
        B => 
        \AB_CM_inst.AB_CM_smev_wrapper_inst.U0.u_nbnjbfrkqwq.rdgwgtpkbgc[3]\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_951\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc_12[8]\ : 
        MX2
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc_12_d_0[8]_net_1\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc_11[8]_net_1\, 
        S => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rdgwgtpkbgc_0[2]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc[8]\);
    
    \COMP_SM_inst/valid_8_0_0_a4\ : AO1D
      port map(A => \COMP_SM_inst/N_421\, B => 
        \COMP_SM_inst/N_422\, C => 
        \COMP_SM_inst/valid_8_0_0_a4_1_net_1\, Y => 
        \COMP_SM_inst/N_401\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/zbqggxmnpbs_0_iv_0[2]\ : 
        AOI1B
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/fqkdsnjfpdb[17]\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx_0[4]_net_1\, 
        C => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ckghxwbsztp_m[1]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/zbqggxmnpbs_0_iv_0[2]_net_1\);
    
    \COMP_SM_inst/valid_8_0_0_a2_2\ : OR3
      port map(A => \COMP_SM_inst/prev_channel[1]_net_1\, B => 
        \COMP_SM_inst/prev_channel[2]_net_1\, C => 
        \COMP_SM_inst/N_423\, Y => \COMP_SM_inst/N_415\);
    
    
        \COMP_SM_inst/Subtract_inst/sumAux_0_0_SUB_12x12_medium_area_I26_Y\ : 
        AO13
      port map(A => \COMP_SM_inst/R1[8]_net_1\, B => 
        \COMP_SM_inst/Subtract_inst/N154\, C => 
        \COMP_SM_inst/R2[8]_net_1\, Y => 
        \COMP_SM_inst/Subtract_inst/N196\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/un1_fskhwddcbbg_i_o3\ : 
        OR3
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx[0]_net_1\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx[3]_net_1\, 
        C => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx_0[4]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_209\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rqrqhcwpqdn[6]\ : 
        DFN1E1C0
      port map(D => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_820\, 
        CLK => SYSCLK_c, CLR => SYSRSTn_c, E => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_823\, 
        Q => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rqrqhcwpqdn[6]_net_1\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/fqkdsnjfpdb_0_0_ADD_18x18_medium_I28_Y\ : 
        AO1B
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N246\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N250\, 
        C => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N249\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N294\);
    
    \Diff2_pad[7]/U0/U1\ : IOTRI_OB_EB
      port map(D => \Diff2_c[7]\, E => SOC_VCC_NET, DOUT => 
        \Diff2_pad[7]/U0/NET1\, EOUT => \Diff2_pad[7]/U0/NET2\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/zbqggxmnpbs_r[8]\ : 
        AOI1B
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/fqkdsnjfpdb_m[5]_net_1\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/fqkdsnjfpdb_m[14]_net_1\, 
        C => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_196\, 
        Y => \AB_CM_inst/EV_RAM_DI_B_net[8]\);
    
    \Diff2_pad[1]/U0/U0\ : IOPAD_TRI
      port map(D => \Diff2_pad[1]/U0/NET1\, E => 
        \Diff2_pad[1]/U0/NET2\, PAD => Diff2(1));
    
    
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/fsrxhtjthgw_i_a2\ : 
        AO1C
      port map(A => \AB_CM_inst/EV_DONE_net\, B => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/un6_bdbpcvshhqt_1_net_1\, 
        C => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/jzzdfrmzwdj_i[1]\, 
        Y => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/N_314\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc_12[11]\ : 
        MX2
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_955\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_789\, 
        S => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rdgwgtpkbgc_2[2]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc[11]\);
    
    
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/bnrsdrtmtsg_5_r[4]\ : 
        NOR2B
      port map(A => INIT_DONE, B => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/N_357\, 
        Y => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/bnrsdrtmtsg_5[4]_net_1\);
    
    
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/save_fsm/u_wbsfnwwctpn/crpwsdfhcqq[1]\ : 
        DFN1C0
      port map(D => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/save_fsm/u_wbsfnwwctpn/crpwsdfhcqq_ns[7]_net_1\, 
        CLK => SYSCLK_c, CLR => SYSRSTn_c, Q => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/save_fsm/u_wbsfnwwctpn/crpwsdfhcqq[1]_net_1\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rqrqhcwpqdn[3]\ : 
        DFN1E1C0
      port map(D => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_817\, 
        CLK => SYSCLK_c, CLR => SYSRSTn_c, E => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_823\, 
        Q => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rqrqhcwpqdn[3]_net_1\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/gjkdbmpgrtc_3[11]\ : 
        MX2
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_545\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_547\, 
        S => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rdgwgtpkbgc[1]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_449\);
    
    
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/jzzdfrmzwdj_ns_i_1[5]\ : 
        OR2B
      port map(A => INIT_DONE, B => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/jzzdfrmzwdj[11]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/jzzdfrmzwdj_ns_i_1[5]_net_1\);
    
    
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/cpwfrthtnfr_13_sqmuxa\ : 
        OR2
      port map(A => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/cpwfrthtnfr_13_sqmuxa_1\, 
        B => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/N_500\, 
        Y => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/cpwfrthtnfr_13_sqmuxa_net_1\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/fqkdsnjfpdb_0_0_ADD_18x18_medium_I97_Y\ : 
        XNOR2
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ADD_18x18_medium_I97_Y_0\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N354\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/fqkdsnjfpdb_i[5]\);
    
    
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/init_fsm/u_stnpfdkggvx/mwtvnzdkmwm[0]\ : 
        DFN1C0
      port map(D => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/init_fsm/u_stnpfdkggvx/mwtvnzdkmwm_ns_i_a2[7]_net_1\, 
        CLK => SYSCLK_c, CLR => SYSRSTn_c, Q => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/qdvwjxmzbpf\);
    
    \COMP_SM_inst/Latest_Update_3_sqmuxa_0_a2\ : NOR2B
      port map(A => \COMP_SM_inst/Latest_Update_9[1]\, B => 
        \ADC_CHNUMBER[1]\, Y => \COMP_SM_inst/N_418\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/gjkdbmpgrtc_3[12]\ : 
        MX2
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_546\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_548\, 
        S => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rdgwgtpkbgc_0[1]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_450\);
    
    
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/un1_bksnhfwfshc_0_sqmuxa_0_o3_0\ : 
        NOR2A
      port map(A => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/bksczsjcvgb_net_1\, 
        B => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/jzzdfrmzwdj_i[1]\, 
        Y => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/N_253\);
    
    \Diff1_pad[10]/U0/U1\ : IOTRI_OB_EB
      port map(D => \Diff1_c[10]\, E => SOC_VCC_NET, DOUT => 
        \Diff1_pad[10]/U0/NET1\, EOUT => \Diff1_pad[10]/U0/NET2\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/gpjgkmhxbkn_1\ : 
        XNOR2
      port map(A => \AB_CM_inst/EV_RAM_DO_B_net_net_5\, B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rqrqhcwpqdn[2]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/gpjgkmhxbkn_1_i\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rqrqhcwpqdn_5_0[2]\ : 
        MX2
      port map(A => \AB_CM_inst/ASSC_RAM_DO_A_net_net_5\, B => 
        \AB_CM_inst/EV_RAM_DO_B_net_net_5\, S => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/un1_xkwrgrspmcf_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_816\);
    
    
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/znjtscvsvcs_iv_0_a2_0\ : 
        OR3C
      port map(A => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/N_385_i_i_0\, 
        B => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/hnbsspwxkpd_net_1\, 
        C => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/N_434_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/N_434\);
    
    \COMP_SM_inst/R1[2]\ : DFN1E1C0
      port map(D => \ADC_RESULT[2]\, CLK => SYSCLK_c, CLR => 
        SYSRSTn_c, E => \COMP_SM_inst/pres_state_0[3]_net_1\, Q
         => \COMP_SM_inst/R1[2]_net_1\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/fqkdsnjfpdb_0_0_ADD_18x18_medium_I7_P0N\ : 
        OR3
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_277\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_275\, 
        C => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/G_118_0_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N253\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/fqkdsnjfpdb_0_0_ADD_18x18_medium_I4_P0N_0\ : 
        OR2
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_260\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_262\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ADD_18x18_medium_I4_P0N_0\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc_9[5]\ : 
        MX2
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnvtvdkcnpp[5]_net_1\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnvtvdkcnpp[6]_net_1\, 
        S => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rdgwgtpkbgc_2[0]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_749\);
    
    
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/address_gen/u_dxwqxgdccxc/jvbvzqvvxpc_un10_gnmdxrqrdgs_NE_0\ : 
        ZOR3
      port map(A => \INIT_ADDR[6]\, B => \INIT_ADDR[4]\, C => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/N_2174\, 
        Y => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/address_gen/u_dxwqxgdccxc/un10_gnmdxrqrdgs_NE_0\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/fqkdsnjfpdb_0_0_ADD_18x18_medium_I68_un1_Y_0\ : 
        NOR2A
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N307\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N311\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ADD_18x18_medium_I68_un1_Y_0\);
    
    
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/valid_client/u_gpbdjfttbjd/fpppnnsbksx_0[3]\ : 
        AO1C
      port map(A => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/npgnwznthhx\, 
        B => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/valid_client/u_gpbdjfttbjd/fpppnnsbksx_0_a3_0_0[3]_net_1\, 
        C => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/valid_client/u_gpbdjfttbjd/N_24\, 
        Y => 
        \NVM_CM_inst.NVM_CM_init_wrapper_inst.U0.u_grwzcnqmqzm.valid_client.u_gpbdjfttbjd.N_10\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx_ns_a3_0_1[4]\ : 
        NOR2B
      port map(A => \AB_CM_inst/EV_RAM_DO_B_net_net_1\, B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx[12]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_227_1\);
    
    \Diff5_pad[2]/U0/U0\ : IOPAD_TRI
      port map(D => \Diff5_pad[2]/U0/NET1\, E => 
        \Diff5_pad[2]/U0/NET2\, PAD => Diff5(2));
    
    
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/cpwfrthtnfr_11_sqmuxa_0_a2_0\ : 
        NOR3C
      port map(A => \AB_CM_inst/Z\\\\TR_RAM_DO_B_net\\\\\, B => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/frcskdnwvmx[6]_net_1\, 
        C => \AB_CM_inst/TR_RAM_DO_B_net_net_2\, Y => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/N_285\);
    
    \Diff3_pad[5]/U0/U0\ : IOPAD_TRI
      port map(D => \Diff3_pad[5]/U0/NET1\, E => 
        \Diff3_pad[5]/U0/NET2\, PAD => Diff3(5));
    
    \COMP_SM_inst/Diff_5[10]\ : DFN1E1C0
      port map(D => \COMP_SM_inst/Result[10]\, CLK => SYSCLK_c, 
        CLR => SYSRSTn_c, E => 
        \COMP_SM_inst/Latest_Update_5_sqmuxa\, Q => \Diff5_c[10]\);
    
    
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/dspfgfmqhwh[4]\ : 
        DFN1E1C0
      port map(D => \AB_CM_inst/ASSC_RAM_DO_B_net_net_3\, CLK => 
        SYSCLK_c, CLR => SYSRSTn_c, E => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/jzzdfrmzwdj[12]_net_1\, 
        Q => \ADC_CHNUMBER[4]\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/pvtdpmmqdpp_un2_pbzxzjhqhwz_0_I_62\ : 
        NOR2A
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnvtvdkcnpp[2]_net_1\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rqrqhcwpqdn[2]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ACT_LT4_E[7]\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/pvtdpmmqdpp_un2_pbzxzjhqhwz_0_I_19\ : 
        NOR2A
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rqrqhcwpqdn[7]_net_1\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnvtvdkcnpp[7]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_30\);
    
    \COMP_SM_inst/Diff_4[1]\ : DFN1E1C0
      port map(D => \COMP_SM_inst/Result[1]\, CLK => SYSCLK_c, 
        CLR => SYSRSTn_c, E => 
        \COMP_SM_inst/Latest_Update_4_sqmuxa\, Q => \Diff4_c[1]\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx[6]\ : 
        DFN1C0
      port map(D => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx_ns_i[11]_net_1\, 
        CLK => SYSCLK_c, CLR => SYSRSTn_c, Q => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx[6]_net_1\);
    
    
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/valid_client/u_gpbdjfttbjd/fpppnnsbksx_0_a3_0[2]\ : 
        OR3A
      port map(A => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/gpbbjwsprsj[1]\, 
        B => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/npgnwznthhx\, 
        C => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/gpbbjwsprsj[0]\, 
        Y => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/valid_client/u_gpbdjfttbjd/N_23\);
    
    
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/mksbfqnmmgw[6]\ : 
        NOR2A
      port map(A => \ADC_RESULT[6]\, B => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/jzzdfrmzwdj_0[4]_net_1\, 
        Y => \AB_CM_inst/ASSC_RAM_DI_B_net_net_1\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rdgwgtpkbgc[1]\ : 
        DFN1E0C0
      port map(D => \AB_CM_inst/EV_RAM_DO_B_net_net_6\, CLK => 
        SYSCLK_c, CLR => SYSRSTn_c, E => 
        \AB_CM_inst/bskrjhjvqpf_1_sqmuxa\, Q => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rdgwgtpkbgc[1]_net_1\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/pvtdpmmqdpp_un2_pbzxzjhqhwz_0_I_58\ : 
        AOI1A
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ACT_LT4_E[0]\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ACT_LT4_E[1]\, 
        C => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ACT_LT4_E[2]\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ACT_LT4_E[3]\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/gjkdbmpgrtc_11[8]\ : 
        MX2
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_546\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/gjkdbmpgrtc_11_d[8]_net_1\, 
        S => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc_11_s[6]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/gjkdbmpgrtc_11[8]_net_1\);
    
    
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/jzzdfrmzwdj[14]\ : 
        DFN1C0
      port map(D => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/N_200_i_0\, 
        CLK => SYSCLK_c, CLR => SYSRSTn_c, Q => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/jzzdfrmzwdj[14]_net_1\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnvtvdkcnpp_5[3]\ : 
        MX2C
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnvtvdkcnpp[3]_net_1\, 
        B => \AB_CM_inst/EV_RAM_DO_B_net_net_4\, S => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/un3_qvqqfftqsfc_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnvtvdkcnpp_5[3]_net_1\);
    
    
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/un1_bksnhfwfshc_1_sqmuxa_0_a3\ : 
        NOR2A
      port map(A => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/jzzdfrmzwdj[15]_net_1\, 
        B => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/bksczsjcvgb_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/un1_bksnhfwfshc_1_sqmuxa_0_a3_net_1\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/pvtdpmmqdpp_un2_pbzxzjhqhwz_0_I_1\ : 
        XNOR2
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnvtvdkcnpp[8]_net_1\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rqrqhcwpqdn[8]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/DWACT_BL_EQUAL_0_E_0[1]\);
    
    
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/mksbfqnmmgw[7]\ : 
        NOR2A
      port map(A => \ADC_RESULT[7]\, B => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/jzzdfrmzwdj_0[4]_net_1\, 
        Y => \AB_CM_inst/Z\\\\ASSC_RAM_DI_B_net\\\\\);
    
    
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/address_gen/u_dxwqxgdccxc/un1_dkjzqmrkvwb_ADD_13x13_fast_I9_G0N\ : 
        AO1D
      port map(A => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/N_2340\, 
        B => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/N_2358\, 
        C => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/address_gen/u_dxwqxgdccxc/ggfvvjbkdws[9]_net_1\, 
        Y => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/N189\);
    
    
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/qvkpfznsfjx\ : 
        DFN1C0
      port map(D => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/hdxtpkktfvz\, 
        CLK => SYSCLK_c, CLR => SYSRSTn_c, Q => ASSC_DONE);
    
    \Diff4_pad[4]/U0/U1\ : IOTRI_OB_EB
      port map(D => \Diff4_c[4]\, E => SOC_VCC_NET, DOUT => 
        \Diff4_pad[4]/U0/NET1\, EOUT => \Diff4_pad[4]/U0/NET2\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ckghxwbsztp_m[2]\ : 
        OR2B
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx[0]_net_1\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ckghxwbsztp[2]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ckghxwbsztp_m[2]_net_1\);
    
    
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/un1_znbmnfdbzvr_m\ : 
        NOR3B
      port map(A => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/bksczsjcvgb_net_1\, 
        B => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/jzzdfrmzwdj[15]_net_1\, 
        C => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/znbmnfdbzvr_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/un1_znbmnfdbzvr_m_net_1\);
    
    \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/G_153\ : 
        AO13
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnvtvdkcnpp[7]_net_1\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/gjkdbmpgrtc[13]\, 
        C => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc[13]\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_308\);
    
    \AB_CM_inst/AB_CM_smtr_ram_inst/AB_CM_smtr_ram_R0C0\ : RAM4K9
      port map(ADDRA11 => AFLSDF_GND, ADDRA10 => AFLSDF_GND, 
        ADDRA9 => AFLSDF_GND, ADDRA8 => \INIT_ADDR[8]\, ADDRA7
         => \INIT_ADDR[7]\, ADDRA6 => \INIT_ADDR[6]\, ADDRA5 => 
        \INIT_ADDR[5]\, ADDRA4 => \INIT_ADDR[4]\, ADDRA3 => 
        \INIT_ADDR[3]\, ADDRA2 => \INIT_ADDR[2]\, ADDRA1 => 
        \INIT_ADDR[1]\, ADDRA0 => \INIT_ADDR[0]\, ADDRB11 => 
        AFLSDF_GND, ADDRB10 => AFLSDF_GND, ADDRB9 => AFLSDF_GND, 
        ADDRB8 => \AB_CM_inst/TR_RAM_ADDR_B_net[8]\, ADDRB7 => 
        \AB_CM_inst/Z\\\\TR_RAM_ADDR_B_net\\\\\, ADDRB6 => 
        \AB_CM_inst/TR_RAM_ADDR_B_net_net_1\, ADDRB5 => 
        \AB_CM_inst/TR_RAM_ADDR_B_net_net_2\, ADDRB4 => 
        \AB_CM_inst/TR_RAM_ADDR_B_net_net_3\, ADDRB3 => 
        \AB_CM_inst/TR_RAM_ADDR_B_net_net_4\, ADDRB2 => 
        \AB_CM_inst/TR_RAM_ADDR_B_net_net_5\, ADDRB1 => 
        \AB_CM_inst/TR_RAM_ADDR_B_net_net_6\, ADDRB0 => 
        \AB_CM_inst/TR_RAM_ADDR_B_net_net_7\, DINA8 => 
        \INIT_DATA[8]\, DINA7 => \INIT_DATA[7]\, DINA6 => 
        \INIT_DATA[6]\, DINA5 => \INIT_DATA[5]\, DINA4 => 
        \INIT_DATA[4]\, DINA3 => \INIT_DATA[3]\, DINA2 => 
        \INIT_DATA[2]\, DINA1 => \INIT_DATA[1]\, DINA0 => 
        \INIT_DATA[0]\, DINB8 => \AB_CM_inst/TR_RAM_DI_B_net[8]\, 
        DINB7 => \AB_CM_inst/Z\\\\TR_RAM_DI_B_net\\\\\, DINB6 => 
        \AB_CM_inst/TR_RAM_DI_B_net_net_1\, DINB5 => 
        \AB_CM_inst/TR_RAM_DI_B_net_net_2\, DINB4 => 
        \AB_CM_inst/TR_RAM_DI_B_net_net_3\, DINB3 => 
        \AB_CM_inst/TR_RAM_DI_B_net_net_4\, DINB2 => 
        \AB_CM_inst/TR_RAM_DI_B_net_net_5\, DINB1 => 
        \AB_CM_inst/TR_RAM_DI_B_net_net_6\, DINB0 => 
        \AB_CM_inst/TR_RAM_DI_B_net_net_7\, WIDTHA0 => 
        SOC_VCC_NET, WIDTHA1 => SOC_VCC_NET, WIDTHB0 => 
        SOC_VCC_NET, WIDTHB1 => SOC_VCC_NET, PIPEA => \GND\, 
        PIPEB => \GND\, WMODEA => SOC_VCC_NET, WMODEB => 
        SOC_VCC_NET, BLKA => \AB_CM_inst/TR_RAM_RW_A_net\, BLKB
         => \AB_CM_inst/TR_RAM_CSN_B_net\, WENA => 
        \AB_CM_inst/TR_RAM_RW_A_net\, WENB => 
        \AB_CM_inst/xgnmbzmtzbb_0\, CLKA => SYSCLK_c, CLKB => 
        SYSCLK_c, RESET => SYSRSTn_c, DOUTA8 => OPEN, DOUTA7 => 
        OPEN, DOUTA6 => OPEN, DOUTA5 => OPEN, DOUTA4 => OPEN, 
        DOUTA3 => OPEN, DOUTA2 => OPEN, DOUTA1 => OPEN, DOUTA0
         => OPEN, DOUTB8 => \AB_CM_inst/TR_RAM_DO_B_net[8]\, 
        DOUTB7 => \AB_CM_inst/Z\\\\TR_RAM_DO_B_net\\\\\, DOUTB6
         => \AB_CM_inst/TR_RAM_DO_B_net_net_1\, DOUTB5 => 
        \AB_CM_inst/TR_RAM_DO_B_net_net_2\, DOUTB4 => 
        \AB_CM_inst/TR_RAM_DO_B_net_net_3\, DOUTB3 => 
        \AB_CM_inst/TR_RAM_DO_B_net_net_4\, DOUTB2 => 
        \AB_CM_inst/TR_RAM_DO_B_net_net_5\, DOUTB1 => 
        \AB_CM_inst/TR_RAM_DO_B_net_net_6\, DOUTB0 => 
        \AB_CM_inst/TR_RAM_DO_B_net_net_7\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/gjkdbmpgrtc_12[10]\ : 
        MX2
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_940\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_584\, 
        S => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rdgwgtpkbgc_1[2]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/gjkdbmpgrtc[10]\);
    
    
        \COMP_SM_inst/Subtract_inst/sumAux_0_0_SUB_12x12_medium_area_I34_Y\ : 
        OR2A
      port map(A => \COMP_SM_inst/R2[0]_net_1\, B => 
        \COMP_SM_inst/R1[0]_net_1\, Y => 
        \COMP_SM_inst/Subtract_inst/N173\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/xwhwqsjfmgh_0\ : 
        DFN1C0
      port map(D => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bskrjhjvqpf_6_sqmuxa\, 
        CLK => SYSCLK_c, CLR => SYSRSTn_c, Q => 
        \AB_CM_inst/EV_DONE_net_0\);
    
    
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/ksbhwjctscp[7]\ : 
        MX2
      port map(A => \INIT_ADDR[7]\, B => 
        \AB_CM_inst/Z\\\\EV_ASSCADDR_net\\\\\, S => INIT_DONE, Y
         => \AB_CM_inst/Z\\\\ASSC_RAM_ADDR_A_net\\\\\);
    
    
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/address_gen/u_dxwqxgdccxc/gnmdxrqrdgs[4]\ : 
        DFN1C0
      port map(D => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/address_gen/u_dxwqxgdccxc/gnmdxrqrdgs_3[4]\, 
        CLK => SYSCLK_c, CLR => SYSRSTn_c, Q => \INIT_ADDR[4]\);
    
    
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/un1_bksnhfwfshc_4_sqmuxa_1_0_o3\ : 
        NOR2B
      port map(A => \AB_CM_inst/ASSC_RAM_DO_B_net[8]\, B => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/jzzdfrmzwdj_0[14]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/N_254_i_0\);
    
    \COMP_SM_inst/Latest_Update_0_sqmuxa_0_a2_0\ : NOR2A
      port map(A => \COMP_SM_inst/completed_sync_net_1\, B => 
        \ADC_CHNUMBER[0]\, Y => \COMP_SM_inst/N_419\);
    
    
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/jfkkdmfhcdn_0_a3[8]\ : 
        NOR2A
      port map(A => \AB_CM_inst/TR_RAM_DO_B_net[8]\, B => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/frcskdnwvmx[0]_net_1\, 
        Y => \AB_CM_inst/TR_RAM_DI_B_net[8]\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnvtvdkcnpp_9[0]\ : 
        MX2
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnvtvdkcnpp_5[0]_net_1\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/fqkdsnjfpdb[6]\, 
        S => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx[4]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnvtvdkcnpp_9[0]_net_1\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/gjkdbmpgrtc75_0_a3_0_1\ : 
        OR2
      port map(A => 
        \AB_CM_inst.AB_CM_smev_wrapper_inst.U0.u_nbnjbfrkqwq.rdgwgtpkbgc[3]\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rdgwgtpkbgc_0[2]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/gjkdbmpgrtc75_0_a3_0_1_net_1\);
    
    
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/dbcvwwhvvwh[6]\ : 
        DFN1E1C0
      port map(D => \AB_CM_inst/ASSC_RAM_DO_B_net_net_1\, CLK => 
        SYSCLK_c, CLR => SYSRSTn_c, E => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/jzzdfrmzwdj[13]_net_1\, 
        Q => \AB_CM_inst/Z\\\\ADC_TVC_net\\\\\);
    
    \Diff2_pad[9]/U0/U0\ : IOPAD_TRI
      port map(D => \Diff2_pad[9]/U0/NET1\, E => 
        \Diff2_pad[9]/U0/NET2\, PAD => Diff2(9));
    
    \Diff1_pad[9]/U0/U0\ : IOPAD_TRI
      port map(D => \Diff1_pad[9]/U0/NET1\, E => 
        \Diff1_pad[9]/U0/NET2\, PAD => Diff1(9));
    
    
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/frcskdnwvmx_ns_i_m2[4]\ : 
        MX2A
      port map(A => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/hnbsspwxkpd_net_1\, 
        B => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/jnfrmfqggmk_net_1\, 
        S => \AB_CM_inst/TR_RAM_DO_B_net_net_2\, Y => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/N_233\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnvtvdkcnpp_0[2]\ : 
        DFN1C0
      port map(D => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnvtvdkcnpp_9[2]_net_1\, 
        CLK => SYSCLK_c, CLR => SYSRSTn_c, Q => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnvtvdkcnpp_0[2]_net_1\);
    
    
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/un1_cfxfrwgjccr_7_0\ : 
        OR2B
      port map(A => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/N_311\, 
        B => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/N_263\, 
        Y => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/un1_cfxfrwgjccr_7\);
    
    
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/address_gen/u_dxwqxgdccxc/jvbvzqvvxpc_gnmdxrqrdgs_3[4]\ : 
        XA1B
      port map(A => \INIT_ADDR[4]\, B => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/address_gen/u_dxwqxgdccxc/DWACT_ADD_CI_0_g_array_2[0]\, 
        C => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/wtjtwqjkqbd\, 
        Y => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/address_gen/u_dxwqxgdccxc/gnmdxrqrdgs_3[4]\);
    
    \Diff1_pad[6]/U0/U0\ : IOPAD_TRI
      port map(D => \Diff1_pad[6]/U0/NET1\, E => 
        \Diff1_pad[6]/U0/NET2\, PAD => Diff1(6));
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/fqkdsnjfpdb_0_0_ADD_18x18_medium_I62_un1_Y\ : 
        OR2
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ADD_18x18_medium_I62_un1_Y_0\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N297\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ADD_18x18_medium_I62_un1_Y\);
    
    
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/ddvbdtxtbpx_i_2_0\ : 
        OR2
      port map(A => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/jzzdfrmzwdj[5]_net_1\, 
        B => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/un1_AB_CM_inst_2_0\, 
        Y => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/ddvbdtxtbpx_i_2_0_net_1\);
    
    
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/dbcvwwhvvwh[7]\ : 
        DFN1E1C0
      port map(D => \AB_CM_inst/Z\\\\ASSC_RAM_DO_B_net\\\\\, CLK
         => SYSCLK_c, CLR => SYSRSTn_c, E => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/jzzdfrmzwdj[13]_net_1\, 
        Q => \AB_CM_inst/ADC_TVC_net[7]\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/mkmkbnghgkd[4]\ : 
        MX2
      port map(A => \INIT_ADDR[4]\, B => 
        \AB_CM_inst/TR_EV_ADDR_net_net_3\, S => INIT_DONE, Y => 
        \AB_CM_inst/EV_RAM_ADDR_A_net_net_3\);
    
    
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/dspfgfmqhwh[2]\ : 
        DFN1E1C0
      port map(D => \AB_CM_inst/ASSC_RAM_DO_B_net_net_5\, CLK => 
        SYSCLK_c, CLR => SYSRSTn_c, E => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/un1_AB_CM_inst_2_0\, 
        Q => \ADC_CHNUMBER[2]\);
    
    
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/init_fsm/u_stnpfdkggvx/mwtvnzdkmwm_ns[4]\ : 
        AO1
      port map(A => \NVM_CM_inst/NVM_BUSY_net\, B => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/xbkjkgdsbfh\, 
        C => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/mwtvnzdkmwm[4]\, 
        Y => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/init_fsm/u_stnpfdkggvx/mwtvnzdkmwm_ns[4]_net_1\);
    
    
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/un1_qgnzcpmbksd_I_53\ : 
        AND2
      port map(A => \AB_CM_inst/TR_RAM_ADDR_B_net_net_3\, B => 
        \AB_CM_inst/TR_RAM_ADDR_B_net_net_2\, Y => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/DWACT_ADD_CI_0_pog_array_1_1[0]\);
    
    \COMP_SM_inst/Diff_5[1]\ : DFN1E1C0
      port map(D => \COMP_SM_inst/Result[1]\, CLK => SYSCLK_c, 
        CLR => SYSRSTn_c, E => 
        \COMP_SM_inst/Latest_Update_5_sqmuxa\, Q => \Diff5_c[1]\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/un1_dhzrwbnrbpw_m[6]\ : 
        OR2B
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/I_33\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_201_i_0\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/un1_dhzrwbnrbpw_m[6]_net_1\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ftbkrvpxdbp[5]\ : 
        DFN1E0C0
      port map(D => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ftbkrvpxdbp_5[5]_net_1\, 
        CLK => SYSCLK_c, CLR => SYSRSTn_c, E => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ftbkrvpxdbp_1_sqmuxa_net_1\, 
        Q => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ftbkrvpxdbp[5]_net_1\);
    
    \COMP_SM_inst/Latest_Update_4_sqmuxa_0_a2\ : NOR2B
      port map(A => \ADC_CHNUMBER[3]\, B => \ADC_CHNUMBER[1]\, Y
         => \COMP_SM_inst/N_425\);
    
    
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/frcskdnwvmx_0[8]\ : 
        DFN1C0
      port map(D => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/frcskdnwvmx_ns_i[3]_net_1\, 
        CLK => SYSCLK_c, CLR => SYSRSTn_c, Q => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/frcskdnwvmx_0[8]_net_1\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ckghxwbsztp_3_0_o2[0]\ : 
        MX2A
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_924\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_965\, 
        S => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/spbznmtdmpd_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_923\);
    
    
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/address_gen/u_dxwqxgdccxc/jvbvzqvvxpc_un10_gnmdxrqrdgs_7\ : 
        XOR2
      port map(A => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/mmsccbknsvn[12]\, 
        B => \INIT_ADDR[7]\, Y => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/address_gen/u_dxwqxgdccxc/un10_gnmdxrqrdgs_7\);
    
    \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/G_128\ : 
        AO1
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnvtvdkcnpp_0[2]_net_1\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc[8]\, 
        C => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/G_128_0_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_283\);
    
    
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/save_fsm/u_wbsfnwwctpn/un5_jxxpqzrmzff_i_a3\ : 
        OR2
      port map(A => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/save_fsm/u_wbsfnwwctpn/crpwsdfhcqq[7]_net_1\, 
        B => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/save_fsm/u_wbsfnwwctpn/crpwsdfhcqq[3]_net_1\, 
        Y => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/N_51\);
    
    
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/qgnzcpmbksd[1]\ : 
        DFN1C0
      port map(D => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/qgnzcpmbksd_7[1]\, 
        CLK => SYSCLK_c, CLR => SYSRSTn_c, Q => 
        \AB_CM_inst/TR_RAM_ADDR_B_net_net_6\);
    
    
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/frcskdnwvmx[4]\ : 
        DFN1C0
      port map(D => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/frcskdnwvmx_ns[7]\, 
        CLK => SYSCLK_c, CLR => SYSRSTn_c, Q => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/frcskdnwvmx[4]_net_1\);
    
    
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/brxxctcvrmh_qgnzcpmbksd_7_0_iv[4]\ : 
        AO1B
      port map(A => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/N_230_i_0\, 
        B => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/I_30_0\, 
        C => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/qgnzcpmbksd_7_0_iv_0[4]\, 
        Y => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/qgnzcpmbksd_7[4]\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ckghxwbsztp_3_0_a3[4]\ : 
        XA1
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_4\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rqrqhcwpqdn[5]_net_1\, 
        C => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_923\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ckghxwbsztp_3[4]\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnvtvdkcnpp[5]\ : 
        DFN1C0
      port map(D => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnvtvdkcnpp_9[5]_net_1\, 
        CLK => SYSCLK_c, CLR => SYSRSTn_c, Q => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnvtvdkcnpp[5]_net_1\);
    
    
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/hgqdwrxvgzm_3[5]\ : 
        MX2
      port map(A => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/hgqdwrxvgzm[5]_net_1\, 
        B => \AB_CM_inst/ASSC_RAM_DO_B_net_net_2\, S => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/jzzdfrmzwdj[14]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/hgqdwrxvgzm_3[5]_net_1\);
    
    \Diff1_pad[5]/U0/U0\ : IOPAD_TRI
      port map(D => \Diff1_pad[5]/U0/NET1\, E => 
        \Diff1_pad[5]/U0/NET2\, PAD => Diff1(5));
    
    \COMP_SM_inst/Latest_Update_0_sqmuxa_0_a2\ : OR2
      port map(A => \ADC_CHNUMBER[4]\, B => \ADC_CHNUMBER[2]\, Y
         => \COMP_SM_inst/N_407\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/un1_qvqqfftqsfc\ : 
        OR2B
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx[9]_net_1\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/kkgccghmrzf_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/un1_qvqqfftqsfc_net_1\);
    
    \Diff0_pad[0]/U0/U0\ : IOPAD_TRI
      port map(D => \Diff0_pad[0]/U0/NET1\, E => 
        \Diff0_pad[0]/U0/NET2\, PAD => Diff0(0));
    
    \Diff0_pad[9]/U0/U0\ : IOPAD_TRI
      port map(D => \Diff0_pad[9]/U0/NET1\, E => 
        \Diff0_pad[9]/U0/NET2\, PAD => Diff0(9));
    
    
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/frcskdnwvmx_ns_i[4]\ : 
        NOR3A
      port map(A => INIT_DONE, B => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/N_272\, 
        C => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/N_271\, 
        Y => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/frcskdnwvmx_ns_i[4]_net_1\);
    
    
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/jzzdfrmzwdj_ns_i[14]\ : 
        OR3C
      port map(A => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/N_305\, 
        B => INIT_DONE, C => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/N_303\, 
        Y => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/N_226_i_0\);
    
    
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/init_fsm/u_stnpfdkggvx/un2_grfncxsbmcc_i_a2\ : 
        OR2
      port map(A => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/init_fsm/u_stnpfdkggvx/mwtvnzdkmwm[6]_net_1\, 
        B => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/init_fsm/u_stnpfdkggvx/mwtvnzdkmwm[5]_net_1\, 
        Y => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/N_42\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/mtbjcfqsbqf_m[3]\ : 
        OR2B
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rgmpzqrbghh_net_1\, 
        B => \AB_CM_inst/Z\\\\EV_CHHOLD_net\\\\\, Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/mtbjcfqsbqf_m[3]_net_1\);
    
    \COMP_SM_inst/prev_channel[0]\ : DFN1E1C0
      port map(D => \ADC_CHNUMBER[0]\, CLK => SYSCLK_c, CLR => 
        SYSRSTn_c, E => ASSC_DONE, Q => 
        \COMP_SM_inst/prev_channel[0]_net_1\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rdgwgtpkbgc_1[0]\ : 
        DFN1E0C0
      port map(D => \AB_CM_inst/EV_RAM_DO_B_net_net_7\, CLK => 
        SYSCLK_c, CLR => SYSRSTn_c, E => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bskrjhjvqpf_1_sqmuxa_0\, 
        Q => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rdgwgtpkbgc_1[0]_net_1\);
    
    
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/address_gen/u_dxwqxgdccxc/un1_dkjzqmrkvwb_ADD_13x13_fast_I35_Y\ : 
        OR3C
      port map(A => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/address_gen/u_dxwqxgdccxc/I13_un1_Y\, 
        B => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/N189\, 
        C => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/address_gen/u_dxwqxgdccxc/I35_un1_Y\, 
        Y => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/N246\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/fqkdsnjfpdb_m[6]\ : 
        OR2B
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx[5]_net_1\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/fqkdsnjfpdb[6]\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/fqkdsnjfpdb_m[6]_net_1\);
    
    
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/address_gen/u_dxwqxgdccxc/un1_dkjzqmrkvwb_ADD_13x13_fast_I15_Y\ : 
        AOI1
      port map(A => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/ggfvvjbkdws[7]\, 
        B => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/mmsccbknsvn[12]\, 
        C => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/address_gen/u_dxwqxgdccxc/ggfvvjbkdws[8]_net_1\, 
        Y => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/N222\);
    
    
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/brxxctcvrmh_qgnzcpmbksd_7_0_iv_0[5]\ : 
        AOI1B
      port map(A => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/N_310\, 
        B => \AB_CM_inst/EV_CHHOLD_net[4]\, C => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/tpxkpvnpvvn_m_0[5]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/qgnzcpmbksd_7_0_iv_0[5]\);
    
    \COMP_SM_inst/Diff_4[5]\ : DFN1E1C0
      port map(D => \COMP_SM_inst/Result[5]\, CLK => SYSCLK_c, 
        CLR => SYSRSTn_c, E => 
        \COMP_SM_inst/Latest_Update_4_sqmuxa\, Q => \Diff4_c[5]\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/gjkdbmpgrtc_11[12]\ : 
        MX2
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_968\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rqrqhcwpqdn[6]_net_1\, 
        S => 
        \AB_CM_inst.AB_CM_smev_wrapper_inst.U0.u_nbnjbfrkqwq.rdgwgtpkbgc[3]\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_586\);
    
    
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/hgqdwrxvgzm[4]\ : 
        DFN1E1C0
      port map(D => \AB_CM_inst/ASSC_RAM_DO_B_net_net_3\, CLK => 
        SYSCLK_c, CLR => SYSRSTn_c, E => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/jzzdfrmzwdj[14]_net_1\, 
        Q => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/hgqdwrxvgzm[4]_net_1\);
    
    \COMP_SM_inst/Diff_0[11]\ : DFN1E1C0
      port map(D => \COMP_SM_inst/Result[11]\, CLK => SYSCLK_c, 
        CLR => SYSRSTn_c, E => 
        \COMP_SM_inst/Latest_Update_0_sqmuxa\, Q => \Diff0_c[11]\);
    
    
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/ksbhwjctscp[0]\ : 
        MX2B
      port map(A => \INIT_ADDR[0]\, B => 
        \AB_CM_inst/EV_ASSCADDR_net_net_5\, S => INIT_DONE, Y => 
        \AB_CM_inst/ASSC_RAM_ADDR_A_net_net_7\);
    
    \Diff5_pad[11]/U0/U0\ : IOPAD_TRI
      port map(D => \Diff5_pad[11]/U0/NET1\, E => 
        \Diff5_pad[11]/U0/NET2\, PAD => Diff5(11));
    
    \Diff0_pad[5]/U0/U1\ : IOTRI_OB_EB
      port map(D => \Diff0_c[5]\, E => SOC_VCC_NET, DOUT => 
        \Diff0_pad[5]/U0/NET1\, EOUT => \Diff0_pad[5]/U0/NET2\);
    
    \COMP_SM_inst/Diff_4[10]\ : DFN1E1C0
      port map(D => \COMP_SM_inst/Result[10]\, CLK => SYSCLK_c, 
        CLR => SYSRSTn_c, E => 
        \COMP_SM_inst/Latest_Update_4_sqmuxa\, Q => \Diff4_c[10]\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/fqkdsnjfpdb_0_0_ADD_18x18_medium_I104_Y\ : 
        AX1E
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/I86_un1_Y_i\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N264\, 
        C => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ADD_18x18_medium_I104_Y_0\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/fqkdsnjfpdb[12]\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc_12[5]\ : 
        MX2
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_715\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc_11[5]_net_1\, 
        S => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rdgwgtpkbgc_2[2]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc[5]\);
    
    
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/jzzdfrmzwdj[9]\ : 
        DFN1C0
      port map(D => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/jzzdfrmzwdj_ns_i_1[6]_net_1\, 
        CLK => SYSCLK_c, CLR => SYSRSTn_c, Q => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/jzzdfrmzwdj[9]_net_1\);
    
    \Diff5_pad[6]/U0/U0\ : IOPAD_TRI
      port map(D => \Diff5_pad[6]/U0/NET1\, E => 
        \Diff5_pad[6]/U0/NET2\, PAD => Diff5(6));
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/pvtdpmmqdpp_un2_pbzxzjhqhwz_0_I_24\ : 
        OR2A
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnvtvdkcnpp[11]_net_1\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rqrqhcwpqdn[11]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_35\);
    
    
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/save_fsm/u_wbsfnwwctpn/crpwsdfhcqq[5]\ : 
        DFN1C0
      port map(D => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/save_fsm/u_wbsfnwwctpn/crpwsdfhcqq_ns[3]_net_1\, 
        CLK => SYSCLK_c, CLR => SYSRSTn_c, Q => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/npgnwznthhx\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/fqkdsnjfpdb_0_0_ADD_18x18_medium_I3_P0N\ : 
        XO1A
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc[3]\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/G_99_0_net_1\, 
        C => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ADD_18x18_medium_I3_P0N_0\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N241\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnvtvdkcnpp_9[11]\ : 
        MX2
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnvtvdkcnpp_8[11]_net_1\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/fqkdsnjfpdb[17]\, 
        S => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx_1[4]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnvtvdkcnpp_9[11]_net_1\);
    
    
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/init_fsm/u_stnpfdkggvx/mwtvnzdkmwm_ns_a2[5]\ : 
        NOR3B
      port map(A => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/xbkjkgdsbfh\, 
        B => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/mhxwcfnvbgt\, 
        C => \NVM_CM_inst/NVM_BUSY_net\, Y => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/init_fsm/u_stnpfdkggvx/mwtvnzdkmwm_ns[5]\);
    
    
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/hgqdwrxvgzm_3[1]\ : 
        MX2
      port map(A => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/hgqdwrxvgzm[1]_net_1\, 
        B => \AB_CM_inst/ASSC_RAM_DO_B_net_net_6\, S => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/jzzdfrmzwdj_0[14]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/hgqdwrxvgzm_3[1]_net_1\);
    
    \Diff0_pad[2]/U0/U1\ : IOTRI_OB_EB
      port map(D => \Diff0_c[2]\, E => SOC_VCC_NET, DOUT => 
        \Diff0_pad[2]/U0/NET1\, EOUT => \Diff0_pad[2]/U0/NET2\);
    
    \COMP_SM_inst/Diff_2[0]\ : DFN1E0C0
      port map(D => \COMP_SM_inst/N139\, CLK => SYSCLK_c, CLR => 
        SYSRSTn_c, E => \COMP_SM_inst/Latest_Update_2_sqmuxa_0\, 
        Q => \Diff2_c[0]\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rqrqhcwpqdn_9_sn_m1\ : 
        NOR2
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/un1_mvnkctvqsgp_net_1\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx[6]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_838\);
    
    
        \COMP_SM_inst/Subtract_inst/sumAux_0_0_SUB_12x12_medium_area_I39_un1_Y\ : 
        OR3C
      port map(A => \COMP_SM_inst/Subtract_inst/N141\, B => 
        \COMP_SM_inst/Subtract_inst/N143\, C => 
        \COMP_SM_inst/Subtract_inst/N173\, Y => 
        \COMP_SM_inst/Subtract_inst/I39_un1_Y\);
    
    \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/G_148\ : 
        OR2
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_305\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/G_148_0_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_303\);
    
    
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/un1_bksnhfwfshc_4_sqmuxa_1_0_a3\ : 
        NOR2A
      port map(A => INIT_DONE, B => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/N_311\, 
        Y => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/N_272\);
    
    \COMP_SM_inst/statereg_un2_resetn\ : NOR2B
      port map(A => SYSRSTn_c, B => INIT_DONE, Y => 
        \COMP_SM_inst/un2_resetn\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/un3_ckghxwbsztp_I_19\ : 
        NOR2B
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rqrqhcwpqdn[4]_net_1\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/DWACT_FINC_E[0]\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_4\);
    
    
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/qgnzcpmbksd[3]\ : 
        DFN1C0
      port map(D => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/qgnzcpmbksd_7[3]\, 
        CLK => SYSCLK_c, CLR => SYSRSTn_c, Q => 
        \AB_CM_inst/TR_RAM_ADDR_B_net_net_4\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rqrqhcwpqdn[4]\ : 
        DFN1E1C0
      port map(D => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_818\, 
        CLK => SYSCLK_c, CLR => SYSRSTn_c, E => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_823\, 
        Q => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rqrqhcwpqdn[4]_net_1\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/qrbxknbdvjj_m[5]\ : 
        OR3B
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx[8]_net_1\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/qrbxknbdvjj[5]_net_1\, 
        C => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rgmpzqrbghh_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/qrbxknbdvjj_m[5]_net_1\);
    
    \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/G_129\ : 
        XNOR3
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/gjkdbmpgrtc[9]\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnvtvdkcnpp[3]_net_1\, 
        C => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc[9]\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_287\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/fqkdsnjfpdb_0_0_ADD_18x18_medium_I30_un1_Y\ : 
        OAI1
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/G_103_0_net_1\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ADD_18x18_medium_I4_P0N_0\, 
        C => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N240\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ADD_18x18_medium_I30_un1_Y\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx[3]\ : 
        DFN1C0
      port map(D => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx_ns[14]\, 
        CLK => SYSCLK_c, CLR => SYSRSTn_c, Q => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx[3]_net_1\);
    
    \Diff2_pad[5]/U0/U1\ : IOTRI_OB_EB
      port map(D => \Diff2_c[5]\, E => SOC_VCC_NET, DOUT => 
        \Diff2_pad[5]/U0/NET1\, EOUT => \Diff2_pad[5]/U0/NET2\);
    
    \COMP_SM_inst/R1[5]\ : DFN1E1C0
      port map(D => \ADC_RESULT[5]\, CLK => SYSCLK_c, CLR => 
        SYSRSTn_c, E => \COMP_SM_inst/pres_state_0[3]_net_1\, Q
         => \COMP_SM_inst/R1[5]_net_1\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc_7_0_a3[16]\ : 
        NOR2A
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_966\, 
        B => 
        \AB_CM_inst.AB_CM_smev_wrapper_inst.U0.u_nbnjbfrkqwq.rdgwgtpkbgc[3]\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_960\);
    
    
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/address_gen/u_dxwqxgdccxc/ggfvvjbkdws[4]\ : 
        MX2C
      port map(A => \INIT_ADDR[4]\, B => \INIT_ADDR[3]\, S => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/ggsxvgncrgz[0]\, 
        Y => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/ggfvvjbkdws[4]\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx_ns_i[12]\ : 
        NOR2B
      port map(A => INIT_DONE, B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx[6]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx_ns_i[12]_net_1\);
    
    
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/sxrhkdkngbh_m\ : 
        AO1D
      port map(A => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/hnbsspwxkpd_net_1\, 
        B => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/jnfrmfqggmk_net_1\, 
        C => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/cpwfrthtnfr_13_sqmuxa_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/sxrhkdkngbh_m_net_1\);
    
    \COMP_SM_inst/Latest_Update_1_sqmuxa_0_a2_0\ : NOR2B
      port map(A => \COMP_SM_inst/completed_sync_net_1\, B => 
        \ADC_CHNUMBER[0]\, Y => \COMP_SM_inst/N_420\);
    
    
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/un1_bksnhfwfshc_4_sqmuxa_1_0_a3_0\ : 
        OR3B
      port map(A => \AB_CM_inst/ASSC_RAM_DO_B_net_net_1\, B => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/N_254_i_0\, 
        C => \AB_CM_inst/Z\\\\ASSC_RAM_DO_B_net\\\\\, Y => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/N_311\);
    
    
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/mksbfqnmmgw[0]\ : 
        MX2
      port map(A => \ADC_RESULT[0]\, B => \ADC_RESULT[9]\, S => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/jzzdfrmzwdj[4]_net_1\, 
        Y => \AB_CM_inst/ASSC_RAM_DI_B_net_net_7\);
    
    
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/init_fsm/u_stnpfdkggvx/mwtvnzdkmwm_ns_a2[6]\ : 
        NOR3C
      port map(A => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/gpbbjwsprsj[0]\, 
        B => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/gpbbjwsprsj[1]\, 
        C => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/init_fsm/u_stnpfdkggvx/mwtvnzdkmwm[2]_net_1\, 
        Y => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/init_fsm/u_stnpfdkggvx/mwtvnzdkmwm_ns[6]\);
    
    
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/address_gen/u_dxwqxgdccxc/un1_gnmdxrqrdgs_I_46\ : 
        NOR3C
      port map(A => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/address_gen/u_dxwqxgdccxc/DWACT_ADD_CI_0_pog_array_1_1[0]\, 
        B => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/address_gen/u_dxwqxgdccxc/DWACT_ADD_CI_0_pog_array_1_2[0]\, 
        C => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/address_gen/u_dxwqxgdccxc/DWACT_ADD_CI_0_g_array_2[0]\, 
        Y => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/address_gen/u_dxwqxgdccxc/DWACT_ADD_CI_0_g_array_3[0]\);
    
    \Diff3_pad[9]/U0/U1\ : IOTRI_OB_EB
      port map(D => \Diff3_c[9]\, E => SOC_VCC_NET, DOUT => 
        \Diff3_pad[9]/U0/NET1\, EOUT => \Diff3_pad[9]/U0/NET2\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/fqkdsnjfpdb_0_0_ADD_18x18_medium_I67_Y_0\ : 
        AO1D
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N287\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N288\, 
        C => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N286\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ADD_18x18_medium_I67_Y_0\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/gjkdbmpgrtc_6_0_a3[9]\ : 
        NOR3A
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rqrqhcwpqdn[11]_net_1\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rdgwgtpkbgc[0]_net_1\, 
        C => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rdgwgtpkbgc_2[1]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_939\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ckghxwbsztp[2]\ : 
        DFN1E1C0
      port map(D => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ckghxwbsztp_3[2]\, 
        CLK => SYSCLK_c, CLR => SYSRSTn_c, E => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx[1]_net_1\, 
        Q => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ckghxwbsztp[2]_net_1\);
    
    
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/init_fsm/u_stnpfdkggvx/mwtvnzdkmwm[4]\ : 
        DFN1C0
      port map(D => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/init_fsm/u_stnpfdkggvx/mwtvnzdkmwm_ns[3]_net_1\, 
        CLK => SYSCLK_c, CLR => SYSRSTn_c, Q => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/mwtvnzdkmwm[4]\);
    
    \Diff1_pad[11]/U0/U0\ : IOPAD_TRI
      port map(D => \Diff1_pad[11]/U0/NET1\, E => 
        \Diff1_pad[11]/U0/NET2\, PAD => Diff1(11));
    
    \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/G_168\ : 
        AO18
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnvtvdkcnpp[10]_net_1\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc[16]\, 
        C => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/gjkdbmpgrtc[16]\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_323_i\);
    
    
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/bnrsdrtmtsg_5[1]\ : 
        MX2
      port map(A => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/hgqdwrxvgzm_3[1]_net_1\, 
        B => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/trnwxjxxrbp[1]_net_1\, 
        S => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/N_345\, 
        Y => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/N_354\);
    
    \COMP_SM_inst/Diff_0[7]\ : DFN1E1C0
      port map(D => \COMP_SM_inst/Result[7]\, CLK => SYSCLK_c, 
        CLR => SYSRSTn_c, E => 
        \COMP_SM_inst/Latest_Update_0_sqmuxa\, Q => \Diff0_c[7]\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/pvtdpmmqdpp_un2_pbzxzjhqhwz_0_I_44\ : 
        AND2A
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rqrqhcwpqdn[5]_net_1\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnvtvdkcnpp[5]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ACT_LT3_E[2]\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/mtbjcfqsbqf[2]\ : 
        DFN1E1C0
      port map(D => \ADC_CHNUMBER[2]\, CLK => SYSCLK_c, CLR => 
        SYSRSTn_c, E => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/qmmwhjxxxmv_net_1\, 
        Q => \AB_CM_inst/EV_CHHOLD_net_net_1\);
    
    
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/user_control/u_ffppvfwnggt/srdtcqsfmmm_i[6]\ : 
        NOR2A
      port map(A => \NVM_CM_inst/un1_wxqqqsndpvg_i_0\, B => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/ggfvvjbkdws[6]\, 
        Y => \NVM_CM_inst/srdtcqsfmmm_i[6]\);
    
    \COMP_SM_inst/pres_state[2]\ : DFN1C0
      port map(D => \COMP_SM_inst/pres_state_ns[2]\, CLK => 
        SYSCLK_c, CLR => \COMP_SM_inst/un2_resetn\, Q => 
        \COMP_SM_inst/pres_state[2]_net_1\);
    
    \SPARE_pad/U0/U1\ : IOTRI_OB_EB
      port map(D => SPARE_c, E => SOC_VCC_NET, DOUT => 
        \SPARE_pad/U0/NET1\, EOUT => \SPARE_pad/U0/NET2\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rqrqhcwpqdn[9]\ : 
        DFN1E0C0
      port map(D => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_835\, 
        CLK => SYSCLK_c, CLR => SYSRSTn_c, E => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_838\, 
        Q => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rqrqhcwpqdn[9]_net_1\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/pptwzsjcmcz_dhzrwbnrbpw_7_iv_0[0]\ : 
        AOI1B
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_199_i_0\, 
        B => \AB_CM_inst/EV_RAM_DO_B_net_net_7\, C => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/qrbxknbdvjj_m[0]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/dhzrwbnrbpw_7_iv_0[0]\);
    
    \Diff2_pad[1]/U0/U1\ : IOTRI_OB_EB
      port map(D => \Diff2_c[1]\, E => SOC_VCC_NET, DOUT => 
        \Diff2_pad[1]/U0/NET1\, EOUT => \Diff2_pad[1]/U0/NET2\);
    
    
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/frcskdnwvmx_ns_i_a3_0[5]\ : 
        AND3C
      port map(A => \AB_CM_inst/Z\\\\TR_RAM_DO_B_net\\\\\, B => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/N_287\, 
        C => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/N_234_i\, 
        Y => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/N_274\);
    
    
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/cpwfrthtnfr_11_sqmuxa_0_a3\ : 
        OR3B
      port map(A => \AB_CM_inst/TR_RAM_DO_B_net[8]\, B => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/N_285\, 
        C => \AB_CM_inst/TR_RAM_DO_B_net_net_1\, Y => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/cpwfrthtnfr_11_sqmuxa\);
    
    
        \COMP_SM_inst/Subtract_inst/sumAux_0_0_SUB_12x12_medium_area_I77_Y\ : 
        XOR3
      port map(A => \COMP_SM_inst/R1[10]_net_1\, B => 
        \COMP_SM_inst/R2[10]_net_1\, C => 
        \COMP_SM_inst/Subtract_inst/N214_i\, Y => 
        \COMP_SM_inst/Result[10]\);
    
    \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/G_149\ : 
        XNOR3
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/gjkdbmpgrtc[13]\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnvtvdkcnpp[7]_net_1\, 
        C => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc[13]\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_307\);
    
    \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/G_146\ : 
        NOR2A
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnvtvdkcnpp[6]_net_1\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc[12]\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_305\);
    
    
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/znbkwkbspdc_1_i_o3\ : 
        NOR2
      port map(A => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/N_318\, 
        B => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/N_256\, 
        Y => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/N_263\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/fqkdsnjfpdb_0_0_ADD_18x18_medium_I75_Y_2\ : 
        OA1A
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N306\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N303\, 
        C => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ADD_18x18_medium_I75_Y_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ADD_18x18_medium_I75_Y_2\);
    
    \COMP_SM_inst/Diff_2[6]\ : DFN1E0C0
      port map(D => \COMP_SM_inst/Result[6]\, CLK => SYSCLK_c, 
        CLR => SYSRSTn_c, E => 
        \COMP_SM_inst/Latest_Update_2_sqmuxa\, Q => \Diff2_c[6]\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/gjkdbmpgrtc_12[11]\ : 
        MX2
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_941\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_585\, 
        S => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rdgwgtpkbgc_1[2]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/gjkdbmpgrtc[11]\);
    
    \Diff3_pad[10]/U0/U1\ : IOTRI_OB_EB
      port map(D => \Diff3_c[10]\, E => SOC_VCC_NET, DOUT => 
        \Diff3_pad[10]/U0/NET1\, EOUT => \Diff3_pad[10]/U0/NET2\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/fqkdsnjfpdb_0_0_ADD_18x18_medium_I13_G0N\ : 
        NOR2B
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_307\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_303\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N270\);
    
    
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/jzzdfrmzwdj_ns_i_1[8]\ : 
        NOR2B
      port map(A => INIT_DONE, B => \AB_CM_inst/ADC_START_net\, Y
         => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/jzzdfrmzwdj_ns_i_1[8]_net_1\);
    
    \COMP_SM_inst/Diff_3[6]\ : DFN1E1C0
      port map(D => \COMP_SM_inst/Result[6]\, CLK => SYSCLK_c, 
        CLR => SYSRSTn_c, E => 
        \COMP_SM_inst/Latest_Update_3_sqmuxa\, Q => \Diff3_c[6]\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/pvtdpmmqdpp_un2_pbzxzjhqhwz_0_I_5\ : 
        XNOR2
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnvtvdkcnpp[7]_net_1\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rqrqhcwpqdn[7]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/DWACT_BL_EQUAL_0_E_0[0]\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/gjkdbmpgrtc_11_0_a3[3]\ : 
        NOR2A
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_445\, 
        B => 
        \AB_CM_inst.AB_CM_smev_wrapper_inst.U0.u_nbnjbfrkqwq.rdgwgtpkbgc[3]\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_950\);
    
    
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/ptxbvztnpnf[2]\ : 
        DFN1E1C0
      port map(D => \AB_CM_inst/ASSC_RAM_DO_B_net_net_5\, CLK => 
        SYSCLK_c, CLR => SYSRSTn_c, E => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/jzzdfrmzwdj[11]_net_1\, 
        Q => \AB_CM_inst/ADC_STC_net_net_4\);
    
    
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/save_fsm/u_wbsfnwwctpn/bzcdnkppzhj[0]\ : 
        DFN1C0
      port map(D => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/save_fsm/u_wbsfnwwctpn/DWACT_ADD_CI_0_partial_sum[0]\, 
        CLK => SYSCLK_c, CLR => SYSRSTn_c, Q => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/vvpkfmmpprk[0]\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc_3_0_a2[16]\ : 
        NOR2A
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_754\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rdgwgtpkbgc_1[1]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_966\);
    
    \COMP_SM_inst/Latest_Update_9_a2_0_a2[1]\ : NOR2A
      port map(A => \ADC_CHNUMBER[3]\, B => \COMP_SM_inst/N_407\, 
        Y => \COMP_SM_inst/Latest_Update_9[1]\);
    
    
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/cpwfrthtnfr_13_sqmuxa_1_0_a2\ : 
        OR3C
      port map(A => \AB_CM_inst/TR_RAM_DO_B_net_0[8]\, B => 
        \AB_CM_inst/TR_RAM_DO_B_net_net_1_0\, C => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/cpwfrthtnfr_10_sqmuxa_0_a3_0\, 
        Y => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/cpwfrthtnfr_13_sqmuxa_1\);
    
    
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/ksbhwjctscp[4]\ : 
        MX2
      port map(A => \INIT_ADDR[4]\, B => 
        \AB_CM_inst/EV_ASSCADDR_net_net_3\, S => INIT_DONE, Y => 
        \AB_CM_inst/ASSC_RAM_ADDR_A_net_net_3\);
    
    
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/user_control/u_ffppvfwnggt/srdtcqsfmmm_i[5]\ : 
        NOR2A
      port map(A => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/user_control/u_ffppvfwnggt/un1_wxqqqsndpvg_i_0_0\, 
        B => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/ggfvvjbkdws[5]\, 
        Y => \NVM_CM_inst/srdtcqsfmmm_i[5]\);
    
    
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/dbcvwwhvvwh[2]\ : 
        DFN1E1C0
      port map(D => \AB_CM_inst/ASSC_RAM_DO_B_net_net_5\, CLK => 
        SYSCLK_c, CLR => SYSRSTn_c, E => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/jzzdfrmzwdj[13]_net_1\, 
        Q => \AB_CM_inst/ADC_TVC_net_net_4\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/un1_dhzrwbnrbpw_m[2]\ : 
        XAI1
      port map(A => \AB_CM_inst/EV_RAM_ADDR_B_net_net_6\, B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/DWACT_ADD_CI_0_TMP[0]\, 
        C => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_201_i_0\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/un1_dhzrwbnrbpw_m[2]_net_1\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx_ns_o3[0]\ : 
        NOR2A
      port map(A => INIT_DONE, B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bskrjhjvqpf_6_sqmuxa\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_211\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx_ns_o2[4]\ : 
        OR3
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_209\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx[2]_net_1\, 
        C => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_207\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_216\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/dhzrwbnrbpw[2]\ : 
        DFN1C0
      port map(D => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/dhzrwbnrbpw_7[2]\, 
        CLK => SYSCLK_c, CLR => SYSRSTn_c, Q => 
        \AB_CM_inst/EV_RAM_ADDR_B_net_net_5\);
    
    
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/bksnhfwfshc_6_sqmuxa_0_o3\ : 
        ZOR3I
      port map(A => \AB_CM_inst/Z\\\\ASSC_RAM_DO_B_net\\\\\, B
         => \AB_CM_inst/ASSC_RAM_DO_B_net_net_1\, C => 
        \AB_CM_inst/ASSC_RAM_DO_B_net[8]\, Y => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/N_251\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/dhzrwbnrbpw[5]\ : 
        DFN1C0
      port map(D => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/dhzrwbnrbpw_7[5]\, 
        CLK => SYSCLK_c, CLR => SYSRSTn_c, Q => 
        \AB_CM_inst/EV_RAM_ADDR_B_net_net_2\);
    
    
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/valid_client/u_gpbdjfttbjd/fpppnnsbksx_0_a3[1]\ : 
        OR3B
      port map(A => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/npgnwznthhx\, 
        B => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/vvpkfmmpprk[0]\, 
        C => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/vvpkfmmpprk[1]\, 
        Y => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/valid_client/u_gpbdjfttbjd/N_20\);
    
    \Diff2_pad[4]/U0/U0\ : IOPAD_TRI
      port map(D => \Diff2_pad[4]/U0/NET1\, E => 
        \Diff2_pad[4]/U0/NET2\, PAD => Diff2(4));
    
    \Diff4_pad[11]/U0/U0\ : IOPAD_TRI
      port map(D => \Diff4_pad[11]/U0/NET1\, E => 
        \Diff4_pad[11]/U0/NET2\, PAD => Diff4(11));
    
    \Diff5_pad[2]/U0/U1\ : IOTRI_OB_EB
      port map(D => \Diff5_c[2]\, E => SOC_VCC_NET, DOUT => 
        \Diff5_pad[2]/U0/NET1\, EOUT => \Diff5_pad[2]/U0/NET2\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/fqkdsnjfpdb_0_0_ADD_18x18_medium_I30_Y\ : 
        OR2B
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N243\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ADD_18x18_medium_I30_un1_Y\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ADD_18x18_medium_I30_Y\);
    
    \Diff3_pad[5]/U0/U1\ : IOTRI_OB_EB
      port map(D => \Diff3_c[5]\, E => SOC_VCC_NET, DOUT => 
        \Diff3_pad[5]/U0/NET1\, EOUT => \Diff3_pad[5]/U0/NET2\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/gjkdbmpgrtc_12[16]\ : 
        MX2
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_946\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_590\, 
        S => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rdgwgtpkbgc_2[2]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/gjkdbmpgrtc[16]\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc_11_d_s[3]\ : 
        NOR2A
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rdgwgtpkbgc_0[0]_net_1\, 
        B => 
        \AB_CM_inst.AB_CM_smev_wrapper_inst.U0.u_nbnjbfrkqwq.rdgwgtpkbgc[3]\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc_11_d_s[3]_net_1\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx[8]\ : 
        DFN1C0
      port map(D => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx_ns_i[9]_net_1\, 
        CLK => SYSCLK_c, CLR => SYSRSTn_c, Q => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx[8]_net_1\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rqrqhcwpqdn_5_0[4]\ : 
        MX2
      port map(A => \AB_CM_inst/ASSC_RAM_DO_A_net_net_3\, B => 
        \AB_CM_inst/EV_RAM_DO_B_net_net_3\, S => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/un1_xkwrgrspmcf_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_818\);
    
    \COMP_SM_inst/pres_state_ns_a5_0_a4[2]\ : NOR3C
      port map(A => \COMP_SM_inst/pres_state[1]_net_1\, B => 
        \COMP_SM_inst/valid_net_1\, C => ASSC_DONE, Y => 
        \COMP_SM_inst/pres_state_ns[2]\);
    
    
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/user_control/u_ffppvfwnggt/pqmzrrnpzvx_0_o2_0[0]\ : 
        NOR2
      port map(A => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/vvpkfmmpprk[1]\, 
        B => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/vvpkfmmpprk[0]\, 
        Y => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/N_1839\);
    
    
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/user_clk_sel/u_jhmkpjjmdkx/hrgmtcpsdzr\ : 
        DFN1C0
      port map(D => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/user_clk_sel/u_jhmkpjjmdkx/crmctgwbctb_net_1\, 
        CLK => SYSCLK_c, CLR => SYSRSTn_c, Q => hrgmtcpsdzr);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/pvtdpmmqdpp_un2_pbzxzjhqhwz_0_I_34\ : 
        XNOR2
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnvtvdkcnpp[4]_net_1\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rqrqhcwpqdn[4]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/DWACT_BL_EQUAL_0_E[0]\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/fqkdsnjfpdb_0_0_ADD_18x18_medium_I101_Y\ : 
        XNOR3
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_283\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_287\, 
        C => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N349\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/fqkdsnjfpdb_i[9]\);
    
    
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/jzzdfrmzwdj_ns_i[9]\ : 
        OA1
      port map(A => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/jzzdfrmzwdj[7]_net_1\, 
        B => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/jzzdfrmzwdj_ns_i_0_tz[9]_net_1\, 
        C => INIT_DONE, Y => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/jzzdfrmzwdj_ns_i[9]_net_1\);
    
    
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/save_fsm/u_wbsfnwwctpn/crpwsdfhcqq_ns_a3[6]\ : 
        OR2B
      port map(A => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/mhxwcfnvbgt\, 
        B => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/save_fsm/u_wbsfnwwctpn/jspcghhzwmg\, 
        Y => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/save_fsm/u_wbsfnwwctpn/N_60\);
    
    \Diff1_pad[4]/U0/U0\ : IOPAD_TRI
      port map(D => \Diff1_pad[4]/U0/NET1\, E => 
        \Diff1_pad[4]/U0/NET2\, PAD => Diff1(4));
    
    
        \COMP_SM_inst/Subtract_inst/sumAux_0_0_SUB_12x12_medium_area_I66_un1_Y\ : 
        NOR2B
      port map(A => \COMP_SM_inst/Subtract_inst/N173\, B => 
        \COMP_SM_inst/Subtract_inst/N141\, Y => 
        \COMP_SM_inst/Subtract_inst/I66_un1_Y\);
    
    
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/un1_qgnzcpmbksd_I_21\ : 
        XOR2
      port map(A => \AB_CM_inst/TR_RAM_ADDR_B_net_net_7\, B => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/jvxfmjbzjmc_i_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/DWACT_ADD_CI_0_partial_sum[0]\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/gjkdbmpgrtc_7_0_a3[10]\ : 
        NOR2A
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_448\, 
        B => 
        \AB_CM_inst.AB_CM_smev_wrapper_inst.U0.u_nbnjbfrkqwq.rdgwgtpkbgc[3]\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_940\);
    
    
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/fsrxhtjthgw_i_a2_0\ : 
        OR2
      port map(A => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/N_253\, 
        B => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/N_248\, 
        Y => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/N_315\);
    
    
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/user_control/u_ffppvfwnggt/srdtcqsfmmm_i[12]\ : 
        XA1A
      port map(A => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/ggfvvjbkdws[7]\, 
        B => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/mmsccbknsvn[12]\, 
        C => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/user_control/u_ffppvfwnggt/un1_wxqqqsndpvg_i_0_0\, 
        Y => \NVM_CM_inst/srdtcqsfmmm_i[12]\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc_11_d[7]\ : 
        MX2
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_749\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnvtvdkcnpp[1]_net_1\, 
        S => 
        \AB_CM_inst.AB_CM_smev_wrapper_inst.U0.u_nbnjbfrkqwq.rdgwgtpkbgc[3]\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc_11_d[7]_net_1\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/gjkdbmpgrtc_3[10]\ : 
        MX2
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_544\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_546\, 
        S => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rdgwgtpkbgc[1]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_448\);
    
    \SYSRSTn_pad/U0/U1\ : CLKSRC
      port map(A => \SYSRSTn_pad/U0/NET1\, Y => SYSRSTn_c);
    
    
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/tpxkpvnpvvn_m_0[5]\ : 
        OR3B
      port map(A => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/frcskdnwvmx[8]_net_1\, 
        B => \AB_CM_inst/TR_RAM_DO_B_net_net_2\, C => 
        \AB_CM_inst/EV_DONE_net_0\, Y => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/tpxkpvnpvvn_m_0[5]_net_1\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx[11]\ : 
        DFN1C0
      port map(D => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx_ns[6]\, 
        CLK => SYSCLK_c, CLR => SYSRSTn_c, Q => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx[11]_net_1\);
    
    
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/ptxbvztnpnf[7]\ : 
        DFN1E1C0
      port map(D => \AB_CM_inst/Z\\\\ASSC_RAM_DO_B_net\\\\\, CLK
         => SYSCLK_c, CLR => SYSRSTn_c, E => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/jzzdfrmzwdj[11]_net_1\, 
        Q => \AB_CM_inst/ADC_STC_net[7]\);
    
    
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/bnrsdrtmtsg_5_r[5]\ : 
        NOR2B
      port map(A => INIT_DONE, B => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/N_358\, 
        Y => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/bnrsdrtmtsg_5[5]_net_1\);
    
    
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/jzzdfrmzwdj_ns_i[15]\ : 
        OA1A
      port map(A => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/N_262\, 
        B => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/jzzdfrmzwdj[0]_net_1\, 
        C => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/jzzdfrmzwdj_ns_i_0[15]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/N_228_i_0\);
    
    \Diff2_pad[9]/U0/U1\ : IOTRI_OB_EB
      port map(D => \Diff2_c[9]\, E => SOC_VCC_NET, DOUT => 
        \Diff2_pad[9]/U0/NET1\, EOUT => \Diff2_pad[9]/U0/NET2\);
    
    \Diff1_pad[9]/U0/U1\ : IOTRI_OB_EB
      port map(D => \Diff1_c[9]\, E => SOC_VCC_NET, DOUT => 
        \Diff1_pad[9]/U0/NET1\, EOUT => \Diff1_pad[9]/U0/NET2\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rqrqhcwpqdn[10]\ : 
        DFN1E0C0
      port map(D => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_836\, 
        CLK => SYSCLK_c, CLR => SYSRSTn_c, E => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_838\, 
        Q => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rqrqhcwpqdn[10]_net_1\);
    
    
        \COMP_SM_inst/Subtract_inst/sumAux_0_0_SUB_12x12_medium_area_I70_Y\ : 
        XOR2
      port map(A => \COMP_SM_inst/Subtract_inst/N210\, B => 
        \COMP_SM_inst/Subtract_inst/N145\, Y => 
        \COMP_SM_inst/Result[3]\);
    
    \COMP_SM_inst/Diff_3[5]\ : DFN1E1C0
      port map(D => \COMP_SM_inst/Result[5]\, CLK => SYSCLK_c, 
        CLR => SYSRSTn_c, E => 
        \COMP_SM_inst/Latest_Update_3_sqmuxa\, Q => \Diff3_c[5]\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/gjkdbmpgrtc_9[2]\ : 
        MX2
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rqrqhcwpqdn[2]_net_1\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rqrqhcwpqdn[3]_net_1\, 
        S => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rdgwgtpkbgc_0[0]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_542\);
    
    \Diff4_pad[1]/U0/U0\ : IOPAD_TRI
      port map(D => \Diff4_pad[1]/U0/NET1\, E => 
        \Diff4_pad[1]/U0/NET2\, PAD => Diff4(1));
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rqrqhcwpqdn_9_0[11]\ : 
        MX2
      port map(A => \AB_CM_inst/ASSC_RAM_DO_A_net_net_5\, B => 
        \AB_CM_inst/EV_RAM_DO_B_net_net_5\, S => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/un1_mvnkctvqsgp_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_837\);
    
    \Diff1_pad[6]/U0/U1\ : IOTRI_OB_EB
      port map(D => \Diff1_c[6]\, E => SOC_VCC_NET, DOUT => 
        \Diff1_pad[6]/U0/NET1\, EOUT => \Diff1_pad[6]/U0/NET2\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/pptwzsjcmcz_dhzrwbnrbpw_7_iv_1[4]\ : 
        NOR3C
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/qrbxknbdvjj_m[4]_net_1\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/mtbjcfqsbqf_m[3]_net_1\, 
        C => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/jrgzmrqhbkv_m[4]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/dhzrwbnrbpw_7_iv_1[4]\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/gjkdbmpgrtc_11_d[6]\ : 
        MX2
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_544\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rqrqhcwpqdn[0]_net_1\, 
        S => 
        \AB_CM_inst.AB_CM_smev_wrapper_inst.U0.u_nbnjbfrkqwq.rdgwgtpkbgc[3]\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/gjkdbmpgrtc_11_d[6]_net_1\);
    
    \COMP_SM_inst/Diff_2[3]\ : DFN1E0C0
      port map(D => \COMP_SM_inst/Result[3]\, CLK => SYSCLK_c, 
        CLR => SYSRSTn_c, E => 
        \COMP_SM_inst/Latest_Update_2_sqmuxa_0\, Q => 
        \Diff2_c[3]\);
    
    
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/znjtscvsvcs_iv_0_x3\ : 
        XOR2
      port map(A => \AB_CM_inst/TR_RAM_DO_B_net_net_2\, B => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/N_368\, 
        Y => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/N_385_i_i_0\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/fqkdsnjfpdb_0_0_ADD_18x18_medium_I105_Y\ : 
        XOR3
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_303\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_307\, 
        C => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N345\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/fqkdsnjfpdb[13]\);
    
    
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/frcskdnwvmx_ns_a3_1[0]\ : 
        NOR2
      port map(A => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/frcskdnwvmx[6]_net_1\, 
        B => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/frcskdnwvmx_0[8]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/frcskdnwvmx_ns_a3_1[0]_net_1\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tddhwjzbsrj\ : 
        DFN1E1C0
      port map(D => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/gcqsptsqnzg\, 
        CLK => SYSCLK_c, CLR => SYSRSTn_c, E => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx[1]_net_1\, 
        Q => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tddhwjzbsrj_net_1\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc_11[11]\ : 
        MX2
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_753\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc_11_d[11]_net_1\, 
        S => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc_11_s[6]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_789\);
    
    \COMP_SM_inst/un1_completed_sync_7_i_a2\ : XA1B
      port map(A => \ADC_CHNUMBER[2]\, B => \ADC_CHNUMBER[4]\, C
         => \COMP_SM_inst/N_413\, Y => \COMP_SM_inst/N_406\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/gjkdbmpgrtc75_0\ : 
        AXOI3
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/gjkdbmpgrtc75_0_a3_0_0_net_1\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rdgwgtpkbgc[2]_net_1\, 
        C => 
        \AB_CM_inst.AB_CM_smev_wrapper_inst.U0.u_nbnjbfrkqwq.rdgwgtpkbgc[3]\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/gjkdbmpgrtc75\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/fqkdsnjfpdb_0_0_ADD_18x18_medium_I102_Y\ : 
        AX1A
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ADD_18x18_medium_I9_G0N\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ADD_18x18_medium_I87_un1_Y\, 
        C => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ADD_18x18_medium_I102_Y_0\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/fqkdsnjfpdb[10]\);
    
    
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/ktwrhqstzjg\ : 
        OR3B
      port map(A => INIT_DONE, B => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/znbmnfdbzvr_net_1\, 
        C => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/bksnhfwfshc\, 
        Y => \AB_CM_inst/ktwrhqstzjg\);
    
    
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/bksnhfwfshc_iv\ : 
        NOR3
      port map(A => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/N_184_m_net_1\, 
        B => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/un1_znbmnfdbzvr_m_net_1\, 
        C => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/bksnhfwfshc_6_sqmuxa\, 
        Y => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/bksnhfwfshc\);
    
    \COMP_SM_inst/Diff_1[5]\ : DFN1E1C0
      port map(D => \COMP_SM_inst/Result[5]\, CLK => SYSCLK_c, 
        CLR => SYSRSTn_c, E => 
        \COMP_SM_inst/Latest_Update_1_sqmuxa\, Q => \Diff1_c[5]\);
    
    \Diff2_pad[6]/U0/U0\ : IOPAD_TRI
      port map(D => \Diff2_pad[6]/U0/NET1\, E => 
        \Diff2_pad[6]/U0/NET2\, PAD => Diff2(6));
    
    \Diff1_pad[5]/U0/U1\ : IOTRI_OB_EB
      port map(D => \Diff1_c[5]\, E => SOC_VCC_NET, DOUT => 
        \Diff1_pad[5]/U0/NET1\, EOUT => \Diff1_pad[5]/U0/NET2\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/zbqggxmnpbs_r[0]\ : 
        OA1
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_206\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_209\, 
        C => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/zbqggxmnpbs_0_iv[0]_net_1\, 
        Y => \AB_CM_inst/EV_RAM_DI_B_net_net_7\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/gjkdbmpgrtc_12[8]\ : 
        MX2
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_514\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/gjkdbmpgrtc_11[8]_net_1\, 
        S => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rdgwgtpkbgc_1[2]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/gjkdbmpgrtc_12[8]_net_1\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/fqkdsnjfpdb_m[3]\ : 
        OR2B
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx[4]_net_1\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/fqkdsnjfpdb[3]\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/fqkdsnjfpdb_m[3]_net_1\);
    
    \Diff0_pad[0]/U0/U1\ : IOTRI_OB_EB
      port map(D => \Diff0_c[0]\, E => SOC_VCC_NET, DOUT => 
        \Diff0_pad[0]/U0/NET1\, EOUT => \Diff0_pad[0]/U0/NET2\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/un1_dhzrwbnrbpw_I_42\ : 
        NOR2B
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/DWACT_ADD_CI_0_g_array_2[0]\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/DWACT_ADD_CI_0_pog_array_1_1[0]\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/DWACT_ADD_CI_0_g_array_11[0]\);
    
    
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/jfkkdmfhcdn[4]\ : 
        NOR2A
      port map(A => \AB_CM_inst/TR_RAM_DO_B_net_net_3\, B => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/frcskdnwvmx[0]_net_1\, 
        Y => \AB_CM_inst/TR_RAM_DI_B_net_net_3\);
    
    
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/brxxctcvrmh_qgnzcpmbksd_7_0_iv_0[1]\ : 
        AOI1B
      port map(A => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/N_310\, 
        B => \AB_CM_inst/EV_CHHOLD_net_net_3\, C => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/tpxkpvnpvvn_m_0[1]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/qgnzcpmbksd_7_0_iv_0[1]\);
    
    \Diff0_pad[9]/U0/U1\ : IOTRI_OB_EB
      port map(D => \Diff0_c[9]\, E => SOC_VCC_NET, DOUT => 
        \Diff0_pad[9]/U0/NET1\, EOUT => \Diff0_pad[9]/U0/NET2\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/fqkdsnjfpdb_0_0_ADD_18x18_medium_I41_Y\ : 
        AO1A
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N291\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N292\, 
        C => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N290\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N308\);
    
    \COMP_SM_inst/Diff_3[1]\ : DFN1E1C0
      port map(D => \COMP_SM_inst/Result[1]\, CLK => SYSCLK_c, 
        CLR => SYSRSTn_c, E => 
        \COMP_SM_inst/Latest_Update_3_sqmuxa\, Q => \Diff3_c[1]\);
    
    \COMP_SM_inst/Latest_Update_5_sqmuxa_0_a4\ : NOR3A
      port map(A => \COMP_SM_inst/N_420\, B => 
        \COMP_SM_inst/N_413\, C => \COMP_SM_inst/N_421_1\, Y => 
        \COMP_SM_inst/Latest_Update_5_sqmuxa\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx_ns_a3[15]\ : 
        NOR3B
      port map(A => INIT_DONE, B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_239\, 
        C => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_237\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx_ns[15]\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/zbqggxmnpbs_0_iv_0[4]\ : 
        AOI1B
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/fqkdsnjfpdb[1]\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx_0[4]_net_1\, 
        C => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ckghxwbsztp_m[3]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/zbqggxmnpbs_0_iv_0[4]_net_1\);
    
    \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/G_158_0\ : 
        OA1A
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc[14]\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnvtvdkcnpp[8]_net_1\, 
        C => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/gjkdbmpgrtc[14]\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/G_158_0_net_1\);
    
    \Diff1_pad[2]/U0/U0\ : IOPAD_TRI
      port map(D => \Diff1_pad[2]/U0/NET1\, E => 
        \Diff1_pad[2]/U0/NET2\, PAD => Diff1(2));
    
    
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/svpbmqwvncp_0_1\ : 
        NOR3
      port map(A => \AB_CM_inst/TR_EV_RD_net\, B => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/frcskdnwvmx[11]_net_1\, 
        C => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/frcskdnwvmx_0[8]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/svpbmqwvncp_0_1_net_1\);
    
    
        \COMP_SM_inst/Subtract_inst/sumAux_0_0_SUB_12x12_medium_area_I15_S\ : 
        XNOR2
      port map(A => \COMP_SM_inst/R2[3]_net_1\, B => 
        \COMP_SM_inst/R1[3]_net_1\, Y => 
        \COMP_SM_inst/Subtract_inst/N145\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/fqkdsnjfpdb_0_0_ADD_18x18_medium_I1_P0N\ : 
        XAI1A
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/gjkdbmpgrtc[1]\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/G_89_0_net_1\, 
        C => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc[1]\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N235\);
    
    
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/frcskdnwvmx_ns_i[3]\ : 
        OA1
      port map(A => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/N_248\, 
        B => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/frcskdnwvmx[9]_net_1\, 
        C => INIT_DONE, Y => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/frcskdnwvmx_ns_i[3]_net_1\);
    
    
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/qgtkpxrgqqs_un1_xjrbtnwdszs_0_sqmuxa_0\ : 
        AO1A
      port map(A => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/dvqzjxhqhrh_net_1\, 
        B => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/frcskdnwvmx[2]_net_1\, 
        C => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/N_434_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/un1_xjrbtnwdszs_0_sqmuxa_0\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc_2[1]\ : 
        MX2
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ftbkrvpxdbp[3]_net_1\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ftbkrvpxdbp[4]_net_1\, 
        S => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rdgwgtpkbgc_1[0]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_626\);
    
    
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/valid_client/u_gpbdjfttbjd/fpppnnsbksx_0_a3[2]\ : 
        OR3B
      port map(A => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/vvpkfmmpprk[1]\, 
        B => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/npgnwznthhx\, 
        C => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/vvpkfmmpprk[0]\, 
        Y => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/valid_client/u_gpbdjfttbjd/N_22\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx_ns_i[17]\ : 
        NOR2B
      port map(A => INIT_DONE, B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx[1]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx_ns_i[17]_net_1\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/gjkdbmpgrtc_7_0_a3[15]\ : 
        NOR2A
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_453\, 
        B => 
        \AB_CM_inst.AB_CM_smev_wrapper_inst.U0.u_nbnjbfrkqwq.rdgwgtpkbgc[3]\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_945\);
    
    
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/jzzdfrmzwdj_ns_i_a3[14]\ : 
        AO1C
      port map(A => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/N_250\, 
        B => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/N_254_i_0\, 
        C => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/jzzdfrmzwdj_ns_i_a3_0[14]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/N_303\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/pvtdpmmqdpp_un2_pbzxzjhqhwz_0_I_8\ : 
        AND2
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/DWACT_BL_EQUAL_0_DWACT_ANDTREE_E[1]\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/DWACT_BL_EQUAL_0_DWACT_ANDTREE_E[0]\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/DWACT_COMP0_E[1]\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/mkmkbnghgkd[7]\ : 
        MX2
      port map(A => \INIT_ADDR[7]\, B => 
        \AB_CM_inst/Z\\\\TR_EV_ADDR_net\\\\\, S => INIT_DONE, Y
         => \AB_CM_inst/Z\\\\EV_RAM_ADDR_A_net\\\\\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc_3[12]\ : 
        MX2
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_750\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_752\, 
        S => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rdgwgtpkbgc_1[1]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_654\);
    
    
        \COMP_SM_inst/Subtract_inst/sumAux_0_0_SUB_12x12_medium_area_I71_Y\ : 
        AX1D
      port map(A => 
        \COMP_SM_inst/Subtract_inst/SUB_12x12_medium_area_I65_un1_Y\, 
        B => \COMP_SM_inst/Subtract_inst/N146\, C => 
        \COMP_SM_inst/Subtract_inst/N147\, Y => 
        \COMP_SM_inst/Result[4]\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/gjkdbmpgrtc_9[3]\ : 
        MX2
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rqrqhcwpqdn[3]_net_1\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rqrqhcwpqdn[4]_net_1\, 
        S => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rdgwgtpkbgc_0[0]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_543\);
    
    \Diff5_pad[6]/U0/U1\ : IOTRI_OB_EB
      port map(D => \Diff5_c[6]\, E => SOC_VCC_NET, DOUT => 
        \Diff5_pad[6]/U0/NET1\, EOUT => \Diff5_pad[6]/U0/NET2\);
    
    
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/hgqdwrxvgzm[2]\ : 
        DFN1E1C0
      port map(D => \AB_CM_inst/ASSC_RAM_DO_B_net_net_5\, CLK => 
        SYSCLK_c, CLR => SYSRSTn_c, E => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/jzzdfrmzwdj[14]_net_1\, 
        Q => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/hgqdwrxvgzm[2]_net_1\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/fqkdsnjfpdb_0_0_ADD_18x18_medium_I96_Y\ : 
        AX1D
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ADD_18x18_medium_I90_un1_Y\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N240\, 
        C => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ADD_18x18_medium_I96_Y_0\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/fqkdsnjfpdb[4]\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rdgwgtpkbgc[2]\ : 
        DFN1E0C0
      port map(D => \AB_CM_inst/EV_RAM_DO_B_net_net_5\, CLK => 
        SYSCLK_c, CLR => SYSRSTn_c, E => 
        \AB_CM_inst/bskrjhjvqpf_1_sqmuxa\, Q => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rdgwgtpkbgc[2]_net_1\);
    
    
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/ddvbdtxtbpx_i_0\ : 
        AO1
      port map(A => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/bksczsjcvgb_net_1\, 
        B => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/jzzdfrmzwdj[15]_net_1\, 
        C => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/jzzdfrmzwdj_0[4]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/ddvbdtxtbpx_i_0_net_1\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/fqkdsnjfpdb_0_0_ADD_18x18_medium_I90_un1_Y\ : 
        NOR2B
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N316\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N241\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ADD_18x18_medium_I90_un1_Y\);
    
    \Diff4_pad[8]/U0/U0\ : IOPAD_TRI
      port map(D => \Diff4_pad[8]/U0/NET1\, E => 
        \Diff4_pad[8]/U0/NET2\, PAD => Diff4(8));
    
    
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/trnwxjxxrbp[1]\ : 
        DFN1C0
      port map(D => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/trnwxjxxrbp[1]_net_1\, 
        CLK => SYSCLK_c, CLR => SYSRSTn_c, Q => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/trnwxjxxrbp[1]_net_1\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/gjkdbmpgrtc_7_0_a3[13]\ : 
        NOR2A
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_451\, 
        B => 
        \AB_CM_inst.AB_CM_smev_wrapper_inst.U0.u_nbnjbfrkqwq.rdgwgtpkbgc[3]\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_943\);
    
    
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/znbmnfdbzvr\ : 
        DFN1C0
      port map(D => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/znbmnfdbzvr_38_net_1\, 
        CLK => SYSCLK_c, CLR => SYSRSTn_c, Q => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/znbmnfdbzvr_net_1\);
    
    \COMP_SM_inst/R2[8]\ : DFN1E1C0
      port map(D => \ADC_RESULT[8]\, CLK => SYSCLK_c, CLR => 
        SYSRSTn_c, E => \COMP_SM_inst/pres_state[2]_net_1\, Q => 
        \COMP_SM_inst/R2[8]_net_1\);
    
    \COMP_SM_inst/Diff_0[6]\ : DFN1E1C0
      port map(D => \COMP_SM_inst/Result[6]\, CLK => SYSCLK_c, 
        CLR => SYSRSTn_c, E => 
        \COMP_SM_inst/Latest_Update_0_sqmuxa\, Q => \Diff0_c[6]\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/fqkdsnjfpdb_0_0_ADD_18x18_medium_I39_Y\ : 
        AO1C
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N289\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N290\, 
        C => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N288\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N306\);
    
    \COMP_SM_inst/Diff_2[1]\ : DFN1E0C0
      port map(D => \COMP_SM_inst/Result[1]\, CLK => SYSCLK_c, 
        CLR => SYSRSTn_c, E => 
        \COMP_SM_inst/Latest_Update_2_sqmuxa_0\, Q => 
        \Diff2_c[1]\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnvtvdkcnpp_5[7]\ : 
        MX2
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnvtvdkcnpp[7]_net_1\, 
        B => \AB_CM_inst/Z\\\\EV_RAM_DO_B_net\\\\\, S => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/un3_qvqqfftqsfc_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnvtvdkcnpp_5[7]_net_1\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/un3_ckghxwbsztp_I_12\ : 
        AND3
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rqrqhcwpqdn[1]_net_1\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rqrqhcwpqdn[2]_net_1\, 
        C => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rqrqhcwpqdn[3]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_9\);
    
    
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/jzzdfrmzwdj_ns_1_0[0]\ : 
        OR3A
      port map(A => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/N_310\, 
        B => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/N_253\, 
        C => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/N_256\, 
        Y => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/jzzdfrmzwdj_ns_1_0[0]_net_1\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/hmzcpnxsdwg\ : 
        NOR2B
      port map(A => ASSC_DONE, B => 
        \AB_CM_inst/ASSC_SAMPFLAG_net\, Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/hmzcpnxsdwg_net_1\);
    
    \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/G_131\ : 
        NOR2A
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnvtvdkcnpp[3]_net_1\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc[9]\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_290\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnvtvdkcnpp_5[2]\ : 
        MX2
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnvtvdkcnpp[2]_net_1\, 
        B => \AB_CM_inst/EV_RAM_DO_B_net_net_5\, S => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/un3_qvqqfftqsfc_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnvtvdkcnpp_5[2]_net_1\);
    
    
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/bcmkdjqtngz\ : 
        DFN1E0C0
      port map(D => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/bcmkdjqtngz_1_net_1\, 
        CLK => SYSCLK_c, CLR => SYSRSTn_c, E => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/un1_cfxfrwgjccr_1_net_1\, 
        Q => \AB_CM_inst/ASSC_SAMPFLAG_net\);
    
    
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/address_gen/u_dxwqxgdccxc/un1_dkjzqmrkvwb_ADD_13x13_fast_I9_P0N\ : 
        OR3A
      port map(A => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/address_gen/u_dxwqxgdccxc/ggfvvjbkdws[9]_net_1\, 
        B => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/N_2340\, 
        C => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/N_2358\, 
        Y => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/address_gen/u_dxwqxgdccxc/N190\);
    
    
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/mksbfqnmmgw[5]\ : 
        NOR2A
      port map(A => \ADC_RESULT[5]\, B => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/jzzdfrmzwdj_0[4]_net_1\, 
        Y => \AB_CM_inst/ASSC_RAM_DI_B_net_net_2\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/un1_xkwrgrspmcf\ : 
        NOR2B
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx[9]_net_1\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/mvnkctvqsgp_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/un1_xkwrgrspmcf_net_1\);
    
    
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/user_control/u_ffppvfwnggt/cpqqthwwhvc_0_0_o2[0]\ : 
        OR2B
      port map(A => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/user_control/u_ffppvfwnggt/N_2342\, 
        B => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/user_control/u_ffppvfwnggt/N_2334\, 
        Y => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/N_2174\);
    
    \COMP_SM_inst/valid_8_0_0_a2_3_1\ : OR2A
      port map(A => \ADC_CHNUMBER[4]\, B => \ADC_CHNUMBER[2]\, Y
         => \COMP_SM_inst/N_421_1\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/fqkdsnjfpdb_0_0_ADD_18x18_medium_I88_Y\ : 
        AOI1
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N253\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N351\, 
        C => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N252\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N397_i\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/fqkdsnjfpdb_0_0_ADD_18x18_medium_I67_un1_Y\ : 
        NOR3C
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N305\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N309\, 
        C => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N351\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/I67_un1_Y\);
    
    
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/jzzdfrmzwdj[1]\ : 
        DFN1P0
      port map(D => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/N_226_i_0\, 
        CLK => SYSCLK_c, PRE => SYSRSTn_c, Q => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/jzzdfrmzwdj_i[1]\);
    
    
        \COMP_SM_inst/Subtract_inst/sumAux_0_0_SUB_12x12_medium_area_I47_Y\ : 
        AOI1
      port map(A => \COMP_SM_inst/Subtract_inst/N200\, B => 
        \COMP_SM_inst/Subtract_inst/SUB_12x12_medium_area_I47_un1_Y_0\, 
        C => 
        \COMP_SM_inst/Subtract_inst/SUB_12x12_medium_area_I47_Y_1\, 
        Y => \COMP_SM_inst/Subtract_inst/N192\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/mkmkbnghgkd[6]\ : 
        MX2
      port map(A => \INIT_ADDR[6]\, B => 
        \AB_CM_inst/TR_EV_ADDR_net_net_1\, S => INIT_DONE, Y => 
        \AB_CM_inst/EV_RAM_ADDR_A_net_net_1\);
    
    
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/hgqdwrxvgzm_3[3]\ : 
        MX2
      port map(A => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/hgqdwrxvgzm[3]_net_1\, 
        B => \AB_CM_inst/ASSC_RAM_DO_B_net_net_4\, S => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/jzzdfrmzwdj_0[14]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/hgqdwrxvgzm_3[3]_net_1\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/fqkdsnjfpdb_0_0_ADD_18x18_medium_I92_Y\ : 
        XNOR3
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/gjkdbmpgrtc[0]\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ftbkrvpxdbp[0]_net_1\, 
        C => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc[0]\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/fqkdsnjfpdb[0]\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/fqkdsnjfpdb_0_0_ADD_18x18_medium_I25_Y\ : 
        OAI1
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/G_128_0_net_1\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ADD_18x18_medium_I9_P0N_0\, 
        C => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N262\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N291\);
    
    
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/dtcvhtqxgdc\ : 
        DFN1E1C0
      port map(D => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/N_272\, 
        CLK => SYSCLK_c, CLR => SYSRSTn_c, E => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/un1_cfxfrwgjccr_7\, 
        Q => \AB_CM_inst/ADC_PDOWN_net\);
    
    
        \COMP_SM_inst/Subtract_inst/sumAux_0_0_SUB_12x12_medium_area_I15_CO1\ : 
        NOR2A
      port map(A => \COMP_SM_inst/R1[3]_net_1\, B => 
        \COMP_SM_inst/R2[3]_net_1\, Y => 
        \COMP_SM_inst/Subtract_inst/N146\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx_ns_0[4]\ : 
        AOI1B
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_239\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx_ns_a3_0_0[4]_net_1\, 
        C => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_228\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx_ns_0[4]_net_1\);
    
    
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/save_fsm/u_wbsfnwwctpn/crpwsdfhcqq_ns[3]\ : 
        AO1
      port map(A => \NVM_CM_inst/NVM_BUSY_net\, B => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/npgnwznthhx\, 
        C => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/fhpsqkqvwpw\, 
        Y => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/save_fsm/u_wbsfnwwctpn/crpwsdfhcqq_ns[3]_net_1\);
    
    \Diff0_pad[6]/U0/U0\ : IOPAD_TRI
      port map(D => \Diff0_pad[6]/U0/NET1\, E => 
        \Diff0_pad[6]/U0/NET2\, PAD => Diff0(6));
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/pvtdpmmqdpp_un2_pbzxzjhqhwz_0_I_60\ : 
        NOR2A
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rqrqhcwpqdn[3]_net_1\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnvtvdkcnpp[3]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ACT_LT4_E[5]\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/pvtdpmmqdpp_un2_pbzxzjhqhwz_0_I_55\ : 
        NOR2A
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rqrqhcwpqdn[0]_net_1\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnvtvdkcnpp[0]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ACT_LT4_E[0]\);
    
    
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/frcskdnwvmx_ns_a3[6]\ : 
        NOR3A
      port map(A => INIT_DONE, B => 
        \AB_CM_inst/TR_RAM_DO_B_net_net_2\, C => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/N_289\, 
        Y => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/frcskdnwvmx_ns[6]\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc_12_d_0[8]\ : 
        MX2C
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_650\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_966\, 
        S => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/gjkdbmpgrtc75_0_a3_0_1_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc_12_d_0[8]_net_1\);
    
    \COMP_SM_inst/Diff_2[11]\ : DFN1E0C0
      port map(D => \COMP_SM_inst/Result[11]\, CLK => SYSCLK_c, 
        CLR => SYSRSTn_c, E => 
        \COMP_SM_inst/Latest_Update_2_sqmuxa\, Q => \Diff2_c[11]\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/dhzrwbnrbpw[4]\ : 
        DFN1C0
      port map(D => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/dhzrwbnrbpw_7[4]\, 
        CLK => SYSCLK_c, CLR => SYSRSTn_c, Q => 
        \AB_CM_inst/EV_RAM_ADDR_B_net_net_3\);
    
    \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/G_114\ : 
        XNOR3
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/gjkdbmpgrtc[6]\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnvtvdkcnpp[0]_net_1\, 
        C => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc[6]\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_272\);
    
    
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/ptxbvztnpnf[5]\ : 
        DFN1E1C0
      port map(D => \AB_CM_inst/ASSC_RAM_DO_B_net_net_2\, CLK => 
        SYSCLK_c, CLR => SYSRSTn_c, E => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/jzzdfrmzwdj[11]_net_1\, 
        Q => \AB_CM_inst/ADC_STC_net_net_1\);
    
    \AB_CM_inst/AB_INST\ : AB
      port map(DAVOUT0 => OPEN, DACOUT0 => OPEN, DATOUT0 => OPEN, 
        DAVOUT1 => OPEN, DACOUT1 => OPEN, DATOUT1 => OPEN, 
        DAVOUT2 => OPEN, DACOUT2 => OPEN, DATOUT2 => OPEN, 
        DAVOUT3 => OPEN, DACOUT3 => OPEN, DATOUT3 => OPEN, 
        DAVOUT4 => OPEN, DACOUT4 => OPEN, DATOUT4 => OPEN, 
        DAVOUT5 => OPEN, DACOUT5 => OPEN, DATOUT5 => OPEN, 
        DAVOUT6 => OPEN, DACOUT6 => OPEN, DATOUT6 => OPEN, 
        DAVOUT7 => OPEN, DACOUT7 => OPEN, DATOUT7 => OPEN, 
        DAVOUT8 => OPEN, DACOUT8 => OPEN, DATOUT8 => OPEN, 
        DAVOUT9 => OPEN, DACOUT9 => OPEN, DATOUT9 => OPEN, DENAV0
         => \GND\, DENAC0 => \GND\, DENAT0 => \GND\, DENAV1 => 
        \GND\, DENAC1 => \GND\, DENAT1 => \GND\, DENAV2 => \GND\, 
        DENAC2 => \GND\, DENAT2 => \GND\, DENAV3 => \GND\, DENAC3
         => \GND\, DENAT3 => \GND\, DENAV4 => \GND\, DENAC4 => 
        \GND\, DENAT4 => \GND\, DENAV5 => \GND\, DENAC5 => \GND\, 
        DENAT5 => \GND\, DENAV6 => \GND\, DENAC6 => \GND\, DENAT6
         => \GND\, DENAV7 => \GND\, DENAC7 => \GND\, DENAT7 => 
        \GND\, DENAV8 => \GND\, DENAC8 => \GND\, DENAT8 => \GND\, 
        DENAV9 => \GND\, DENAC9 => \GND\, DENAT9 => \GND\, AV0
         => \AB_CM_inst/AV0_net\, AC0 => \AB_CM_inst/AC0_net\, 
        AT0 => \GND\, AG0 => OPEN, AV1 => \AB_CM_inst/AV1_net\, 
        AC1 => \AB_CM_inst/AC1_net\, AT1 => \GND\, AG1 => OPEN, 
        AV2 => \AB_CM_inst/AV2_net\, AC2 => \AB_CM_inst/AC2_net\, 
        AT2 => \GND\, AG2 => OPEN, AV3 => \AB_CM_inst/AV3_net\, 
        AC3 => \AB_CM_inst/AC3_net\, AT3 => \GND\, AG3 => OPEN, 
        AV4 => \AB_CM_inst/AV4_net\, AC4 => \AB_CM_inst/AC4_net\, 
        AT4 => \GND\, AG4 => OPEN, AV5 => \AB_CM_inst/AV5_net\, 
        AC5 => \AB_CM_inst/AC5_net\, AT5 => \GND\, AG5 => OPEN, 
        AV6 => \GND\, AC6 => \GND\, AT6 => \GND\, AG6 => OPEN, 
        AV7 => \GND\, AC7 => \GND\, AT7 => \GND\, AG7 => OPEN, 
        AV8 => \GND\, AC8 => \GND\, AT8 => \GND\, AG8 => OPEN, 
        AV9 => \GND\, AC9 => \GND\, AT9 => \GND\, AG9 => OPEN, 
        ATRETURN01 => \GND\, ATRETURN23 => \GND\, ATRETURN45 => 
        \GND\, ATRETURN67 => \GND\, ATRETURN89 => \GND\, VAREF
         => VAREF, GNDREF => \GND\, GDON0 => \GND\, GDON1 => 
        \GND\, GDON2 => \GND\, GDON3 => \GND\, GDON4 => \GND\, 
        GDON5 => \GND\, GDON6 => \GND\, GDON7 => \GND\, GDON8 => 
        \GND\, GDON9 => \GND\, CMSTB0 => \GND\, CMSTB1 => \GND\, 
        CMSTB2 => \GND\, CMSTB3 => \GND\, CMSTB4 => \GND\, CMSTB5
         => \GND\, CMSTB6 => \GND\, CMSTB7 => \GND\, CMSTB8 => 
        \GND\, CMSTB9 => \GND\, TMSTB0 => \GND\, TMSTB1 => \GND\, 
        TMSTB2 => \GND\, TMSTB3 => \GND\, TMSTB4 => \GND\, TMSTB5
         => \GND\, TMSTB6 => \GND\, TMSTB7 => \GND\, TMSTB8 => 
        \GND\, TMSTB9 => \GND\, TMSTBINT => \GND\, RESULT(11) => 
        \ADC_RESULT[11]\, RESULT(10) => \ADC_RESULT[10]\, 
        RESULT(9) => \ADC_RESULT[9]\, RESULT(8) => 
        \ADC_RESULT[8]\, RESULT(7) => \ADC_RESULT[7]\, RESULT(6)
         => \ADC_RESULT[6]\, RESULT(5) => \ADC_RESULT[5]\, 
        RESULT(4) => \ADC_RESULT[4]\, RESULT(3) => 
        \ADC_RESULT[3]\, RESULT(2) => \ADC_RESULT[2]\, RESULT(1)
         => \ADC_RESULT[1]\, RESULT(0) => \ADC_RESULT[0]\, 
        ACMRDATA(7) => nc7, ACMRDATA(6) => nc6, ACMRDATA(5) => 
        nc19, ACMRDATA(4) => nc29, ACMRDATA(3) => nc8, 
        ACMRDATA(2) => nc20, ACMRDATA(1) => nc10, ACMRDATA(0) => 
        nc24, ACMWDATA(7) => \INIT_DATA[7]\, ACMWDATA(6) => 
        \INIT_DATA[6]\, ACMWDATA(5) => \INIT_DATA[5]\, 
        ACMWDATA(4) => \INIT_DATA[4]\, ACMWDATA(3) => 
        \INIT_DATA[3]\, ACMWDATA(2) => \INIT_DATA[2]\, 
        ACMWDATA(1) => \INIT_DATA[1]\, ACMWDATA(0) => 
        \INIT_DATA[0]\, ACMADDR(7) => \INIT_ADDR[7]\, ACMADDR(6)
         => \INIT_ADDR[6]\, ACMADDR(5) => \INIT_ADDR[5]\, 
        ACMADDR(4) => \INIT_ADDR[4]\, ACMADDR(3) => 
        \INIT_ADDR[3]\, ACMADDR(2) => \INIT_ADDR[2]\, ACMADDR(1)
         => \INIT_ADDR[1]\, ACMADDR(0) => \INIT_ADDR[0]\, STC(7)
         => \AB_CM_inst/ADC_STC_net[7]\, STC(6) => 
        \AB_CM_inst/Z\\\\ADC_STC_net\\\\\, STC(5) => 
        \AB_CM_inst/ADC_STC_net_net_1\, STC(4) => 
        \AB_CM_inst/ADC_STC_net_net_2\, STC(3) => 
        \AB_CM_inst/ADC_STC_net_net_3\, STC(2) => 
        \AB_CM_inst/ADC_STC_net_net_4\, STC(1) => 
        \AB_CM_inst/ADC_STC_net_net_5\, STC(0) => 
        \AB_CM_inst/ADC_STC_net_net_6\, TVC(7) => 
        \AB_CM_inst/ADC_TVC_net[7]\, TVC(6) => 
        \AB_CM_inst/Z\\\\ADC_TVC_net\\\\\, TVC(5) => 
        \AB_CM_inst/ADC_TVC_net_net_1\, TVC(4) => 
        \AB_CM_inst/ADC_TVC_net_net_2\, TVC(3) => 
        \AB_CM_inst/ADC_TVC_net_net_3\, TVC(2) => 
        \AB_CM_inst/ADC_TVC_net_net_4\, TVC(1) => 
        \AB_CM_inst/ADC_TVC_net_net_5\, TVC(0) => 
        \AB_CM_inst/ADC_TVC_net_net_6\, CHNUMBER(4) => 
        \ADC_CHNUMBER[4]\, CHNUMBER(3) => \ADC_CHNUMBER[3]\, 
        CHNUMBER(2) => \ADC_CHNUMBER[2]\, CHNUMBER(1) => 
        \ADC_CHNUMBER[1]\, CHNUMBER(0) => \ADC_CHNUMBER[0]\, 
        MODE(3) => \AB_CM_inst/ADC_MODE_net[3]\, MODE(2) => 
        \AB_CM_inst/Z\\\\ADC_MODE_net\\\\\, MODE(1) => 
        \AB_CM_inst/ADC_MODE_net_net_1\, MODE(0) => 
        \AB_CM_inst/ADC_MODE_net_net_2\, RTCXTLMODE(1) => nc14, 
        RTCXTLMODE(0) => nc30, ACMRESET => SYSRSTn_c, ACMCLK => 
        SYSCLK_c, ACMWEN => \AB_CM_inst/INIT_ACM_WEN_OR_net\, 
        VAREFSEL => \GND\, DATAVALID => OPEN, CALIBRATE => 
        \AB_CM_inst/ADC_CALIBRATE_net\, SAMPLE => OPEN, BUSY => 
        \AB_CM_inst/ADC_BUSY_net\, PWRDWN => 
        \AB_CM_inst/ADC_PDOWN_net\, SYSCLK => SYSCLK_c, ADCRESET
         => \AB_CM_inst/ADC_RESET_net\, ADCSTART => 
        \AB_CM_inst/ADC_START_net\, RTCMATCH => OPEN, RTCPSMMATCH
         => OPEN, RTCXTLSEL => OPEN, RTCCLK => \GND\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc_7_0_a3[13]\ : 
        NOR2A
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_655\, 
        B => 
        \AB_CM_inst.AB_CM_smev_wrapper_inst.U0.u_nbnjbfrkqwq.rdgwgtpkbgc[3]\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_957\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc_11_s[4]\ : 
        OR2A
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rdgwgtpkbgc_0[1]_net_1\, 
        B => 
        \AB_CM_inst.AB_CM_smev_wrapper_inst.U0.u_nbnjbfrkqwq.rdgwgtpkbgc[3]\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc_11_s[4]_net_1\);
    
    \VR_INT_inst/VRPSM1\ : VRPSM
      port map(PUB => PUB, VRPU => \GND\, VRINITSTATE => 
        SOC_VCC_NET, RTCPSMMATCH => \GND\, FPGAGOOD => SPARE_c, 
        PUCORE => OPEN);
    
    \COMP_SM_inst/Latest_Update[1]\ : DFN1E1P0
      port map(D => \COMP_SM_inst/Latest_Update_9[1]\, CLK => 
        SYSCLK_c, PRE => SYSRSTn_c, E => \COMP_SM_inst/N_364\, Q
         => \Latest_Update_c[1]\);
    
    
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/rjhhzsggrtr[4]\ : 
        DFN1E1C0
      port map(D => \AB_CM_inst/TR_RAM_DO_B_net_net_3\, CLK => 
        SYSCLK_c, CLR => SYSRSTn_c, E => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/frcskdnwvmx[4]_net_1\, 
        Q => \AB_CM_inst/TR_EV_ADDR_net_net_3\);
    
    \Diff1_pad[7]/U0/U0\ : IOPAD_TRI
      port map(D => \Diff1_pad[7]/U0/NET1\, E => 
        \Diff1_pad[7]/U0/NET2\, PAD => Diff1(7));
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/gjkdbmpgrtc_7[3]\ : 
        MX2
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_938\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_449\, 
        S => 
        \AB_CM_inst.AB_CM_smev_wrapper_inst.U0.u_nbnjbfrkqwq.rdgwgtpkbgc[3]\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_509\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc_3[11]\ : 
        MX2
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_749\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_751\, 
        S => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rdgwgtpkbgc_1[1]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_653\);
    
    \COMP_SM_inst/Latest_Update_1_sqmuxa_0_a4\ : NOR3B
      port map(A => \COMP_SM_inst/N_420\, B => 
        \COMP_SM_inst/N_424\, C => \COMP_SM_inst/N_413\, Y => 
        \COMP_SM_inst/Latest_Update_1_sqmuxa\);
    
    \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/G_148_0\ : 
        OA1A
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc[12]\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnvtvdkcnpp[6]_net_1\, 
        C => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/gjkdbmpgrtc[12]\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/G_148_0_net_1\);
    
    
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/jzzdfrmzwdj_ns_i_1[12]\ : 
        OR2B
      port map(A => INIT_DONE, B => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/jzzdfrmzwdj_0[4]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/jzzdfrmzwdj_ns_i_1[12]_net_1\);
    
    
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/un1_bksnhfwfshc_1_sqmuxa_0\ : 
        OA1C
      port map(A => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/N_254_i_0\, 
        B => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/N_250\, 
        C => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/un1_bksnhfwfshc_1_sqmuxa_0_a3_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/un1_bksnhfwfshc_1_sqmuxa\);
    
    
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/qgnzcpmbksd[0]\ : 
        DFN1C0
      port map(D => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/qgnzcpmbksd_7[0]\, 
        CLK => SYSCLK_c, CLR => SYSRSTn_c, Q => 
        \AB_CM_inst/TR_RAM_ADDR_B_net_net_7\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/gjkdbmpgrtc_9[8]\ : 
        MX2
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rqrqhcwpqdn[8]_net_1\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rqrqhcwpqdn[9]_net_1\, 
        S => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rdgwgtpkbgc_1[0]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_548\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/gjkdbmpgrtc_11_d[8]\ : 
        MX2
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_548\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rqrqhcwpqdn[2]_net_1\, 
        S => 
        \AB_CM_inst.AB_CM_smev_wrapper_inst.U0.u_nbnjbfrkqwq.rdgwgtpkbgc[3]\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/gjkdbmpgrtc_11_d[8]_net_1\);
    
    
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/save_fsm/u_wbsfnwwctpn/crpwsdfhcqq[0]\ : 
        DFN1C0
      port map(D => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/save_fsm/u_wbsfnwwctpn/crpwsdfhcqq_ns_a3[8]_net_1\, 
        CLK => SYSCLK_c, CLR => SYSRSTn_c, Q => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/save_fsm/u_wbsfnwwctpn/crpwsdfhcqq[0]_net_1\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ftbkrvpxdbp[1]\ : 
        DFN1E0C0
      port map(D => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ftbkrvpxdbp_5[1]_net_1\, 
        CLK => SYSCLK_c, CLR => SYSRSTn_c, E => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ftbkrvpxdbp_1_sqmuxa_net_1\, 
        Q => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ftbkrvpxdbp[1]_net_1\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnvtvdkcnpp[8]\ : 
        DFN1C0
      port map(D => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnvtvdkcnpp_9[8]_net_1\, 
        CLK => SYSCLK_c, CLR => SYSRSTn_c, Q => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnvtvdkcnpp[8]_net_1\);
    
    \Diff1_pad[11]/U0/U1\ : IOTRI_OB_EB
      port map(D => \Diff1_c[11]\, E => SOC_VCC_NET, DOUT => 
        \Diff1_pad[11]/U0/NET1\, EOUT => \Diff1_pad[11]/U0/NET2\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/zbcrjjxqjgg_i_o3\ : 
        AO1
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_203\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx[12]_net_1\, 
        C => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx[5]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_206\);
    
    \Diff4_pad[7]/U0/U0\ : IOPAD_TRI
      port map(D => \Diff4_pad[7]/U0/NET1\, E => 
        \Diff4_pad[7]/U0/NET2\, PAD => Diff4(7));
    
    \COMP_SM_inst/Diff_5[5]\ : DFN1E1C0
      port map(D => \COMP_SM_inst/Result[5]\, CLK => SYSCLK_c, 
        CLR => SYSRSTn_c, E => 
        \COMP_SM_inst/Latest_Update_5_sqmuxa\, Q => \Diff5_c[5]\);
    
    \Diff2_pad[10]/U0/U0\ : IOPAD_TRI
      port map(D => \Diff2_pad[10]/U0/NET1\, E => 
        \Diff2_pad[10]/U0/NET2\, PAD => Diff2(10));
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc_11_d_d[6]\ : 
        MX2
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnvtvdkcnpp[7]_net_1\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnvtvdkcnpp[0]_net_1\, 
        S => 
        \AB_CM_inst.AB_CM_smev_wrapper_inst.U0.u_nbnjbfrkqwq.rdgwgtpkbgc[3]\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc_11_d_d[6]_net_1\);
    
    \Diff1_pad[0]/U0/U0\ : IOPAD_TRI
      port map(D => \Diff1_pad[0]/U0/NET1\, E => 
        \Diff1_pad[0]/U0/NET2\, PAD => Diff1(0));
    
    
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/jvxfmjbzjmc_i_o2\ : 
        NOR2B
      port map(A => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/frcskdnwvmx[6]_net_1\, 
        B => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/N_282\, 
        Y => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/N_236\);
    
    
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/frcskdnwvmx_ns_i[11]\ : 
        NOR2B
      port map(A => INIT_DONE, B => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/frcskdnwvmx[1]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/frcskdnwvmx_ns_i[11]_net_1\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/frhjqwkkhgk_0\ : 
        NOR3
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_209\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx[2]_net_1\, 
        C => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_206\, 
        Y => \AB_CM_inst/EV_RAM_WR_BUSY_B_net\);
    
    
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/cpwfrthtnfr_14_sqmuxa_0_a2\ : 
        NOR2A
      port map(A => \AB_CM_inst/TR_RAM_DO_B_net_net_6\, B => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/cpwfrthtnfr_13_sqmuxa_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/cpwfrthtnfr_14_sqmuxa\);
    
    
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/un1_sgbwkmbvtjw_0_o3\ : 
        OR2
      port map(A => \AB_CM_inst/ASSC_RAM_DO_B_net_net_1\, B => 
        \AB_CM_inst/Z\\\\ASSC_RAM_DO_B_net\\\\\, Y => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/N_250\);
    
    
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/ptxbvztnpnf[1]\ : 
        DFN1E1C0
      port map(D => \AB_CM_inst/ASSC_RAM_DO_B_net_net_6\, CLK => 
        SYSCLK_c, CLR => SYSRSTn_c, E => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/jzzdfrmzwdj[11]_net_1\, 
        Q => \AB_CM_inst/ADC_STC_net_net_5\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/gjkdbmpgrtc_12[5]\ : 
        MX2
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_511\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_952\, 
        S => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rdgwgtpkbgc_1[2]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/gjkdbmpgrtc[5]\);
    
    \Diff2_pad[4]/U0/U1\ : IOTRI_OB_EB
      port map(D => \Diff2_c[4]\, E => SOC_VCC_NET, DOUT => 
        \Diff2_pad[4]/U0/NET1\, EOUT => \Diff2_pad[4]/U0/NET2\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/gjkdbmpgrtc_8_i[1]\ : 
        NOR2B
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rqrqhcwpqdn[0]_net_1\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rdgwgtpkbgc[0]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_901\);
    
    
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/jfkkdmfhcdn_0_a3[6]\ : 
        NOR2A
      port map(A => \AB_CM_inst/TR_RAM_DO_B_net_net_1\, B => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/frcskdnwvmx_0[0]_net_1\, 
        Y => \AB_CM_inst/TR_RAM_DI_B_net_net_1\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rqrqhcwpqdn[8]\ : 
        DFN1E1C0
      port map(D => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_822\, 
        CLK => SYSCLK_c, CLR => SYSRSTn_c, E => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_823\, 
        Q => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rqrqhcwpqdn[8]_net_1\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc_12_d_s[3]\ : 
        OA1A
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rdgwgtpkbgc_0[1]_net_1\, 
        B => 
        \AB_CM_inst.AB_CM_smev_wrapper_inst.U0.u_nbnjbfrkqwq.rdgwgtpkbgc[3]\, 
        C => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rdgwgtpkbgc_0[2]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc_12_d_s[3]_net_1\);
    
    \COMP_SM_inst/R2[2]\ : DFN1E1C0
      port map(D => \ADC_RESULT[2]\, CLK => SYSCLK_c, CLR => 
        SYSRSTn_c, E => \COMP_SM_inst/pres_state_0[2]_net_1\, Q
         => \COMP_SM_inst/R2[2]_net_1\);
    
    \COMP_SM_inst/R2[0]\ : DFN1E1C0
      port map(D => \ADC_RESULT[0]\, CLK => SYSCLK_c, CLR => 
        SYSRSTn_c, E => \COMP_SM_inst/pres_state_0[2]_net_1\, Q
         => \COMP_SM_inst/R2[0]_net_1\);
    
    \COMP_SM_inst/R2[9]\ : DFN1E1C0
      port map(D => \ADC_RESULT[9]\, CLK => SYSCLK_c, CLR => 
        SYSRSTn_c, E => \COMP_SM_inst/pres_state[2]_net_1\, Q => 
        \COMP_SM_inst/R2[9]_net_1\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/mkmkbnghgkd[5]\ : 
        MX2
      port map(A => \INIT_ADDR[5]\, B => 
        \AB_CM_inst/TR_EV_ADDR_net_net_2\, S => INIT_DONE, Y => 
        \AB_CM_inst/EV_RAM_ADDR_A_net_net_2\);
    
    
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/user_clk_sel/u_jhmkpjjmdkx/qqqjcnjzntg\ : 
        DFN1C0
      port map(D => SOC_VCC_NET, CLK => SYSCLK_c, CLR => 
        SYSRSTn_c, Q => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/bfcqzvtnrcn\);
    
    \Diff1_pad[8]/U0/U0\ : IOPAD_TRI
      port map(D => \Diff1_pad[8]/U0/NET1\, E => 
        \Diff1_pad[8]/U0/NET2\, PAD => Diff1(8));
    
    
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/tpxkpvnpvvn_m_0[2]\ : 
        OR3B
      port map(A => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/frcskdnwvmx_0[8]_net_1\, 
        B => \AB_CM_inst/TR_RAM_DO_B_net_net_5\, C => 
        \AB_CM_inst/EV_DONE_net_0\, Y => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/tpxkpvnpvvn_m_0[2]_net_1\);
    
    
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/jfkkdmfhcdn[3]\ : 
        NOR2A
      port map(A => \AB_CM_inst/TR_RAM_DO_B_net_net_4\, B => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/frcskdnwvmx[0]_net_1\, 
        Y => \AB_CM_inst/TR_RAM_DI_B_net_net_4\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/zbcrjjxqjgg_i_o2\ : 
        AXOI5
      port map(A => \AB_CM_inst/EV_RAM_DO_B_net_net_1\, B => 
        \AB_CM_inst/Z\\\\EV_RAM_DO_B_net\\\\\, C => 
        \AB_CM_inst/EV_RAM_DO_B_net[8]\, Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_203\);
    
    
        \COMP_SM_inst/Subtract_inst/sumAux_0_0_SUB_12x12_medium_area_I40_Y\ : 
        AO1B
      port map(A => \COMP_SM_inst/Subtract_inst/N210\, B => 
        \COMP_SM_inst/Subtract_inst/SUB_12x12_medium_area_I40_un1_Y_0\, 
        C => 
        \COMP_SM_inst/Subtract_inst/SUB_12x12_medium_area_I40_Y_1\, 
        Y => \COMP_SM_inst/Subtract_inst/N200\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rfrdbqfdrhx[0]\ : 
        DFN1E1C0
      port map(D => \AB_CM_inst/EV_RAM_DO_B_net_net_3\, CLK => 
        SYSCLK_c, CLR => SYSRSTn_c, E => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bskrjhjvqpf_0_sqmuxa\, 
        Q => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rfrdbqfdrhx[0]_net_1\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/fqkdsnjfpdb_0_0_ADD_18x18_medium_I61_Y\ : 
        OR2A
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/I61_un1_Y_i\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N312\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N351\);
    
    
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/jzzdfrmzwdj_ns_i_1[1]\ : 
        NOR3C
      port map(A => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/bksczsjcvgb_net_1\, 
        B => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/jzzdfrmzwdj[15]_net_1\, 
        C => INIT_DONE, Y => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/N_200_i_0\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/gjkdbmpgrtc_3[8]\ : 
        MX2
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_542\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_544\, 
        S => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rdgwgtpkbgc[1]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_446\);
    
    \Diff4_pad[6]/U0/U0\ : IOPAD_TRI
      port map(D => \Diff4_pad[6]/U0/NET1\, E => 
        \Diff4_pad[6]/U0/NET2\, PAD => Diff4(6));
    
    \Diff1_pad[4]/U0/U1\ : IOTRI_OB_EB
      port map(D => \Diff1_c[4]\, E => SOC_VCC_NET, DOUT => 
        \Diff1_pad[4]/U0/NET1\, EOUT => \Diff1_pad[4]/U0/NET2\);
    
    \COMP_SM_inst/R1[9]\ : DFN1E1C0
      port map(D => \ADC_RESULT[9]\, CLK => SYSCLK_c, CLR => 
        SYSRSTn_c, E => \COMP_SM_inst/pres_state[3]_net_1\, Q => 
        \COMP_SM_inst/R1[9]_net_1\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/pvtdpmmqdpp_un2_pbzxzjhqhwz_0_I_22\ : 
        OA1A
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnvtvdkcnpp[10]_net_1\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rqrqhcwpqdn[10]_net_1\, 
        C => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_29\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_33\);
    
    
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/jzzdfrmzwdj_0[14]\ : 
        DFN1C0
      port map(D => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/N_200_i_0\, 
        CLK => SYSCLK_c, CLR => SYSRSTn_c, Q => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/jzzdfrmzwdj_0[14]_net_1\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/fqkdsnjfpdb_0_0_ADD_18x18_medium_I75_Y_3\ : 
        OA1A
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N322\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ADD_18x18_medium_I75_un1_Y_0\, 
        C => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ADD_18x18_medium_I75_Y_2\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ADD_18x18_medium_I75_Y_3\);
    
    
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/jvxfmjbzjmc_i_o2_0\ : 
        OR3B
      port map(A => \AB_CM_inst/TR_RAM_DO_B_net_net_1_0\, B => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/N_233\, 
        C => \AB_CM_inst/TR_RAM_DO_B_net_0[8]\, Y => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/N_247\);
    
    
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/address_gen/u_dxwqxgdccxc/un1_dkjzqmrkvwb_ADD_13x13_fast_I87_Y_0\ : 
        AX1B
      port map(A => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/N_2340\, 
        B => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/N_2358\, 
        C => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/address_gen/u_dxwqxgdccxc/ggfvvjbkdws[9]_net_1\, 
        Y => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/ADD_13x13_fast_I87_Y_0\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rqrqhcwpqdn_9_0[9]\ : 
        MX2
      port map(A => \AB_CM_inst/ASSC_RAM_DO_A_net_net_7\, B => 
        \AB_CM_inst/EV_RAM_DO_B_net_net_7\, S => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/un1_mvnkctvqsgp_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_835\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc_12_d[0]\ : 
        MX2
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc_12_d_d[0]_net_1\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_646\, 
        S => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc_12_d_s[0]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc_12_d[0]_net_1\);
    
    
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/wwhrbsjdjpn\ : 
        DFN1C0
      port map(D => \AB_CM_inst/ADC_CALIBRATE_net\, CLK => 
        SYSCLK_c, CLR => SYSRSTn_c, Q => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/wwhrbsjdjpn_net_1\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc_3[6]\ : 
        MX2
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_744\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_746\, 
        S => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rdgwgtpkbgc_2[1]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_648\);
    
    
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/init_fsm/u_stnpfdkggvx/mwtvnzdkmwm[2]\ : 
        DFN1C0
      port map(D => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/init_fsm/u_stnpfdkggvx/mwtvnzdkmwm_ns[5]\, 
        CLK => SYSCLK_c, CLR => SYSRSTn_c, Q => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/init_fsm/u_stnpfdkggvx/mwtvnzdkmwm[2]_net_1\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/dbdctxjdvkp_2_sqmuxa_0_a3\ : 
        NOR2B
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_239\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_227_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/dbdctxjdvkp_2_sqmuxa\);
    
    
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/init_fsm/u_stnpfdkggvx/mwtvnzdkmwm[1]\ : 
        DFN1C0
      port map(D => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/init_fsm/u_stnpfdkggvx/mwtvnzdkmwm_ns[6]\, 
        CLK => SYSCLK_c, CLR => SYSRSTn_c, Q => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/init_fsm/u_stnpfdkggvx/mwtvnzdkmwm[1]_net_1\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/gjkdbmpgrtc_3[5]\ : 
        MX2
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_901\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_541\, 
        S => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rdgwgtpkbgc[1]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_443\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/qrbxknbdvjj[7]\ : 
        DFN1E1C0
      port map(D => \AB_CM_inst/Z\\\\EV_RAM_ADDR_B_net\\\\\, CLK
         => SYSCLK_c, CLR => SYSRSTn_c, E => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx[11]_net_1\, 
        Q => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/qrbxknbdvjj[7]_net_1\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/fqkdsnjfpdb_0_0_ADD_18x18_medium_I20_Y\ : 
        MAJ3
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_308\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_312\, 
        C => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N270\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N286\);
    
    \Diff4_pad[1]/U0/U1\ : IOTRI_OB_EB
      port map(D => \Diff4_c[1]\, E => SOC_VCC_NET, DOUT => 
        \Diff4_pad[1]/U0/NET1\, EOUT => \Diff4_pad[1]/U0/NET2\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc_11_s[6]\ : 
        OR2
      port map(A => 
        \AB_CM_inst.AB_CM_smev_wrapper_inst.U0.u_nbnjbfrkqwq.rdgwgtpkbgc[3]\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rdgwgtpkbgc_0[1]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc_11_s[6]_net_1\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/gjkdbmpgrtc_7_0_a3[11]\ : 
        NOR2A
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_449\, 
        B => 
        \AB_CM_inst.AB_CM_smev_wrapper_inst.U0.u_nbnjbfrkqwq.rdgwgtpkbgc[3]\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_941\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/kkkmkxwwscv[5]\ : 
        DFN1E1C0
      port map(D => \AB_CM_inst/ASSC_SEQOUT_net[5]\, CLK => 
        SYSCLK_c, CLR => SYSRSTn_c, E => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/qmmwhjxxxmv_net_1\, 
        Q => \AB_CM_inst/EV_ASSCADDR_net[8]\);
    
    
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/ksbhwjctscp[3]\ : 
        MX2
      port map(A => \INIT_ADDR[3]\, B => 
        \AB_CM_inst/EV_ASSCADDR_net_net_4\, S => INIT_DONE, Y => 
        \AB_CM_inst/ASSC_RAM_ADDR_A_net_net_4\);
    
    
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/frcskdnwvmx_ns_a3[10]\ : 
        NOR2A
      port map(A => INIT_DONE, B => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/N_288\, 
        Y => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/frcskdnwvmx_ns[10]\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc_12[14]\ : 
        MX2
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_958\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_792\, 
        S => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rdgwgtpkbgc[2]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc[14]\);
    
    \Diff5_pad[5]/U0/U0\ : IOPAD_TRI
      port map(D => \Diff5_pad[5]/U0/NET1\, E => 
        \Diff5_pad[5]/U0/NET2\, PAD => Diff5(5));
    
    
        \COMP_SM_inst/Subtract_inst/sumAux_0_0_SUB_12x12_medium_area_I75_Y\ : 
        XOR3
      port map(A => \COMP_SM_inst/R1[8]_net_1\, B => 
        \COMP_SM_inst/R2[8]_net_1\, C => 
        \COMP_SM_inst/Subtract_inst/N216_i\, Y => 
        \COMP_SM_inst/Result[8]\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rqrqhcwpqdn[2]\ : 
        DFN1E1C0
      port map(D => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_816\, 
        CLK => SYSCLK_c, CLR => SYSRSTn_c, E => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_823\, 
        Q => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rqrqhcwpqdn[2]_net_1\);
    
    \Diff2_pad[6]/U0/U1\ : IOTRI_OB_EB
      port map(D => \Diff2_c[6]\, E => SOC_VCC_NET, DOUT => 
        \Diff2_pad[6]/U0/NET1\, EOUT => \Diff2_pad[6]/U0/NET2\);
    
    
        \COMP_SM_inst/Subtract_inst/sumAux_0_0_SUB_12x12_medium_area_I72_Y\ : 
        AX1D
      port map(A => \COMP_SM_inst/Subtract_inst/I61_un1_Y\, B => 
        \COMP_SM_inst/Subtract_inst/N206\, C => 
        \COMP_SM_inst/Subtract_inst/N149\, Y => 
        \COMP_SM_inst/Result[5]\);
    
    
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/save_fsm/u_wbsfnwwctpn/crpwsdfhcqq_ns[6]\ : 
        AO1B
      port map(A => \NVM_CM_inst/NVM_BUSY_net\, B => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/save_fsm/u_wbsfnwwctpn/mfwjfgrqchd\, 
        C => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/save_fsm/u_wbsfnwwctpn/N_60\, 
        Y => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/save_fsm/u_wbsfnwwctpn/crpwsdfhcqq_ns[6]_net_1\);
    
    
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/thrxvbszptn\ : 
        DFN1P0
      port map(D => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/frcskdnwvmx_i[0]_net_1\, 
        CLK => SYSCLK_c, PRE => SYSRSTn_c, Q => 
        \AB_CM_inst/TR_DONE_net_i_0\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/fqkdsnjfpdb_0_0_ADD_18x18_medium_I13_P0N\ : 
        OR3
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_307\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_305\, 
        C => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/G_148_0_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N271\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/fqkdsnjfpdb_0_0_ADD_18x18_medium_I97_Y_0\ : 
        AX1D
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/G_108_0_net_1\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_265\, 
        C => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_267\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ADD_18x18_medium_I97_Y_0\);
    
    \COMP_SM_inst/Diff_4[9]\ : DFN1E1C0
      port map(D => \COMP_SM_inst/Result[9]\, CLK => SYSCLK_c, 
        CLR => SYSRSTn_c, E => 
        \COMP_SM_inst/Latest_Update_4_sqmuxa\, Q => \Diff4_c[9]\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/pvtdpmmqdpp_un2_pbzxzjhqhwz_0_I_42\ : 
        NOR2A
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rqrqhcwpqdn[4]_net_1\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnvtvdkcnpp[4]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ACT_LT3_E[0]\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc_2[0]\ : 
        MX2
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ftbkrvpxdbp[2]_net_1\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ftbkrvpxdbp[3]_net_1\, 
        S => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rdgwgtpkbgc_1[0]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_625\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/fqkdsnjfpdb_0_0_ADD_18x18_medium_I12_P0N\ : 
        OR2
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_298\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_302\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N268\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc_3[7]\ : 
        MX2
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_745\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_747\, 
        S => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rdgwgtpkbgc_2[1]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_649\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/fqkdsnjfpdb_0_0_ADD_18x18_medium_I34_Y\ : 
        AO13
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc[0]\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/gjkdbmpgrtc[0]\, 
        C => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ftbkrvpxdbp[0]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N300\);
    
    \Diff1_pad[2]/U0/U1\ : IOTRI_OB_EB
      port map(D => \Diff1_c[2]\, E => SOC_VCC_NET, DOUT => 
        \Diff1_pad[2]/U0/NET1\, EOUT => \Diff1_pad[2]/U0/NET2\);
    
    
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/un1_qgnzcpmbksd_I_42\ : 
        NOR2B
      port map(A => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/DWACT_ADD_CI_0_g_array_2[0]\, 
        B => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/DWACT_ADD_CI_0_pog_array_1_1[0]\, 
        Y => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/DWACT_ADD_CI_0_g_array_11[0]\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rqrqhcwpqdn_5_0[1]\ : 
        MX2
      port map(A => \AB_CM_inst/ASSC_RAM_DO_A_net_net_6\, B => 
        \AB_CM_inst/EV_RAM_DO_B_net_net_6\, S => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/un1_xkwrgrspmcf_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_815\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bskrjhjvqpf_i_o3\ : 
        NOR3
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx_0[8]_net_1\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx[14]_net_1\, 
        C => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx[11]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_215\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc_3[13]\ : 
        MX2
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_751\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_753\, 
        S => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rdgwgtpkbgc_2[1]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_655\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/gcqsptsqnzg_iv_0_a2\ : 
        AOI1
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/wqpbnjzjqsx_NE_1_net_1\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/wqpbnjzjqsx_NE_2_net_1\, 
        C => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rqrqhcwpqdn[0]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_965\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx[4]\ : 
        DFN1C0
      port map(D => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx_ns_i[13]_net_1\, 
        CLK => SYSCLK_c, CLR => SYSRSTn_c, Q => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx[4]_net_1\);
    
    
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/un1_qgnzcpmbksd_I_46\ : 
        NOR3C
      port map(A => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/DWACT_ADD_CI_0_pog_array_1_1[0]\, 
        B => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/DWACT_ADD_CI_0_pog_array_1_2[0]\, 
        C => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/DWACT_ADD_CI_0_g_array_2[0]\, 
        Y => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/DWACT_ADD_CI_0_g_array_3[0]\);
    
    
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/frcskdnwvmx[10]\ : 
        DFN1C0
      port map(D => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/frcskdnwvmx_ns_i[1]_net_1\, 
        CLK => SYSCLK_c, CLR => SYSRSTn_c, Q => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/frcskdnwvmx[10]_net_1\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx_ns_i[11]\ : 
        NOR2B
      port map(A => INIT_DONE, B => 
        \AB_CM_inst/EV_ASSCADDR_net_net_5\, Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx_ns_i[11]_net_1\);
    
    
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/save_fsm/u_wbsfnwwctpn/crpwsdfhcqq[3]\ : 
        DFN1C0
      port map(D => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/save_fsm/u_wbsfnwwctpn/crpwsdfhcqq_ns[5]_net_1\, 
        CLK => SYSCLK_c, CLR => SYSRSTn_c, Q => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/save_fsm/u_wbsfnwwctpn/crpwsdfhcqq[3]_net_1\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/qrbxknbdvjj[0]\ : 
        DFN1E1C0
      port map(D => \AB_CM_inst/EV_RAM_ADDR_B_net_net_7\, CLK => 
        SYSCLK_c, CLR => SYSRSTn_c, E => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx[11]_net_1\, 
        Q => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/qrbxknbdvjj[0]_net_1\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnvtvdkcnpp_9[10]\ : 
        MX2
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnvtvdkcnpp_8[10]_net_1\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/fqkdsnjfpdb[16]\, 
        S => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx_1[4]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnvtvdkcnpp_9[10]_net_1\);
    
    
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/jzzdfrmzwdj_ns_i_0_tz[9]\ : 
        NOR2B
      port map(A => \AB_CM_inst/ADC_BUSY_net\, B => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/jzzdfrmzwdj[6]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/jzzdfrmzwdj_ns_i_0_tz[9]_net_1\);
    
    
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/un1_qgnzcpmbksd_I_32\ : 
        XOR2
      port map(A => \AB_CM_inst/TR_RAM_ADDR_B_net_net_6\, B => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/DWACT_ADD_CI_0_TMP[0]\, 
        Y => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/I_32_0\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/pvtdpmmqdpp_un2_pbzxzjhqhwz_0_I_17\ : 
        OR2A
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rqrqhcwpqdn[8]_net_1\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnvtvdkcnpp[8]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_28\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/pvtdpmmqdpp_un2_pbzxzjhqhwz_0_I_7\ : 
        XA1A
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnvtvdkcnpp[10]_net_1\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rqrqhcwpqdn[10]_net_1\, 
        C => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/DWACT_BL_EQUAL_0_E[4]\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/DWACT_BL_EQUAL_0_DWACT_ANDTREE_E[1]\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/gjkdbmpgrtc_9[6]\ : 
        MX2
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rqrqhcwpqdn[6]_net_1\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rqrqhcwpqdn[7]_net_1\, 
        S => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rdgwgtpkbgc_0[0]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_546\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc_11_d[10]\ : 
        MX2
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_754\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnvtvdkcnpp[4]_net_1\, 
        S => 
        \AB_CM_inst.AB_CM_smev_wrapper_inst.U0.u_nbnjbfrkqwq.rdgwgtpkbgc[3]\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc_11_d[10]_net_1\);
    
    
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/bnrsdrtmtsg[0]\ : 
        DFN1E0C0
      port map(D => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/bnrsdrtmtsg_5[0]_net_1\, 
        CLK => SYSCLK_c, CLR => SYSRSTn_c, E => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/un1_cfxfrwgjccr_9_net_1\, 
        Q => \AB_CM_inst/ASSC_SEQOUT_net_net_4\);
    
    \Diff4_pad[8]/U0/U1\ : IOTRI_OB_EB
      port map(D => \Diff4_c[8]\, E => SOC_VCC_NET, DOUT => 
        \Diff4_pad[8]/U0/NET1\, EOUT => \Diff4_pad[8]/U0/NET2\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnvtvdkcnpp[4]\ : 
        DFN1C0
      port map(D => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnvtvdkcnpp_9[4]_net_1\, 
        CLK => SYSCLK_c, CLR => SYSRSTn_c, Q => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnvtvdkcnpp[4]_net_1\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc_3[10]\ : 
        MX2
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_748\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_750\, 
        S => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rdgwgtpkbgc_1[1]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_652\);
    
    \COMP_SM_inst/Diff_3[11]\ : DFN1E1C0
      port map(D => \COMP_SM_inst/Result[11]\, CLK => SYSCLK_c, 
        CLR => SYSRSTn_c, E => 
        \COMP_SM_inst/Latest_Update_3_sqmuxa\, Q => \Diff3_c[11]\);
    
    \AB_CM_inst/AC3_PAD\ : IOPAD_A_IN
      port map(PAD => AC3, Y => \AB_CM_inst/AC3_net\);
    
    
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/un1_qgnzcpmbksd_I_36\ : 
        XOR2
      port map(A => \AB_CM_inst/TR_RAM_ADDR_B_net[8]\, B => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/DWACT_ADD_CI_0_g_array_3[0]\, 
        Y => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/I_36_0\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc_11[7]\ : 
        MX2
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_751\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc_11_d[7]_net_1\, 
        S => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc_11_s[4]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_785\);
    
    
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/svpbmqwvncp_0_a3\ : 
        OR3
      port map(A => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/N_235\, 
        B => \AB_CM_inst/TR_RAM_DO_B_net[8]\, C => 
        \AB_CM_inst/TR_RAM_DO_B_net_net_1\, Y => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/N_264\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/fqkdsnjfpdb_m[11]\ : 
        OR2B
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx[5]_net_1\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/fqkdsnjfpdb[11]\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/fqkdsnjfpdb_m[11]_net_1\);
    
    \COMP_SM_inst/Diff_4[3]\ : DFN1E1C0
      port map(D => \COMP_SM_inst/Result[3]\, CLK => SYSCLK_c, 
        CLR => SYSRSTn_c, E => 
        \COMP_SM_inst/Latest_Update_4_sqmuxa\, Q => \Diff4_c[3]\);
    
    \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/N_184_m\ : 
        OA1C
      port map(A => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/N_310\, 
        B => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/N_253\, 
        C => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/znbkwkbspdc_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/N_184_m_net_1\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/mtbjcfqsbqf[4]\ : 
        DFN1E1C0
      port map(D => \ADC_CHNUMBER[4]\, CLK => SYSCLK_c, CLR => 
        SYSRSTn_c, E => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/qmmwhjxxxmv_net_1\, 
        Q => \AB_CM_inst/EV_CHHOLD_net[4]\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bskrjhjvqpf_0_sqmuxa_0_a3\ : 
        NOR3A
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx[12]_net_1\, 
        B => \AB_CM_inst/Z\\\\EV_RAM_DO_B_net\\\\\, C => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_205\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bskrjhjvqpf_0_sqmuxa\);
    
    
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/user_control/u_ffppvfwnggt/srdtcqsfmmm_i[14]\ : 
        XA1
      port map(A => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/N222\, 
        B => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/ADD_13x13_fast_I87_Y_0\, 
        C => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/user_control/u_ffppvfwnggt/un1_wxqqqsndpvg_i_0_0\, 
        Y => \NVM_CM_inst/srdtcqsfmmm_i[14]\);
    
    
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/tpxkpvnpvvn_m_0[6]\ : 
        OR3B
      port map(A => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/frcskdnwvmx[8]_net_1\, 
        B => \AB_CM_inst/TR_RAM_DO_B_net_net_1\, C => 
        \AB_CM_inst/EV_DONE_net\, Y => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/tpxkpvnpvvn_m_0[6]_net_1\);
    
    
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/un1_qgnzcpmbksd_I_44\ : 
        NOR2B
      port map(A => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/DWACT_ADD_CI_0_TMP[0]\, 
        B => \AB_CM_inst/TR_RAM_ADDR_B_net_net_6\, Y => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/DWACT_ADD_CI_0_g_array_1[0]\);
    
    
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/cpwfrthtnfr_6_sqmuxa_0_a2_0\ : 
        OR3A
      port map(A => \AB_CM_inst/TR_RAM_DO_B_net_0[8]\, B => 
        \AB_CM_inst/TR_RAM_DO_B_net_net_1_0\, C => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/N_235\, 
        Y => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/N_289\);
    
    \COMP_SM_inst/prev_channel[1]\ : DFN1E1C0
      port map(D => \ADC_CHNUMBER[1]\, CLK => SYSCLK_c, CLR => 
        SYSRSTn_c, E => ASSC_DONE, Q => 
        \COMP_SM_inst/prev_channel[1]_net_1\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/fqkdsnjfpdb_0_0_ADD_18x18_medium_I95_Y_0\ : 
        XNOR3
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc[3]\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/G_99_0_net_1\, 
        C => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_253\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ADD_18x18_medium_I95_Y_0\);
    
    
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/address_gen/u_dxwqxgdccxc/un1_gnmdxrqrdgs_I_44\ : 
        NOR2B
      port map(A => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/address_gen/u_dxwqxgdccxc/DWACT_ADD_CI_0_TMP[0]\, 
        B => \INIT_ADDR[1]\, Y => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/address_gen/u_dxwqxgdccxc/DWACT_ADD_CI_0_g_array_1[0]\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/pptwzsjcmcz_dhzrwbnrbpw_7_iv_0[1]\ : 
        AOI1B
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rgmpzqrbghh_0_net_1\, 
        B => \AB_CM_inst/EV_CHHOLD_net_net_3\, C => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/qrbxknbdvjj_m[1]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/dhzrwbnrbpw_7_iv_0[1]\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/fqkdsnjfpdb_0_0_ADD_18x18_medium_I75_Y_0\ : 
        AO18
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_322\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_318\, 
        C => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N276\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ADD_18x18_medium_I75_Y_0\);
    
    
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/ptxbvztnpnf[0]\ : 
        DFN1E1C0
      port map(D => \AB_CM_inst/ASSC_RAM_DO_B_net_net_7\, CLK => 
        SYSCLK_c, CLR => SYSRSTn_c, E => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/jzzdfrmzwdj[11]_net_1\, 
        Q => \AB_CM_inst/ADC_STC_net_net_6\);
    
    
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/jzzdfrmzwdj_0[4]\ : 
        DFN1C0
      port map(D => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/jzzdfrmzwdj_ns_i_1[11]_net_1\, 
        CLK => SYSCLK_c, CLR => SYSRSTn_c, Q => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/jzzdfrmzwdj_0[4]_net_1\);
    
    
        \COMP_SM_inst/Subtract_inst/sumAux_0_0_SUB_12x12_medium_area_I40_Y_1\ : 
        AOI1B
      port map(A => \COMP_SM_inst/Subtract_inst/N168\, B => 
        \COMP_SM_inst/Subtract_inst/N206\, C => 
        \COMP_SM_inst/Subtract_inst/SUB_12x12_medium_area_I40_Y_0\, 
        Y => 
        \COMP_SM_inst/Subtract_inst/SUB_12x12_medium_area_I40_Y_1\);
    
    \COMP_SM_inst/prev_channel[4]\ : DFN1E1C0
      port map(D => \ADC_CHNUMBER[4]\, CLK => SYSCLK_c, CLR => 
        SYSRSTn_c, E => ASSC_DONE, Q => 
        \COMP_SM_inst/prev_channel[4]_net_1\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/un1_dhzrwbnrbpw_I_1\ : 
        AND2
      port map(A => \AB_CM_inst/EV_RAM_ADDR_B_net_net_7\, B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bskrjhjvqpf_i_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/DWACT_ADD_CI_0_TMP[0]\);
    
    
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/frcskdnwvmx_ns_i[2]\ : 
        NOR2B
      port map(A => INIT_DONE, B => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/frcskdnwvmx[10]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/frcskdnwvmx_ns_i[2]_net_1\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx_ns_a3[6]\ : 
        NOR3A
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx[12]_net_1\, 
        B => \AB_CM_inst/Z\\\\EV_RAM_DO_B_net\\\\_0\, C => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx_ns_a3_0[6]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx_ns[6]\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/fqkdsnjfpdb_0_0_ADD_18x18_medium_I23_Y\ : 
        AO1C
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/G_138_0_net_1\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ADD_18x18_medium_I11_P0N_0\, 
        C => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N268\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N289\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/mtbjcfqsbqf[1]\ : 
        DFN1E1C0
      port map(D => \ADC_CHNUMBER[1]\, CLK => SYSCLK_c, CLR => 
        SYSRSTn_c, E => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/qmmwhjxxxmv_net_1\, 
        Q => \AB_CM_inst/EV_CHHOLD_net_net_2\);
    
    \Diff5_pad[3]/U0/U0\ : IOPAD_TRI
      port map(D => \Diff5_pad[3]/U0/NET1\, E => 
        \Diff5_pad[3]/U0/NET2\, PAD => Diff5(3));
    
    
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/ksbhwjctscp[6]\ : 
        MX2
      port map(A => \INIT_ADDR[6]\, B => 
        \AB_CM_inst/EV_ASSCADDR_net_net_1\, S => INIT_DONE, Y => 
        \AB_CM_inst/ASSC_RAM_ADDR_A_net_net_1\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/kkjrqmngvjc_0_a2\ : 
        NOR2
      port map(A => \AB_CM_inst/EV_RAM_DO_B_net[8]\, B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_237\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_240\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/fqkdsnjfpdb_0_0_ADD_18x18_medium_I6_P0N\ : 
        OR3
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_272\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_270\, 
        C => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/G_113_0_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N250\);
    
    
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/un1_qgnzcpmbksd_I_34\ : 
        AX1C
      port map(A => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/DWACT_ADD_CI_0_g_array_11[0]\, 
        B => \AB_CM_inst/TR_RAM_ADDR_B_net_net_1\, C => 
        \AB_CM_inst/Z\\\\TR_RAM_ADDR_B_net\\\\\, Y => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/I_34_0\);
    
    \Diff0_pad[6]/U0/U1\ : IOTRI_OB_EB
      port map(D => \Diff0_c[6]\, E => SOC_VCC_NET, DOUT => 
        \Diff0_pad[6]/U0/NET1\, EOUT => \Diff0_pad[6]/U0/NET2\);
    
    \Diff0_pad[10]/U0/U0\ : IOPAD_TRI
      port map(D => \Diff0_pad[10]/U0/NET1\, E => 
        \Diff0_pad[10]/U0/NET2\, PAD => Diff0(10));
    
    
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/frcskdnwvmx_ns_i_a3[5]\ : 
        NOR2
      port map(A => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/N_287\, 
        B => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/N_236\, 
        Y => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/N_273\);
    
    
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/frcskdnwvmx[5]\ : 
        DFN1C0
      port map(D => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/frcskdnwvmx_ns[6]\, 
        CLK => SYSCLK_c, CLR => SYSRSTn_c, Q => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/frcskdnwvmx[5]_net_1\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/dhzrwbnrbpw[8]\ : 
        DFN1C0
      port map(D => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/dhzrwbnrbpw_7[8]\, 
        CLK => SYSCLK_c, CLR => SYSRSTn_c, Q => 
        \AB_CM_inst/EV_RAM_ADDR_B_net[8]\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/zbqggxmnpbs_0_iv_0[3]\ : 
        AOI1B
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/fqkdsnjfpdb[0]\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx_0[4]_net_1\, 
        C => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ckghxwbsztp_m[2]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/zbqggxmnpbs_0_iv_0[3]_net_1\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/qrbxknbdvjj_m[0]\ : 
        OR3B
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx_0[8]_net_1\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/qrbxknbdvjj[0]_net_1\, 
        C => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rgmpzqrbghh_0_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/qrbxknbdvjj_m[0]_net_1\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/fqkdsnjfpdb_0_0_ADD_18x18_medium_I29_Y\ : 
        NOR2B
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N250\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ADD_18x18_medium_I5_P0N\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N295\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/dhzrwbnrbpw[0]\ : 
        DFN1C0
      port map(D => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/dhzrwbnrbpw_7[0]\, 
        CLK => SYSCLK_c, CLR => SYSRSTn_c, Q => 
        \AB_CM_inst/EV_RAM_ADDR_B_net_net_7\);
    
    \COMP_SM_inst/Diff_1[10]\ : DFN1E1C0
      port map(D => \COMP_SM_inst/Result[10]\, CLK => SYSCLK_c, 
        CLR => SYSRSTn_c, E => 
        \COMP_SM_inst/Latest_Update_1_sqmuxa\, Q => \Diff1_c[10]\);
    
    \New_Measurement_pad/U0/U0\ : IOPAD_TRI
      port map(D => \New_Measurement_pad/U0/NET1\, E => 
        \New_Measurement_pad/U0/NET2\, PAD => New_Measurement);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx_ns_i[1]\ : 
        NOR3C
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rgmpzqrbghh_0_net_1\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx[17]_net_1\, 
        C => INIT_DONE, Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx_ns_i[1]_net_1\);
    
    \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/G_109\ : 
        XNOR3
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/gjkdbmpgrtc[5]\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ftbkrvpxdbp[5]_net_1\, 
        C => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc[5]\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_267\);
    
    \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/G_106\ : 
        NOR2B
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ftbkrvpxdbp[4]_net_1\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc_12[4]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_265\);
    
    \COMP_SM_inst/Diff_3[0]\ : DFN1E1C0
      port map(D => \COMP_SM_inst/N139\, CLK => SYSCLK_c, CLR => 
        SYSRSTn_c, E => \COMP_SM_inst/Latest_Update_3_sqmuxa\, Q
         => \Diff3_c[0]\);
    
    
        \COMP_SM_inst/Subtract_inst/sumAux_0_0_SUB_12x12_medium_area_I17_S\ : 
        XNOR2
      port map(A => \COMP_SM_inst/R2[5]_net_1\, B => 
        \COMP_SM_inst/R1[5]_net_1\, Y => 
        \COMP_SM_inst/Subtract_inst/N149\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx_ns_a3_1[4]\ : 
        OR3B
      port map(A => INIT_DONE, B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_240\, 
        C => \AB_CM_inst/Z\\\\EV_RAM_DO_B_net\\\\_0\, Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_228\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/zbqggxmnpbs_0_iv_0[1]\ : 
        AOI1B
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/fqkdsnjfpdb[7]\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx[5]_net_1\, 
        C => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ckghxwbsztp_m[0]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/zbqggxmnpbs_0_iv_0[1]_net_1\);
    
    \Diff1_pad[7]/U0/U1\ : IOTRI_OB_EB
      port map(D => \Diff1_c[7]\, E => SOC_VCC_NET, DOUT => 
        \Diff1_pad[7]/U0/NET1\, EOUT => \Diff1_pad[7]/U0/NET2\);
    
    
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/cpwfrthtnfr_13_sqmuxa_1_0_a2_0\ : 
        NOR3B
      port map(A => \AB_CM_inst/Z\\\\TR_RAM_DO_B_net\\\\\, B => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/frcskdnwvmx[6]_net_1\, 
        C => \AB_CM_inst/TR_RAM_DO_B_net_net_2\, Y => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/cpwfrthtnfr_10_sqmuxa_0_a3_0\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx[16]\ : 
        DFN1C0
      port map(D => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx_ns_i[1]_net_1\, 
        CLK => SYSCLK_c, CLR => SYSRSTn_c, Q => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx[16]_net_1\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/gjkdbmpgrtc_12[6]\ : 
        MX2
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_512\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_580\, 
        S => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rdgwgtpkbgc_1[2]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/gjkdbmpgrtc[6]\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ckghxwbsztp_3_0_a3[2]\ : 
        NOR2B
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/I_9\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_923\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ckghxwbsztp_3[2]\);
    
    
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/cvpkmgjqwzb_0_a2_0_o2_1\ : 
        OR3
      port map(A => \AB_CM_inst/TR_RAM_DO_B_net_net_4\, B => 
        \AB_CM_inst/TR_RAM_DO_B_net_net_5\, C => 
        \AB_CM_inst/TR_RAM_DO_B_net_net_3\, Y => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/cvpkmgjqwzb_0_a2_0_o2_1_net_1\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bskrjhjvqpf_1_sqmuxa_0_a2_0\ : 
        OR2B
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_240\, 
        B => \AB_CM_inst/Z\\\\EV_RAM_DO_B_net\\\\_0\, Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bskrjhjvqpf_1_sqmuxa_0\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/pptwzsjcmcz_dhzrwbnrbpw_7_iv[8]\ : 
        AO1B
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_201_i_0\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/I_36\, 
        C => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/dhzrwbnrbpw_7_iv_0[8]\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/dhzrwbnrbpw_7[8]\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/un1_dhzrwbnrbpw_I_21\ : 
        XOR2
      port map(A => \AB_CM_inst/EV_RAM_ADDR_B_net_net_7\, B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bskrjhjvqpf_i_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/DWACT_ADD_CI_0_partial_sum[0]\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/un3_ckghxwbsztp_I_9\ : 
        AX1C
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rqrqhcwpqdn[2]_net_1\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rqrqhcwpqdn[1]_net_1\, 
        C => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rqrqhcwpqdn[3]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/I_9\);
    
    \Diff3_pad[11]/U0/U1\ : IOTRI_OB_EB
      port map(D => \Diff3_c[11]\, E => SOC_VCC_NET, DOUT => 
        \Diff3_pad[11]/U0/NET1\, EOUT => \Diff3_pad[11]/U0/NET2\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/gpjgkmhxbkn_0\ : 
        XNOR2
      port map(A => \AB_CM_inst/EV_RAM_DO_B_net_net_6\, B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rqrqhcwpqdn[1]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/gpjgkmhxbkn_0_i\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/kkkmkxwwscv[2]\ : 
        DFN1E1C0
      port map(D => \AB_CM_inst/ASSC_SEQOUT_net_net_2\, CLK => 
        SYSCLK_c, CLR => SYSRSTn_c, E => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/qmmwhjxxxmv_net_1\, 
        Q => \AB_CM_inst/EV_ASSCADDR_net_net_2\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/fqkdsnjfpdb_0_0_ADD_18x18_medium_I68_Y_0\ : 
        AO1A
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N310\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N307\, 
        C => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N306\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ADD_18x18_medium_I68_Y_0\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/zbqggxmnpbs_0_iv[4]\ : 
        AO1B
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx[5]_net_1\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/fqkdsnjfpdb[10]\, 
        C => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/zbqggxmnpbs_0_iv_0[4]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/zbqggxmnpbs_0_iv[4]_net_1\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/fqkdsnjfpdb_0_0_ADD_18x18_medium_I108_Y\ : 
        AX1A
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N276\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ADD_18x18_medium_I84_un1_Y\, 
        C => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ADD_18x18_medium_I108_Y_0\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/fqkdsnjfpdb[16]\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnvtvdkcnpp_5[5]\ : 
        MX2
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnvtvdkcnpp[5]_net_1\, 
        B => \AB_CM_inst/EV_RAM_DO_B_net_net_2\, S => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/un3_qvqqfftqsfc_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnvtvdkcnpp_5[5]_net_1\);
    
    
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/address_gen/u_dxwqxgdccxc/gnmdxrqrdgs[6]\ : 
        DFN1C0
      port map(D => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/address_gen/u_dxwqxgdccxc/gnmdxrqrdgs_3[6]\, 
        CLK => SYSCLK_c, CLR => SYSRSTn_c, Q => \INIT_ADDR[6]\);
    
    
        \COMP_SM_inst/Subtract_inst/sumAux_0_0_SUB_12x12_medium_area_I47_Y_0\ : 
        AO13
      port map(A => \COMP_SM_inst/R1[10]_net_1\, B => 
        \COMP_SM_inst/Subtract_inst/N158\, C => 
        \COMP_SM_inst/R2[10]_net_1\, Y => 
        \COMP_SM_inst/Subtract_inst/SUB_12x12_medium_area_I47_Y_0\);
    
    \Diff4_pad[7]/U0/U1\ : IOTRI_OB_EB
      port map(D => \Diff4_c[7]\, E => SOC_VCC_NET, DOUT => 
        \Diff4_pad[7]/U0/NET1\, EOUT => \Diff4_pad[7]/U0/NET2\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/fqkdsnjfpdb_0_0_ADD_18x18_medium_I47_un1_Y\ : 
        NOR2A
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N298\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N297\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ADD_18x18_medium_I47_un1_Y\);
    
    
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/un7_nwjvqqsgrjz_i_o3\ : 
        OR2B
      port map(A => \AB_CM_inst/EV_DONE_net\, B => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/frcskdnwvmx[11]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/N_243\);
    
    
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/hgqdwrxvgzm[1]\ : 
        DFN1E1C0
      port map(D => \AB_CM_inst/ASSC_RAM_DO_B_net_net_6\, CLK => 
        SYSCLK_c, CLR => SYSRSTn_c, E => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/jzzdfrmzwdj[14]_net_1\, 
        Q => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/hgqdwrxvgzm[1]_net_1\);
    
    \Diff1_pad[0]/U0/U1\ : IOTRI_OB_EB
      port map(D => \Diff1_c[0]\, E => SOC_VCC_NET, DOUT => 
        \Diff1_pad[0]/U0/NET1\, EOUT => \Diff1_pad[0]/U0/NET2\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc_11_d_s[4]\ : 
        OR2
      port map(A => 
        \AB_CM_inst.AB_CM_smev_wrapper_inst.U0.u_nbnjbfrkqwq.rdgwgtpkbgc[3]\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rdgwgtpkbgc_0[0]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc_11_d_s[4]_net_1\);
    
    
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/znbmnfdbzvr_38\ : 
        AO1A
      port map(A => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/bksnhfwfshc\, 
        B => INIT_DONE, C => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/znbmnfdbzvr_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/znbmnfdbzvr_38_net_1\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/gjkdbmpgrtc_9[9]\ : 
        MX2
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rqrqhcwpqdn[9]_net_1\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rqrqhcwpqdn[10]_net_1\, 
        S => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rdgwgtpkbgc_1[0]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_549\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc_7_0_a3[10]\ : 
        NOR2A
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_652\, 
        B => 
        \AB_CM_inst.AB_CM_smev_wrapper_inst.U0.u_nbnjbfrkqwq.rdgwgtpkbgc[3]\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_954\);
    
    
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/frcskdnwvmx[1]\ : 
        DFN1C0
      port map(D => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/frcskdnwvmx_ns[10]\, 
        CLK => SYSCLK_c, CLR => SYSRSTn_c, Q => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/frcskdnwvmx[1]_net_1\);
    
    \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/G_124\ : 
        XOR3
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnvtvdkcnpp_0[2]_net_1\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/gjkdbmpgrtc_12[8]_net_1\, 
        C => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc[8]\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_282\);
    
    
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/user_control/u_ffppvfwnggt/cpqqthwwhvc_i_i_a2_3[7]\ : 
        OR2B
      port map(A => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/gpbbjwsprsj[0]\, 
        B => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/bfcqzvtnrcn\, 
        Y => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/user_control/u_ffppvfwnggt/N_2342\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnvtvdkcnpp_5[0]\ : 
        MX2
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnvtvdkcnpp[0]_net_1\, 
        B => \AB_CM_inst/EV_RAM_DO_B_net_net_7\, S => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/un3_qvqqfftqsfc_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnvtvdkcnpp_5[0]_net_1\);
    
    
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/wkpfnwqwgcb\ : 
        DFN1C0
      port map(D => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/wwhrbsjdjpn_net_1\, 
        CLK => SYSCLK_c, CLR => SYSRSTn_c, Q => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/wkpfnwqwgcb_net_1\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/fqkdsnjfpdb_0_0_ADD_18x18_medium_I68_Y\ : 
        AO1
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N354\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ADD_18x18_medium_I68_un1_Y_0\, 
        C => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ADD_18x18_medium_I68_Y_0\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N345\);
    
    
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/user_control/u_ffppvfwnggt/hcmmkfggqvf_13_0_s[12]\ : 
        XNOR2
      port map(A => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/gpbbjwsprsj[0]\, 
        B => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/gpbbjwsprsj[1]\, 
        Y => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/user_control/u_ffppvfwnggt/hcmmkfggqvf_13[12]\);
    
    
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/xjrbtnwdszs_1_sqmuxa\ : 
        OR2B
      port map(A => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/frcskdnwvmx[2]_net_1\, 
        B => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/dvqzjxhqhrh_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/xjrbtnwdszs_1_sqmuxa_net_1\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/gpjgkmhxbkn_3\ : 
        XNOR2
      port map(A => \AB_CM_inst/EV_RAM_DO_B_net_net_3\, B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rqrqhcwpqdn[4]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/gpjgkmhxbkn_3_i\);
    
    \Diff1_pad[8]/U0/U1\ : IOTRI_OB_EB
      port map(D => \Diff1_c[8]\, E => SOC_VCC_NET, DOUT => 
        \Diff1_pad[8]/U0/NET1\, EOUT => \Diff1_pad[8]/U0/NET2\);
    
    
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/user_control/u_ffppvfwnggt/cpqqthwwhvc_0_0_a2_3[0]\ : 
        NOR3C
      port map(A => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/bfcqzvtnrcn\, 
        B => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/gpbbjwsprsj[1]\, 
        C => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/gpbbjwsprsj[0]\, 
        Y => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/N_2340\);
    
    \COMP_SM_inst/pres_state_ns_a5_0_a4[1]\ : AOI1B
      port map(A => \COMP_SM_inst/N_416\, B => 
        \COMP_SM_inst/N_417\, C => 
        \COMP_SM_inst/pres_state_ns_a5_0_a4_2[1]_net_1\, Y => 
        \COMP_SM_inst/pres_state_ns[1]\);
    
    \Diff5_pad[10]/U0/U1\ : IOTRI_OB_EB
      port map(D => \Diff5_c[10]\, E => SOC_VCC_NET, DOUT => 
        \Diff5_pad[10]/U0/NET1\, EOUT => \Diff5_pad[10]/U0/NET2\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/kkgccghmrzf\ : 
        NOR2A
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rfrdbqfdrhx[0]_net_1\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rfrdbqfdrhx[1]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/kkgccghmrzf_net_1\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/gjkdbmpgrtc_11[15]\ : 
        NOR2B
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rqrqhcwpqdn[9]_net_1\, 
        B => 
        \AB_CM_inst.AB_CM_smev_wrapper_inst.U0.u_nbnjbfrkqwq.rdgwgtpkbgc[3]\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_589\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnvtvdkcnpp_9[7]\ : 
        MX2
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnvtvdkcnpp_5[7]_net_1\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/fqkdsnjfpdb[13]\, 
        S => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx_1[4]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnvtvdkcnpp_9[7]_net_1\);
    
    
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/bnrsdrtmtsg_5_r[1]\ : 
        NOR2B
      port map(A => INIT_DONE, B => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/N_354\, 
        Y => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/bnrsdrtmtsg_5[1]_net_1\);
    
    
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/init_fsm/u_stnpfdkggvx/mwtvnzdkmwm_1_sqmuxa_0_a2\ : 
        NOR3A
      port map(A => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/xbkjkgdsbfh\, 
        B => \NVM_CM_inst/NVM_BUSY_net\, C => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/mhxwcfnvbgt\, 
        Y => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/dxpbcqjpxtw\);
    
    \Diff5_pad[4]/U0/U0\ : IOPAD_TRI
      port map(D => \Diff5_pad[4]/U0/NET1\, E => 
        \Diff5_pad[4]/U0/NET2\, PAD => Diff5(4));
    
    
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/jzzdfrmzwdj[6]\ : 
        DFN1C0
      port map(D => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/jzzdfrmzwdj_ns_i[9]_net_1\, 
        CLK => SYSCLK_c, CLR => SYSRSTn_c, Q => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/jzzdfrmzwdj[6]_net_1\);
    
    \Diff4_pad[6]/U0/U1\ : IOTRI_OB_EB
      port map(D => \Diff4_c[6]\, E => SOC_VCC_NET, DOUT => 
        \Diff4_pad[6]/U0/NET1\, EOUT => \Diff4_pad[6]/U0/NET2\);
    
    \COMP_SM_inst/Diff_4[7]\ : DFN1E1C0
      port map(D => \COMP_SM_inst/Result[7]\, CLK => SYSCLK_c, 
        CLR => SYSRSTn_c, E => 
        \COMP_SM_inst/Latest_Update_4_sqmuxa\, Q => \Diff4_c[7]\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc_11_d[3]\ : 
        MX2C
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc_11_d_d[3]_net_1\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnvtvdkcnpp_0[2]_net_1\, 
        S => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc_11_d_s[3]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc_11_d[3]_net_1\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/wqpbnjzjqsx_0\ : 
        XNOR2
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rqrqhcwpqdn[1]_net_1\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnvtvdkcnpp[1]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/wqpbnjzjqsx_0_i\);
    
    \COMP_SM_inst/valid_8_0_0_a2_1_0\ : NOR2B
      port map(A => \COMP_SM_inst/prev_channel[2]_net_1\, B => 
        \COMP_SM_inst/prev_channel[1]_net_1\, Y => 
        \COMP_SM_inst/valid_8_0_0_a2_1_0_net_1\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rdgwgtpkbgc_1[1]\ : 
        DFN1E0C0
      port map(D => \AB_CM_inst/EV_RAM_DO_B_net_net_6\, CLK => 
        SYSCLK_c, CLR => SYSRSTn_c, E => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bskrjhjvqpf_1_sqmuxa_0\, 
        Q => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rdgwgtpkbgc_1[1]_net_1\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/qrbxknbdvjj[1]\ : 
        DFN1E1C0
      port map(D => \AB_CM_inst/EV_RAM_ADDR_B_net_net_6\, CLK => 
        SYSCLK_c, CLR => SYSRSTn_c, E => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx[11]_net_1\, 
        Q => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/qrbxknbdvjj[1]_net_1\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/pvtdpmmqdpp_un2_pbzxzjhqhwz_0_I_61\ : 
        AOI1A
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnvtvdkcnpp[2]_net_1\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rqrqhcwpqdn[2]_net_1\, 
        C => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ACT_LT4_E[5]\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ACT_LT4_E[6]\);
    
    
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/bksnhfwfshc_0_sqmuxa_3_i_0_o3\ : 
        OR2B
      port map(A => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/jzzdfrmzwdj_i_0[3]\, 
        B => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/jzzdfrmzwdj_i_0[2]\, 
        Y => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/N_248\);
    
    
        \COMP_SM_inst/Subtract_inst/sumAux_0_0_SUB_12x12_medium_area_I39_Y\ : 
        OR2B
      port map(A => 
        \COMP_SM_inst/Subtract_inst/SUB_12x12_medium_area_I39_Y_0\, 
        B => \COMP_SM_inst/Subtract_inst/I39_un1_Y\, Y => 
        \COMP_SM_inst/Subtract_inst/N210\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx_ns_i[5]\ : 
        NOR2B
      port map(A => INIT_DONE, B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx[13]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx_ns_i[5]_net_1\);
    
    
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/address_gen/u_dxwqxgdccxc/un1_gnmdxrqrdgs_I_54\ : 
        AND2
      port map(A => \INIT_ADDR[6]\, B => \INIT_ADDR[7]\, Y => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/address_gen/u_dxwqxgdccxc/DWACT_ADD_CI_0_pog_array_1_2[0]\);
    
    
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/user_control/u_ffppvfwnggt/hrdbnmzftpn_0_0_a2_3[13]\ : 
        OR2A
      port map(A => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/vvpkfmmpprk[0]\, 
        B => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/bfcqzvtnrcn\, 
        Y => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/user_control/u_ffppvfwnggt/N_2334\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/gjkdbmpgrtc_11_0_a3[0]\ : 
        NOR2A
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_884\, 
        B => 
        \AB_CM_inst.AB_CM_smev_wrapper_inst.U0.u_nbnjbfrkqwq.rdgwgtpkbgc[3]\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_947\);
    
    \COMP_SM_inst/Diff_2[8]\ : DFN1E0C0
      port map(D => \COMP_SM_inst/Result[8]\, CLK => SYSCLK_c, 
        CLR => SYSRSTn_c, E => 
        \COMP_SM_inst/Latest_Update_2_sqmuxa\, Q => \Diff2_c[8]\);
    
    \COMP_SM_inst/pres_state[1]\ : DFN1C0
      port map(D => \COMP_SM_inst/pres_state_ns[3]\, CLK => 
        SYSCLK_c, CLR => \COMP_SM_inst/un2_resetn\, Q => 
        \COMP_SM_inst/pres_state[1]_net_1\);
    
    
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/save_fsm/u_wbsfnwwctpn/crpwsdfhcqq_ns[5]\ : 
        AO1
      port map(A => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/mhxwcfnvbgt\, 
        B => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/save_fsm/u_wbsfnwwctpn/crpwsdfhcqq[0]_net_1\, 
        C => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/save_fsm/u_wbsfnwwctpn/crpwsdfhcqq[7]_net_1\, 
        Y => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/save_fsm/u_wbsfnwwctpn/crpwsdfhcqq_ns[5]_net_1\);
    
    \COMP_SM_inst/un1_completed_sync_7_i_o2\ : OR2
      port map(A => \COMP_SM_inst/N_418\, B => 
        \COMP_SM_inst/N_406\, Y => \COMP_SM_inst/N_372\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/njhxtffzjds\ : 
        DFN1E0C0
      port map(D => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_211\, 
        CLK => SYSCLK_c, CLR => SYSRSTn_c, E => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/un1_bskrjhjvqpf_6_sqmuxa_1_net_1\, 
        Q => \AB_CM_inst/EV_EVFLAG_net\);
    
    
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/tpxkpvnpvvn_m[8]\ : 
        OR3B
      port map(A => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/frcskdnwvmx[8]_net_1\, 
        B => \AB_CM_inst/TR_RAM_DO_B_net_0[8]\, C => 
        \AB_CM_inst/EV_DONE_net\, Y => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/tpxkpvnpvvn_m[8]_net_1\);
    
    \COMP_SM_inst/un1_completed_sync_7_i_0\ : AOI1B
      port map(A => \COMP_SM_inst/N_419\, B => 
        \COMP_SM_inst/un1_completed_sync_7_i_a4_0_1_net_1\, C => 
        \COMP_SM_inst/Latest_Update_2_sqmuxa_0\, Y => 
        \COMP_SM_inst/un1_completed_sync_7_i_0_net_1\);
    
    \COMP_SM_inst/R2[11]\ : DFN1E1C0
      port map(D => \ADC_RESULT[11]\, CLK => SYSCLK_c, CLR => 
        SYSRSTn_c, E => \COMP_SM_inst/pres_state[2]_net_1\, Q => 
        \COMP_SM_inst/R2[11]_net_1\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/dhzrwbnrbpw[1]\ : 
        DFN1C0
      port map(D => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/dhzrwbnrbpw_7[1]\, 
        CLK => SYSCLK_c, CLR => SYSRSTn_c, Q => 
        \AB_CM_inst/EV_RAM_ADDR_B_net_net_6\);
    
    
        \COMP_SM_inst/Subtract_inst/sumAux_0_0_SUB_12x12_medium_area_I78_Y\ : 
        XOR3
      port map(A => \COMP_SM_inst/R1[11]_net_1\, B => 
        \COMP_SM_inst/R2[11]_net_1\, C => 
        \COMP_SM_inst/Subtract_inst/N192\, Y => 
        \COMP_SM_inst/Result[11]\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/gjkdbmpgrtc_12[13]\ : 
        MX2
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_943\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_587\, 
        S => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rdgwgtpkbgc_1[2]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/gjkdbmpgrtc[13]\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/gjkdbmpgrtc_9[4]\ : 
        MX2
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rqrqhcwpqdn[4]_net_1\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rqrqhcwpqdn[5]_net_1\, 
        S => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rdgwgtpkbgc_0[0]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_544\);
    
    
        \COMP_SM_inst/Subtract_inst/sumAux_0_0_SUB_12x12_medium_area_I17_CO1\ : 
        NOR2A
      port map(A => \COMP_SM_inst/R1[5]_net_1\, B => 
        \COMP_SM_inst/R2[5]_net_1\, Y => 
        \COMP_SM_inst/Subtract_inst/N150\);
    
    \COMP_SM_inst/Diff_1[6]\ : DFN1E1C0
      port map(D => \COMP_SM_inst/Result[6]\, CLK => SYSCLK_c, 
        CLR => SYSRSTn_c, E => 
        \COMP_SM_inst/Latest_Update_1_sqmuxa\, Q => \Diff1_c[6]\);
    
    
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/frcskdnwvmx[7]\ : 
        DFN1C0
      port map(D => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/frcskdnwvmx_ns_i[4]_net_1\, 
        CLK => SYSCLK_c, CLR => SYSRSTn_c, Q => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/frcskdnwvmx[7]_net_1\);
    
    \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/G_144\ : 
        XNOR3
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/gjkdbmpgrtc[12]\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnvtvdkcnpp[6]_net_1\, 
        C => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc[12]\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_302\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc_11_s_0[2]\ : 
        NOR2
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rdgwgtpkbgc_0[1]_net_1\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rdgwgtpkbgc_0[2]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc_11_s_0[2]_net_1\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc_11_d[11]\ : 
        MX2
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_967\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnvtvdkcnpp[5]_net_1\, 
        S => 
        \AB_CM_inst.AB_CM_smev_wrapper_inst.U0.u_nbnjbfrkqwq.rdgwgtpkbgc[3]\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc_11_d[11]_net_1\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnvtvdkcnpp[9]\ : 
        DFN1C0
      port map(D => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnvtvdkcnpp_9[9]_net_1\, 
        CLK => SYSCLK_c, CLR => SYSRSTn_c, Q => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnvtvdkcnpp[9]_net_1\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/gjkdbmpgrtc_12[3]\ : 
        MX2
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_509\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_950\, 
        S => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rdgwgtpkbgc[2]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/gjkdbmpgrtc[3]\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/fqkdsnjfpdb_0_0_ADD_18x18_medium_I103_Y\ : 
        XOR2
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ADD_18x18_medium_I103_Y_0\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N347\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/fqkdsnjfpdb[11]\);
    
    
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/address_gen/u_dxwqxgdccxc/ggfvvjbkdws[8]\ : 
        MX2C
      port map(A => \INIT_ADDR[8]\, B => \INIT_ADDR[7]\, S => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/ggsxvgncrgz[0]\, 
        Y => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/address_gen/u_dxwqxgdccxc/ggfvvjbkdws[8]_net_1\);
    
    \COMP_SM_inst/valid_8_0_0_a4_1\ : AO1B
      port map(A => \COMP_SM_inst/N_409\, B => 
        \COMP_SM_inst/N_410\, C => 
        \COMP_SM_inst/valid_8_0_0_a4_1_3_net_1\, Y => 
        \COMP_SM_inst/N_403_i\);
    
    \COMP_SM_inst/Latest_Update_3_sqmuxa_0_a4\ : NOR2B
      port map(A => \COMP_SM_inst/N_420\, B => 
        \COMP_SM_inst/N_418\, Y => 
        \COMP_SM_inst/Latest_Update_3_sqmuxa\);
    
    
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/bnrsdrtmtsg_5_r[0]\ : 
        NOR2B
      port map(A => INIT_DONE, B => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/N_353\, 
        Y => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/bnrsdrtmtsg_5[0]_net_1\);
    
    
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/cpwfrthtnfr_12_sqmuxa_0_a2\ : 
        NOR2
      port map(A => \AB_CM_inst/TR_RAM_DO_B_net_net_7\, B => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/cpwfrthtnfr_13_sqmuxa_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/cpwfrthtnfr_12_sqmuxa\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bskrjhjvqpf_i_0\ : 
        OR2
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx[15]_net_1\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx[9]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bskrjhjvqpf_i_0_net_1\);
    
    \SPARE_pad/U0/U0\ : IOPAD_TRI
      port map(D => \SPARE_pad/U0/NET1\, E => \SPARE_pad/U0/NET2\, 
        PAD => SPARE);
    
    
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/address_gen/u_dxwqxgdccxc/jvbvzqvvxpc_un10_gnmdxrqrdgs_NE\ : 
        NOR2B
      port map(A => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/address_gen/u_dxwqxgdccxc/un10_gnmdxrqrdgs_NE_6\, 
        B => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/address_gen/u_dxwqxgdccxc/un10_gnmdxrqrdgs_NE_5\, 
        Y => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/address_gen/u_dxwqxgdccxc/un10_gnmdxrqrdgs_NE\);
    
    
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/mwzbqqvzwjt_12_iv_0_o2[25]\ : 
        OR2A
      port map(A => \AB_CM_inst/TR_RAM_DO_B_net_net_7\, B => 
        \AB_CM_inst/TR_RAM_DO_B_net_net_6\, Y => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/N_500\);
    
    
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/vgdscntczht_m\ : 
        OAI1
      port map(A => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/N_368\, 
        B => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/jnfrmfqggmk_net_1\, 
        C => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/cpwfrthtnfr_10_sqmuxa\, 
        Y => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/vgdscntczht_m_net_1\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/pvtdpmmqdpp_un2_pbzxzjhqhwz_0_I_57\ : 
        AND2A
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rqrqhcwpqdn[1]_net_1\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnvtvdkcnpp[1]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ACT_LT4_E[2]\);
    
    
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/bnrsdrtmtsg[4]\ : 
        DFN1E0C0
      port map(D => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/bnrsdrtmtsg_5[4]_net_1\, 
        CLK => SYSCLK_c, CLR => SYSRSTn_c, E => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/un1_cfxfrwgjccr_9_net_1\, 
        Q => \AB_CM_inst/Z\\\\ASSC_SEQOUT_net\\\\\);
    
    
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/valid_client/u_gpbdjfttbjd/fpppnnsbksx_r[1]\ : 
        AOI1B
      port map(A => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/valid_client/u_gpbdjfttbjd/N_20\, 
        B => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/valid_client/u_gpbdjfttbjd/N_21\, 
        C => 
        \NVM_CM_inst.NVM_CM_init_wrapper_inst.U0.u_grwzcnqmqzm.valid_client.u_gpbdjfttbjd.N_12\, 
        Y => INIT_ASSC_WEN);
    
    
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/ksbhwjctscp[2]\ : 
        MX2
      port map(A => \INIT_ADDR[2]\, B => 
        \AB_CM_inst/EV_ASSCADDR_net_net_5\, S => INIT_DONE, Y => 
        \AB_CM_inst/ASSC_RAM_ADDR_A_net_net_5\);
    
    
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/address_gen/u_dxwqxgdccxc/un1_dkjzqmrkvwb_ADD_13x13_fast_I86_Y\ : 
        AX1E
      port map(A => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/ggfvvjbkdws[7]\, 
        B => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/mmsccbknsvn[12]\, 
        C => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/address_gen/u_dxwqxgdccxc/ggfvvjbkdws[8]_net_1\, 
        Y => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/bqhrfdzctjc_i_0[13]\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/kkjrqmngvjc_0\ : 
        OR3
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bskrjhjvqpf_6_sqmuxa\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/kkjrqmngvjc_0_0_net_1\, 
        C => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_240\, 
        Y => \AB_CM_inst/EV_RAM_CSN_B_net\);
    
    \Diff5_pad[5]/U0/U1\ : IOTRI_OB_EB
      port map(D => \Diff5_c[5]\, E => SOC_VCC_NET, DOUT => 
        \Diff5_pad[5]/U0/NET1\, EOUT => \Diff5_pad[5]/U0/NET2\);
    
    
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/init_fsm/u_stnpfdkggvx/mwtvnzdkmwm_ns_a2[0]\ : 
        NOR2A
      port map(A => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/init_fsm/u_stnpfdkggvx/mwtvnzdkmwm[7]_net_1\, 
        B => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/bfcqzvtnrcn\, 
        Y => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/init_fsm/u_stnpfdkggvx/mwtvnzdkmwm_ns[0]\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bskrjhjvqpf_i_o2_0\ : 
        OR2
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx[14]_net_1\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx_0[8]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_207\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/un1_kkgccghmrzf\ : 
        OR2B
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx_0[8]_net_1\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/kkgccghmrzf_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/un1_kkgccghmrzf_net_1\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnvtvdkcnpp_8[9]\ : 
        MX2
      port map(A => \AB_CM_inst/EV_RAM_DO_B_net_net_7\, B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnvtvdkcnpp[9]_net_1\, 
        S => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/un1_kkgccghmrzf_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnvtvdkcnpp_8[9]_net_1\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/un1_mvnkctvqsgp\ : 
        NOR2B
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx_0[8]_net_1\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/mvnkctvqsgp_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/un1_mvnkctvqsgp_net_1\);
    
    \Diff5_pad[9]/U0/U0\ : IOPAD_TRI
      port map(D => \Diff5_pad[9]/U0/NET1\, E => 
        \Diff5_pad[9]/U0/NET2\, PAD => Diff5(9));
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/pvtdpmmqdpp_un2_pbzxzjhqhwz_0_I_6\ : 
        AND3
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/DWACT_BL_EQUAL_0_E_0[0]\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/DWACT_BL_EQUAL_0_E_0[1]\, 
        C => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/DWACT_BL_EQUAL_0_E_0[2]\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/DWACT_BL_EQUAL_0_DWACT_ANDTREE_E[0]\);
    
    
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/bnrsdrtmtsg[3]\ : 
        DFN1E0C0
      port map(D => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/bnrsdrtmtsg_5[3]_net_1\, 
        CLK => SYSCLK_c, CLR => SYSRSTn_c, E => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/un1_cfxfrwgjccr_9_net_1\, 
        Q => \AB_CM_inst/ASSC_SEQOUT_net_net_1\);
    
    
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/valid_client/u_gpbdjfttbjd/fpppnnsbksx_0_a3_0[1]\ : 
        OR3A
      port map(A => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/gpbbjwsprsj[0]\, 
        B => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/gpbbjwsprsj[1]\, 
        C => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/npgnwznthhx\, 
        Y => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/valid_client/u_gpbdjfttbjd/N_21\);
    
    \Diff3_pad[6]/U0/U0\ : IOPAD_TRI
      port map(D => \Diff3_pad[6]/U0/NET1\, E => 
        \Diff3_pad[6]/U0/NET2\, PAD => Diff3(6));
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/dhzrwbnrbpw_0_sqmuxa_i\ : 
        OA1B
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx[11]_net_1\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx[14]_net_1\, 
        C => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rgmpzqrbghh_0_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_199_i_0\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/gjkdbmpgrtc_12[9]\ : 
        MX2
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_515\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_583\, 
        S => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rdgwgtpkbgc_1[2]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/gjkdbmpgrtc[9]\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/fqkdsnjfpdb_0_0_ADD_18x18_medium_I75_Y_1\ : 
        AOI1B
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N285\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N286\, 
        C => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ADD_18x18_medium_I75_Y_0\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ADD_18x18_medium_I75_Y_1\);
    
    \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/G_164\ : 
        XNOR3
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnvtvdkcnpp[10]_net_1\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/gjkdbmpgrtc[16]\, 
        C => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc[16]\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_322\);
    
    
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/frcskdnwvmx[6]\ : 
        DFN1C0
      port map(D => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/frcskdnwvmx_ns_i[5]_net_1\, 
        CLK => SYSCLK_c, CLR => SYSRSTn_c, Q => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/frcskdnwvmx[6]_net_1\);
    
    \AB_CM_inst/AV3_PAD\ : IOPAD_A_IN
      port map(PAD => AV3, Y => \AB_CM_inst/AV3_net\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc_12[0]\ : 
        MX2C
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_650\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc_12_d[0]_net_1\, 
        S => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc_12_s[4]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc[0]\);
    
    \COMP_SM_inst/Diff_2[5]\ : DFN1E0C0
      port map(D => \COMP_SM_inst/Result[5]\, CLK => SYSCLK_c, 
        CLR => SYSRSTn_c, E => 
        \COMP_SM_inst/Latest_Update_2_sqmuxa_0\, Q => 
        \Diff2_c[5]\);
    
    
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/frcskdnwvmx_ns_i[8]\ : 
        NOR2B
      port map(A => INIT_DONE, B => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/frcskdnwvmx[4]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/frcskdnwvmx_ns_i[8]_net_1\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rqrqhcwpqdn_5_0[0]\ : 
        MX2
      port map(A => \AB_CM_inst/ASSC_RAM_DO_A_net_net_7\, B => 
        \AB_CM_inst/EV_RAM_DO_B_net_net_7\, S => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/un1_xkwrgrspmcf_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_814\);
    
    
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/user_control/u_ffppvfwnggt/pqmzrrnpzvx_0_o2[0]\ : 
        NOR2
      port map(A => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/gpbbjwsprsj[1]\, 
        B => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/gpbbjwsprsj[0]\, 
        Y => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/N_1838\);
    
    
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/qgtkpxrgqqs_un1_xjrbtnwdszs_0_sqmuxa\ : 
        OR3
      port map(A => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/cpwfrthtnfr_12_sqmuxa\, 
        B => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/un1_xjrbtnwdszs_0_sqmuxa_0\, 
        C => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/cpwfrthtnfr_14_sqmuxa\, 
        Y => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/un1_xjrbtnwdszs_0_sqmuxa\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc_11_d[5]\ : 
        MX2B
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnvtvdkcnpp[3]_net_1\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc_11_d_d[5]_net_1\, 
        S => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc_11_d_s[4]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc_11_d[5]_net_1\);
    
    \Diff2_pad[8]/U0/U0\ : IOPAD_TRI
      port map(D => \Diff2_pad[8]/U0/NET1\, E => 
        \Diff2_pad[8]/U0/NET2\, PAD => Diff2(8));
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc_9[2]\ : 
        MX2
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnvtvdkcnpp[2]_net_1\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnvtvdkcnpp[3]_net_1\, 
        S => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rdgwgtpkbgc_2[0]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_746\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/qrbxknbdvjj_m[7]\ : 
        OR3B
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx[8]_net_1\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/qrbxknbdvjj[7]_net_1\, 
        C => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rgmpzqrbghh_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/qrbxknbdvjj_m[7]_net_1\);
    
    
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/frcskdnwvmx[11]\ : 
        DFN1P0
      port map(D => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/frcskdnwvmx_ns[0]_net_1\, 
        CLK => SYSCLK_c, PRE => SYSRSTn_c, Q => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/frcskdnwvmx[11]_net_1\);
    
    
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/frcskdnwvmx_ns_i_a2[5]\ : 
        OR3
      port map(A => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/frcskdnwvmx[5]_net_1\, 
        B => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/frcskdnwvmx[7]_net_1\, 
        C => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/frcskdnwvmx[2]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/N_287\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/fqkdsnjfpdb_0_0_ADD_18x18_medium_I85_Y\ : 
        AOI1
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N271\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N345\, 
        C => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N270\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ADD_18x18_medium_I85_Y\);
    
    \COMP_SM_inst/Diff_3[4]\ : DFN1E1C0
      port map(D => \COMP_SM_inst/Result[4]\, CLK => SYSCLK_c, 
        CLR => SYSRSTn_c, E => 
        \COMP_SM_inst/Latest_Update_3_sqmuxa\, Q => \Diff3_c[4]\);
    
    
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/dbcvwwhvvwh[4]\ : 
        DFN1E1C0
      port map(D => \AB_CM_inst/ASSC_RAM_DO_B_net_net_3\, CLK => 
        SYSCLK_c, CLR => SYSRSTn_c, E => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/jzzdfrmzwdj[13]_net_1\, 
        Q => \AB_CM_inst/ADC_TVC_net_net_2\);
    
    \COMP_SM_inst/Diff_0[3]\ : DFN1E1C0
      port map(D => \COMP_SM_inst/Result[3]\, CLK => SYSCLK_c, 
        CLR => SYSRSTn_c, E => 
        \COMP_SM_inst/Latest_Update_0_sqmuxa\, Q => \Diff0_c[3]\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc_6_0_a3[9]\ : 
        NOR3A
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnvtvdkcnpp[11]_net_1\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rdgwgtpkbgc[0]_net_1\, 
        C => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rdgwgtpkbgc_1[1]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_953\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/gjkdbmpgrtc_3[15]\ : 
        MX2
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_549\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_969\, 
        S => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rdgwgtpkbgc_2[1]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_453\);
    
    \COMP_SM_inst/prev_channel[2]\ : DFN1E1C0
      port map(D => \ADC_CHNUMBER[2]\, CLK => SYSCLK_c, CLR => 
        SYSRSTn_c, E => ASSC_DONE, Q => 
        \COMP_SM_inst/prev_channel[2]_net_1\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/qrbxknbdvjj_m[4]\ : 
        OR3B
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx[8]_net_1\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/qrbxknbdvjj[4]_net_1\, 
        C => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rgmpzqrbghh_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/qrbxknbdvjj_m[4]_net_1\);
    
    \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/G_93\ : 
        MAJ3
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ftbkrvpxdbp[1]_net_1\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/gjkdbmpgrtc[1]\, 
        C => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ftbkrvpxdbp[0]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_248\);
    
    
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/dbcvwwhvvwh[0]\ : 
        DFN1E1C0
      port map(D => \AB_CM_inst/ASSC_RAM_DO_B_net_net_7\, CLK => 
        SYSCLK_c, CLR => SYSRSTn_c, E => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/jzzdfrmzwdj[13]_net_1\, 
        Q => \AB_CM_inst/ADC_TVC_net_net_6\);
    
    
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/user_control/u_ffppvfwnggt/cpqqthwwhvc_i_m2_i_m2[5]\ : 
        MX2
      port map(A => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/vvpkfmmpprk[1]\, 
        B => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/gpbbjwsprsj[1]\, 
        S => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/bfcqzvtnrcn\, 
        Y => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/bdhvhfjwtxd_i_0[5]\);
    
    \Latest_Update_pad[1]/U0/U1\ : IOTRI_OB_EB
      port map(D => \Latest_Update_c[1]\, E => SOC_VCC_NET, DOUT
         => \Latest_Update_pad[1]/U0/NET1\, EOUT => 
        \Latest_Update_pad[1]/U0/NET2\);
    
    \COMP_SM_inst/Diff_5[2]\ : DFN1E1C0
      port map(D => \COMP_SM_inst/Result[2]\, CLK => SYSCLK_c, 
        CLR => SYSRSTn_c, E => 
        \COMP_SM_inst/Latest_Update_5_sqmuxa\, Q => \Diff5_c[2]\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/fqkdsnjfpdb_0_0_ADD_18x18_medium_I24_Y\ : 
        AO1B
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ADD_18x18_medium_I9_G0N\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N262\, 
        C => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N261\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N290\);
    
    
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/address_gen/u_dxwqxgdccxc/un1_dkjzqmrkvwb_ADD_13x13_fast_I35_un1_Y_0\ : 
        NOR3A
      port map(A => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/mmsccbknsvn[12]\, 
        B => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/address_gen/u_dxwqxgdccxc/ggfvvjbkdws[8]_net_1\, 
        C => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/ggfvvjbkdws[7]\, 
        Y => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/address_gen/u_dxwqxgdccxc/ADD_13x13_fast_I35_un1_Y_0\);
    
    
        \COMP_SM_inst/Subtract_inst/sumAux_0_0_SUB_12x12_medium_area_I62_Y\ : 
        AO18
      port map(A => \COMP_SM_inst/R1[9]_net_1\, B => 
        \COMP_SM_inst/R2[9]_net_1\, C => 
        \COMP_SM_inst/Subtract_inst/N202\, Y => 
        \COMP_SM_inst/Subtract_inst/N214_i\);
    
    \Diff3_pad[7]/U0/U0\ : IOPAD_TRI
      port map(D => \Diff3_pad[7]/U0/NET1\, E => 
        \Diff3_pad[7]/U0/NET2\, PAD => Diff3(7));
    
    
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/frcskdnwvmx_i[0]\ : 
        INV
      port map(A => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/frcskdnwvmx_0[0]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/frcskdnwvmx_i[0]_net_1\);
    
    \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/G_159\ : 
        XNOR3
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/gjkdbmpgrtc[15]\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnvtvdkcnpp[9]_net_1\, 
        C => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc[15]\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_317\);
    
    \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/G_156\ : 
        NOR2A
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnvtvdkcnpp[8]_net_1\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc[14]\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_315\);
    
    \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/I_151\ : 
        OR2A
      port map(A => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/znbmnfdbzvr_net_1\, 
        B => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/bksnhfwfshc\, 
        Y => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/N_345\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx_ns[4]\ : 
        AO1B
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_216\, 
        B => INIT_DONE, C => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx_ns_0[4]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx_ns[4]_net_1\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/qmmwhjxxxmv\ : 
        AOI1B
      port map(A => \AB_CM_inst/N_266\, B => 
        \AB_CM_inst/ktwrhqstzjg\, C => 
        \AB_CM_inst/ASSC_SAMPFLAG_net\, Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/qmmwhjxxxmv_net_1\);
    
    
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/brxxctcvrmh_qgnzcpmbksd_7_0_iv[6]\ : 
        AO1B
      port map(A => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/N_230_i_0\, 
        B => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/I_38_0\, 
        C => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/tpxkpvnpvvn_m_0[6]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/qgnzcpmbksd_7[6]\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/fqkdsnjfpdb_0_0_ADD_18x18_medium_I107_Y\ : 
        AX1B
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/I67_un1_Y\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ADD_18x18_medium_I67_Y_1\, 
        C => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ADD_18x18_medium_I107_Y_0\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/fqkdsnjfpdb[15]\);
    
    
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/un1_qgnzcpmbksd_I_38\ : 
        XOR2
      port map(A => \AB_CM_inst/TR_RAM_ADDR_B_net_net_1\, B => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/DWACT_ADD_CI_0_g_array_11[0]\, 
        Y => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/I_38_0\);
    
    
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/brxxctcvrmh_qgnzcpmbksd_7_0_iv_0[3]\ : 
        AOI1B
      port map(A => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/N_310\, 
        B => \AB_CM_inst/EV_CHHOLD_net_net_1\, C => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/tpxkpvnpvvn_m_0[3]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/qgnzcpmbksd_7_0_iv_0[3]\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc_7_0_a3[11]\ : 
        NOR2A
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_653\, 
        B => 
        \AB_CM_inst.AB_CM_smev_wrapper_inst.U0.u_nbnjbfrkqwq.rdgwgtpkbgc[3]\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_955\);
    
    \Diff5_pad[3]/U0/U1\ : IOTRI_OB_EB
      port map(D => \Diff5_c[3]\, E => SOC_VCC_NET, DOUT => 
        \Diff5_pad[3]/U0/NET1\, EOUT => \Diff5_pad[3]/U0/NET2\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/un3_bmkwsvgbnqv_1_i\ : 
        NOR2A
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_215\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rgmpzqrbghh_0_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_201_i_0\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/gjkdbmpgrtc_7[4]\ : 
        MX2
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_884\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_450\, 
        S => 
        \AB_CM_inst.AB_CM_smev_wrapper_inst.U0.u_nbnjbfrkqwq.rdgwgtpkbgc[3]\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_510\);
    
    
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/address_gen/u_dxwqxgdccxc/jvbvzqvvxpc_un2_tnjvgqqhdkd\ : 
        OR2
      port map(A => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/wtjtwqjkqbd\, 
        B => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/address_gen/u_dxwqxgdccxc/un10_gnmdxrqrdgs_NE\, 
        Y => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/address_gen/u_dxwqxgdccxc/un2_tnjvgqqhdkd\);
    
    
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/address_gen/u_dxwqxgdccxc/jvbvzqvvxpc_gnmdxrqrdgs_3[6]\ : 
        XA1B
      port map(A => \INIT_ADDR[6]\, B => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/address_gen/u_dxwqxgdccxc/DWACT_ADD_CI_0_g_array_11[0]\, 
        C => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/wtjtwqjkqbd\, 
        Y => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/address_gen/u_dxwqxgdccxc/gnmdxrqrdgs_3[6]\);
    
    \COMP_SM_inst/Diff_2[4]\ : DFN1E0C0
      port map(D => \COMP_SM_inst/Result[4]\, CLK => SYSCLK_c, 
        CLR => SYSRSTn_c, E => 
        \COMP_SM_inst/Latest_Update_2_sqmuxa_0\, Q => 
        \Diff2_c[4]\);
    
    
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/frcskdnwvmx_ns_a3_2[0]\ : 
        NOR3A
      port map(A => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/frcskdnwvmx_ns_a3_1[0]_net_1\, 
        B => \AB_CM_inst/TR_EV_RD_net\, C => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/frcskdnwvmx[9]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/frcskdnwvmx_ns_a3_2[0]_net_1\);
    
    \COMP_SM_inst/R1[7]\ : DFN1E1C0
      port map(D => \ADC_RESULT[7]\, CLK => SYSCLK_c, CLR => 
        SYSRSTn_c, E => \COMP_SM_inst/pres_state[3]_net_1\, Q => 
        \COMP_SM_inst/R1[7]_net_1\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc_11[14]\ : 
        NOR2B
      port map(A => 
        \AB_CM_inst.AB_CM_smev_wrapper_inst.U0.u_nbnjbfrkqwq.rdgwgtpkbgc[3]\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnvtvdkcnpp[8]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_792\);
    
    
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/ksbhwjctscp[1]\ : 
        MX2B
      port map(A => \INIT_ADDR[1]\, B => 
        \AB_CM_inst/EV_ASSCADDR_net_net_5\, S => INIT_DONE, Y => 
        \AB_CM_inst/ASSC_RAM_ADDR_A_net_net_6\);
    
    
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/trnwxjxxrbp[0]\ : 
        DFN1C0
      port map(D => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/trnwxjxxrbp[0]_net_1\, 
        CLK => SYSCLK_c, CLR => SYSRSTn_c, Q => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/trnwxjxxrbp[0]_net_1\);
    
    
        \COMP_SM_inst/Subtract_inst/sumAux_0_0_SUB_12x12_medium_area_I29_Y\ : 
        NOR2B
      port map(A => \COMP_SM_inst/Subtract_inst/N151\, B => 
        \COMP_SM_inst/Subtract_inst/N149\, Y => 
        \COMP_SM_inst/Subtract_inst/N168\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/qrbxknbdvjj[6]\ : 
        DFN1E1C0
      port map(D => \AB_CM_inst/EV_RAM_ADDR_B_net_net_1\, CLK => 
        SYSCLK_c, CLR => SYSRSTn_c, E => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx[11]_net_1\, 
        Q => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/qrbxknbdvjj[6]_net_1\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/jrgzmrqhbkv_m[5]\ : 
        OR2B
      port map(A => \AB_CM_inst/EV_RAM_DO_B_net_net_2\, B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_199_i_0\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/jrgzmrqhbkv_m[5]_net_1\);
    
    
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/trnwxjxxrbp[2]\ : 
        DFN1C0
      port map(D => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/trnwxjxxrbp[2]_net_1\, 
        CLK => SYSCLK_c, CLR => SYSRSTn_c, Q => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/trnwxjxxrbp[2]_net_1\);
    
    
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/un2_hfnznbmwdbg_1_i\ : 
        NOR3B
      port map(A => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/un1_wjpccrvpdms\, 
        B => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/N_288\, 
        C => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/frcskdnwvmx_0[8]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/N_230_i_0\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rdgwgtpkbgc_0[2]\ : 
        DFN1E0C0
      port map(D => \AB_CM_inst/EV_RAM_DO_B_net_net_5\, CLK => 
        SYSCLK_c, CLR => SYSRSTn_c, E => 
        \AB_CM_inst/bskrjhjvqpf_1_sqmuxa\, Q => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rdgwgtpkbgc_0[2]_net_1\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx[0]\ : 
        DFN1C0
      port map(D => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx_ns_i[17]_net_1\, 
        CLK => SYSCLK_c, CLR => SYSRSTn_c, Q => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx[0]_net_1\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/gjkdbmpgrtc_7[6]\ : 
        MX2
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_444\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_452\, 
        S => 
        \AB_CM_inst.AB_CM_smev_wrapper_inst.U0.u_nbnjbfrkqwq.rdgwgtpkbgc[3]\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_512\);
    
    \COMP_SM_inst/Diff_0[5]\ : DFN1E1C0
      port map(D => \COMP_SM_inst/Result[5]\, CLK => SYSCLK_c, 
        CLR => SYSRSTn_c, E => 
        \COMP_SM_inst/Latest_Update_0_sqmuxa\, Q => \Diff0_c[5]\);
    
    \COMP_SM_inst/Diff_1[3]\ : DFN1E1C0
      port map(D => \COMP_SM_inst/Result[3]\, CLK => SYSCLK_c, 
        CLR => SYSRSTn_c, E => 
        \COMP_SM_inst/Latest_Update_1_sqmuxa\, Q => \Diff1_c[3]\);
    
    
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/jzzdfrmzwdj_ns_i[2]\ : 
        NOR3C
      port map(A => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/N_278\, 
        B => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/jzzdfrmzwdj_ns_i_0[2]_net_1\, 
        C => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/jzzdfrmzwdj_ns_i_2[2]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/N_202_i_0\);
    
    
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/jzzdfrmzwdj[4]\ : 
        DFN1C0
      port map(D => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/jzzdfrmzwdj_ns_i_1[11]_net_1\, 
        CLK => SYSCLK_c, CLR => SYSRSTn_c, Q => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/jzzdfrmzwdj[4]_net_1\);
    
    
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/user_control/u_ffppvfwnggt/pqmzrrnpzvx_0_i_m2[0]\ : 
        MX2C
      port map(A => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/N_1839\, 
        B => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/N_1838\, 
        S => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/bfcqzvtnrcn\, 
        Y => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/ggsxvgncrgz[0]\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/jrgzmrqhbkv_m[2]\ : 
        OR2B
      port map(A => \AB_CM_inst/EV_RAM_DO_B_net_net_5\, B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_199_i_0\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/jrgzmrqhbkv_m[2]_net_1\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/pvtdpmmqdpp_un2_pbzxzjhqhwz_0_I_20\ : 
        OR2A
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rqrqhcwpqdn[11]_net_1\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnvtvdkcnpp[11]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_31\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/mtbjcfqsbqf[0]\ : 
        DFN1E1C0
      port map(D => \ADC_CHNUMBER[0]\, CLK => SYSCLK_c, CLR => 
        SYSRSTn_c, E => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/qmmwhjxxxmv_net_1\, 
        Q => \AB_CM_inst/EV_CHHOLD_net_net_3\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ftbkrvpxdbp[2]\ : 
        DFN1E0C0
      port map(D => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ftbkrvpxdbp_5[2]_net_1\, 
        CLK => SYSCLK_c, CLR => SYSRSTn_c, E => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ftbkrvpxdbp_1_sqmuxa_net_1\, 
        Q => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ftbkrvpxdbp[2]_net_1\);
    
    
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/address_gen/u_dxwqxgdccxc/gnmdxrqrdgs[3]\ : 
        DFN1C0
      port map(D => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/address_gen/u_dxwqxgdccxc/gnmdxrqrdgs_3[3]\, 
        CLK => SYSCLK_c, CLR => SYSRSTn_c, Q => \INIT_ADDR[3]\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc_3[1]\ : 
        MX2
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_609\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_626\, 
        S => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rdgwgtpkbgc_0[1]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_643\);
    
    
        \COMP_SM_inst/Subtract_inst/sumAux_0_0_SUB_12x12_medium_area_I76_Y\ : 
        XOR2
      port map(A => \COMP_SM_inst/Subtract_inst/N202\, B => 
        \COMP_SM_inst/Subtract_inst/N157\, Y => 
        \COMP_SM_inst/Result[9]\);
    
    
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/address_gen/u_dxwqxgdccxc/ggfvvjbkdws[9]\ : 
        OR2B
      port map(A => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/ggsxvgncrgz[0]\, 
        B => \INIT_ADDR[8]\, Y => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/address_gen/u_dxwqxgdccxc/ggfvvjbkdws[9]_net_1\);
    
    
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/save_fsm/u_wbsfnwwctpn/crpwsdfhcqq[2]\ : 
        DFN1C0
      port map(D => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/save_fsm/u_wbsfnwwctpn/crpwsdfhcqq_ns[6]_net_1\, 
        CLK => SYSCLK_c, CLR => SYSRSTn_c, Q => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/save_fsm/u_wbsfnwwctpn/mfwjfgrqchd\);
    
    \Latest_Update_pad[0]/U0/U1\ : IOTRI_OB_EB
      port map(D => \Latest_Update_c[0]\, E => SOC_VCC_NET, DOUT
         => \Latest_Update_pad[0]/U0/NET1\, EOUT => 
        \Latest_Update_pad[0]/U0/NET2\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ftbkrvpxdbp_5[5]\ : 
        MX2B
      port map(A => \AB_CM_inst/EV_RAM_DO_B_net[8]\, B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/fqkdsnjfpdb_i[5]\, 
        S => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx_1[4]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ftbkrvpxdbp_5[5]_net_1\);
    
    \Diff2_pad[11]/U0/U0\ : IOPAD_TRI
      port map(D => \Diff2_pad[11]/U0/NET1\, E => 
        \Diff2_pad[11]/U0/NET2\, PAD => Diff2(11));
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/fqkdsnjfpdb_0_0_ADD_18x18_medium_I9_G0N\ : 
        NOR2B
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_287\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_283\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ADD_18x18_medium_I9_G0N\);
    
    \Diff5_pad[0]/U0/U0\ : IOPAD_TRI
      port map(D => \Diff5_pad[0]/U0/NET1\, E => 
        \Diff5_pad[0]/U0/NET2\, PAD => Diff5(0));
    
    
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/jvxfmjbzjmc_i_a2\ : 
        OR3C
      port map(A => \AB_CM_inst/Z\\\\TR_RAM_DO_B_net\\\\\, B => 
        \AB_CM_inst/TR_RAM_DO_B_net_net_2\, C => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/N_234_i\, 
        Y => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/N_282\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnvtvdkcnpp[7]\ : 
        DFN1C0
      port map(D => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnvtvdkcnpp_9[7]_net_1\, 
        CLK => SYSCLK_c, CLR => SYSRSTn_c, Q => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnvtvdkcnpp[7]_net_1\);
    
    
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/bnrsdrtmtsg_5[2]\ : 
        MX2
      port map(A => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/hgqdwrxvgzm_3[2]_net_1\, 
        B => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/trnwxjxxrbp[2]_net_1\, 
        S => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/N_345\, 
        Y => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/N_355\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/qrbxknbdvjj_m[6]\ : 
        OR3B
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx[8]_net_1\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/qrbxknbdvjj[6]_net_1\, 
        C => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rgmpzqrbghh_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/qrbxknbdvjj_m[6]_net_1\);
    
    
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/rjhhzsggrtr[3]\ : 
        DFN1E1C0
      port map(D => \AB_CM_inst/TR_RAM_DO_B_net_net_4\, CLK => 
        SYSCLK_c, CLR => SYSRSTn_c, E => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/frcskdnwvmx[4]_net_1\, 
        Q => \AB_CM_inst/TR_EV_ADDR_net_net_4\);
    
    \COMP_SM_inst/Diff_0[10]\ : DFN1E1C0
      port map(D => \COMP_SM_inst/Result[10]\, CLK => SYSCLK_c, 
        CLR => SYSRSTn_c, E => 
        \COMP_SM_inst/Latest_Update_0_sqmuxa\, Q => \Diff0_c[10]\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rdgwgtpkbgc[3]\ : 
        DFN1E0C0
      port map(D => \AB_CM_inst/EV_RAM_DO_B_net_net_4\, CLK => 
        SYSCLK_c, CLR => SYSRSTn_c, E => 
        \AB_CM_inst/bskrjhjvqpf_1_sqmuxa\, Q => \rdgwgtpkbgc[3]\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnvtvdkcnpp_8[11]\ : 
        MX2
      port map(A => \AB_CM_inst/EV_RAM_DO_B_net_net_5\, B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnvtvdkcnpp[11]_net_1\, 
        S => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/un1_kkgccghmrzf_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnvtvdkcnpp_8[11]_net_1\);
    
    \COMP_SM_inst/valid_8_0_0_a4_1_4\ : OR3A
      port map(A => \ADC_CHNUMBER[0]\, B => 
        \COMP_SM_inst/prev_channel[0]_net_1\, C => 
        \COMP_SM_inst/prev_channel[2]_net_1\, Y => 
        \COMP_SM_inst/valid_8_0_0_a4_1_net_1\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/pvtdpmmqdpp_un2_pbzxzjhqhwz_0_I_26\ : 
        OA1A
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_32\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_34\, 
        C => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_33\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_37\);
    
    \COMP_SM_inst/R2[3]\ : DFN1E1C0
      port map(D => \ADC_RESULT[3]\, CLK => SYSCLK_c, CLR => 
        SYSRSTn_c, E => \COMP_SM_inst/pres_state_0[2]_net_1\, Q
         => \COMP_SM_inst/R2[3]_net_1\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/fqkdsnjfpdb_0_0_ADD_18x18_medium_I69_un1_Y\ : 
        NOR2B
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ADD_18x18_medium_I69_un1_Y_0\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N316\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/I69_un1_Y\);
    
    \COMP_SM_inst/Diff_0[0]\ : DFN1E1C0
      port map(D => \COMP_SM_inst/N139\, CLK => SYSCLK_c, CLR => 
        SYSRSTn_c, E => \COMP_SM_inst/Latest_Update_0_sqmuxa\, Q
         => \Diff0_c[0]\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ftbkrvpxdbp[0]\ : 
        DFN1E0C0
      port map(D => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ftbkrvpxdbp_5[0]_net_1\, 
        CLK => SYSCLK_c, CLR => SYSRSTn_c, E => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ftbkrvpxdbp_1_sqmuxa_net_1\, 
        Q => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ftbkrvpxdbp[0]_net_1\);
    
    
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/tpxkpvnpvvn_m_0[7]\ : 
        OR3B
      port map(A => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/frcskdnwvmx[8]_net_1\, 
        B => \AB_CM_inst/Z\\\\TR_RAM_DO_B_net\\\\\, C => 
        \AB_CM_inst/EV_DONE_net_0\, Y => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/tpxkpvnpvvn_m_0[7]_net_1\);
    
    
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/bnrsdrtmtsg_5[0]\ : 
        MX2
      port map(A => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/hgqdwrxvgzm_3[0]_net_1\, 
        B => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/trnwxjxxrbp[0]_net_1\, 
        S => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/N_345\, 
        Y => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/N_353\);
    
    \Diff5_pad[8]/U0/U0\ : IOPAD_TRI
      port map(D => \Diff5_pad[8]/U0/NET1\, E => 
        \Diff5_pad[8]/U0/NET2\, PAD => Diff5(8));
    
    \COMP_SM_inst/un1_completed_sync_7_i_a4_0_1\ : XA1A
      port map(A => \ADC_CHNUMBER[2]\, B => \ADC_CHNUMBER[3]\, C
         => \COMP_SM_inst/un1_completed_sync_7_i_a4_0_0_net_1\, Y
         => \COMP_SM_inst/un1_completed_sync_7_i_a4_0_1_net_1\);
    
    
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/user_control/u_ffppvfwnggt/jsnhqgkgbcr_un1_wxqqqsndpvg_0_a2_0_o2\ : 
        NOR2A
      port map(A => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/bfcqzvtnrcn\, 
        B => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/qdvwjxmzbpf\, 
        Y => \NVM_CM_inst/un1_wxqqqsndpvg_i_0\);
    
    \Diff3_pad[8]/U0/U0\ : IOPAD_TRI
      port map(D => \Diff3_pad[8]/U0/NET1\, E => 
        \Diff3_pad[8]/U0/NET2\, PAD => Diff3(8));
    
    
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/brxxctcvrmh_qgnzcpmbksd_7_0_iv_0[4]\ : 
        AOI1B
      port map(A => \AB_CM_inst/Z\\\\EV_CHHOLD_net\\\\\, B => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/N_310\, 
        C => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/tpxkpvnpvvn_m_0[4]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/qgnzcpmbksd_7_0_iv_0[4]\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/fqkdsnjfpdb_0_0_ADD_18x18_medium_I100_Y\ : 
        XNOR3
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_278\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_282\, 
        C => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N397_i\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/fqkdsnjfpdb[8]\);
    
    
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/grkzscwpbcr_0\ : 
        NOR2
      port map(A => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/jzzdfrmzwdj[5]_net_1\, 
        B => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/jzzdfrmzwdj[4]_net_1\, 
        Y => \AB_CM_inst/ASSC_RAM_WR_BUSY_B_net\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc_3[4]\ : 
        MX2
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_727\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_744\, 
        S => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rdgwgtpkbgc_2[1]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_646\);
    
    
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/znbkwkbspdc_1_i_a3_0\ : 
        OR2B
      port map(A => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/znbkwkbspdc_net_1\, 
        B => INIT_DONE, Y => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/znbkwkbspdc_1_i_a3_0_net_1\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx[14]\ : 
        DFN1C0
      port map(D => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx_ns_i[3]_net_1\, 
        CLK => SYSCLK_c, CLR => SYSRSTn_c, Q => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx[14]_net_1\);
    
    
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/jzzdfrmzwdj_ns_i[13]\ : 
        OR2B
      port map(A => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/jzzdfrmzwdj_ns_i_0[13]_net_1\, 
        B => INIT_DONE, Y => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/N_224_i_0\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/pptwzsjcmcz_dhzrwbnrbpw_7_iv[1]\ : 
        OR3C
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/jrgzmrqhbkv_m[1]_net_1\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/dhzrwbnrbpw_7_iv_0[1]\, 
        C => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/un1_dhzrwbnrbpw_m[2]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/dhzrwbnrbpw_7[1]\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/un1_dhzrwbnrbpw_I_38\ : 
        XOR2
      port map(A => \AB_CM_inst/EV_RAM_ADDR_B_net_net_1\, B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/DWACT_ADD_CI_0_g_array_11[0]\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/I_38\);
    
    \Diff3_pad[10]/U0/U0\ : IOPAD_TRI
      port map(D => \Diff3_pad[10]/U0/NET1\, E => 
        \Diff3_pad[10]/U0/NET2\, PAD => Diff3(10));
    
    
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/jdhgstfqkjm_2_i\ : 
        INV
      port map(A => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/jdhgstfqkjm_2_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/jdhgstfqkjm_2_i_net_1\);
    
    \Diff5_pad[4]/U0/U1\ : IOTRI_OB_EB
      port map(D => \Diff5_c[4]\, E => SOC_VCC_NET, DOUT => 
        \Diff5_pad[4]/U0/NET1\, EOUT => \Diff5_pad[4]/U0/NET2\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/pptwzsjcmcz_dhzrwbnrbpw_7_iv_0[7]\ : 
        AOI1B
      port map(A => \AB_CM_inst/Z\\\\EV_RAM_DO_B_net\\\\_0\, B
         => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_199_i_0\, 
        C => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/qrbxknbdvjj_m[7]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/dhzrwbnrbpw_7_iv_0[7]\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/gcqsptsqnzg_iv_0\ : 
        OA1C
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_924\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/spbznmtdmpd_net_1\, 
        C => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_965\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/gcqsptsqnzg\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bskrjhjvqpf_i_2\ : 
        OR2A
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_215\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bskrjhjvqpf_i_2_1_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_191_2\);
    
    
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/brxxctcvrmh_qgnzcpmbksd_7[5]\ : 
        OR3A
      port map(A => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/N_288\, 
        B => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/frcskdnwvmx[1]_net_1\, 
        C => \AB_CM_inst/EV_DONE_net_0\, Y => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/N_310\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/fqkdsnjfpdb_0_0_ADD_18x18_medium_I2_P0N\ : 
        OR2
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_252\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_248\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N238\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc_12[10]\ : 
        MX2
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_954\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_788\, 
        S => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rdgwgtpkbgc_2[2]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc[10]\);
    
    
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/init_fsm/u_stnpfdkggvx/mwtvnzdkmwm[6]\ : 
        DFN1C0
      port map(D => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/init_fsm/u_stnpfdkggvx/mwtvnzdkmwm_ns[1]_net_1\, 
        CLK => SYSCLK_c, CLR => SYSRSTn_c, Q => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/init_fsm/u_stnpfdkggvx/mwtvnzdkmwm[6]_net_1\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tddhwjzbsrj_m\ : 
        OR2B
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx[0]_net_1\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tddhwjzbsrj_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tddhwjzbsrj_m_net_1\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnvtvdkcnpp_9[4]\ : 
        MX2
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnvtvdkcnpp_5[4]_net_1\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/fqkdsnjfpdb[10]\, 
        S => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx_1[4]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnvtvdkcnpp_9[4]_net_1\);
    
    
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/rjhhzsggrtr[0]\ : 
        DFN1E1C0
      port map(D => \AB_CM_inst/TR_RAM_DO_B_net_net_7\, CLK => 
        SYSCLK_c, CLR => SYSRSTn_c, E => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/frcskdnwvmx[4]_net_1\, 
        Q => \AB_CM_inst/TR_EV_ADDR_net_net_7\);
    
    \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/G_98\ : 
        AO13
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ftbkrvpxdbp[2]_net_1\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/gjkdbmpgrtc[2]\, 
        C => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc[2]\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_253\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/zbqggxmnpbs_0_iv[6]\ : 
        AO1B
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/fqkdsnjfpdb[12]\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx[5]_net_1\, 
        C => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/fqkdsnjfpdb_m[3]_net_1\, 
        Y => \AB_CM_inst/EV_RAM_DI_B_net_net_1\);
    
    \Diff2_pad[2]/U0/U0\ : IOPAD_TRI
      port map(D => \Diff2_pad[2]/U0/NET1\, E => 
        \Diff2_pad[2]/U0/NET2\, PAD => Diff2(2));
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/fqkdsnjfpdb_0_0_ADD_18x18_medium_I45_Y\ : 
        AO1
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ADD_18x18_medium_I30_Y\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N295\, 
        C => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N294\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N312\);
    
    
        \COMP_SM_inst/Subtract_inst/sumAux_0_0_SUB_12x12_medium_area_I16_S\ : 
        XNOR2
      port map(A => \COMP_SM_inst/R2[4]_net_1\, B => 
        \COMP_SM_inst/R1[4]_net_1\, Y => 
        \COMP_SM_inst/Subtract_inst/N147\);
    
    
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/bnrsdrtmtsg[5]\ : 
        DFN1E0C0
      port map(D => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/bnrsdrtmtsg_5[5]_net_1\, 
        CLK => SYSCLK_c, CLR => SYSRSTn_c, E => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/un1_cfxfrwgjccr_9_net_1\, 
        Q => \AB_CM_inst/ASSC_SEQOUT_net[5]\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/pvtdpmmqdpp_un2_pbzxzjhqhwz_0_I_65\ : 
        AOI1A
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ACT_LT4_E[3]\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ACT_LT4_E[6]\, 
        C => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ACT_LT4_E[10]\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/DWACT_CMPLE_PO2_DWACT_COMP0_E[2]\);
    
    \COMP_SM_inst/R1[8]\ : DFN1E1C0
      port map(D => \ADC_RESULT[8]\, CLK => SYSCLK_c, CLR => 
        SYSRSTn_c, E => \COMP_SM_inst/pres_state[3]_net_1\, Q => 
        \COMP_SM_inst/R1[8]_net_1\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/pvtdpmmqdpp_un2_pbzxzjhqhwz_0_I_46\ : 
        OR2A
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rqrqhcwpqdn[6]_net_1\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnvtvdkcnpp[6]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ACT_LT3_E[4]\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc_12[2]\ : 
        MX2
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_712\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_780\, 
        S => 
        \AB_CM_inst.AB_CM_smev_wrapper_inst.U0.u_nbnjbfrkqwq.rdgwgtpkbgc[3]\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc[2]\);
    
    
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/qgnzcpmbksd[8]\ : 
        DFN1C0
      port map(D => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/qgnzcpmbksd_7[8]\, 
        CLK => SYSCLK_c, CLR => SYSRSTn_c, Q => 
        \AB_CM_inst/TR_RAM_ADDR_B_net[8]\);
    
    
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/address_gen/u_dxwqxgdccxc/un1_gnmdxrqrdgs_I_49\ : 
        NOR2B
      port map(A => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/address_gen/u_dxwqxgdccxc/DWACT_ADD_CI_0_g_array_1[0]\, 
        B => \INIT_ADDR[2]\, Y => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/address_gen/u_dxwqxgdccxc/DWACT_ADD_CI_0_g_array_12[0]\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/fqkdsnjfpdb_0_0_ADD_18x18_medium_I27_Y\ : 
        AOI1D
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_282\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_278\, 
        C => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N253\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N293\);
    
    
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/user_control/u_ffppvfwnggt/srdtcqsfmmm_i[1]\ : 
        NOR2A
      port map(A => \NVM_CM_inst/un1_wxqqqsndpvg_i_0\, B => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/ggfvvjbkdws[1]\, 
        Y => \NVM_CM_inst/srdtcqsfmmm_i[1]\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/fqkdsnjfpdb_0_0_ADD_18x18_medium_I104_Y_0\ : 
        XOR2
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_302\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_298\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ADD_18x18_medium_I104_Y_0\);
    
    \COMP_SM_inst/valid_8_0_0_a2_3_2\ : OR2
      port map(A => \COMP_SM_inst/prev_channel[3]_net_1\, B => 
        \COMP_SM_inst/N_413\, Y => \COMP_SM_inst/N_421_2\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/zbqggxmnpbs_0_iv[0]\ : 
        AO1B
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/fqkdsnjfpdb[15]\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx_0[4]_net_1\, 
        C => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/zbqggxmnpbs_0_iv_1[0]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/zbqggxmnpbs_0_iv[0]_net_1\);
    
    
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/svpbmqwvncp_0\ : 
        OR3B
      port map(A => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/svpbmqwvncp_0_1_net_1\, 
        B => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/N_264\, 
        C => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/frcskdnwvmx[4]_net_1\, 
        Y => \AB_CM_inst/TR_RAM_CSN_B_net\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc_9_0_a2[11]\ : 
        NOR2A
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnvtvdkcnpp[11]_net_1\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rdgwgtpkbgc[0]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_967\);
    
    
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/dbcvwwhvvwh[3]\ : 
        DFN1E1C0
      port map(D => \AB_CM_inst/ASSC_RAM_DO_B_net_net_4\, CLK => 
        SYSCLK_c, CLR => SYSRSTn_c, E => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/jzzdfrmzwdj[13]_net_1\, 
        Q => \AB_CM_inst/ADC_TVC_net_net_3\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc_1[0]\ : 
        MX2
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ftbkrvpxdbp[0]_net_1\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ftbkrvpxdbp[1]_net_1\, 
        S => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rdgwgtpkbgc_1[0]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_608\);
    
    \COMP_SM_inst/Latest_Update_4_sqmuxa_0_a4\ : NOR3C
      port map(A => \COMP_SM_inst/N_424\, B => 
        \COMP_SM_inst/N_425\, C => \COMP_SM_inst/N_419\, Y => 
        \COMP_SM_inst/Latest_Update_4_sqmuxa\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ftbkrvpxdbp_1_sqmuxa\ : 
        NOR2A
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/un1_kkgccghmrzf_net_1\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx[4]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ftbkrvpxdbp_1_sqmuxa_net_1\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc_11_s[2]\ : 
        OR2A
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rdgwgtpkbgc_0[1]_net_1\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rdgwgtpkbgc_0[2]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc_11_s[2]_net_1\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/gjkdbmpgrtc_9[0]\ : 
        MX2
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rqrqhcwpqdn[0]_net_1\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rqrqhcwpqdn[1]_net_1\, 
        S => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rdgwgtpkbgc_0[0]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_540\);
    
    
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/frcskdnwvmx_ns[0]\ : 
        OR3B
      port map(A => INIT_DONE, B => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/N_269_i\, 
        C => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/frcskdnwvmx_0[0]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/frcskdnwvmx_ns[0]_net_1\);
    
    \Diff4_pad[0]/U0/U0\ : IOPAD_TRI
      port map(D => \Diff4_pad[0]/U0/NET1\, E => 
        \Diff4_pad[0]/U0/NET2\, PAD => Diff4(0));
    
    
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/dttrrgvsnmg_iv\ : 
        OR3C
      port map(A => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/sxrhkdkngbh_m_net_1\, 
        B => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/dttrrgvsnmg_iv_1_net_1\, 
        C => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/hnbsspwxkpd_m_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/dttrrgvsnmg\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/gjkdbmpgrtc_9_0_a2[11]\ : 
        NOR2A
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rqrqhcwpqdn[11]_net_1\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rdgwgtpkbgc[0]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_969\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnvtvdkcnpp_5[1]\ : 
        MX2
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnvtvdkcnpp[1]_net_1\, 
        B => \AB_CM_inst/EV_RAM_DO_B_net_net_6\, S => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/un3_qvqqfftqsfc_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnvtvdkcnpp_5[1]_net_1\);
    
    
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/address_gen/u_dxwqxgdccxc/jvbvzqvvxpc_un10_gnmdxrqrdgs_0\ : 
        XNOR2
      port map(A => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/ggsxvgncrgz[0]\, 
        B => \INIT_ADDR[0]\, Y => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/address_gen/u_dxwqxgdccxc/un10_gnmdxrqrdgs_0_i\);
    
    \SYSRSTn_pad/U0/U0\ : IOPAD_IN
      port map(PAD => SYSRSTn, Y => \SYSRSTn_pad/U0/NET1\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/gjkdbmpgrtc_7_0_a3[12]\ : 
        NOR2A
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_450\, 
        B => 
        \AB_CM_inst.AB_CM_smev_wrapper_inst.U0.u_nbnjbfrkqwq.rdgwgtpkbgc[3]\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_942\);
    
    \Diff5_pad[9]/U0/U1\ : IOTRI_OB_EB
      port map(D => \Diff5_c[9]\, E => SOC_VCC_NET, DOUT => 
        \Diff5_pad[9]/U0/NET1\, EOUT => \Diff5_pad[9]/U0/NET2\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/mkmkbnghgkd[1]\ : 
        MX2
      port map(A => \INIT_ADDR[1]\, B => 
        \AB_CM_inst/TR_EV_ADDR_net_net_6\, S => INIT_DONE, Y => 
        \AB_CM_inst/EV_RAM_ADDR_A_net_net_6\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ftbkrvpxdbp_5[0]\ : 
        MX2
      port map(A => \AB_CM_inst/EV_RAM_DO_B_net_net_4\, B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/fqkdsnjfpdb[0]\, 
        S => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx_0[4]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ftbkrvpxdbp_5[0]_net_1\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc_12[13]\ : 
        MX2
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_957\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_791\, 
        S => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rdgwgtpkbgc[2]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc[13]\);
    
    
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/user_control/u_ffppvfwnggt/hrdbnmzftpn_i_m2_i_m2[12]\ : 
        MX2
      port map(A => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/user_control/u_ffppvfwnggt/N_2183_i_i_0\, 
        B => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/user_control/u_ffppvfwnggt/hcmmkfggqvf_13[12]\, 
        S => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/bfcqzvtnrcn\, 
        Y => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/mmsccbknsvn[12]\);
    
    \Diff3_pad[6]/U0/U1\ : IOTRI_OB_EB
      port map(D => \Diff3_c[6]\, E => SOC_VCC_NET, DOUT => 
        \Diff3_pad[6]/U0/NET1\, EOUT => \Diff3_pad[6]/U0/NET2\);
    
    \Diff0_pad[10]/U0/U1\ : IOTRI_OB_EB
      port map(D => \Diff0_c[10]\, E => SOC_VCC_NET, DOUT => 
        \Diff0_pad[10]/U0/NET1\, EOUT => \Diff0_pad[10]/U0/NET2\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/fqkdsnjfpdb_0_0_ADD_18x18_medium_I91_Y\ : 
        AOI1
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N235\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N300\, 
        C => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N234\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N403_i\);
    
    \COMP_SM_inst/valid_8_0_0_a2\ : OR3C
      port map(A => \COMP_SM_inst/prev_channel[0]_net_1\, B => 
        \COMP_SM_inst/prev_channel[3]_net_1\, C => 
        \COMP_SM_inst/N_425\, Y => \COMP_SM_inst/N_409\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ckghxwbsztp_m[4]\ : 
        OR2B
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx[0]_net_1\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ckghxwbsztp[4]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ckghxwbsztp_m[4]_net_1\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/qrbxknbdvjj_m[2]\ : 
        OR3B
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx_0[8]_net_1\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/qrbxknbdvjj[2]_net_1\, 
        C => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rgmpzqrbghh_0_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/qrbxknbdvjj_m[2]_net_1\);
    
    \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/G_128_0\ : 
        OA1
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnvtvdkcnpp_0[2]_net_1\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc[8]\, 
        C => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/gjkdbmpgrtc_12[8]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/G_128_0_net_1\);
    
    
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/user_control/u_ffppvfwnggt/hbqjhzzrbnr_i[0]\ : 
        NOR2A
      port map(A => \NVM_CM_inst/un1_wxqqqsndpvg_i_0\, B => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/N_1838\, 
        Y => \NVM_CM_inst/hbqjhzzrbnr_i[0]\);
    
    
        \COMP_SM_inst/Subtract_inst/sumAux_0_0_SUB_12x12_medium_area_I68_Y\ : 
        XOR2
      port map(A => \COMP_SM_inst/Subtract_inst/N173\, B => 
        \COMP_SM_inst/Subtract_inst/N141\, Y => 
        \COMP_SM_inst/Result[1]\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/qrbxknbdvjj[4]\ : 
        DFN1E1C0
      port map(D => \AB_CM_inst/EV_RAM_ADDR_B_net_net_3\, CLK => 
        SYSCLK_c, CLR => SYSRSTn_c, E => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx[11]_net_1\, 
        Q => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/qrbxknbdvjj[4]_net_1\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/fqkdsnjfpdb_0_0_ADD_18x18_medium_I1_G0N\ : 
        XA1B
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/gjkdbmpgrtc[1]\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/G_89_0_net_1\, 
        C => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc[1]\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N234\);
    
    
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/init_fsm/u_stnpfdkggvx/rhjctqnqzsn[1]\ : 
        DFN1C0
      port map(D => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/init_fsm/u_stnpfdkggvx/I_10\, 
        CLK => SYSCLK_c, CLR => SYSRSTn_c, Q => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/gpbbjwsprsj[1]\);
    
    \Diff2_pad[8]/U0/U1\ : IOTRI_OB_EB
      port map(D => \Diff2_c[8]\, E => SOC_VCC_NET, DOUT => 
        \Diff2_pad[8]/U0/NET1\, EOUT => \Diff2_pad[8]/U0/NET2\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rdgwgtpkbgc_0[0]\ : 
        DFN1E0C0
      port map(D => \AB_CM_inst/EV_RAM_DO_B_net_net_7\, CLK => 
        SYSCLK_c, CLR => SYSRSTn_c, E => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bskrjhjvqpf_1_sqmuxa_0\, 
        Q => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rdgwgtpkbgc_0[0]_net_1\);
    
    \COMP_SM_inst/Diff_2[7]\ : DFN1E0C0
      port map(D => \COMP_SM_inst/Result[7]\, CLK => SYSCLK_c, 
        CLR => SYSRSTn_c, E => 
        \COMP_SM_inst/Latest_Update_2_sqmuxa\, Q => \Diff2_c[7]\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/gjkdbmpgrtc_12[0]\ : 
        MX2
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_888\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_947\, 
        S => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rdgwgtpkbgc_0[2]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/gjkdbmpgrtc[0]\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/pptwzsjcmcz_dhzrwbnrbpw_7_iv[0]\ : 
        AO1B
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_201_i_0\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/DWACT_ADD_CI_0_partial_sum[0]\, 
        C => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/dhzrwbnrbpw_7_iv_0[0]\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/dhzrwbnrbpw_7[0]\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc_12[1]\ : 
        MX2
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_711\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_779\, 
        S => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rdgwgtpkbgc_2[2]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc[1]\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/kkkmkxwwscv[4]\ : 
        DFN1E1C0
      port map(D => \AB_CM_inst/Z\\\\ASSC_SEQOUT_net\\\\\, CLK
         => SYSCLK_c, CLR => SYSRSTn_c, E => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/qmmwhjxxxmv_net_1\, 
        Q => \AB_CM_inst/Z\\\\EV_ASSCADDR_net\\\\\);
    
    
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/init_fsm/u_stnpfdkggvx/mwtvnzdkmwm_ns[3]\ : 
        AO1A
      port map(A => \NVM_CM_inst/NVM_BUSY_net\, B => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/init_fsm/u_stnpfdkggvx/mwtvnzdkmwm[5]_net_1\, 
        C => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/dxpbcqjpxtw\, 
        Y => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/init_fsm/u_stnpfdkggvx/mwtvnzdkmwm_ns[3]_net_1\);
    
    \COMP_SM_inst/R1[11]\ : DFN1E1C0
      port map(D => \ADC_RESULT[11]\, CLK => SYSCLK_c, CLR => 
        SYSRSTn_c, E => \COMP_SM_inst/pres_state[3]_net_1\, Q => 
        \COMP_SM_inst/R1[11]_net_1\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc_12[7]\ : 
        MX2
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_717\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_785\, 
        S => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rdgwgtpkbgc_2[2]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc[7]\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/gjkdbmpgrtc_11_0_a3[2]\ : 
        NOR2A
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_444\, 
        B => 
        \AB_CM_inst.AB_CM_smev_wrapper_inst.U0.u_nbnjbfrkqwq.rdgwgtpkbgc[3]\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_949\);
    
    \AB_CM_inst/AB_CM_smev_ram_inst/AB_CM_smev_ram_R0C0\ : RAM4K9
      port map(ADDRA11 => AFLSDF_GND, ADDRA10 => AFLSDF_GND, 
        ADDRA9 => AFLSDF_GND, ADDRA8 => 
        \AB_CM_inst/EV_RAM_ADDR_A_net[8]\, ADDRA7 => 
        \AB_CM_inst/Z\\\\EV_RAM_ADDR_A_net\\\\\, ADDRA6 => 
        \AB_CM_inst/EV_RAM_ADDR_A_net_net_1\, ADDRA5 => 
        \AB_CM_inst/EV_RAM_ADDR_A_net_net_2\, ADDRA4 => 
        \AB_CM_inst/EV_RAM_ADDR_A_net_net_3\, ADDRA3 => 
        \AB_CM_inst/EV_RAM_ADDR_A_net_net_4\, ADDRA2 => 
        \AB_CM_inst/EV_RAM_ADDR_A_net_net_5\, ADDRA1 => 
        \AB_CM_inst/EV_RAM_ADDR_A_net_net_6\, ADDRA0 => 
        \AB_CM_inst/EV_RAM_ADDR_A_net_net_7\, ADDRB11 => 
        AFLSDF_GND, ADDRB10 => AFLSDF_GND, ADDRB9 => AFLSDF_GND, 
        ADDRB8 => \AB_CM_inst/EV_RAM_ADDR_B_net[8]\, ADDRB7 => 
        \AB_CM_inst/Z\\\\EV_RAM_ADDR_B_net\\\\\, ADDRB6 => 
        \AB_CM_inst/EV_RAM_ADDR_B_net_net_1\, ADDRB5 => 
        \AB_CM_inst/EV_RAM_ADDR_B_net_net_2\, ADDRB4 => 
        \AB_CM_inst/EV_RAM_ADDR_B_net_net_3\, ADDRB3 => 
        \AB_CM_inst/EV_RAM_ADDR_B_net_net_4\, ADDRB2 => 
        \AB_CM_inst/EV_RAM_ADDR_B_net_net_5\, ADDRB1 => 
        \AB_CM_inst/EV_RAM_ADDR_B_net_net_6\, ADDRB0 => 
        \AB_CM_inst/EV_RAM_ADDR_B_net_net_7\, DINA8 => 
        \INIT_DATA[8]\, DINA7 => \INIT_DATA[7]\, DINA6 => 
        \INIT_DATA[6]\, DINA5 => \INIT_DATA[5]\, DINA4 => 
        \INIT_DATA[4]\, DINA3 => \INIT_DATA[3]\, DINA2 => 
        \INIT_DATA[2]\, DINA1 => \INIT_DATA[1]\, DINA0 => 
        \INIT_DATA[0]\, DINB8 => \AB_CM_inst/EV_RAM_DI_B_net[8]\, 
        DINB7 => \AB_CM_inst/Z\\\\EV_RAM_DI_B_net\\\\\, DINB6 => 
        \AB_CM_inst/EV_RAM_DI_B_net_net_1\, DINB5 => 
        \AB_CM_inst/EV_RAM_DI_B_net_net_2\, DINB4 => 
        \AB_CM_inst/EV_RAM_DI_B_net_net_3\, DINB3 => 
        \AB_CM_inst/EV_RAM_DI_B_net_net_4\, DINB2 => 
        \AB_CM_inst/EV_RAM_DI_B_net_net_5\, DINB1 => 
        \AB_CM_inst/EV_RAM_DI_B_net_net_6\, DINB0 => 
        \AB_CM_inst/EV_RAM_DI_B_net_net_7\, WIDTHA0 => 
        SOC_VCC_NET, WIDTHA1 => SOC_VCC_NET, WIDTHB0 => 
        SOC_VCC_NET, WIDTHB1 => SOC_VCC_NET, PIPEA => \GND\, 
        PIPEB => \GND\, WMODEA => SOC_VCC_NET, WMODEB => 
        SOC_VCC_NET, BLKA => \AB_CM_inst/EV_RAM_CSN_A_net\, BLKB
         => \AB_CM_inst/EV_RAM_CSN_B_net\, WENA => 
        \AB_CM_inst/EV_RAM_RW_A_net\, WENB => 
        \AB_CM_inst/EV_RAM_WR_BUSY_B_net\, CLKA => SYSCLK_c, CLKB
         => SYSCLK_c, RESET => SYSRSTn_c, DOUTA8 => OPEN, DOUTA7
         => OPEN, DOUTA6 => OPEN, DOUTA5 => OPEN, DOUTA4 => OPEN, 
        DOUTA3 => OPEN, DOUTA2 => OPEN, DOUTA1 => OPEN, DOUTA0
         => \AB_CM_inst/EV_RAM_DO_A_net_net_7\, DOUTB8 => 
        \AB_CM_inst/EV_RAM_DO_B_net[8]\, DOUTB7 => 
        \AB_CM_inst/Z\\\\EV_RAM_DO_B_net\\\\\, DOUTB6 => 
        \AB_CM_inst/EV_RAM_DO_B_net_net_1\, DOUTB5 => 
        \AB_CM_inst/EV_RAM_DO_B_net_net_2\, DOUTB4 => 
        \AB_CM_inst/EV_RAM_DO_B_net_net_3\, DOUTB3 => 
        \AB_CM_inst/EV_RAM_DO_B_net_net_4\, DOUTB2 => 
        \AB_CM_inst/EV_RAM_DO_B_net_net_5\, DOUTB1 => 
        \AB_CM_inst/EV_RAM_DO_B_net_net_6\, DOUTB0 => 
        \AB_CM_inst/EV_RAM_DO_B_net_net_7\);
    
    \Latest_Update_pad[2]/U0/U1\ : IOTRI_OB_EB
      port map(D => \Latest_Update_c[2]\, E => SOC_VCC_NET, DOUT
         => \Latest_Update_pad[2]/U0/NET1\, EOUT => 
        \Latest_Update_pad[2]/U0/NET2\);
    
    \COMP_SM_inst/pres_state_ns_0[3]\ : AO1A
      port map(A => ASSC_DONE, B => 
        \COMP_SM_inst/pres_state[1]_net_1\, C => 
        \COMP_SM_inst/pres_state_0[3]_net_1\, Y => 
        \COMP_SM_inst/pres_state_ns[3]\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/pvtdpmmqdpp_un2_pbzxzjhqhwz_0_I_36\ : 
        XNOR2
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnvtvdkcnpp[6]_net_1\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rqrqhcwpqdn[6]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/DWACT_BL_EQUAL_0_E[2]\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rdgwgtpkbgc[0]\ : 
        DFN1E0C0
      port map(D => \AB_CM_inst/EV_RAM_DO_B_net_net_7\, CLK => 
        SYSCLK_c, CLR => SYSRSTn_c, E => 
        \AB_CM_inst/bskrjhjvqpf_1_sqmuxa\, Q => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rdgwgtpkbgc[0]_net_1\);
    
    
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/trnwxjxxrbp[4]\ : 
        DFN1C0
      port map(D => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/trnwxjxxrbp[4]_net_1\, 
        CLK => SYSCLK_c, CLR => SYSRSTn_c, Q => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/trnwxjxxrbp[4]_net_1\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rqrqhcwpqdn[5]\ : 
        DFN1E1C0
      port map(D => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_819\, 
        CLK => SYSCLK_c, CLR => SYSRSTn_c, E => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_823\, 
        Q => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rqrqhcwpqdn[5]_net_1\);
    
    \COMP_SM_inst/Diff_2[9]\ : DFN1E0C0
      port map(D => \COMP_SM_inst/Result[9]\, CLK => SYSCLK_c, 
        CLR => SYSRSTn_c, E => 
        \COMP_SM_inst/Latest_Update_2_sqmuxa\, Q => \Diff2_c[9]\);
    
    \COMP_SM_inst/R2[7]\ : DFN1E1C0
      port map(D => \ADC_RESULT[7]\, CLK => SYSCLK_c, CLR => 
        SYSRSTn_c, E => \COMP_SM_inst/pres_state[2]_net_1\, Q => 
        \COMP_SM_inst/R2[7]_net_1\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/fqkdsnjfpdb_0_0_ADD_18x18_medium_I89_Y\ : 
        AOI1
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ADD_18x18_medium_I5_P0N\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N354\, 
        C => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N246\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ADD_18x18_medium_I89_Y\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/fqkdsnjfpdb_0_0_ADD_18x18_medium_I61_un1_Y\ : 
        OR3B
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N295\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N316\, 
        C => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N297\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/I61_un1_Y_i\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ftbkrvpxdbp[4]\ : 
        DFN1E0C0
      port map(D => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ftbkrvpxdbp_5[4]_net_1\, 
        CLK => SYSCLK_c, CLR => SYSRSTn_c, E => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ftbkrvpxdbp_1_sqmuxa_net_1\, 
        Q => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ftbkrvpxdbp[4]_net_1\);
    
    \COMP_SM_inst/valid_8_0_0_a2_1\ : OR3B
      port map(A => \ADC_CHNUMBER[3]\, B => 
        \COMP_SM_inst/valid_8_0_0_a2_1_0_net_1\, C => 
        \ADC_CHNUMBER[1]\, Y => \COMP_SM_inst/N_414\);
    
    \COMP_SM_inst/completed_sync\ : DFN1C0
      port map(D => \COMP_SM_inst/pres_state_0[2]_net_1\, CLK => 
        SYSCLK_c, CLR => SYSRSTn_c, Q => 
        \COMP_SM_inst/completed_sync_net_1\);
    
    
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/dbcvwwhvvwh[1]\ : 
        DFN1E1C0
      port map(D => \AB_CM_inst/ASSC_RAM_DO_B_net_net_6\, CLK => 
        SYSCLK_c, CLR => SYSRSTn_c, E => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/jzzdfrmzwdj[13]_net_1\, 
        Q => \AB_CM_inst/ADC_TVC_net_net_5\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/un1_dhzrwbnrbpw_I_49\ : 
        NOR2B
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/DWACT_ADD_CI_0_g_array_1[0]\, 
        B => \AB_CM_inst/EV_RAM_ADDR_B_net_net_5\, Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/DWACT_ADD_CI_0_g_array_12[0]\);
    
    \Diff3_pad[7]/U0/U1\ : IOTRI_OB_EB
      port map(D => \Diff3_c[7]\, E => SOC_VCC_NET, DOUT => 
        \Diff3_pad[7]/U0/NET1\, EOUT => \Diff3_pad[7]/U0/NET2\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/mtbjcfqsbqf[3]\ : 
        DFN1E1C0
      port map(D => \ADC_CHNUMBER[3]\, CLK => SYSCLK_c, CLR => 
        SYSRSTn_c, E => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/qmmwhjxxxmv_net_1\, 
        Q => \AB_CM_inst/Z\\\\EV_CHHOLD_net\\\\\);
    
    
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/cpwfrthtnfr_7_sqmuxa_0_a2\ : 
        NOR2A
      port map(A => \AB_CM_inst/TR_RAM_DO_B_net_net_2\, B => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/N_289\, 
        Y => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/cpwfrthtnfr_7_sqmuxa\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx[1]\ : 
        DFN1C0
      port map(D => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx_ns[16]\, 
        CLK => SYSCLK_c, CLR => SYSRSTn_c, Q => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx[1]_net_1\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/gjkdbmpgrtc_11_0_a3[1]\ : 
        NOR2A
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_443\, 
        B => 
        \AB_CM_inst.AB_CM_smev_wrapper_inst.U0.u_nbnjbfrkqwq.rdgwgtpkbgc[3]\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_948\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/gjkdbmpgrtc_11[9]\ : 
        MX2
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_451\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rqrqhcwpqdn[3]_net_1\, 
        S => 
        \AB_CM_inst.AB_CM_smev_wrapper_inst.U0.u_nbnjbfrkqwq.rdgwgtpkbgc[3]\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_583\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/fqkdsnjfpdb_0_0_ADD_18x18_medium_I5_G0N\ : 
        OA1
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/G_108_0_net_1\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_265\, 
        C => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_267\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N246\);
    
    
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/mksbfqnmmgw[1]\ : 
        MX2
      port map(A => \ADC_RESULT[1]\, B => \ADC_RESULT[10]\, S => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/jzzdfrmzwdj[4]_net_1\, 
        Y => \AB_CM_inst/ASSC_RAM_DI_B_net_net_6\);
    
    \COMP_SM_inst/Latest_Update_2_sqmuxa_0_a4\ : OR3B
      port map(A => \COMP_SM_inst/N_419\, B => 
        \COMP_SM_inst/Latest_Update_9[1]\, C => \ADC_CHNUMBER[1]\, 
        Y => \COMP_SM_inst/Latest_Update_2_sqmuxa\);
    
    \COMP_SM_inst/Diff_5[6]\ : DFN1E1C0
      port map(D => \COMP_SM_inst/Result[6]\, CLK => SYSCLK_c, 
        CLR => SYSRSTn_c, E => 
        \COMP_SM_inst/Latest_Update_5_sqmuxa\, Q => \Diff5_c[6]\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc_3[5]\ : 
        MX2
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_728\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_745\, 
        S => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rdgwgtpkbgc_2[1]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_647\);
    
    
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/brxxctcvrmh_qgnzcpmbksd_7_0_iv[2]\ : 
        AO1B
      port map(A => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/N_230_i_0\, 
        B => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/I_35_0\, 
        C => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/qgnzcpmbksd_7_0_iv_0[2]\, 
        Y => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/qgnzcpmbksd_7[2]\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rdgwgtpkbgc_2[0]\ : 
        DFN1E0C0
      port map(D => \AB_CM_inst/EV_RAM_DO_B_net_net_7\, CLK => 
        SYSCLK_c, CLR => SYSRSTn_c, E => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bskrjhjvqpf_1_sqmuxa_0\, 
        Q => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rdgwgtpkbgc_2[0]_net_1\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/pvtdpmmqdpp_un2_pbzxzjhqhwz_m\ : 
        OR2B
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/un2_pbzxzjhqhwz\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/dbdctxjdvkp_2_sqmuxa\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/un2_pbzxzjhqhwz_m\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/fqkdsnjfpdb_0_0_ADD_18x18_medium_I36_Y\ : 
        OR2A
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N285\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N287\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N303\);
    
    
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/jdhgstfqkjm\ : 
        DFN1P0
      port map(D => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/jdhgstfqkjm_2_net_1\, 
        CLK => SYSCLK_c, PRE => SYSRSTn_c, Q => 
        \AB_CM_inst/ADC_RESET_net\);
    
    
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/jfkkdmfhcdn[1]\ : 
        NOR2A
      port map(A => \AB_CM_inst/TR_RAM_DO_B_net_net_6\, B => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/frcskdnwvmx[0]_net_1\, 
        Y => \AB_CM_inst/TR_RAM_DI_B_net_net_6\);
    
    
        \COMP_SM_inst/Subtract_inst/sumAux_0_0_SUB_12x12_medium_area_I65_un1_Y\ : 
        NOR2B
      port map(A => \COMP_SM_inst/Subtract_inst/N210\, B => 
        \COMP_SM_inst/Subtract_inst/N145\, Y => 
        \COMP_SM_inst/Subtract_inst/SUB_12x12_medium_area_I65_un1_Y\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx_ns_a3_0[6]\ : 
        OR2A
      port map(A => INIT_DONE, B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_205\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx_ns_a3_0[6]_net_1\);
    
    \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/G_99_0\ : 
        XOR2
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ftbkrvpxdbp[3]_net_1\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/gjkdbmpgrtc[3]\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/G_99_0_net_1\);
    
    
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/address_gen/u_dxwqxgdccxc/jvbvzqvvxpc_gnmdxrqrdgs_3[8]\ : 
        XA1B
      port map(A => \INIT_ADDR[8]\, B => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/address_gen/u_dxwqxgdccxc/DWACT_ADD_CI_0_g_array_3[0]\, 
        C => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/wtjtwqjkqbd\, 
        Y => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/address_gen/u_dxwqxgdccxc/gnmdxrqrdgs_3[8]\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/fqkdsnjfpdb_0_0_ADD_18x18_medium_I40_Y\ : 
        NOR2
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N291\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N289\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N307\);
    
    
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/mksbfqnmmgw[3]\ : 
        NOR2A
      port map(A => \ADC_RESULT[3]\, B => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/jzzdfrmzwdj[4]_net_1\, 
        Y => \AB_CM_inst/ASSC_RAM_DI_B_net_net_4\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/pvtdpmmqdpp_un2_pbzxzjhqhwz_0_I_63\ : 
        OR2A
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnvtvdkcnpp[3]_net_1\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rqrqhcwpqdn[3]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ACT_LT4_E[8]\);
    
    \Diff0_pad[11]/U0/U0\ : IOPAD_TRI
      port map(D => \Diff0_pad[11]/U0/NET1\, E => 
        \Diff0_pad[11]/U0/NET2\, PAD => Diff0(11));
    
    
        \COMP_SM_inst/Subtract_inst/sumAux_0_0_SUB_12x12_medium_area_I18_S\ : 
        XNOR2
      port map(A => \COMP_SM_inst/R2[6]_net_1\, B => 
        \COMP_SM_inst/R1[6]_net_1\, Y => 
        \COMP_SM_inst/Subtract_inst/N151\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/gcqsptsqnzg_iv_0_o2\ : 
        AO1B
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/gpjgkmhxbkn_NE_0_net_1\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/gpjgkmhxbkn_NE_2_net_1\, 
        C => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rqrqhcwpqdn[0]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_924\);
    
    
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/znjtscvsvcs_iv_0_o2\ : 
        AO1A
      port map(A => \AB_CM_inst/TR_RAM_DO_B_net_net_7\, B => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/hnbsspwxkpd_net_1\, 
        C => \AB_CM_inst/TR_RAM_DO_B_net_net_6\, Y => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/N_388\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bskrjhjvqpf_i_a3\ : 
        NOR2A
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_205\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_241\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_234\);
    
    \COMP_SM_inst/valid_8_0_0_a4_0\ : AO1B
      port map(A => \COMP_SM_inst/N_414\, B => 
        \COMP_SM_inst/N_415\, C => 
        \COMP_SM_inst/valid_8_0_0_a4_0_3_net_1\, Y => 
        \COMP_SM_inst/N_402_i\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/fqkdsnjfpdb_0_0_ADD_18x18_medium_I6_G0N\ : 
        OR2B
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_272\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_268\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N249\);
    
    \AB_CM_inst/AB_CM_smev_ram_inst/AB_CM_smev_ram_R0C0_0\ : BUFF
      port map(A => \AB_CM_inst/Z\\\\EV_RAM_DO_B_net\\\\\, Y => 
        \AB_CM_inst/Z\\\\EV_RAM_DO_B_net\\\\_0\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/mkmkbnghgkd[8]\ : 
        MX2
      port map(A => \INIT_ADDR[8]\, B => 
        \AB_CM_inst/TR_EV_ADDR_net[8]\, S => INIT_DONE, Y => 
        \AB_CM_inst/EV_RAM_ADDR_A_net[8]\);
    
    
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/jzzdfrmzwdj_ns_i_0[15]\ : 
        OA1A
      port map(A => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/znbkwkbspdc_net_1\, 
        B => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/jzzdfrmzwdj_0[14]_net_1\, 
        C => INIT_DONE, Y => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/jzzdfrmzwdj_ns_i_0[15]_net_1\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx_ns_a3[16]\ : 
        NOR3B
      port map(A => INIT_DONE, B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx_ns_1[16]\, 
        C => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_237\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx_ns[16]\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc_9[8]\ : 
        MX2
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnvtvdkcnpp[8]_net_1\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnvtvdkcnpp[9]_net_1\, 
        S => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rdgwgtpkbgc_2[0]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_752\);
    
    \COMP_SM_inst/Diff_3[2]\ : DFN1E1C0
      port map(D => \COMP_SM_inst/Result[2]\, CLK => SYSCLK_c, 
        CLR => SYSRSTn_c, E => 
        \COMP_SM_inst/Latest_Update_3_sqmuxa\, Q => \Diff3_c[2]\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx[10]\ : 
        DFN1C0
      port map(D => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx_ns_i[7]_net_1\, 
        CLK => SYSCLK_c, CLR => SYSRSTn_c, Q => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx[10]_net_1\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/gjkdbmpgrtc_12[12]\ : 
        MX2
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_942\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_586\, 
        S => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rdgwgtpkbgc_1[2]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/gjkdbmpgrtc[12]\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/gjkdbmpgrtc_3[7]\ : 
        MX2
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_541\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_543\, 
        S => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rdgwgtpkbgc[1]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_445\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ckghxwbsztp[3]\ : 
        DFN1E1C0
      port map(D => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ckghxwbsztp_3[3]\, 
        CLK => SYSCLK_c, CLR => SYSRSTn_c, E => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx[1]_net_1\, 
        Q => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ckghxwbsztp[3]_net_1\);
    
    
        \COMP_SM_inst/Subtract_inst/sumAux_0_0_SUB_12x12_medium_area_I74_Y\ : 
        XOR2
      port map(A => \COMP_SM_inst/Subtract_inst/N200\, B => 
        \COMP_SM_inst/Subtract_inst/N153\, Y => 
        \COMP_SM_inst/Result[7]\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/fqkdsnjfpdb_0_0_ADD_18x18_medium_I32_Y\ : 
        MAJ3
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_248\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_252\, 
        C => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N234\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N298\);
    
    
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/user_control/u_ffppvfwnggt/hrdbnmzftpn_0_0_a2_6[15]\ : 
        NOR3B
      port map(A => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/vvpkfmmpprk[1]\, 
        B => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/vvpkfmmpprk[0]\, 
        C => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/bfcqzvtnrcn\, 
        Y => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/N_2358\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/pvtdpmmqdpp_un2_pbzxzjhqhwz_0_I_77\ : 
        AO1
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/DWACT_COMP0_E[1]\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/DWACT_COMP0_E[2]\, 
        C => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/DWACT_COMP0_E[0]\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/un2_pbzxzjhqhwz\);
    
    
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/address_gen/u_dxwqxgdccxc/jvbvzqvvxpc_un10_gnmdxrqrdgs_8\ : 
        AX1C
      port map(A => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/N_2324\, 
        B => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/N_2357\, 
        C => \INIT_ADDR[8]\, Y => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/address_gen/u_dxwqxgdccxc/un10_gnmdxrqrdgs_8_i\);
    
    
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/address_gen/u_dxwqxgdccxc/gnmdxrqrdgs[0]\ : 
        DFN1C0
      port map(D => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/address_gen/u_dxwqxgdccxc/gnmdxrqrdgs_3[0]\, 
        CLK => SYSCLK_c, CLR => SYSRSTn_c, Q => \INIT_ADDR[0]\);
    
    \COMP_SM_inst/Diff_0[1]\ : DFN1E1C0
      port map(D => \COMP_SM_inst/Result[1]\, CLK => SYSCLK_c, 
        CLR => SYSRSTn_c, E => 
        \COMP_SM_inst/Latest_Update_0_sqmuxa\, Q => \Diff0_c[1]\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/pvtdpmmqdpp_un2_pbzxzjhqhwz_0_I_48\ : 
        AOI1A
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ACT_LT3_E[3]\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ACT_LT3_E[4]\, 
        C => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ACT_LT3_E[5]\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/DWACT_CMPLE_PO2_DWACT_COMP0_E[0]\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc_12_d_0[4]\ : 
        MX2C
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_654\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_646\, 
        S => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc_12_s[4]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc_12_d_0[4]_net_1\);
    
    
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/jzzdfrmzwdj_ns_o3[0]\ : 
        AO1B
      port map(A => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/jzzdfrmzwdj[0]_net_1\, 
        B => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/znbkwkbspdc_net_1\, 
        C => INIT_DONE, Y => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/N_256\);
    
    \Diff5_pad[0]/U0/U1\ : IOTRI_OB_EB
      port map(D => \Diff5_c[0]\, E => SOC_VCC_NET, DOUT => 
        \Diff5_pad[0]/U0/NET1\, EOUT => \Diff5_pad[0]/U0/NET2\);
    
    \COMP_SM_inst/R1[1]\ : DFN1E1C0
      port map(D => \ADC_RESULT[1]\, CLK => SYSCLK_c, CLR => 
        SYSRSTn_c, E => \COMP_SM_inst/pres_state_0[3]_net_1\, Q
         => \COMP_SM_inst/R1[1]_net_1\);
    
    
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/un1_qgnzcpmbksd_I_43\ : 
        NOR3C
      port map(A => \AB_CM_inst/TR_RAM_ADDR_B_net_net_5\, B => 
        \AB_CM_inst/TR_RAM_ADDR_B_net_net_4\, C => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/DWACT_ADD_CI_0_g_array_1[0]\, 
        Y => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/DWACT_ADD_CI_0_g_array_2[0]\);
    
    \COMP_SM_inst/Latest_Update_1_sqmuxa_0_a2\ : OR2
      port map(A => \ADC_CHNUMBER[3]\, B => \ADC_CHNUMBER[1]\, Y
         => \COMP_SM_inst/N_413\);
    
    
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/qgnzcpmbksd[5]\ : 
        DFN1C0
      port map(D => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/qgnzcpmbksd_7[5]\, 
        CLK => SYSCLK_c, CLR => SYSRSTn_c, Q => 
        \AB_CM_inst/TR_RAM_ADDR_B_net_net_2\);
    
    
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/jvxfmjbzjmc_i_a3_0_0\ : 
        OR3
      port map(A => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/N_287\, 
        B => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/frcskdnwvmx[10]_net_1\, 
        C => \AB_CM_inst/Z\\\\TR_RAM_DO_B_net\\\\\, Y => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/jvxfmjbzjmc_i_a3_0_0_net_1\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/gjkdbmpgrtc75_0_a3_0_0\ : 
        OR2
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rdgwgtpkbgc_0[1]_net_1\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rdgwgtpkbgc_0[0]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/gjkdbmpgrtc75_0_a3_0_0_net_1\);
    
    \COMP_SM_inst/Diff_5[0]\ : DFN1E1C0
      port map(D => \COMP_SM_inst/N139\, CLK => SYSCLK_c, CLR => 
        SYSRSTn_c, E => \COMP_SM_inst/Latest_Update_5_sqmuxa\, Q
         => \Diff5_c[0]\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc_11_d[8]\ : 
        MX2
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_752\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnvtvdkcnpp_0[2]_net_1\, 
        S => 
        \AB_CM_inst.AB_CM_smev_wrapper_inst.U0.u_nbnjbfrkqwq.rdgwgtpkbgc[3]\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc_11_d[8]_net_1\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rqrqhcwpqdn[11]\ : 
        DFN1E0C0
      port map(D => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_837\, 
        CLK => SYSCLK_c, CLR => SYSRSTn_c, E => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_838\, 
        Q => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rqrqhcwpqdn[11]_net_1\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rdgwgtpkbgc_2[2]\ : 
        DFN1E0C0
      port map(D => \AB_CM_inst/EV_RAM_DO_B_net_net_5\, CLK => 
        SYSCLK_c, CLR => SYSRSTn_c, E => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bskrjhjvqpf_1_sqmuxa_0\, 
        Q => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rdgwgtpkbgc_2[2]_net_1\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/gjkdbmpgrtc_11[7]\ : 
        MX2
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_449\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rqrqhcwpqdn[1]_net_1\, 
        S => 
        \AB_CM_inst.AB_CM_smev_wrapper_inst.U0.u_nbnjbfrkqwq.rdgwgtpkbgc[3]\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_581\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/wqpbnjzjqsx_NE_2\ : 
        NOR3C
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/wqpbnjzjqsx_3_i\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/wqpbnjzjqsx_4_i\, 
        C => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/wqpbnjzjqsx_0_i\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/wqpbnjzjqsx_NE_2_net_1\);
    
    
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/un1_qgnzcpmbksd_I_33\ : 
        AX1C
      port map(A => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/DWACT_ADD_CI_0_g_array_2[0]\, 
        B => \AB_CM_inst/TR_RAM_ADDR_B_net_net_3\, C => 
        \AB_CM_inst/TR_RAM_ADDR_B_net_net_2\, Y => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/I_33_0\);
    
    \Diff5_pad[8]/U0/U1\ : IOTRI_OB_EB
      port map(D => \Diff5_c[8]\, E => SOC_VCC_NET, DOUT => 
        \Diff5_pad[8]/U0/NET1\, EOUT => \Diff5_pad[8]/U0/NET2\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/pfbntnkqtmt\ : 
        OR2A
      port map(A => INIT_EV_WEN, B => INIT_DONE, Y => 
        \AB_CM_inst/EV_RAM_RW_A_net\);
    
    \COMP_SM_inst/pres_state_ns_a5_0_a2[1]\ : OR3B
      port map(A => \ADC_CHNUMBER[0]\, B => \COMP_SM_inst/N_376\, 
        C => \ADC_CHNUMBER[4]\, Y => \COMP_SM_inst/N_416\);
    
    
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/vmpskspphnb_m\ : 
        AO1A
      port map(A => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/jnfrmfqggmk_net_1\, 
        B => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/N_368\, 
        C => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/cpwfrthtnfr_11_sqmuxa\, 
        Y => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/vmpskspphnb_m_net_1\);
    
    \Diff3_pad[8]/U0/U1\ : IOTRI_OB_EB
      port map(D => \Diff3_c[8]\, E => SOC_VCC_NET, DOUT => 
        \Diff3_pad[8]/U0/NET1\, EOUT => \Diff3_pad[8]/U0/NET2\);
    
    \Diff5_pad[11]/U0/U1\ : IOTRI_OB_EB
      port map(D => \Diff5_c[11]\, E => SOC_VCC_NET, DOUT => 
        \Diff5_pad[11]/U0/NET1\, EOUT => \Diff5_pad[11]/U0/NET2\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/fqkdsnjfpdb_0_0_ADD_18x18_medium_I109_Y\ : 
        XOR3
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ADD_18x18_medium_I109_Y_1\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_323_i\, 
        C => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N363\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/fqkdsnjfpdb[17]\);
    
    \COMP_SM_inst/Diff_5[9]\ : DFN1E1C0
      port map(D => \COMP_SM_inst/Result[9]\, CLK => SYSCLK_c, 
        CLR => SYSRSTn_c, E => 
        \COMP_SM_inst/Latest_Update_5_sqmuxa\, Q => \Diff5_c[9]\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ftbkrvpxdbp_5[1]\ : 
        MX2
      port map(A => \AB_CM_inst/EV_RAM_DO_B_net_net_3\, B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/fqkdsnjfpdb[1]\, 
        S => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx_0[4]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ftbkrvpxdbp_5[1]_net_1\);
    
    
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/un1_cfxfrwgjccr_6\ : 
        NOR2B
      port map(A => INIT_DONE, B => \AB_CM_inst/N_266\, Y => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/un1_cfxfrwgjccr_6_net_1\);
    
    \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/G_133_0\ : 
        OA1A
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc[9]\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnvtvdkcnpp[3]_net_1\, 
        C => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/gjkdbmpgrtc[9]\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/G_133_0_net_1\);
    
    
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/ptxbvztnpnf[4]\ : 
        DFN1E1C0
      port map(D => \AB_CM_inst/ASSC_RAM_DO_B_net_net_3\, CLK => 
        SYSCLK_c, CLR => SYSRSTn_c, E => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/jzzdfrmzwdj[11]_net_1\, 
        Q => \AB_CM_inst/ADC_STC_net_net_2\);
    
    
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/user_control/u_ffppvfwnggt/srdtcqsfmmm_i[16]\ : 
        AOI1B
      port map(A => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/I33_un1_Y\, 
        B => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/N189\, 
        C => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/user_control/u_ffppvfwnggt/un1_wxqqqsndpvg_i_0_0\, 
        Y => \NVM_CM_inst/srdtcqsfmmm_i[16]\);
    
    
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/hgqdwrxvgzm[3]\ : 
        DFN1E1C0
      port map(D => \AB_CM_inst/ASSC_RAM_DO_B_net_net_4\, CLK => 
        SYSCLK_c, CLR => SYSRSTn_c, E => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/jzzdfrmzwdj[14]_net_1\, 
        Q => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/hgqdwrxvgzm[3]_net_1\);
    
    
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/hnbsspwxkpd_m\ : 
        OR2B
      port map(A => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/hnbsspwxkpd_net_1\, 
        B => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/cpwfrthtnfr_14_sqmuxa\, 
        Y => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/hnbsspwxkpd_m_net_1\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/fqkdsnjfpdb_0_0_ADD_18x18_medium_I75_Y\ : 
        OR2B
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ADD_18x18_medium_I75_Y_3\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/I65_un1_Y\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N363\);
    
    
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/frcskdnwvmx_0[0]\ : 
        DFN1C0
      port map(D => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/frcskdnwvmx_ns_i[11]_net_1\, 
        CLK => SYSCLK_c, CLR => SYSRSTn_c, Q => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/frcskdnwvmx_0[0]_net_1\);
    
    
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/jzzdfrmzwdj[7]\ : 
        DFN1C0
      port map(D => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/jzzdfrmzwdj_ns_i_1[8]_net_1\, 
        CLK => SYSCLK_c, CLR => SYSRSTn_c, Q => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/jzzdfrmzwdj[7]_net_1\);
    
    
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/jvxfmjbzjmc_i\ : 
        OA1B
      port map(A => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/N_247\, 
        B => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/jvxfmjbzjmc_i_a3_0_0_net_1\, 
        C => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/N_262\, 
        Y => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/jvxfmjbzjmc_i_net_1\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/pptwzsjcmcz_dhzrwbnrbpw_7_iv_0[2]\ : 
        AOI1B
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rgmpzqrbghh_0_net_1\, 
        B => \AB_CM_inst/EV_CHHOLD_net_net_2\, C => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/qrbxknbdvjj_m[2]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/dhzrwbnrbpw_7_iv_0[2]\);
    
    
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/address_gen/u_dxwqxgdccxc/jvbvzqvvxpc_un10_gnmdxrqrdgs_NE_6\ : 
        NOR3C
      port map(A => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/address_gen/u_dxwqxgdccxc/un10_gnmdxrqrdgs_NE_3\, 
        B => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/address_gen/u_dxwqxgdccxc/un10_gnmdxrqrdgs_NE_2\, 
        C => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/address_gen/u_dxwqxgdccxc/un10_gnmdxrqrdgs_0_i\, 
        Y => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/address_gen/u_dxwqxgdccxc/un10_gnmdxrqrdgs_NE_6\);
    
    \COMP_SM_inst/pres_state_ns_a5_0_a4_2[1]\ : NOR3B
      port map(A => ASSC_DONE, B => 
        \COMP_SM_inst/pres_state_ns_a5_0_a4_1[1]_net_1\, C => 
        \COMP_SM_inst/pres_state[1]_net_1\, Y => 
        \COMP_SM_inst/pres_state_ns_a5_0_a4_2[1]_net_1\);
    
    
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/hgqdwrxvgzm_3[4]\ : 
        MX2
      port map(A => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/hgqdwrxvgzm[4]_net_1\, 
        B => \AB_CM_inst/ASSC_RAM_DO_B_net_net_3\, S => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/jzzdfrmzwdj_0[14]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/hgqdwrxvgzm_3[4]_net_1\);
    
    \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/G_113_0\ : 
        OA1A
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc[5]\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ftbkrvpxdbp[5]_net_1\, 
        C => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/gjkdbmpgrtc[5]\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/G_113_0_net_1\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/zbqggxmnpbs_0_iv[7]\ : 
        AO1B
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/fqkdsnjfpdb[4]\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx[4]_net_1\, 
        C => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/fqkdsnjfpdb_m[13]_net_1\, 
        Y => \AB_CM_inst/Z\\\\EV_RAM_DI_B_net\\\\\);
    
    \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/G_104\ : 
        XOR3
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/gjkdbmpgrtc[4]\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ftbkrvpxdbp[4]_net_1\, 
        C => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc_12[4]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_262\);
    
    
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/address_gen/u_dxwqxgdccxc/jvbvzqvvxpc_un10_gnmdxrqrdgs_NE_3\ : 
        XA1
      port map(A => \INIT_ADDR[3]\, B => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/bdhvhfjwtxd_i_0[5]\, 
        C => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/address_gen/u_dxwqxgdccxc/un10_gnmdxrqrdgs_7\, 
        Y => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/address_gen/u_dxwqxgdccxc/un10_gnmdxrqrdgs_NE_3\);
    
    \Diff3_pad[1]/U0/U0\ : IOPAD_TRI
      port map(D => \Diff3_pad[1]/U0/NET1\, E => 
        \Diff3_pad[1]/U0/NET2\, PAD => Diff3(1));
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rqrqhcwpqdn_9_0[10]\ : 
        MX2
      port map(A => \AB_CM_inst/ASSC_RAM_DO_A_net_net_6\, B => 
        \AB_CM_inst/EV_RAM_DO_B_net_net_6\, S => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/un1_mvnkctvqsgp_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_836\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rqrqhcwpqdn_5_0[8]\ : 
        MX2
      port map(A => \AB_CM_inst/ASSC_RAM_DO_A_net[8]\, B => 
        \AB_CM_inst/EV_RAM_DO_B_net[8]\, S => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/un1_xkwrgrspmcf_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_822\);
    
    \Latest_Update_pad[1]/U0/U0\ : IOPAD_TRI
      port map(D => \Latest_Update_pad[1]/U0/NET1\, E => 
        \Latest_Update_pad[1]/U0/NET2\, PAD => Latest_Update(1));
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/fqkdsnjfpdb_0_0_ADD_18x18_medium_I3_G0N\ : 
        XA1A
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc[3]\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/G_99_0_net_1\, 
        C => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_253\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N240\);
    
    \Diff2_pad[2]/U0/U1\ : IOTRI_OB_EB
      port map(D => \Diff2_c[2]\, E => SOC_VCC_NET, DOUT => 
        \Diff2_pad[2]/U0/NET1\, EOUT => \Diff2_pad[2]/U0/NET2\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rqrqhcwpqdn[1]\ : 
        DFN1E1C0
      port map(D => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_815\, 
        CLK => SYSCLK_c, CLR => SYSRSTn_c, E => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_823\, 
        Q => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rqrqhcwpqdn[1]_net_1\);
    
    \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/G_111\ : 
        NOR2A
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ftbkrvpxdbp[5]_net_1\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc[5]\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_270\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/fqkdsnjfpdb_0_0_ADD_18x18_medium_I43_Y\ : 
        AOI1
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N293\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N294\, 
        C => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N292\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N310\);
    
    \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/G_138_0\ : 
        OA1A
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc[10]\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnvtvdkcnpp[4]_net_1\, 
        C => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/gjkdbmpgrtc[10]\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/G_138_0_net_1\);
    
    \COMP_SM_inst/R2[10]\ : DFN1E1C0
      port map(D => \ADC_RESULT[10]\, CLK => SYSCLK_c, CLR => 
        SYSRSTn_c, E => \COMP_SM_inst/pres_state[2]_net_1\, Q => 
        \COMP_SM_inst/R2[10]_net_1\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/pvtdpmmqdpp_un2_pbzxzjhqhwz_0_I_21\ : 
        AO1C
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rqrqhcwpqdn[8]_net_1\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnvtvdkcnpp[8]_net_1\, 
        C => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_30\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_32\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/fqkdsnjfpdb_0_0_ADD_18x18_medium_I103_Y_0\ : 
        AX1D
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/G_138_0_net_1\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_295\, 
        C => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_297\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ADD_18x18_medium_I103_Y_0\);
    
    
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/init_fsm/u_stnpfdkggvx/mwtvnzdkmwm[5]\ : 
        DFN1C0
      port map(D => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/init_fsm/u_stnpfdkggvx/mwtvnzdkmwm_ns[2]_net_1\, 
        CLK => SYSCLK_c, CLR => SYSRSTn_c, Q => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/init_fsm/u_stnpfdkggvx/mwtvnzdkmwm[5]_net_1\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/jrgzmrqhbkv_m[3]\ : 
        OR2B
      port map(A => \AB_CM_inst/EV_RAM_DO_B_net_net_4\, B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_199_i_0\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/jrgzmrqhbkv_m[3]_net_1\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/fqkdsnjfpdb_0_0_ADD_18x18_medium_I49_un1_Y\ : 
        NOR3C
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N300\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N235\, 
        C => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N238\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/I49_un1_Y\);
    
    
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/jzzdfrmzwdj[11]\ : 
        DFN1C0
      port map(D => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/jzzdfrmzwdj_ns_i_1[4]_net_1\, 
        CLK => SYSCLK_c, CLR => SYSRSTn_c, Q => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/jzzdfrmzwdj[11]_net_1\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/fqkdsnjfpdb_0_0_ADD_18x18_medium_I49_Y\ : 
        OR2
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N298\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/I49_un1_Y\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N316\);
    
    
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/jzzdfrmzwdj[15]\ : 
        DFN1P0
      port map(D => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/jzzdfrmzwdj_ns[0]\, 
        CLK => SYSCLK_c, PRE => SYSRSTn_c, Q => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/jzzdfrmzwdj[15]_net_1\);
    
    \COMP_SM_inst/Diff_2[10]\ : DFN1E0C0
      port map(D => \COMP_SM_inst/Result[10]\, CLK => SYSCLK_c, 
        CLR => SYSRSTn_c, E => 
        \COMP_SM_inst/Latest_Update_2_sqmuxa\, Q => \Diff2_c[10]\);
    
    
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/hgqdwrxvgzm_3[0]\ : 
        MX2
      port map(A => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/hgqdwrxvgzm[0]_net_1\, 
        B => \AB_CM_inst/ASSC_RAM_DO_B_net_net_7\, S => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/jzzdfrmzwdj_0[14]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/hgqdwrxvgzm_3[0]_net_1\);
    
    
        \COMP_SM_inst/Subtract_inst/sumAux_0_0_SUB_12x12_medium_area_I13_S\ : 
        XNOR2
      port map(A => \COMP_SM_inst/R2[1]_net_1\, B => 
        \COMP_SM_inst/R1[1]_net_1\, Y => 
        \COMP_SM_inst/Subtract_inst/N141\);
    
    
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/trnwxjxxrbp[3]\ : 
        DFN1C0
      port map(D => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/trnwxjxxrbp[3]_net_1\, 
        CLK => SYSCLK_c, CLR => SYSRSTn_c, Q => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/trnwxjxxrbp[3]_net_1\);
    
    
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/mksbfqnmmgw[8]\ : 
        NOR2A
      port map(A => \ADC_RESULT[8]\, B => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/jzzdfrmzwdj_0[4]_net_1\, 
        Y => \AB_CM_inst/ASSC_RAM_DI_B_net[8]\);
    
    \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/G_118_0\ : 
        OA1A
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc[6]\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnvtvdkcnpp[0]_net_1\, 
        C => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/gjkdbmpgrtc[6]\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/G_118_0_net_1\);
    
    
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/svpqbbcnvqz[1]\ : 
        OR2A
      port map(A => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/N_232_1\, 
        B => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/jzzdfrmzwdj[5]_net_1\, 
        Y => \AB_CM_inst/ASSC_RAM_ADDR_B_net_net_6\);
    
    \AB_CM_inst/AC5_PAD\ : IOPAD_A_IN
      port map(PAD => AC5, Y => \AB_CM_inst/AC5_net\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc_11[8]\ : 
        MX2C
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_750\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc_11_d[8]_net_1\, 
        S => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc_11_s[6]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc_11[8]_net_1\);
    
    
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/address_gen/u_dxwqxgdccxc/jvbvzqvvxpc_un10_gnmdxrqrdgs_NE_2\ : 
        NOR3C
      port map(A => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/address_gen/u_dxwqxgdccxc/un10_gnmdxrqrdgs_NE_0\, 
        B => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/address_gen/u_dxwqxgdccxc/un10_gnmdxrqrdgs_8_i\, 
        C => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/address_gen/u_dxwqxgdccxc/un10_gnmdxrqrdgs_5\, 
        Y => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/address_gen/u_dxwqxgdccxc/un10_gnmdxrqrdgs_NE_2\);
    
    
        \COMP_SM_inst/Subtract_inst/sumAux_0_0_SUB_12x12_medium_area_I73_Y\ : 
        AX1D
      port map(A => \COMP_SM_inst/Subtract_inst/I64_un1_Y\, B => 
        \COMP_SM_inst/Subtract_inst/N150\, C => 
        \COMP_SM_inst/Subtract_inst/N151\, Y => 
        \COMP_SM_inst/Result[6]\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/kkkmkxwwscv[0]\ : 
        DFN1E1C0
      port map(D => \AB_CM_inst/ASSC_SEQOUT_net_net_4\, CLK => 
        SYSCLK_c, CLR => SYSRSTn_c, E => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/qmmwhjxxxmv_net_1\, 
        Q => \AB_CM_inst/EV_ASSCADDR_net_net_4\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/fqkdsnjfpdb_0_0_ADD_18x18_medium_I98_Y\ : 
        XNOR3
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_272\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_268\, 
        C => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ADD_18x18_medium_I89_Y\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/fqkdsnjfpdb[6]\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ckghxwbsztp_3_0_a3[1]\ : 
        XA1
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rqrqhcwpqdn[1]_net_1\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rqrqhcwpqdn[2]_net_1\, 
        C => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_923\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ckghxwbsztp_3[1]\);
    
    \Diff4_pad[0]/U0/U1\ : IOTRI_OB_EB
      port map(D => \Diff4_c[0]\, E => SOC_VCC_NET, DOUT => 
        \Diff4_pad[0]/U0/NET1\, EOUT => \Diff4_pad[0]/U0/NET2\);
    
    
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/address_gen/u_dxwqxgdccxc/ggfvvjbkdws[1]\ : 
        MX2C
      port map(A => \INIT_ADDR[1]\, B => \INIT_ADDR[0]\, S => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/ggsxvgncrgz[0]\, 
        Y => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/ggfvvjbkdws[1]\);
    
    
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/jzzdfrmzwdj_ns_i_1[4]\ : 
        NOR2B
      port map(A => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/un1_AB_CM_inst_2_0\, 
        B => INIT_DONE, Y => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/jzzdfrmzwdj_ns_i_1[4]_net_1\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/pptwzsjcmcz_dhzrwbnrbpw_7_iv[4]\ : 
        AO1B
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_201_i_0\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/I_30\, 
        C => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/dhzrwbnrbpw_7_iv_1[4]\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/dhzrwbnrbpw_7[4]\);
    
    
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/hgqdwrxvgzm[5]\ : 
        DFN1E1C0
      port map(D => \AB_CM_inst/ASSC_RAM_DO_B_net_net_2\, CLK => 
        SYSCLK_c, CLR => SYSRSTn_c, E => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/jzzdfrmzwdj[14]_net_1\, 
        Q => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/hgqdwrxvgzm[5]_net_1\);
    
    \Diff3_pad[3]/U0/U0\ : IOPAD_TRI
      port map(D => \Diff3_pad[3]/U0/NET1\, E => 
        \Diff3_pad[3]/U0/NET2\, PAD => Diff3(3));
    
    \Diff0_pad[7]/U0/U0\ : IOPAD_TRI
      port map(D => \Diff0_pad[7]/U0/NET1\, E => 
        \Diff0_pad[7]/U0/NET2\, PAD => Diff0(7));
    
    
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/user_control/u_ffppvfwnggt/jsnhqgkgbcr_un1_wxqqqsndpvg_0_a2_0_o2_0\ : 
        NOR2A
      port map(A => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/bfcqzvtnrcn\, 
        B => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/qdvwjxmzbpf\, 
        Y => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/user_control/u_ffppvfwnggt/un1_wxqqqsndpvg_i_0_0\);
    
    \COMP_SM_inst/Diff_1[7]\ : DFN1E1C0
      port map(D => \COMP_SM_inst/Result[7]\, CLK => SYSCLK_c, 
        CLR => SYSRSTn_c, E => 
        \COMP_SM_inst/Latest_Update_1_sqmuxa\, Q => \Diff1_c[7]\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/pptwzsjcmcz_dhzrwbnrbpw_7_iv[2]\ : 
        OR3C
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/jrgzmrqhbkv_m[2]_net_1\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/dhzrwbnrbpw_7_iv_0[2]\, 
        C => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/un1_dhzrwbnrbpw_m[3]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/dhzrwbnrbpw_7[2]\);
    
    
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/znjtscvsvcs_iv_0_a2_0_1\ : 
        NOR3B
      port map(A => \AB_CM_inst/TR_RAM_DO_B_net_0[8]\, B => 
        \AB_CM_inst/TR_RAM_DO_B_net_net_1_0\, C => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/N_235\, 
        Y => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/N_434_1\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc_9[7]\ : 
        MX2
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnvtvdkcnpp[7]_net_1\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnvtvdkcnpp[8]_net_1\, 
        S => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rdgwgtpkbgc_2[0]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_751\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/un1_fskhwddcbbg_i\ : 
        OR2
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_206\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_209\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_196\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/qrbxknbdvjj_m[3]\ : 
        OR3B
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx[8]_net_1\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/qrbxknbdvjj[3]_net_1\, 
        C => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rgmpzqrbghh_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/qrbxknbdvjj_m[3]_net_1\);
    
    \COMP_SM_inst/pres_state_0[3]\ : DFN1C0
      port map(D => \COMP_SM_inst/pres_state_ns[1]\, CLK => 
        SYSCLK_c, CLR => \COMP_SM_inst/un2_resetn\, Q => 
        \COMP_SM_inst/pres_state_0[3]_net_1\);
    
    
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/jfkkdmfhcdn_0_a3[7]\ : 
        NOR2A
      port map(A => \AB_CM_inst/Z\\\\TR_RAM_DO_B_net\\\\\, B => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/frcskdnwvmx_0[0]_net_1\, 
        Y => \AB_CM_inst/Z\\\\TR_RAM_DI_B_net\\\\\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/zbqggxmnpbs_0_iv[1]\ : 
        AO1B
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/fqkdsnjfpdb[16]\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx_0[4]_net_1\, 
        C => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/zbqggxmnpbs_0_iv_0[1]_net_1\, 
        Y => \AB_CM_inst/EV_RAM_DI_B_net_net_6\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/gjkdbmpgrtc_11_d[10]\ : 
        MX2
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_550\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rqrqhcwpqdn[4]_net_1\, 
        S => 
        \AB_CM_inst.AB_CM_smev_wrapper_inst.U0.u_nbnjbfrkqwq.rdgwgtpkbgc[3]\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/gjkdbmpgrtc_11_d[10]_net_1\);
    
    
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/znbkwkbspdc\ : 
        DFN1E0C0
      port map(D => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/N_263\, 
        CLK => SYSCLK_c, CLR => SYSRSTn_c, E => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/un1_cfxfrwgjccr_6_net_1\, 
        Q => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/znbkwkbspdc_net_1\);
    
    
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/hgqdwrxvgzm_3[2]\ : 
        MX2
      port map(A => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/hgqdwrxvgzm[2]_net_1\, 
        B => \AB_CM_inst/ASSC_RAM_DO_B_net_net_5\, S => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/jzzdfrmzwdj_0[14]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/hgqdwrxvgzm_3[2]_net_1\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/pvtdpmmqdpp_un2_pbzxzjhqhwz_0_I_2\ : 
        XNOR2
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnvtvdkcnpp[11]_net_1\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rqrqhcwpqdn[11]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/DWACT_BL_EQUAL_0_E[4]\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/pptwzsjcmcz_dhzrwbnrbpw_7_iv_0[6]\ : 
        AOI1B
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_199_i_0\, 
        B => \AB_CM_inst/EV_RAM_DO_B_net_net_1\, C => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/qrbxknbdvjj_m[6]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/dhzrwbnrbpw_7_iv_0[6]\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc_12[16]\ : 
        MX2
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_960\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_794\, 
        S => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rdgwgtpkbgc[2]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc[16]\);
    
    
        \COMP_SM_inst/Subtract_inst/sumAux_0_0_SUB_12x12_medium_area_I54_Y\ : 
        AO1
      port map(A => \COMP_SM_inst/Subtract_inst/N197\, B => 
        \COMP_SM_inst/Subtract_inst/N200\, C => 
        \COMP_SM_inst/Subtract_inst/N196\, Y => 
        \COMP_SM_inst/Subtract_inst/N202\);
    
    
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/bnrsdrtmtsg_5[5]\ : 
        MX2
      port map(A => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/hgqdwrxvgzm_3[5]_net_1\, 
        B => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/trnwxjxxrbp[5]_net_1\, 
        S => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/N_345\, 
        Y => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/N_358\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/gjkdbmpgrtc_3[9]\ : 
        MX2
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_543\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_545\, 
        S => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rdgwgtpkbgc[1]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_447\);
    
    
        \COMP_SM_inst/Subtract_inst/sumAux_0_0_SUB_12x12_medium_area_I19_S\ : 
        XNOR2
      port map(A => \COMP_SM_inst/R2[7]_net_1\, B => 
        \COMP_SM_inst/R1[7]_net_1\, Y => 
        \COMP_SM_inst/Subtract_inst/N153\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/fqkdsnjfpdb_0_0_ADD_18x18_medium_I4_G0N\ : 
        OAI1
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/G_103_0_net_1\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_260\, 
        C => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_262\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N243\);
    
    \Latest_Update_pad[0]/U0/U0\ : IOPAD_TRI
      port map(D => \Latest_Update_pad[0]/U0/NET1\, E => 
        \Latest_Update_pad[0]/U0/NET2\, PAD => Latest_Update(0));
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc_9[0]\ : 
        MX2
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnvtvdkcnpp[0]_net_1\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnvtvdkcnpp[1]_net_1\, 
        S => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rdgwgtpkbgc_2[0]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_744\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx_ns[0]\ : 
        AO1C
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rgmpzqrbghh_net_1\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx[17]_net_1\, 
        C => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_211\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx_ns[0]_net_1\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/zbqggxmnpbs_0_iv_1[0]\ : 
        NOR3C
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/un2_pbzxzjhqhwz_m\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tddhwjzbsrj_m_net_1\, 
        C => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/fqkdsnjfpdb_m[6]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/zbqggxmnpbs_0_iv_1[0]_net_1\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/wqpbnjzjqsx_NE_1\ : 
        XA1A
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnvtvdkcnpp[3]_net_1\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rqrqhcwpqdn[3]_net_1\, 
        C => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/wqpbnjzjqsx_1_i\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/wqpbnjzjqsx_NE_1_net_1\);
    
    \I_200/U_CLKSRC\ : CLKSRC
      port map(A => \rdgwgtpkbgc[3]\, Y => 
        \AB_CM_inst.AB_CM_smev_wrapper_inst.U0.u_nbnjbfrkqwq.rdgwgtpkbgc[3]\);
    
    \COMP_SM_inst/R2[5]\ : DFN1E1C0
      port map(D => \ADC_RESULT[5]\, CLK => SYSCLK_c, CLR => 
        SYSRSTn_c, E => \COMP_SM_inst/pres_state_0[2]_net_1\, Q
         => \COMP_SM_inst/R2[5]_net_1\);
    
    \COMP_SM_inst/Diff_3[3]\ : DFN1E1C0
      port map(D => \COMP_SM_inst/Result[3]\, CLK => SYSCLK_c, 
        CLR => SYSRSTn_c, E => 
        \COMP_SM_inst/Latest_Update_3_sqmuxa\, Q => \Diff3_c[3]\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnvtvdkcnpp_5[4]\ : 
        MX2
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnvtvdkcnpp[4]_net_1\, 
        B => \AB_CM_inst/EV_RAM_DO_B_net_net_3\, S => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/un3_qvqqfftqsfc_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnvtvdkcnpp_5[4]_net_1\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc_11[10]\ : 
        MX2
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_752\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc_11_d[10]_net_1\, 
        S => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc_11_s[6]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_788\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc_12_d_s[0]\ : 
        NOR2A
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rdgwgtpkbgc_0[2]_net_1\, 
        B => 
        \AB_CM_inst.AB_CM_smev_wrapper_inst.U0.u_nbnjbfrkqwq.rdgwgtpkbgc[3]\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc_12_d_s[0]_net_1\);
    
    
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/jzzdfrmzwdj[2]\ : 
        DFN1P0
      port map(D => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/N_224_i_0\, 
        CLK => SYSCLK_c, PRE => SYSRSTn_c, Q => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/jzzdfrmzwdj_i_0[2]\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnvtvdkcnpp[11]\ : 
        DFN1C0
      port map(D => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnvtvdkcnpp_9[11]_net_1\, 
        CLK => SYSCLK_c, CLR => SYSRSTn_c, Q => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnvtvdkcnpp[11]_net_1\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/fqkdsnjfpdb_0_0_ADD_18x18_medium_I86_un1_Y\ : 
        AO1C
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/G_138_0_net_1\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ADD_18x18_medium_I11_P0N_0\, 
        C => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N347\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/I86_un1_Y_i\);
    
    
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/address_gen/u_dxwqxgdccxc/gnmdxrqrdgs[7]\ : 
        DFN1C0
      port map(D => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/address_gen/u_dxwqxgdccxc/gnmdxrqrdgs_3[7]\, 
        CLK => SYSCLK_c, CLR => SYSRSTn_c, Q => \INIT_ADDR[7]\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/fqkdsnjfpdb_0_0_ADD_18x18_medium_I70_Y\ : 
        OR3B
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N310\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ADD_18x18_medium_I70_un1_Y\, 
        C => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/I59_un1_Y\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N349\);
    
    \COMP_SM_inst/Diff_2[2]\ : DFN1E0C0
      port map(D => \COMP_SM_inst/Result[2]\, CLK => SYSCLK_c, 
        CLR => SYSRSTn_c, E => 
        \COMP_SM_inst/Latest_Update_2_sqmuxa_0\, Q => 
        \Diff2_c[2]\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rqrqhcwpqdn_5_0[5]\ : 
        MX2
      port map(A => \AB_CM_inst/ASSC_RAM_DO_A_net_net_2\, B => 
        \AB_CM_inst/EV_RAM_DO_B_net_net_2\, S => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/un1_xkwrgrspmcf_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_819\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/gjkdbmpgrtc_11[10]\ : 
        MX2
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_548\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/gjkdbmpgrtc_11_d[10]_net_1\, 
        S => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc_11_s[6]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_584\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc_3[14]\ : 
        MX2
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_752\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_754\, 
        S => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rdgwgtpkbgc_1[1]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_656\);
    
    \COMP_SM_inst/valid_8_0_0_a2_4\ : NOR2B
      port map(A => \COMP_SM_inst/valid_8_0_0_a2_4_1_net_1\, B
         => \COMP_SM_inst/N_418\, Y => \COMP_SM_inst/N_422\);
    
    \AB_CM_inst/AC2_PAD\ : IOPAD_A_IN
      port map(PAD => AC2, Y => \AB_CM_inst/AC2_net\);
    
    \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/G_139\ : 
        XNOR3
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/gjkdbmpgrtc[11]\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnvtvdkcnpp[5]_net_1\, 
        C => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc[11]\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_297\);
    
    \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/G_136\ : 
        NOR2A
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnvtvdkcnpp[4]_net_1\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc[10]\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_295\);
    
    \Diff4_pad[10]/U0/U1\ : IOTRI_OB_EB
      port map(D => \Diff4_c[10]\, E => SOC_VCC_NET, DOUT => 
        \Diff4_pad[10]/U0/NET1\, EOUT => \Diff4_pad[10]/U0/NET2\);
    
    
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/mksbfqnmmgw[4]\ : 
        NOR2A
      port map(A => \ADC_RESULT[4]\, B => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/jzzdfrmzwdj[4]_net_1\, 
        Y => \AB_CM_inst/ASSC_RAM_DI_B_net_net_3\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/fqkdsnjfpdb_m[2]\ : 
        OR2B
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx[4]_net_1\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/fqkdsnjfpdb[2]\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/fqkdsnjfpdb_m[2]_net_1\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc_7[5]\ : 
        MX2
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_647\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_655\, 
        S => 
        \AB_CM_inst.AB_CM_smev_wrapper_inst.U0.u_nbnjbfrkqwq.rdgwgtpkbgc[3]\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_715\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc_12[15]\ : 
        MX2
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_959\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_793\, 
        S => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rdgwgtpkbgc[2]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc[15]\);
    
    
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/qgnzcpmbksd[4]\ : 
        DFN1C0
      port map(D => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/qgnzcpmbksd_7[4]\, 
        CLK => SYSCLK_c, CLR => SYSRSTn_c, Q => 
        \AB_CM_inst/TR_RAM_ADDR_B_net_net_3\);
    
    
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/init_fsm/u_stnpfdkggvx/rhjctqnqzsn[0]\ : 
        DFN1C0
      port map(D => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/init_fsm/u_stnpfdkggvx/DWACT_ADD_CI_0_partial_sum[0]\, 
        CLK => SYSCLK_c, CLR => SYSRSTn_c, Q => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/gpbbjwsprsj[0]\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnvtvdkcnpp[10]\ : 
        DFN1C0
      port map(D => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnvtvdkcnpp_9[10]_net_1\, 
        CLK => SYSCLK_c, CLR => SYSRSTn_c, Q => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnvtvdkcnpp[10]_net_1\);
    
    
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/un6_bdbpcvshhqt_1\ : 
        NOR3A
      port map(A => \AB_CM_inst/TR_DONE_net_i_0\, B => 
        \AB_CM_inst/TR_TRFLAG_net\, C => 
        \AB_CM_inst/EV_EVFLAG_net\, Y => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/un6_bdbpcvshhqt_1_net_1\);
    
    \Diff2_pad[3]/U0/U0\ : IOPAD_TRI
      port map(D => \Diff2_pad[3]/U0/NET1\, E => 
        \Diff2_pad[3]/U0/NET2\, PAD => Diff2(3));
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc_3[2]\ : 
        MX2
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_625\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_727\, 
        S => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rdgwgtpkbgc_0[1]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_644\);
    
    
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/fsrxhtjthgw_i_a3\ : 
        AO1
      port map(A => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/N_314\, 
        B => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/N_315\, 
        C => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/jzzdfrmzwdj[0]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/N_317\);
    
    
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/user_control/u_ffppvfwnggt/ttkcwbrgmjd_i_m2\ : 
        MX2
      port map(A => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/N_51\, 
        B => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/N_42\, 
        S => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/user_control/u_ffppvfwnggt/un1_wxqqqsndpvg_i_0_0\, 
        Y => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/wtjtwqjkqbd\);
    
    
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/ddvbdtxtbpx_i\ : 
        NOR3B
      port map(A => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/N_232_1\, 
        B => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/N_232_2\, 
        C => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/ddvbdtxtbpx_i_0_net_1\, 
        Y => \AB_CM_inst/ddvbdtxtbpx_i\);
    
    
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/un1_qgnzcpmbksd_I_1\ : 
        AND2
      port map(A => \AB_CM_inst/TR_RAM_ADDR_B_net_net_7\, B => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/jvxfmjbzjmc_i_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/DWACT_ADD_CI_0_TMP[0]\);
    
    \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/G_113\ : 
        OR2
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_270\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/G_113_0_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_268\);
    
    
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/user_control/u_ffppvfwnggt/hrdbnmzftpn_0_0_x2[15]\ : 
        XNOR2
      port map(A => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/vvpkfmmpprk[1]\, 
        B => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/vvpkfmmpprk[0]\, 
        Y => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/user_control/u_ffppvfwnggt/N_2183_i_i_0\);
    
    
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/dspfgfmqhwh[0]\ : 
        DFN1E1C0
      port map(D => \AB_CM_inst/ASSC_RAM_DO_B_net_net_7\, CLK => 
        SYSCLK_c, CLR => SYSRSTn_c, E => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/un1_AB_CM_inst_2_0\, 
        Q => \ADC_CHNUMBER[0]\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/fqkdsnjfpdb_0_0_ADD_18x18_medium_I3_P0N_0\ : 
        AO13
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ftbkrvpxdbp[2]_net_1\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/gjkdbmpgrtc[2]\, 
        C => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc[2]\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ADD_18x18_medium_I3_P0N_0\);
    
    
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/init_fsm/u_stnpfdkggvx/un1_rhjctqnqzsn_I_8\ : 
        XOR2
      port map(A => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/gpbbjwsprsj[0]\, 
        B => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/init_fsm/u_stnpfdkggvx/mwtvnzdkmwm[2]_net_1\, 
        Y => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/init_fsm/u_stnpfdkggvx/DWACT_ADD_CI_0_partial_sum[0]\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/jrgzmrqhbkv_m[1]\ : 
        OR2B
      port map(A => \AB_CM_inst/EV_RAM_DO_B_net_net_6\, B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_199_i_0\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/jrgzmrqhbkv_m[1]_net_1\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/gjkdbmpgrtc_12[4]\ : 
        MX2
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_510\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_951\, 
        S => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rdgwgtpkbgc_1[2]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/gjkdbmpgrtc[4]\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/un1_dhzrwbnrbpw_I_51\ : 
        NOR3C
      port map(A => \AB_CM_inst/EV_RAM_ADDR_B_net_net_1\, B => 
        \AB_CM_inst/Z\\\\EV_RAM_ADDR_B_net\\\\\, C => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/DWACT_ADD_CI_0_pog_array_1_1[0]\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/DWACT_ADD_CI_0_pog_array_2[0]\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc_11[13]\ : 
        MX2
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_953\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnvtvdkcnpp[7]_net_1\, 
        S => 
        \AB_CM_inst.AB_CM_smev_wrapper_inst.U0.u_nbnjbfrkqwq.rdgwgtpkbgc[3]\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_791\);
    
    
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/cnwzzrhdsqv\ : 
        OR3B
      port map(A => 
        \NVM_CM_inst.NVM_CM_init_wrapper_inst.U0.u_grwzcnqmqzm.valid_client.u_gpbdjfttbjd.N_10\, 
        B => 
        \NVM_CM_inst.NVM_CM_init_wrapper_inst.U0.u_grwzcnqmqzm.valid_client.u_gpbdjfttbjd.N_12\, 
        C => INIT_DONE, Y => \AB_CM_inst/TR_RAM_RW_A_net\);
    
    
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/init_fsm/u_stnpfdkggvx/mwtvnzdkmwm[7]\ : 
        DFN1P0
      port map(D => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/init_fsm/u_stnpfdkggvx/mwtvnzdkmwm_ns[0]\, 
        CLK => SYSCLK_c, PRE => SYSRSTn_c, Q => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/init_fsm/u_stnpfdkggvx/mwtvnzdkmwm[7]_net_1\);
    
    
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/address_gen/u_dxwqxgdccxc/un1_dkjzqmrkvwb_ADD_13x13_fast_I35_un1_Y\ : 
        OR2B
      port map(A => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/address_gen/u_dxwqxgdccxc/ADD_13x13_fast_I35_un1_Y_0\, 
        B => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/address_gen/u_dxwqxgdccxc/N190\, 
        Y => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/address_gen/u_dxwqxgdccxc/I35_un1_Y\);
    
    
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/frcskdnwvmx[9]\ : 
        DFN1C0
      port map(D => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/frcskdnwvmx_ns_i[2]_net_1\, 
        CLK => SYSCLK_c, CLR => SYSRSTn_c, Q => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/frcskdnwvmx[9]_net_1\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/gjkdbmpgrtc_7_0_a3[16]\ : 
        NOR2A
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_968\, 
        B => 
        \AB_CM_inst.AB_CM_smev_wrapper_inst.U0.u_nbnjbfrkqwq.rdgwgtpkbgc[3]\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_946\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/fqkdsnjfpdb_0_0_ADD_18x18_medium_I26_Y\ : 
        MAJ3
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_278\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_282\, 
        C => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N252\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N292\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/fqkdsnjfpdb_0_0_ADD_18x18_medium_I69_un1_Y_0\ : 
        NOR3B
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N295\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N309\, 
        C => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N297\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ADD_18x18_medium_I69_un1_Y_0\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/gjkdbmpgrtc_12[1]\ : 
        MX2
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_890\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_948\, 
        S => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rdgwgtpkbgc_1[2]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/gjkdbmpgrtc[1]\);
    
    
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/valid_client/u_gpbdjfttbjd/fpppnnsbksx_r[2]\ : 
        AOI1B
      port map(A => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/valid_client/u_gpbdjfttbjd/N_22\, 
        B => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/valid_client/u_gpbdjfttbjd/N_23\, 
        C => 
        \NVM_CM_inst.NVM_CM_init_wrapper_inst.U0.u_grwzcnqmqzm.valid_client.u_gpbdjfttbjd.N_12\, 
        Y => INIT_EV_WEN);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc_11_d_d[4]\ : 
        MX2C
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnvtvdkcnpp[3]_net_1\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ftbkrvpxdbp[4]_net_1\, 
        S => 
        \AB_CM_inst.AB_CM_smev_wrapper_inst.U0.u_nbnjbfrkqwq.rdgwgtpkbgc[3]\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc_11_d_d[4]_net_1\);
    
    
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/user_clk_sel/u_jhmkpjjmdkx/crmctgwbctb\ : 
        DFN1C0
      port map(D => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/qdvwjxmzbpf\, 
        CLK => SYSCLK_c, CLR => SYSRSTn_c, Q => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/user_clk_sel/u_jhmkpjjmdkx/crmctgwbctb_net_1\);
    
    
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/address_gen/u_dxwqxgdccxc/un1_gnmdxrqrdgs_I_43\ : 
        NOR3C
      port map(A => \INIT_ADDR[2]\, B => \INIT_ADDR[3]\, C => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/address_gen/u_dxwqxgdccxc/DWACT_ADD_CI_0_g_array_1[0]\, 
        Y => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/address_gen/u_dxwqxgdccxc/DWACT_ADD_CI_0_g_array_2[0]\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ftbkrvpxdbp_5[3]\ : 
        MX2
      port map(A => \AB_CM_inst/EV_RAM_DO_B_net_net_1\, B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/fqkdsnjfpdb[3]\, 
        S => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx_1[4]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ftbkrvpxdbp_5[3]_net_1\);
    
    
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/brxxctcvrmh_qgnzcpmbksd_7_0_iv[3]\ : 
        AO1B
      port map(A => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/N_230_i_0\, 
        B => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/I_37_0\, 
        C => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/qgnzcpmbksd_7_0_iv_0[3]\, 
        Y => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/qgnzcpmbksd_7[3]\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnvtvdkcnpp_8[10]\ : 
        MX2
      port map(A => \AB_CM_inst/EV_RAM_DO_B_net_net_6\, B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnvtvdkcnpp[10]_net_1\, 
        S => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/un1_kkgccghmrzf_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnvtvdkcnpp_8[10]_net_1\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc_11_d_d[5]\ : 
        MX2C
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnvtvdkcnpp[4]_net_1\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ftbkrvpxdbp[5]_net_1\, 
        S => 
        \AB_CM_inst.AB_CM_smev_wrapper_inst.U0.u_nbnjbfrkqwq.rdgwgtpkbgc[3]\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc_11_d_d[5]_net_1\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/un1_bskrjhjvqpf_6_sqmuxa_1\ : 
        NOR2A
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_211\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/qmmwhjxxxmv_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/un1_bskrjhjvqpf_6_sqmuxa_1_net_1\);
    
    \COMP_SM_inst/Latest_Update_0_sqmuxa_0_a4\ : NOR3A
      port map(A => \COMP_SM_inst/N_419\, B => 
        \COMP_SM_inst/N_407\, C => \COMP_SM_inst/N_423\, Y => 
        \COMP_SM_inst/Latest_Update_0_sqmuxa\);
    
    
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/qgnzcpmbksd[6]\ : 
        DFN1C0
      port map(D => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/qgnzcpmbksd_7[6]\, 
        CLK => SYSCLK_c, CLR => SYSRSTn_c, Q => 
        \AB_CM_inst/TR_RAM_ADDR_B_net_net_1\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/zbqggxmnpbs_0_iv[5]\ : 
        OR3C
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/fqkdsnjfpdb_m[2]_net_1\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ckghxwbsztp_m[4]_net_1\, 
        C => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/fqkdsnjfpdb_m[11]_net_1\, 
        Y => \AB_CM_inst/EV_RAM_DI_B_net_net_2\);
    
    \COMP_SM_inst/Diff_3[8]\ : DFN1E1C0
      port map(D => \COMP_SM_inst/Result[8]\, CLK => SYSCLK_c, 
        CLR => SYSRSTn_c, E => 
        \COMP_SM_inst/Latest_Update_3_sqmuxa\, Q => \Diff3_c[8]\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/fqkdsnjfpdb_0_0_ADD_18x18_medium_I69_Y\ : 
        OR3
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/I57_un1_Y\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N308\, 
        C => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/I69_un1_Y\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N347\);
    
    \COMP_SM_inst/Diff_5[8]\ : DFN1E1C0
      port map(D => \COMP_SM_inst/Result[8]\, CLK => SYSCLK_c, 
        CLR => SYSRSTn_c, E => 
        \COMP_SM_inst/Latest_Update_5_sqmuxa\, Q => \Diff5_c[8]\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/un1_dhzrwbnrbpw_I_53\ : 
        AND2
      port map(A => \AB_CM_inst/EV_RAM_ADDR_B_net_net_3\, B => 
        \AB_CM_inst/EV_RAM_ADDR_B_net_net_2\, Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/DWACT_ADD_CI_0_pog_array_1_1[0]\);
    
    
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/jzzdfrmzwdj[13]\ : 
        DFN1C0
      port map(D => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/N_202_i_0\, 
        CLK => SYSCLK_c, CLR => SYSRSTn_c, Q => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/jzzdfrmzwdj[13]_net_1\);
    
    
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/tpxkpvnpvvn_m_0[3]\ : 
        OR3B
      port map(A => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/frcskdnwvmx_0[8]_net_1\, 
        B => \AB_CM_inst/TR_RAM_DO_B_net_net_4\, C => 
        \AB_CM_inst/EV_DONE_net_0\, Y => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/tpxkpvnpvvn_m_0[3]_net_1\);
    
    
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/cvpkmgjqwzb_0_a2_0_o2\ : 
        NOR2
      port map(A => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/cvpkmgjqwzb_0_a2_0_o2_1_net_1\, 
        B => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/N_500\, 
        Y => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/N_368\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/dbdctxjdvkp_2_sqmuxa_0_a2\ : 
        NOR2A
      port map(A => \AB_CM_inst/EV_RAM_DO_B_net[8]\, B => 
        \AB_CM_inst/Z\\\\EV_RAM_DO_B_net\\\\_0\, Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_239\);
    
    
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/bnrsdrtmtsg[2]\ : 
        DFN1E0C0
      port map(D => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/bnrsdrtmtsg_5[2]_net_1\, 
        CLK => SYSCLK_c, CLR => SYSRSTn_c, E => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/un1_cfxfrwgjccr_9_net_1\, 
        Q => \AB_CM_inst/ASSC_SEQOUT_net_net_2\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/fqkdsnjfpdb_0_0_ADD_18x18_medium_I15_G0N\ : 
        OA1
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/G_158_0_net_1\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_315\, 
        C => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_317\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N276\);
    
    
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/un1_sgbwkmbvtjw_0_a3_0_0\ : 
        OR2A
      port map(A => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/jzzdfrmzwdj_0[14]_net_1\, 
        B => \AB_CM_inst/ASSC_RAM_DO_B_net[8]\, Y => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/un1_sgbwkmbvtjw_0_a3_0_net_1\);
    
    
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/pfkhhxxsrzp[0]\ : 
        DFN1E1C0
      port map(D => \AB_CM_inst/ASSC_RAM_DO_B_net_net_2\, CLK => 
        SYSCLK_c, CLR => SYSRSTn_c, E => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/jzzdfrmzwdj[12]_net_1\, 
        Q => \AB_CM_inst/ADC_MODE_net_net_2\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/fqkdsnjfpdb_0_0_ADD_18x18_medium_I11_G0N\ : 
        OAI1
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/G_138_0_net_1\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_295\, 
        C => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_297\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N264\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ckghxwbsztp[1]\ : 
        DFN1E1C0
      port map(D => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ckghxwbsztp_3[1]\, 
        CLK => SYSCLK_c, CLR => SYSRSTn_c, E => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx[1]_net_1\, 
        Q => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ckghxwbsztp[1]_net_1\);
    
    \Diff2_pad[0]/U0/U0\ : IOPAD_TRI
      port map(D => \Diff2_pad[0]/U0/NET1\, E => 
        \Diff2_pad[0]/U0/NET2\, PAD => Diff2(0));
    
    
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/un1_qgnzcpmbksd_I_30\ : 
        XOR2
      port map(A => \AB_CM_inst/TR_RAM_ADDR_B_net_net_3\, B => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/DWACT_ADD_CI_0_g_array_2[0]\, 
        Y => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/I_30_0\);
    
    \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/G_154\ : 
        XNOR3
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnvtvdkcnpp[8]_net_1\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/gjkdbmpgrtc[14]\, 
        C => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc[14]\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_312\);
    
    \COMP_SM_inst/Diff_3[10]\ : DFN1E1C0
      port map(D => \COMP_SM_inst/Result[10]\, CLK => SYSCLK_c, 
        CLR => SYSRSTn_c, E => 
        \COMP_SM_inst/Latest_Update_3_sqmuxa\, Q => \Diff3_c[10]\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/pvtdpmmqdpp_un2_pbzxzjhqhwz_0_I_3\ : 
        XNOR2
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnvtvdkcnpp[9]_net_1\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rqrqhcwpqdn[9]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/DWACT_BL_EQUAL_0_E_0[2]\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/gjkdbmpgrtc_7_i[0]\ : 
        NOR2B
      port map(A => 
        \AB_CM_inst.AB_CM_smev_wrapper_inst.U0.u_nbnjbfrkqwq.rdgwgtpkbgc[3]\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_446\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_888\);
    
    
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/init_fsm/u_stnpfdkggvx/mwtvnzdkmwm_ns_a2[1]\ : 
        AO1B
      port map(A => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/gpbbjwsprsj[0]\, 
        B => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/gpbbjwsprsj[1]\, 
        C => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/init_fsm/u_stnpfdkggvx/mwtvnzdkmwm[2]_net_1\, 
        Y => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/init_fsm/u_stnpfdkggvx/N_45\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/fqkdsnjfpdb_0_0_ADD_18x18_medium_I22_Y\ : 
        AO18
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_298\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N264\, 
        C => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_302\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N288\);
    
    \Diff3_pad[11]/U0/U0\ : IOPAD_TRI
      port map(D => \Diff3_pad[11]/U0/NET1\, E => 
        \Diff3_pad[11]/U0/NET2\, PAD => Diff3(11));
    
    
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/frcskdnwvmx[0]\ : 
        DFN1C0
      port map(D => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/frcskdnwvmx_ns_i[11]_net_1\, 
        CLK => SYSCLK_c, CLR => SYSRSTn_c, Q => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/frcskdnwvmx[0]_net_1\);
    
    \COMP_SM_inst/valid_8_0_0_a4_1_1\ : NOR3A
      port map(A => \COMP_SM_inst/prev_channel[2]_net_1\, B => 
        \COMP_SM_inst/prev_channel[4]_net_1\, C => 
        \COMP_SM_inst/prev_channel[1]_net_1\, Y => 
        \COMP_SM_inst/valid_8_0_0_a4_1_1_net_1\);
    
    \Diff3_pad[0]/U0/U0\ : IOPAD_TRI
      port map(D => \Diff3_pad[0]/U0/NET1\, E => 
        \Diff3_pad[0]/U0/NET2\, PAD => Diff3(0));
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/fqkdsnjfpdb_0_0_ADD_18x18_medium_I7_G0N\ : 
        NOR2B
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_277\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_273\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N252\);
    
    
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/frcskdnwvmx_ns_i_o2[5]\ : 
        NOR2B
      port map(A => \AB_CM_inst/TR_RAM_DO_B_net_net_1_0\, B => 
        \AB_CM_inst/TR_RAM_DO_B_net_0[8]\, Y => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/N_234_i\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/fqkdsnjfpdb_0_0_ADD_18x18_medium_I44_Y\ : 
        OR2B
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N295\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N293\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N311\);
    
    \COMP_SM_inst/pres_state[3]\ : DFN1C0
      port map(D => \COMP_SM_inst/pres_state_ns[1]\, CLK => 
        SYSCLK_c, CLR => \COMP_SM_inst/un2_resetn\, Q => 
        \COMP_SM_inst/pres_state[3]_net_1\);
    
    
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/jfkkdmfhcdn_0_a3[5]\ : 
        NOR2A
      port map(A => \AB_CM_inst/TR_RAM_DO_B_net_net_2\, B => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/frcskdnwvmx_0[0]_net_1\, 
        Y => \AB_CM_inst/TR_RAM_DI_B_net_net_2\);
    
    \New_Measurement_pad/U0/U1\ : IOTRI_OB_EB
      port map(D => New_Measurement_c, E => SOC_VCC_NET, DOUT => 
        \New_Measurement_pad/U0/NET1\, EOUT => 
        \New_Measurement_pad/U0/NET2\);
    
    \COMP_SM_inst/R1[0]\ : DFN1E1C0
      port map(D => \ADC_RESULT[0]\, CLK => SYSCLK_c, CLR => 
        SYSRSTn_c, E => \COMP_SM_inst/pres_state_0[3]_net_1\, Q
         => \COMP_SM_inst/R1[0]_net_1\);
    
    
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/address_gen/u_dxwqxgdccxc/ggfvvjbkdws[6]\ : 
        MX2C
      port map(A => \INIT_ADDR[6]\, B => \INIT_ADDR[5]\, S => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/ggsxvgncrgz[0]\, 
        Y => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/ggfvvjbkdws[6]\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/zbqggxmnpbs_0_iv[3]\ : 
        AO1C
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/fqkdsnjfpdb_i[9]\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx[5]_net_1\, 
        C => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/zbqggxmnpbs_0_iv_0[3]_net_1\, 
        Y => \AB_CM_inst/EV_RAM_DI_B_net_net_4\);
    
    \COMP_SM_inst/R1[4]\ : DFN1E1C0
      port map(D => \ADC_RESULT[4]\, CLK => SYSCLK_c, CLR => 
        SYSRSTn_c, E => \COMP_SM_inst/pres_state_0[3]_net_1\, Q
         => \COMP_SM_inst/R1[4]_net_1\);
    
    
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/frcskdnwvmx_ns_a3[0]\ : 
        OR3A
      port map(A => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/frcskdnwvmx_ns_a3_4[0]_net_1\, 
        B => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/N_287\, 
        C => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/frcskdnwvmx[10]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/N_269_i\);
    
    \Latest_Update_pad[2]/U0/U0\ : IOPAD_TRI
      port map(D => \Latest_Update_pad[2]/U0/NET1\, E => 
        \Latest_Update_pad[2]/U0/NET2\, PAD => Latest_Update(2));
    
    
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/rjhhzsggrtr[5]\ : 
        DFN1E1C0
      port map(D => \AB_CM_inst/TR_RAM_DO_B_net_net_2\, CLK => 
        SYSCLK_c, CLR => SYSRSTn_c, E => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/frcskdnwvmx[4]_net_1\, 
        Q => \AB_CM_inst/TR_EV_ADDR_net_net_2\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/gjkdbmpgrtc_7_i[2]\ : 
        NOR2B
      port map(A => 
        \AB_CM_inst.AB_CM_smev_wrapper_inst.U0.u_nbnjbfrkqwq.rdgwgtpkbgc[3]\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_448\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_892\);
    
    \COMP_SM_inst/R2[6]\ : DFN1E1C0
      port map(D => \ADC_RESULT[6]\, CLK => SYSCLK_c, CLR => 
        SYSRSTn_c, E => \COMP_SM_inst/pres_state[2]_net_1\, Q => 
        \COMP_SM_inst/R2[6]_net_1\);
    
    
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/init_fsm/u_stnpfdkggvx/mwtvnzdkmwm_ns[1]\ : 
        AO1B
      port map(A => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/bfcqzvtnrcn\, 
        B => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/init_fsm/u_stnpfdkggvx/mwtvnzdkmwm[7]_net_1\, 
        C => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/init_fsm/u_stnpfdkggvx/N_45\, 
        Y => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/init_fsm/u_stnpfdkggvx/mwtvnzdkmwm_ns[1]_net_1\);
    
    \AB_CM_inst/AV5_PAD\ : IOPAD_A_IN
      port map(PAD => AV5, Y => \AB_CM_inst/AV5_net\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rdgwgtpkbgc_2[1]\ : 
        DFN1E0C0
      port map(D => \AB_CM_inst/EV_RAM_DO_B_net_net_6\, CLK => 
        SYSCLK_c, CLR => SYSRSTn_c, E => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bskrjhjvqpf_1_sqmuxa_0\, 
        Q => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rdgwgtpkbgc_2[1]_net_1\);
    
    \Diff3_pad[1]/U0/U1\ : IOTRI_OB_EB
      port map(D => \Diff3_c[1]\, E => SOC_VCC_NET, DOUT => 
        \Diff3_pad[1]/U0/NET1\, EOUT => \Diff3_pad[1]/U0/NET2\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/pptwzsjcmcz_dhzrwbnrbpw_7_iv[7]\ : 
        AO1B
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_201_i_0\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/I_34\, 
        C => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/dhzrwbnrbpw_7_iv_0[7]\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/dhzrwbnrbpw_7[7]\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/gjkdbmpgrtc_3[14]\ : 
        MX2
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_548\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_550\, 
        S => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rdgwgtpkbgc_2[1]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_452\);
    
    
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/brxxctcvrmh_qgnzcpmbksd_7_iv[0]\ : 
        AO1B
      port map(A => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/N_230_i_0\, 
        B => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/DWACT_ADD_CI_0_partial_sum[0]\, 
        C => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/qgnzcpmbksd_7_iv_0[0]\, 
        Y => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/qgnzcpmbksd_7[0]\);
    
    
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/brxxctcvrmh_qgnzcpmbksd_7_0_iv_0[2]\ : 
        AOI1B
      port map(A => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/N_310\, 
        B => \AB_CM_inst/EV_CHHOLD_net_net_2\, C => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/tpxkpvnpvvn_m_0[2]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/qgnzcpmbksd_7_0_iv_0[2]\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc_9[6]\ : 
        MX2
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnvtvdkcnpp[6]_net_1\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnvtvdkcnpp[7]_net_1\, 
        S => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rdgwgtpkbgc_2[0]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_750\);
    
    \COMP_SM_inst/valid_8_0_0_a4_0_3\ : NOR3A
      port map(A => \COMP_SM_inst/valid_8_0_0_a4_0_1_net_1\, B
         => \ADC_CHNUMBER[0]\, C => \COMP_SM_inst/N_407\, Y => 
        \COMP_SM_inst/valid_8_0_0_a4_0_3_net_1\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bskrjhjvqpf_i_o2\ : 
        OR2A
      port map(A => \AB_CM_inst/EV_RAM_DO_B_net_net_1\, B => 
        \AB_CM_inst/EV_RAM_DO_B_net[8]\, Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_205\);
    
    
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/bnrsdrtmtsg_5_r[3]\ : 
        NOR2B
      port map(A => INIT_DONE, B => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/N_356\, 
        Y => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/bnrsdrtmtsg_5[3]_net_1\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/mkmkbnghgkd[2]\ : 
        MX2
      port map(A => \INIT_ADDR[2]\, B => 
        \AB_CM_inst/TR_EV_ADDR_net_net_5\, S => INIT_DONE, Y => 
        \AB_CM_inst/EV_RAM_ADDR_A_net_net_5\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ftbkrvpxdbp_5[2]\ : 
        MX2
      port map(A => \AB_CM_inst/EV_RAM_DO_B_net_net_2\, B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/fqkdsnjfpdb[2]\, 
        S => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx_0[4]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ftbkrvpxdbp_5[2]_net_1\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/fqkdsnjfpdb_0_0_ADD_18x18_medium_I5_P0N\ : 
        OR3
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_267\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_265\, 
        C => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/G_108_0_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ADD_18x18_medium_I5_P0N\);
    
    
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/trnwxjxxrbp[5]\ : 
        DFN1C0
      port map(D => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/trnwxjxxrbp[5]_net_1\, 
        CLK => SYSCLK_c, CLR => SYSRSTn_c, Q => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/trnwxjxxrbp[5]_net_1\);
    
    
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/ddvbdtxtbpx_i_1\ : 
        NOR2
      port map(A => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/jzzdfrmzwdj[13]_net_1\, 
        B => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/N_267\, 
        Y => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/N_232_1\);
    
    \COMP_SM_inst/Diff_0[9]\ : DFN1E1C0
      port map(D => \COMP_SM_inst/Result[9]\, CLK => SYSCLK_c, 
        CLR => SYSRSTn_c, E => 
        \COMP_SM_inst/Latest_Update_0_sqmuxa\, Q => \Diff0_c[9]\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rqrqhcwpqdn_5_0[3]\ : 
        MX2
      port map(A => \AB_CM_inst/ASSC_RAM_DO_A_net_net_4\, B => 
        \AB_CM_inst/EV_RAM_DO_B_net_net_4\, S => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/un1_xkwrgrspmcf_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_817\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc_11_d[6]\ : 
        MX2C
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnvtvdkcnpp[6]_net_1\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc_11_d_d[6]_net_1\, 
        S => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc_11_d_s[4]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc_11_d[6]_net_1\);
    
    \COMP_SM_inst/valid_8_0_0_a2_3_0\ : OR2A
      port map(A => \COMP_SM_inst/prev_channel[4]_net_1\, B => 
        \COMP_SM_inst/prev_channel[1]_net_1\, Y => 
        \COMP_SM_inst/valid_8_0_0_a2_3_0_net_1\);
    
    \Diff3_pad[4]/U0/U0\ : IOPAD_TRI
      port map(D => \Diff3_pad[4]/U0/NET1\, E => 
        \Diff3_pad[4]/U0/NET2\, PAD => Diff3(4));
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx_0[4]\ : 
        DFN1C0
      port map(D => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx_ns_i[13]_net_1\, 
        CLK => SYSCLK_c, CLR => SYSRSTn_c, Q => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx_0[4]_net_1\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/pvtdpmmqdpp_un2_pbzxzjhqhwz_0_I_25\ : 
        AO1C
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnvtvdkcnpp[10]_net_1\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rqrqhcwpqdn[10]_net_1\, 
        C => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_31\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_36\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc_11_d_d[3]\ : 
        MX2
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnvtvdkcnpp[1]_net_1\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ftbkrvpxdbp[3]_net_1\, 
        S => 
        \AB_CM_inst.AB_CM_smev_wrapper_inst.U0.u_nbnjbfrkqwq.rdgwgtpkbgc[3]\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc_11_d_d[3]_net_1\);
    
    
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/jzzdfrmzwdj_ns_i_0[13]\ : 
        OA1A
      port map(A => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/un6_bdbpcvshhqt_1_net_1\, 
        B => \AB_CM_inst/EV_DONE_net_0\, C => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/N_248\, 
        Y => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/jzzdfrmzwdj_ns_i_0[13]_net_1\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/fqkdsnjfpdb_0_0_ADD_18x18_medium_I65_un1_Y\ : 
        AO1C
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/I59_un1_Y\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N310\, 
        C => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N322\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/I65_un1_Y\);
    
    \Diff0_pad[4]/U0/U0\ : IOPAD_TRI
      port map(D => \Diff0_pad[4]/U0/NET1\, E => 
        \Diff0_pad[4]/U0/NET2\, PAD => Diff0(4));
    
    
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/valid_client/u_gpbdjfttbjd/fpppnnsbksx_0_a3[0]\ : 
        OR2B
      port map(A => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/N_1839\, 
        B => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/npgnwznthhx\, 
        Y => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/valid_client/u_gpbdjfttbjd/N_18\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/gjkdbmpgrtc_12[2]\ : 
        MX2
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_892\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_949\, 
        S => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rdgwgtpkbgc_1[2]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/gjkdbmpgrtc[2]\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/gjkdbmpgrtc_11[11]\ : 
        MX2
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_453\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rqrqhcwpqdn[5]_net_1\, 
        S => 
        \AB_CM_inst.AB_CM_smev_wrapper_inst.U0.u_nbnjbfrkqwq.rdgwgtpkbgc[3]\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_585\);
    
    \Diff3_pad[3]/U0/U1\ : IOTRI_OB_EB
      port map(D => \Diff3_c[3]\, E => SOC_VCC_NET, DOUT => 
        \Diff3_pad[3]/U0/NET1\, EOUT => \Diff3_pad[3]/U0/NET2\);
    
    
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/frcskdnwvmx_ns_i[5]\ : 
        NOR3A
      port map(A => INIT_DONE, B => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/N_274\, 
        C => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/N_273\, 
        Y => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/frcskdnwvmx_ns_i[5]_net_1\);
    
    \Diff0_pad[7]/U0/U1\ : IOTRI_OB_EB
      port map(D => \Diff0_c[7]\, E => SOC_VCC_NET, DOUT => 
        \Diff0_pad[7]/U0/NET1\, EOUT => \Diff0_pad[7]/U0/NET2\);
    
    
        \COMP_SM_inst/Subtract_inst/sumAux_0_0_SUB_12x12_medium_area_I47_un1_Y_0\ : 
        NOR2B
      port map(A => \COMP_SM_inst/Subtract_inst/N197\, B => 
        \COMP_SM_inst/Subtract_inst/N164\, Y => 
        \COMP_SM_inst/Subtract_inst/SUB_12x12_medium_area_I47_un1_Y_0\);
    
    
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/hdxtpkktfvz_0_o3_0\ : 
        XAI1
      port map(A => \AB_CM_inst/Z\\\\ASSC_RAM_DO_B_net\\\\\, B
         => \AB_CM_inst/ASSC_RAM_DO_B_net_net_1\, C => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/N_254_i_0\, 
        Y => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/N_262\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc_7[1]\ : 
        MX2
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_643\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_651\, 
        S => 
        \AB_CM_inst.AB_CM_smev_wrapper_inst.U0.u_nbnjbfrkqwq.rdgwgtpkbgc[3]\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_711\);
    
    
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/user_control/u_ffppvfwnggt/srdtcqsfmmm_i[0]\ : 
        NOR3B
      port map(A => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/user_control/u_ffppvfwnggt/un1_wxqqqsndpvg_i_0_0\, 
        B => \INIT_ADDR[0]\, C => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/ggsxvgncrgz[0]\, 
        Y => \NVM_CM_inst/srdtcqsfmmm_i[0]\);
    
    
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/address_gen/u_dxwqxgdccxc/un1_gnmdxrqrdgs_I_53\ : 
        AND2
      port map(A => \INIT_ADDR[4]\, B => \INIT_ADDR[5]\, Y => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/address_gen/u_dxwqxgdccxc/DWACT_ADD_CI_0_pog_array_1_1[0]\);
    
    
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/frcskdnwvmx[8]\ : 
        DFN1C0
      port map(D => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/frcskdnwvmx_ns_i[3]_net_1\, 
        CLK => SYSCLK_c, CLR => SYSRSTn_c, Q => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/frcskdnwvmx[8]_net_1\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx_ns_a3[14]\ : 
        NOR3A
      port map(A => INIT_DONE, B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_241\, 
        C => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_205\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx_ns[14]\);
    
    \Diff0_pad[11]/U0/U1\ : IOTRI_OB_EB
      port map(D => \Diff0_c[11]\, E => SOC_VCC_NET, DOUT => 
        \Diff0_pad[11]/U0/NET1\, EOUT => \Diff0_pad[11]/U0/NET2\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/spbznmtdmpd\ : 
        DFN1E1C0
      port map(D => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/un2_pbzxzjhqhwz\, 
        CLK => SYSCLK_c, CLR => SYSRSTn_c, E => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/dbdctxjdvkp_2_sqmuxa\, 
        Q => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/spbznmtdmpd_net_1\);
    
    
        \COMP_SM_inst/Subtract_inst/sumAux_0_0_SUB_12x12_medium_area_I30_Y\ : 
        AO13
      port map(A => \COMP_SM_inst/R1[4]_net_1\, B => 
        \COMP_SM_inst/Subtract_inst/N146\, C => 
        \COMP_SM_inst/R2[4]_net_1\, Y => 
        \COMP_SM_inst/Subtract_inst/N206\);
    
    \COMP_SM_inst/Diff_0[4]\ : DFN1E1C0
      port map(D => \COMP_SM_inst/Result[4]\, CLK => SYSCLK_c, 
        CLR => SYSRSTn_c, E => 
        \COMP_SM_inst/Latest_Update_0_sqmuxa\, Q => \Diff0_c[4]\);
    
    \COMP_SM_inst/Diff_1[0]\ : DFN1E1C0
      port map(D => \COMP_SM_inst/N139\, CLK => SYSCLK_c, CLR => 
        SYSRSTn_c, E => \COMP_SM_inst/Latest_Update_1_sqmuxa\, Q
         => \Diff1_c[0]\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc_3[9]\ : 
        MX2
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_747\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_749\, 
        S => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rdgwgtpkbgc_1[1]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_651\);
    
    \COMP_SM_inst/Diff_5[11]\ : DFN1E1C0
      port map(D => \COMP_SM_inst/Result[11]\, CLK => SYSCLK_c, 
        CLR => SYSRSTn_c, E => 
        \COMP_SM_inst/Latest_Update_5_sqmuxa\, Q => \Diff5_c[11]\);
    
    
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/valid_client/u_gpbdjfttbjd/fpppnnsbksx_0_a3_0_0[3]\ : 
        NOR2B
      port map(A => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/gpbbjwsprsj[1]\, 
        B => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/gpbbjwsprsj[0]\, 
        Y => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/valid_client/u_gpbdjfttbjd/fpppnnsbksx_0_a3_0_0[3]_net_1\);
    
    
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/xgnmbzmtzbb_0\ : 
        NOR2
      port map(A => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/frcskdnwvmx[1]_net_1\, 
        B => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/frcskdnwvmx_0[0]_net_1\, 
        Y => \AB_CM_inst/xgnmbzmtzbb_0\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/gjkdbmpgrtc_9[1]\ : 
        MX2
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rqrqhcwpqdn[1]_net_1\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rqrqhcwpqdn[2]_net_1\, 
        S => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rdgwgtpkbgc_0[0]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_541\);
    
    
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/pfkhhxxsrzp[2]\ : 
        DFN1E1C0
      port map(D => \AB_CM_inst/Z\\\\ASSC_RAM_DO_B_net\\\\\, CLK
         => SYSCLK_c, CLR => SYSRSTn_c, E => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/jzzdfrmzwdj[12]_net_1\, 
        Q => \AB_CM_inst/Z\\\\ADC_MODE_net\\\\\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/gjkdbmpgrtc_3[13]\ : 
        MX2
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_547\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_549\, 
        S => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rdgwgtpkbgc[1]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_451\);
    
    \Diff4_pad[2]/U0/U0\ : IOPAD_TRI
      port map(D => \Diff4_pad[2]/U0/NET1\, E => 
        \Diff4_pad[2]/U0/NET2\, PAD => Diff4(2));
    
    
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/frcskdnwvmx_ns_i[9]\ : 
        NOR2B
      port map(A => INIT_DONE, B => \AB_CM_inst/TR_EV_RD_net\, Y
         => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/frcskdnwvmx_ns_i[9]_net_1\);
    
    \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/G_89_0\ : 
        XOR2
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ftbkrvpxdbp[1]_net_1\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ftbkrvpxdbp[0]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/G_89_0_net_1\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/gjkdbmpgrtc_9[5]\ : 
        MX2
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rqrqhcwpqdn[5]_net_1\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rqrqhcwpqdn[6]_net_1\, 
        S => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rdgwgtpkbgc_0[0]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_545\);
    
    
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/un1_qgnzcpmbksd_I_35\ : 
        XOR2
      port map(A => \AB_CM_inst/TR_RAM_ADDR_B_net_net_5\, B => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/DWACT_ADD_CI_0_g_array_1[0]\, 
        Y => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/I_35_0\);
    
    
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/jzzdfrmzwdj_ns_1[0]\ : 
        OR2
      port map(A => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/jzzdfrmzwdj_ns_1_0[0]_net_1\, 
        B => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/bksnhfwfshc_6_sqmuxa\, 
        Y => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/jzzdfrmzwdj_ns[0]\);
    
    
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/address_gen/u_dxwqxgdccxc/jvbvzqvvxpc_gnmdxrqrdgs_3[5]\ : 
        XA1B
      port map(A => \INIT_ADDR[5]\, B => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/address_gen/u_dxwqxgdccxc/DWACT_ADD_CI_0_g_array_12_1[0]\, 
        C => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/wtjtwqjkqbd\, 
        Y => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/address_gen/u_dxwqxgdccxc/gnmdxrqrdgs_3[5]\);
    
    
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/ddvbdtxtbpx_i_o3_0\ : 
        OR2A
      port map(A => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/jzzdfrmzwdj_i[10]\, 
        B => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/jzzdfrmzwdj[11]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/N_267\);
    
    
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/user_control/u_ffppvfwnggt/cpqqthwwhvc_0_0_a2_2[4]\ : 
        OR2
      port map(A => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/vvpkfmmpprk[1]\, 
        B => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/user_control/u_ffppvfwnggt/N_2334\, 
        Y => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/N_2357\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx[17]\ : 
        DFN1P0
      port map(D => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx_ns[0]_net_1\, 
        CLK => SYSCLK_c, PRE => SYSRSTn_c, Q => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx[17]_net_1\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/gjkdbmpgrtc_11[16]\ : 
        NOR2B
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rqrqhcwpqdn[10]_net_1\, 
        B => 
        \AB_CM_inst.AB_CM_smev_wrapper_inst.U0.u_nbnjbfrkqwq.rdgwgtpkbgc[3]\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_590\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/mkmkbnghgkd[0]\ : 
        MX2
      port map(A => \INIT_ADDR[0]\, B => 
        \AB_CM_inst/TR_EV_ADDR_net_net_7\, S => INIT_DONE, Y => 
        \AB_CM_inst/EV_RAM_ADDR_A_net_net_7\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/fqkdsnjfpdb_0_0_ADD_18x18_medium_I57_un1_Y\ : 
        NOR2B
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N312\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N309\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/I57_un1_Y\);
    
    
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/user_control/u_ffppvfwnggt/srdtcqsfmmm_i[2]\ : 
        NOR2A
      port map(A => \NVM_CM_inst/un1_wxqqqsndpvg_i_0\, B => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/ggfvvjbkdws[2]\, 
        Y => \NVM_CM_inst/srdtcqsfmmm_i[2]\);
    
    \AB_CM_inst/AV2_PAD\ : IOPAD_A_IN
      port map(PAD => AV2, Y => \AB_CM_inst/AV2_net\);
    
    \COMP_SM_inst/R1[10]\ : DFN1E1C0
      port map(D => \ADC_RESULT[10]\, CLK => SYSCLK_c, CLR => 
        SYSRSTn_c, E => \COMP_SM_inst/pres_state[3]_net_1\, Q => 
        \COMP_SM_inst/R1[10]_net_1\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx_ns_i[8]\ : 
        NOR2B
      port map(A => INIT_DONE, B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx[10]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx_ns_i[8]_net_1\);
    
    
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/valid_client/u_gpbdjfttbjd/fpppnnsbksx_0_a3[3]\ : 
        OR3C
      port map(A => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/npgnwznthhx\, 
        B => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/vvpkfmmpprk[0]\, 
        C => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/vvpkfmmpprk[1]\, 
        Y => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/valid_client/u_gpbdjfttbjd/N_24\);
    
    
        \COMP_SM_inst/Subtract_inst/sumAux_0_0_SUB_12x12_medium_area_I19_CO1\ : 
        NOR2A
      port map(A => \COMP_SM_inst/R1[7]_net_1\, B => 
        \COMP_SM_inst/R2[7]_net_1\, Y => 
        \COMP_SM_inst/Subtract_inst/N154\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rqrqhcwpqdn_5_sn_m1\ : 
        OR2
      port map(A => \AB_CM_inst/EV_ASSCADDR_net_net_5\, B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/un1_xkwrgrspmcf_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_823\);
    
    
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/dttrrgvsnmg_iv_1\ : 
        NOR3C
      port map(A => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/vmpskspphnb_m_net_1\, 
        B => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/qxzrwpjhcww_m[0]\, 
        C => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/vgdscntczht_m_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/dttrrgvsnmg_iv_1_net_1\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/pvtdpmmqdpp_un2_pbzxzjhqhwz_0_I_45\ : 
        AOI1A
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ACT_LT3_E[0]\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ACT_LT3_E[1]\, 
        C => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ACT_LT3_E[2]\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ACT_LT3_E[3]\);
    
    
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/jzzdfrmzwdj_ns_i_1[6]\ : 
        NOR2A
      port map(A => INIT_DONE, B => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/jzzdfrmzwdj_i[10]\, 
        Y => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/jzzdfrmzwdj_ns_i_1[6]_net_1\);
    
    
        \COMP_SM_inst/Subtract_inst/sumAux_0_0_SUB_12x12_medium_area_I63_Y\ : 
        AO18
      port map(A => \COMP_SM_inst/R1[7]_net_1\, B => 
        \COMP_SM_inst/R2[7]_net_1\, C => 
        \COMP_SM_inst/Subtract_inst/N200\, Y => 
        \COMP_SM_inst/Subtract_inst/N216_i\);
    
    
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/save_fsm/u_wbsfnwwctpn/crpwsdfhcqq[7]\ : 
        DFN1C0
      port map(D => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/save_fsm/u_wbsfnwwctpn/crpwsdfhcqq_ns_a3[1]_net_1\, 
        CLK => SYSCLK_c, CLR => SYSRSTn_c, Q => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/save_fsm/u_wbsfnwwctpn/crpwsdfhcqq[7]_net_1\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx[7]\ : 
        DFN1C0
      port map(D => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx_ns[10]\, 
        CLK => SYSCLK_c, CLR => SYSRSTn_c, Q => 
        \AB_CM_inst/EV_ASSCADDR_net_net_5\);
    
    
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/rjhhzsggrtr[8]\ : 
        DFN1E1C0
      port map(D => \AB_CM_inst/TR_RAM_DO_B_net[8]\, CLK => 
        SYSCLK_c, CLR => SYSRSTn_c, E => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/frcskdnwvmx[4]_net_1\, 
        Q => \AB_CM_inst/TR_EV_ADDR_net[8]\);
    
    
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/address_gen/u_dxwqxgdccxc/gnmdxrqrdgs[2]\ : 
        DFN1C0
      port map(D => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/address_gen/u_dxwqxgdccxc/gnmdxrqrdgs_3[2]\, 
        CLK => SYSCLK_c, CLR => SYSRSTn_c, Q => \INIT_ADDR[2]\);
    
    
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/user_control/u_ffppvfwnggt/srdtcqsfmmm_i[3]\ : 
        NOR2A
      port map(A => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/user_control/u_ffppvfwnggt/un1_wxqqqsndpvg_i_0_0\, 
        B => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/ggfvvjbkdws[3]\, 
        Y => \NVM_CM_inst/srdtcqsfmmm_i[3]\);
    
    
        \COMP_SM_inst/Subtract_inst/sumAux_0_0_SUB_12x12_medium_area_I27_Y\ : 
        XA1A
      port map(A => \COMP_SM_inst/R1[8]_net_1\, B => 
        \COMP_SM_inst/R2[8]_net_1\, C => 
        \COMP_SM_inst/Subtract_inst/N153\, Y => 
        \COMP_SM_inst/Subtract_inst/N197\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/fqkdsnjfpdb_0_0_ADD_18x18_medium_I107_Y_0\ : 
        AX1B
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/G_158_0_net_1\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_315\, 
        C => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_317\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ADD_18x18_medium_I107_Y_0\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnvtvdkcnpp_5[8]\ : 
        MX2C
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnvtvdkcnpp[8]_net_1\, 
        B => \AB_CM_inst/EV_RAM_DO_B_net[8]\, S => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/un3_qvqqfftqsfc_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnvtvdkcnpp_5[8]_net_1\);
    
    \COMP_SM_inst/Latest_Update_9_0[2]\ : AO1
      port map(A => \ADC_CHNUMBER[2]\, B => \ADC_CHNUMBER[3]\, C
         => \ADC_CHNUMBER[4]\, Y => 
        \COMP_SM_inst/Latest_Update_9[2]\);
    
    
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/zwtzpwdfptq_un6_kftxkzdmgnn\ : 
        OR3B
      port map(A => INIT_DONE, B => 
        \AB_CM_inst/bskrjhjvqpf_1_sqmuxa\, C => 
        \AB_CM_inst/EV_ASSCADDR_net_net_5\, Y => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/un1_AB_CM_assc_wrapper_inst\);
    
    
        \COMP_SM_inst/Subtract_inst/sumAux_0_0_SUB_12x12_medium_area_I31_Y\ : 
        NOR2B
      port map(A => \COMP_SM_inst/Subtract_inst/N147\, B => 
        \COMP_SM_inst/Subtract_inst/N145\, Y => 
        \COMP_SM_inst/Subtract_inst/N207\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/gjkdbmpgrtc_7[8]\ : 
        MX2
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_446\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_968\, 
        S => 
        \AB_CM_inst.AB_CM_smev_wrapper_inst.U0.u_nbnjbfrkqwq.rdgwgtpkbgc[3]\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_514\);
    
    
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/ksbhwjctscp[5]\ : 
        MX2
      port map(A => \INIT_ADDR[5]\, B => 
        \AB_CM_inst/EV_ASSCADDR_net_net_2\, S => INIT_DONE, Y => 
        \AB_CM_inst/ASSC_RAM_ADDR_A_net_net_2\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx_ns_a3_1[16]\ : 
        NOR2B
      port map(A => \AB_CM_inst/EV_RAM_DO_B_net[8]\, B => 
        \AB_CM_inst/Z\\\\EV_RAM_DO_B_net\\\\\, Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx_ns_1[16]\);
    
    
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/jzzdfrmzwdj_ns_i_1[7]\ : 
        NOR2B
      port map(A => INIT_DONE, B => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/jzzdfrmzwdj[9]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/jzzdfrmzwdj_ns_i_1[7]_net_1\);
    
    
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/address_gen/u_dxwqxgdccxc/jvbvzqvvxpc_un10_gnmdxrqrdgs_5\ : 
        XOR2
      port map(A => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/bdhvhfjwtxd_i_0[5]\, 
        B => \INIT_ADDR[5]\, Y => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/address_gen/u_dxwqxgdccxc/un10_gnmdxrqrdgs_5\);
    
    \Diff2_pad[3]/U0/U1\ : IOTRI_OB_EB
      port map(D => \Diff2_c[3]\, E => SOC_VCC_NET, DOUT => 
        \Diff2_pad[3]/U0/NET1\, EOUT => \Diff2_pad[3]/U0/NET2\);
    
    
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/qgnzcpmbksd[7]\ : 
        DFN1C0
      port map(D => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/qgnzcpmbksd_7[7]\, 
        CLK => SYSCLK_c, CLR => SYSRSTn_c, Q => 
        \AB_CM_inst/Z\\\\TR_RAM_ADDR_B_net\\\\\);
    
    
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/frcskdnwvmx[2]\ : 
        DFN1C0
      port map(D => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/frcskdnwvmx_ns_i[9]_net_1\, 
        CLK => SYSCLK_c, CLR => SYSRSTn_c, Q => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/frcskdnwvmx[2]_net_1\);
    
    
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/jfkkdmfhcdn[0]\ : 
        NOR2A
      port map(A => \AB_CM_inst/TR_RAM_DO_B_net_net_7\, B => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/frcskdnwvmx[0]_net_1\, 
        Y => \AB_CM_inst/TR_RAM_DI_B_net_net_7\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/gjkdbmpgrtc_3_0_a2[16]\ : 
        NOR2A
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_550\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rdgwgtpkbgc_1[1]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_968\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc_7[7]\ : 
        MX2
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_649\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_657\, 
        S => 
        \AB_CM_inst.AB_CM_smev_wrapper_inst.U0.u_nbnjbfrkqwq.rdgwgtpkbgc[3]\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_717\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc_12[9]\ : 
        MX2
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_719\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_787\, 
        S => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rdgwgtpkbgc_2[2]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc[9]\);
    
    \Diff0_pad[8]/U0/U0\ : IOPAD_TRI
      port map(D => \Diff0_pad[8]/U0/NET1\, E => 
        \Diff0_pad[8]/U0/NET2\, PAD => Diff0(8));
    
    
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/cpwfrthtnfr_9_sqmuxa_0_o2\ : 
        OR2A
      port map(A => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/frcskdnwvmx[6]_net_1\, 
        B => \AB_CM_inst/Z\\\\TR_RAM_DO_B_net\\\\\, Y => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/N_235\);
    
    
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/qxzrwpjhcww_m_0[0]\ : 
        OR2B
      port map(A => \AB_CM_inst/EV_RAM_DO_A_net_net_7\, B => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/frcskdnwvmx[2]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/qxzrwpjhcww_m[0]\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/qrbxknbdvjj_m[8]\ : 
        OR3B
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx[8]_net_1\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/qrbxknbdvjj[8]_net_1\, 
        C => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rgmpzqrbghh_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/qrbxknbdvjj_m[8]_net_1\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/pptwzsjcmcz_dhzrwbnrbpw_7_iv[5]\ : 
        OR3C
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/jrgzmrqhbkv_m[5]_net_1\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/dhzrwbnrbpw_7_iv_0[5]\, 
        C => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/un1_dhzrwbnrbpw_m[6]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/dhzrwbnrbpw_7[5]\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/pvtdpmmqdpp_un2_pbzxzjhqhwz_0_I_23\ : 
        AO1C
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnvtvdkcnpp[9]_net_1\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rqrqhcwpqdn[9]_net_1\, 
        C => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_28\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_34\);
    
    
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/zzzxtvvjqhf\ : 
        DFN1E1C0
      port map(D => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/frcskdnwvmx_ns_i[1]_net_1\, 
        CLK => SYSCLK_c, CLR => SYSRSTn_c, E => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/un1_frcskdnwvmx_3\, 
        Q => \AB_CM_inst/TR_TRFLAG_net\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bskrjhjvqpf_5_sqmuxa_0_a2\ : 
        OR2A
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx[12]_net_1\, 
        B => \AB_CM_inst/EV_RAM_DO_B_net_net_1\, Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_237\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bskrjhjvqpf_1_sqmuxa_0_a2\ : 
        OR2B
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_240\, 
        B => \AB_CM_inst/Z\\\\EV_RAM_DO_B_net\\\\_0\, Y => 
        \AB_CM_inst/bskrjhjvqpf_1_sqmuxa\);
    
    
        \COMP_SM_inst/Subtract_inst/sumAux_0_0_SUB_12x12_medium_area_I14_S\ : 
        XNOR2
      port map(A => \COMP_SM_inst/R2[2]_net_1\, B => 
        \COMP_SM_inst/R1[2]_net_1\, Y => 
        \COMP_SM_inst/Subtract_inst/N143\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rgmpzqrbghh_0\ : 
        DFN1C0
      port map(D => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/hmzcpnxsdwg_net_1\, 
        CLK => SYSCLK_c, CLR => SYSRSTn_c, Q => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rgmpzqrbghh_0_net_1\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/un3_qvqqfftqsfc\ : 
        AO1C
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_237\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx_ns_1[16]\, 
        C => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/un1_qvqqfftqsfc_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/un3_qvqqfftqsfc_net_1\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rgmpzqrbghh\ : 
        DFN1C0
      port map(D => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/hmzcpnxsdwg_net_1\, 
        CLK => SYSCLK_c, CLR => SYSRSTn_c, Q => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rgmpzqrbghh_net_1\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ckghxwbsztp_m[1]\ : 
        OR2B
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx[0]_net_1\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ckghxwbsztp[1]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ckghxwbsztp_m[1]_net_1\);
    
    \COMP_SM_inst/Latest_Update[2]\ : DFN1E1P0
      port map(D => \COMP_SM_inst/Latest_Update_9[2]\, CLK => 
        SYSCLK_c, PRE => SYSRSTn_c, E => \COMP_SM_inst/N_364\, Q
         => \Latest_Update_c[2]\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/gjkdbmpgrtc_3_0_a3[3]\ : 
        NOR3C
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rdgwgtpkbgc[0]_net_1\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rqrqhcwpqdn[0]_net_1\, 
        C => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rdgwgtpkbgc_1[1]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_938\);
    
    
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/jzzdfrmzwdj[5]\ : 
        DFN1C0
      port map(D => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/jzzdfrmzwdj_ns_i_1[10]_net_1\, 
        CLK => SYSCLK_c, CLR => SYSRSTn_c, Q => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/jzzdfrmzwdj[5]_net_1\);
    
    \Diff4_pad[9]/U0/U0\ : IOPAD_TRI
      port map(D => \Diff4_pad[9]/U0/NET1\, E => 
        \Diff4_pad[9]/U0/NET2\, PAD => Diff4(9));
    
    \COMP_SM_inst/Diff_4[11]\ : DFN1E1C0
      port map(D => \COMP_SM_inst/Result[11]\, CLK => SYSCLK_c, 
        CLR => SYSRSTn_c, E => 
        \COMP_SM_inst/Latest_Update_4_sqmuxa\, Q => \Diff4_c[11]\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ckghxwbsztp[4]\ : 
        DFN1E1C0
      port map(D => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ckghxwbsztp_3[4]\, 
        CLK => SYSCLK_c, CLR => SYSRSTn_c, E => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx[1]_net_1\, 
        Q => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ckghxwbsztp[4]_net_1\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc_12[4]\ : 
        MX2
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc_12_d_0[4]_net_1\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc_11[4]_net_1\, 
        S => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rdgwgtpkbgc_0[2]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc_12[4]_net_1\);
    
    
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/address_gen/u_dxwqxgdccxc/un1_gnmdxrqrdgs_I_1\ : 
        AND2
      port map(A => \INIT_ADDR[0]\, B => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/qdgqbvgcnzn\, 
        Y => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/address_gen/u_dxwqxgdccxc/DWACT_ADD_CI_0_TMP[0]\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/pvtdpmmqdpp_un2_pbzxzjhqhwz_0_I_35\ : 
        XNOR2
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnvtvdkcnpp[5]_net_1\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rqrqhcwpqdn[5]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/DWACT_BL_EQUAL_0_E[1]\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc_11[16]\ : 
        NOR2B
      port map(A => 
        \AB_CM_inst.AB_CM_smev_wrapper_inst.U0.u_nbnjbfrkqwq.rdgwgtpkbgc[3]\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnvtvdkcnpp[10]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_794\);
    
    
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/address_gen/u_dxwqxgdccxc/gnmdxrqrdgs[5]\ : 
        DFN1C0
      port map(D => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/address_gen/u_dxwqxgdccxc/gnmdxrqrdgs_3[5]\, 
        CLK => SYSCLK_c, CLR => SYSRSTn_c, Q => \INIT_ADDR[5]\);
    
    \COMP_SM_inst/Diff_4[4]\ : DFN1E1C0
      port map(D => \COMP_SM_inst/Result[4]\, CLK => SYSCLK_c, 
        CLR => SYSRSTn_c, E => 
        \COMP_SM_inst/Latest_Update_4_sqmuxa\, Q => \Diff4_c[4]\);
    
    \COMP_SM_inst/valid_8_0_0_a2_0\ : OR2
      port map(A => \COMP_SM_inst/prev_channel[0]_net_1\, B => 
        \COMP_SM_inst/N_421_2\, Y => \COMP_SM_inst/N_410\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rqrqhcwpqdn[0]\ : 
        DFN1E1C0
      port map(D => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_814\, 
        CLK => SYSCLK_c, CLR => SYSRSTn_c, E => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_823\, 
        Q => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rqrqhcwpqdn[0]_net_1\);
    
    \SYSCLK_pad/U0/U0\ : IOPAD_IN
      port map(PAD => SYSCLK, Y => \SYSCLK_pad/U0/NET1\);
    
    
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/brxxctcvrmh_qgnzcpmbksd_7_0_iv[5]\ : 
        AO1B
      port map(A => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/N_230_i_0\, 
        B => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/I_33_0\, 
        C => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/qgnzcpmbksd_7_0_iv_0[5]\, 
        Y => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/qgnzcpmbksd_7[5]\);
    
    
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/bnrsdrtmtsg[1]\ : 
        DFN1E0C0
      port map(D => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/bnrsdrtmtsg_5[1]_net_1\, 
        CLK => SYSCLK_c, CLR => SYSRSTn_c, E => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/un1_cfxfrwgjccr_9_net_1\, 
        Q => \AB_CM_inst/ASSC_SEQOUT_net_net_3\);
    
    \AB_CM_inst/AC1_PAD\ : IOPAD_A_IN
      port map(PAD => AC1, Y => \AB_CM_inst/AC1_net\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/un1_dhzrwbnrbpw_I_30\ : 
        XOR2
      port map(A => \AB_CM_inst/EV_RAM_ADDR_B_net_net_3\, B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/DWACT_ADD_CI_0_g_array_2[0]\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/I_30\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnvtvdkcnpp[0]\ : 
        DFN1C0
      port map(D => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnvtvdkcnpp_9[0]_net_1\, 
        CLK => SYSCLK_c, CLR => SYSRSTn_c, Q => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnvtvdkcnpp[0]_net_1\);
    
    \I_199/U_CLKSRC\ : CLKSRC
      port map(A => hrgmtcpsdzr, Y => INIT_DONE);
    
    \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/G_123\ : 
        AO13
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnvtvdkcnpp[1]_net_1\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/gjkdbmpgrtc[7]\, 
        C => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc[7]\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_278\);
    
    \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/G_103_0\ : 
        OA1A
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc[3]\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ftbkrvpxdbp[3]_net_1\, 
        C => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/gjkdbmpgrtc[3]\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/G_103_0_net_1\);
    
    \Diff1_pad[3]/U0/U0\ : IOPAD_TRI
      port map(D => \Diff1_pad[3]/U0/NET1\, E => 
        \Diff1_pad[3]/U0/NET2\, PAD => Diff1(3));
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/zcjzqnkdqwb_iv\ : 
        MX2C
      port map(A => INIT_EV_WEN, B => \AB_CM_inst/TR_EV_RD_net\, 
        S => INIT_DONE, Y => \AB_CM_inst/EV_RAM_CSN_A_net\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc_12[3]\ : 
        MX2
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_653\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc_12_d[3]_net_1\, 
        S => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc_12_s[4]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc[3]\);
    
    \Diff2_pad[0]/U0/U1\ : IOTRI_OB_EB
      port map(D => \Diff2_c[0]\, E => SOC_VCC_NET, DOUT => 
        \Diff2_pad[0]/U0/NET1\, EOUT => \Diff2_pad[0]/U0/NET2\);
    
    
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/init_fsm/u_stnpfdkggvx/mwtvnzdkmwm_ns_i_a2[7]\ : 
        OR2
      port map(A => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/qdvwjxmzbpf\, 
        B => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/init_fsm/u_stnpfdkggvx/mwtvnzdkmwm[1]_net_1\, 
        Y => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/init_fsm/u_stnpfdkggvx/mwtvnzdkmwm_ns_i_a2[7]_net_1\);
    
    
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/un2_hfnznbmwdbg_1_i_a2\ : 
        OR3C
      port map(A => \AB_CM_inst/TR_RAM_DO_B_net[8]\, B => 
        \AB_CM_inst/TR_RAM_DO_B_net_net_1\, C => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/N_285\, 
        Y => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/N_288\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnvtvdkcnpp[1]\ : 
        DFN1C0
      port map(D => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnvtvdkcnpp_9[1]_net_1\, 
        CLK => SYSCLK_c, CLR => SYSRSTn_c, Q => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnvtvdkcnpp[1]_net_1\);
    
    
        \COMP_SM_inst/Subtract_inst/sumAux_0_0_SUB_12x12_medium_area_I39_Y_0\ : 
        AO18
      port map(A => \COMP_SM_inst/R1[2]_net_1\, B => 
        \COMP_SM_inst/R2[2]_net_1\, C => 
        \COMP_SM_inst/Subtract_inst/N142\, Y => 
        \COMP_SM_inst/Subtract_inst/SUB_12x12_medium_area_I39_Y_0\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/wqpbnjzjqsx_3\ : 
        XNOR2
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rqrqhcwpqdn[4]_net_1\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnvtvdkcnpp[4]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/wqpbnjzjqsx_3_i\);
    
    
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/save_fsm/u_wbsfnwwctpn/crpwsdfhcqq_ns_a3[1]\ : 
        AOI1B
      port map(A => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/vvpkfmmpprk[0]\, 
        B => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/vvpkfmmpprk[1]\, 
        C => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/save_fsm/u_wbsfnwwctpn/crpwsdfhcqq[3]_net_1\, 
        Y => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/save_fsm/u_wbsfnwwctpn/crpwsdfhcqq_ns_a3[1]_net_1\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnvtvdkcnpp_9[3]\ : 
        MX2C
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnvtvdkcnpp_5[3]_net_1\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/fqkdsnjfpdb_i[9]\, 
        S => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx[4]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnvtvdkcnpp_9[3]_net_1\);
    
    
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/rjhhzsggrtr[1]\ : 
        DFN1E1C0
      port map(D => \AB_CM_inst/TR_RAM_DO_B_net_net_6\, CLK => 
        SYSCLK_c, CLR => SYSRSTn_c, E => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/frcskdnwvmx[4]_net_1\, 
        Q => \AB_CM_inst/TR_EV_ADDR_net_net_6\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/pvtdpmmqdpp_un2_pbzxzjhqhwz_0_I_43\ : 
        OR2A
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rqrqhcwpqdn[5]_net_1\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnvtvdkcnpp[5]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ACT_LT3_E[1]\);
    
    
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/valid_client/u_gpbdjfttbjd/fpppnnsbksx_0_a3_0[0]\ : 
        OR2A
      port map(A => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/N_1838\, 
        B => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/npgnwznthhx\, 
        Y => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/valid_client/u_gpbdjfttbjd/N_19\);
    
    \Diff3_pad[0]/U0/U1\ : IOTRI_OB_EB
      port map(D => \Diff3_c[0]\, E => SOC_VCC_NET, DOUT => 
        \Diff3_pad[0]/U0/NET1\, EOUT => \Diff3_pad[0]/U0/NET2\);
    
    \Diff0_pad[3]/U0/U0\ : IOPAD_TRI
      port map(D => \Diff0_pad[3]/U0/NET1\, E => 
        \Diff0_pad[3]/U0/NET2\, PAD => Diff0(3));
    
    \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/G_108_0\ : 
        OA1
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc_12[4]_net_1\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ftbkrvpxdbp[4]_net_1\, 
        C => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/gjkdbmpgrtc[4]\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/G_108_0_net_1\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/fqkdsnjfpdb_0_0_ADD_18x18_medium_I87_un1_Y\ : 
        OAI1
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/G_128_0_net_1\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ADD_18x18_medium_I9_P0N_0\, 
        C => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N349\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ADD_18x18_medium_I87_un1_Y\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rqrqhcwpqdn_5_0[6]\ : 
        MX2
      port map(A => \AB_CM_inst/ASSC_RAM_DO_A_net_net_1\, B => 
        \AB_CM_inst/EV_RAM_DO_B_net_net_1\, S => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/un1_xkwrgrspmcf_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_820\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bskrjhjvqpf_6_sqmuxa_0_a3\ : 
        NOR3B
      port map(A => \AB_CM_inst/EV_RAM_DO_B_net_net_1\, B => 
        \AB_CM_inst/EV_RAM_DO_B_net[8]\, C => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_241\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bskrjhjvqpf_6_sqmuxa\);
    
    
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/un4_wkpfnwqwgcb\ : 
        AO1A
      port map(A => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/wwhrbsjdjpn_net_1\, 
        B => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/wkpfnwqwgcb_net_1\, 
        C => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/jdhgstfqkjm_2_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/un4_wkpfnwqwgcb_net_1\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx_1[4]\ : 
        DFN1C0
      port map(D => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx_ns_i[13]_net_1\, 
        CLK => SYSCLK_c, CLR => SYSRSTn_c, Q => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx_1[4]_net_1\);
    
    \Diff4_pad[3]/U0/U0\ : IOPAD_TRI
      port map(D => \Diff4_pad[3]/U0/NET1\, E => 
        \Diff4_pad[3]/U0/NET2\, PAD => Diff4(3));
    
    
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/frcskdnwvmx_ns_i[1]\ : 
        NOR2A
      port map(A => INIT_DONE, B => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/N_243\, 
        Y => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/frcskdnwvmx_ns_i[1]_net_1\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/fqkdsnjfpdb_0_0_ADD_18x18_medium_I84_un1_Y\ : 
        AO1D
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/I67_un1_Y\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ADD_18x18_medium_I67_Y_1\, 
        C => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N277\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ADD_18x18_medium_I84_un1_Y\);
    
    
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/rjhhzsggrtr[2]\ : 
        DFN1E1C0
      port map(D => \AB_CM_inst/TR_RAM_DO_B_net_net_5\, CLK => 
        SYSCLK_c, CLR => SYSRSTn_c, E => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/frcskdnwvmx[4]_net_1\, 
        Q => \AB_CM_inst/TR_EV_ADDR_net_net_5\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc_11[15]\ : 
        NOR2B
      port map(A => 
        \AB_CM_inst.AB_CM_smev_wrapper_inst.U0.u_nbnjbfrkqwq.rdgwgtpkbgc[3]\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnvtvdkcnpp[9]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_793\);
    
    \COMP_SM_inst/R1[6]\ : DFN1E1C0
      port map(D => \ADC_RESULT[6]\, CLK => SYSCLK_c, CLR => 
        SYSRSTn_c, E => \COMP_SM_inst/pres_state[3]_net_1\, Q => 
        \COMP_SM_inst/R1[6]_net_1\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/fqkdsnjfpdb_0_0_ADD_18x18_medium_I109_Y_1\ : 
        MX2
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnvtvdkcnpp[11]_net_1\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rqrqhcwpqdn[11]_net_1\, 
        S => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/gjkdbmpgrtc75\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ADD_18x18_medium_I109_Y_1\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnvtvdkcnpp[3]\ : 
        DFN1C0
      port map(D => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnvtvdkcnpp_9[3]_net_1\, 
        CLK => SYSCLK_c, CLR => SYSRSTn_c, Q => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnvtvdkcnpp[3]_net_1\);
    
    
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/jdhgstfqkjm_2\ : 
        AND3B
      port map(A => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/wwhrbsjdjpn_net_1\, 
        B => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/un1_bksnhfwfshc_1_sqmuxa\, 
        C => INIT_DONE, Y => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/jdhgstfqkjm_2_net_1\);
    
    
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/jzzdfrmzwdj_ns_i_a3[2]\ : 
        OR2B
      port map(A => INIT_DONE, B => 
        \AB_CM_inst/ASSC_RAM_DO_B_net[8]\, Y => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/N_278\);
    
    
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/dspfgfmqhwh[1]\ : 
        DFN1E1C0
      port map(D => \AB_CM_inst/ASSC_RAM_DO_B_net_net_6\, CLK => 
        SYSCLK_c, CLR => SYSRSTn_c, E => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/un1_AB_CM_inst_2_0\, 
        Q => \ADC_CHNUMBER[1]\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/jrgzmrqhbkv_m[4]\ : 
        OR2B
      port map(A => \AB_CM_inst/EV_RAM_DO_B_net_net_3\, B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_199_i_0\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/jrgzmrqhbkv_m[4]_net_1\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/fqkdsnjfpdb_0_0_ADD_18x18_medium_I95_Y\ : 
        XOR2
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ADD_18x18_medium_I95_Y_0\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N316\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/fqkdsnjfpdb[3]\);
    
    
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/znbkwkbspdc_1_i_a3\ : 
        OA1C
      port map(A => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/N_310\, 
        B => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/N_253\, 
        C => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/znbkwkbspdc_1_i_a3_0_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/N_318\);
    
    \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/G_143\ : 
        AO13
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnvtvdkcnpp[5]_net_1\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/gjkdbmpgrtc[11]\, 
        C => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc[11]\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_298\);
    
    
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/user_control/u_ffppvfwnggt/srdtcqsfmmm_i[13]\ : 
        NOR2A
      port map(A => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/user_control/u_ffppvfwnggt/un1_wxqqqsndpvg_i_0_0\, 
        B => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/bqhrfdzctjc_i_0[13]\, 
        Y => \NVM_CM_inst/srdtcqsfmmm_i[13]\);
    
    
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/bnrsdrtmtsg_5_r[2]\ : 
        NOR2B
      port map(A => INIT_DONE, B => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/N_355\, 
        Y => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/bnrsdrtmtsg_5[2]_net_1\);
    
    
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/un1_cfxfrwgjccr_9\ : 
        NOR2B
      port map(A => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/un1_cfxfrwgjccr_6_net_1\, 
        B => \AB_CM_inst/ktwrhqstzjg\, Y => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/un1_cfxfrwgjccr_9_net_1\);
    
    
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/un1_cfxfrwgjccr_1\ : 
        NOR3A
      port map(A => INIT_DONE, B => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/un1_AB_CM_inst_2_0\, 
        C => ASSC_DONE, Y => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/un1_cfxfrwgjccr_1_net_1\);
    
    \COMP_SM_inst/Diff_4[0]\ : DFN1E1C0
      port map(D => \COMP_SM_inst/N139\, CLK => SYSCLK_c, CLR => 
        SYSRSTn_c, E => \COMP_SM_inst/Latest_Update_4_sqmuxa\, Q
         => \Diff4_c[0]\);
    
    
        \COMP_SM_inst/Subtract_inst/sumAux_0_0_SUB_12x12_medium_area_I21_S\ : 
        XNOR2
      port map(A => \COMP_SM_inst/R2[9]_net_1\, B => 
        \COMP_SM_inst/R1[9]_net_1\, Y => 
        \COMP_SM_inst/Subtract_inst/N157\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/gjkdbmpgrtc_11_0_a3[5]\ : 
        NOR2A
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_447\, 
        B => 
        \AB_CM_inst.AB_CM_smev_wrapper_inst.U0.u_nbnjbfrkqwq.rdgwgtpkbgc[3]\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_952\);
    
    \Diff2_pad[10]/U0/U1\ : IOTRI_OB_EB
      port map(D => \Diff2_c[10]\, E => SOC_VCC_NET, DOUT => 
        \Diff2_pad[10]/U0/NET1\, EOUT => \Diff2_pad[10]/U0/NET2\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/pptwzsjcmcz_dhzrwbnrbpw_7_iv_0[5]\ : 
        AOI1B
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rgmpzqrbghh_0_net_1\, 
        B => \AB_CM_inst/EV_CHHOLD_net[4]\, C => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/qrbxknbdvjj_m[5]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/dhzrwbnrbpw_7_iv_0[5]\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc_11[5]\ : 
        MX2
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_749\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc_11_d[5]_net_1\, 
        S => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc_11_s[4]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc_11[5]_net_1\);
    
    \Diff3_pad[4]/U0/U1\ : IOTRI_OB_EB
      port map(D => \Diff3_c[4]\, E => SOC_VCC_NET, DOUT => 
        \Diff3_pad[4]/U0/NET1\, EOUT => \Diff3_pad[4]/U0/NET2\);
    
    \COMP_SM_inst/Latest_Update[0]\ : DFN1E1P0
      port map(D => \COMP_SM_inst/N_420\, CLK => SYSCLK_c, PRE
         => SYSRSTn_c, E => \COMP_SM_inst/N_364\, Q => 
        \Latest_Update_c[0]\);
    
    
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/user_control/u_ffppvfwnggt/srdtcqsfmmm_i[4]\ : 
        NOR2A
      port map(A => \NVM_CM_inst/un1_wxqqqsndpvg_i_0\, B => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/ggfvvjbkdws[4]\, 
        Y => \NVM_CM_inst/srdtcqsfmmm_i[4]\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/fqkdsnjfpdb_0_0_ADD_18x18_medium_I102_Y_0\ : 
        AX1D
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/G_133_0_net_1\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_290\, 
        C => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_292\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ADD_18x18_medium_I102_Y_0\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ckghxwbsztp_m[3]\ : 
        OR2B
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx[0]_net_1\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ckghxwbsztp[3]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ckghxwbsztp_m[3]_net_1\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc_11[6]\ : 
        MX2B
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_748\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc_11_d[6]_net_1\, 
        S => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc_11_s[6]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc_11[6]_net_1\);
    
    \Diff0_pad[4]/U0/U1\ : IOTRI_OB_EB
      port map(D => \Diff0_c[4]\, E => SOC_VCC_NET, DOUT => 
        \Diff0_pad[4]/U0/NET1\, EOUT => \Diff0_pad[4]/U0/NET2\);
    
    
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/jzzdfrmzwdj_0[12]\ : 
        DFN1C0
      port map(D => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/jzzdfrmzwdj_ns_i_1[3]_net_1\, 
        CLK => SYSCLK_c, CLR => SYSRSTn_c, Q => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/un1_AB_CM_inst_2_0\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/pptwzsjcmcz_dhzrwbnrbpw_7_iv[6]\ : 
        AO1B
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_201_i_0\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/I_38\, 
        C => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/dhzrwbnrbpw_7_iv_0[6]\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/dhzrwbnrbpw_7[6]\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnvtvdkcnpp_9[2]\ : 
        MX2
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnvtvdkcnpp_5[2]_net_1\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/fqkdsnjfpdb[8]\, 
        S => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx[4]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnvtvdkcnpp_9[2]_net_1\);
    
    
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/tpxkpvnpvvn_m_0[1]\ : 
        OR3B
      port map(A => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/frcskdnwvmx_0[8]_net_1\, 
        B => \AB_CM_inst/TR_RAM_DO_B_net_net_6\, C => 
        \AB_CM_inst/EV_DONE_net_0\, Y => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/tpxkpvnpvvn_m_0[1]_net_1\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/un1_dhzrwbnrbpw_I_44\ : 
        NOR2B
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/DWACT_ADD_CI_0_TMP[0]\, 
        B => \AB_CM_inst/EV_RAM_ADDR_B_net_net_6\, Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/DWACT_ADD_CI_0_g_array_1[0]\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/pptwzsjcmcz_dhzrwbnrbpw_7_iv_0[3]\ : 
        AOI1B
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rgmpzqrbghh_0_net_1\, 
        B => \AB_CM_inst/EV_CHHOLD_net_net_1\, C => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/qrbxknbdvjj_m[3]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/dhzrwbnrbpw_7_iv_0[3]\);
    
    
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/frcskdnwvmx_ns_a3[7]\ : 
        NOR2B
      port map(A => INIT_DONE, B => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/cpwfrthtnfr_7_sqmuxa\, 
        Y => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/frcskdnwvmx_ns[7]\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rdgwgtpkbgc_0[1]\ : 
        DFN1E0C0
      port map(D => \AB_CM_inst/EV_RAM_DO_B_net_net_6\, CLK => 
        SYSCLK_c, CLR => SYSRSTn_c, E => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bskrjhjvqpf_1_sqmuxa_0\, 
        Q => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rdgwgtpkbgc_0[1]_net_1\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/gjkdbmpgrtc_11[6]\ : 
        MX2
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_546\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/gjkdbmpgrtc_11_d[6]_net_1\, 
        S => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc_11_s[4]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_580\);
    
    
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/address_gen/u_dxwqxgdccxc/un1_dkjzqmrkvwb_ADD_13x13_fast_I13_un1_Y\ : 
        OR3A
      port map(A => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/address_gen/u_dxwqxgdccxc/N190\, 
        B => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/address_gen/u_dxwqxgdccxc/ggfvvjbkdws[8]_net_1\, 
        C => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/mmsccbknsvn[12]\, 
        Y => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/address_gen/u_dxwqxgdccxc/I13_un1_Y\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/gpjgkmhxbkn_NE_0\ : 
        XA1A
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rqrqhcwpqdn[5]_net_1\, 
        B => \AB_CM_inst/EV_RAM_DO_B_net_net_2\, C => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/gpjgkmhxbkn_3_i\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/gpjgkmhxbkn_NE_0_net_1\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/fqkdsnjfpdb_0_0_ADD_18x18_medium_I108_Y_0\ : 
        XNOR2
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_322\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_318\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ADD_18x18_medium_I108_Y_0\);
    
    \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/G_163\ : 
        AO18
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnvtvdkcnpp[9]_net_1\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc[15]\, 
        C => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/gjkdbmpgrtc[15]\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_318\);
    
    
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/un1_qgnzcpmbksd_I_37\ : 
        AX1C
      port map(A => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/DWACT_ADD_CI_0_g_array_1[0]\, 
        B => \AB_CM_inst/TR_RAM_ADDR_B_net_net_5\, C => 
        \AB_CM_inst/TR_RAM_ADDR_B_net_net_4\, Y => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/I_37_0\);
    
    
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/ptxbvztnpnf[6]\ : 
        DFN1E1C0
      port map(D => \AB_CM_inst/ASSC_RAM_DO_B_net_net_1\, CLK => 
        SYSCLK_c, CLR => SYSRSTn_c, E => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/jzzdfrmzwdj[11]_net_1\, 
        Q => \AB_CM_inst/Z\\\\ADC_STC_net\\\\\);
    
    
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/dspfgfmqhwh[3]\ : 
        DFN1E1C0
      port map(D => \AB_CM_inst/ASSC_RAM_DO_B_net_net_4\, CLK => 
        SYSCLK_c, CLR => SYSRSTn_c, E => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/jzzdfrmzwdj[12]_net_1\, 
        Q => \ADC_CHNUMBER[3]\);
    
    
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/hnbsspwxkpd\ : 
        DFN1E1C0
      port map(D => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/znjtscvsvcs\, 
        CLK => SYSCLK_c, CLR => SYSRSTn_c, E => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/un1_xjrbtnwdszs_0_sqmuxa\, 
        Q => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/hnbsspwxkpd_net_1\);
    
    
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/user_control/u_ffppvfwnggt/cbfkvdxnxdp_i_m2\ : 
        MX2
      port map(A => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/fhpsqkqvwpw\, 
        B => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/dxpbcqjpxtw\, 
        S => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/user_control/u_ffppvfwnggt/un1_wxqqqsndpvg_i_0_0\, 
        Y => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/qdgqbvgcnzn\);
    
    \Diff4_pad[2]/U0/U1\ : IOTRI_OB_EB
      port map(D => \Diff4_c[2]\, E => SOC_VCC_NET, DOUT => 
        \Diff4_pad[2]/U0/NET1\, EOUT => \Diff4_pad[2]/U0/NET2\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/gjkdbmpgrtc_12[15]\ : 
        MX2
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_945\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_589\, 
        S => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rdgwgtpkbgc_2[2]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/gjkdbmpgrtc[15]\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnvtvdkcnpp[2]\ : 
        DFN1C0
      port map(D => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnvtvdkcnpp_9[2]_net_1\, 
        CLK => SYSCLK_c, CLR => SYSRSTn_c, Q => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnvtvdkcnpp[2]_net_1\);
    
    
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/jzzdfrmzwdj[8]\ : 
        DFN1C0
      port map(D => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/jzzdfrmzwdj_ns_i_1[7]_net_1\, 
        CLK => SYSCLK_c, CLR => SYSRSTn_c, Q => 
        \AB_CM_inst/ADC_START_net\);
    
    
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/address_gen/u_dxwqxgdccxc/jvbvzqvvxpc_gnmdxrqrdgs_3[1]\ : 
        XA1B
      port map(A => \INIT_ADDR[1]\, B => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/address_gen/u_dxwqxgdccxc/DWACT_ADD_CI_0_TMP[0]\, 
        C => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/wtjtwqjkqbd\, 
        Y => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/address_gen/u_dxwqxgdccxc/gnmdxrqrdgs_3[1]\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bskrjhjvqpf_i\ : 
        NOR3
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_191_2\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bskrjhjvqpf_i_0_net_1\, 
        C => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_234\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bskrjhjvqpf_i_net_1\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/gjkdbmpgrtc_11_i[14]\ : 
        NOR2B
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rqrqhcwpqdn[8]_net_1\, 
        B => 
        \AB_CM_inst.AB_CM_smev_wrapper_inst.U0.u_nbnjbfrkqwq.rdgwgtpkbgc[3]\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_910\);
    
    
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/jzzdfrmzwdj_ns_i_a3_1[14]\ : 
        OR3B
      port map(A => INIT_DONE, B => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/bksczsjcvgb_net_1\, 
        C => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/jzzdfrmzwdj_0[14]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/N_305\);
    
    
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/jzzdfrmzwdj[12]\ : 
        DFN1C0
      port map(D => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/jzzdfrmzwdj_ns_i_1[3]_net_1\, 
        CLK => SYSCLK_c, CLR => SYSRSTn_c, Q => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/jzzdfrmzwdj[12]_net_1\);
    
    \Diff3_pad[2]/U0/U0\ : IOPAD_TRI
      port map(D => \Diff3_pad[2]/U0/NET1\, E => 
        \Diff3_pad[2]/U0/NET2\, PAD => Diff3(2));
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/fqkdsnjfpdb_0_0_ADD_18x18_medium_I19_Y\ : 
        AOI1A
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_322\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_318\, 
        C => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N277\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N285\);
    
    \AB_CM_inst/AC0_PAD\ : IOPAD_A_IN
      port map(PAD => AC0, Y => \AB_CM_inst/AC0_net\);
    
    
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/jzzdfrmzwdj_ns_i_0[2]\ : 
        NOR2B
      port map(A => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/N_250\, 
        B => INIT_DONE, Y => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/jzzdfrmzwdj_ns_i_0[2]_net_1\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnvtvdkcnpp_9[6]\ : 
        MX2
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnvtvdkcnpp_5[6]_net_1\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/fqkdsnjfpdb[12]\, 
        S => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx_1[4]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnvtvdkcnpp_9[6]_net_1\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/fqkdsnjfpdb_0_0_ADD_18x18_medium_I31_Y\ : 
        OAI1
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/G_103_0_net_1\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ADD_18x18_medium_I4_P0N_0\, 
        C => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N241\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N297\);
    
    
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/un1_sgbwkmbvtjw_0_a3_0\ : 
        OR3B
      port map(A => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/un6_bdbpcvshhqt_1_net_1\, 
        B => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/N_248\, 
        C => \AB_CM_inst/EV_DONE_net\, Y => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/N_310\);
    
    
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/user_control/u_ffppvfwnggt/cpqqthwwhvc_0_0_a2_4[8]\ : 
        OR2
      port map(A => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/user_control/u_ffppvfwnggt/N_2342\, 
        B => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/gpbbjwsprsj[1]\, 
        Y => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/N_2324\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc_8[0]\ : 
        MX2
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ftbkrvpxdbp[4]_net_1\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ftbkrvpxdbp[5]_net_1\, 
        S => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rdgwgtpkbgc_1[0]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_727\);
    
    
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/save_fsm/u_wbsfnwwctpn/crpwsdfhcqq_ns[7]\ : 
        MX2
      port map(A => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/save_fsm/u_wbsfnwwctpn/mfwjfgrqchd\, 
        B => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/save_fsm/u_wbsfnwwctpn/crpwsdfhcqq[1]_net_1\, 
        S => \NVM_CM_inst/NVM_BUSY_net\, Y => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/save_fsm/u_wbsfnwwctpn/crpwsdfhcqq_ns[7]_net_1\);
    
    \COMP_SM_inst/Latest_Update_2_sqmuxa_0_a4_0\ : OR3B
      port map(A => \COMP_SM_inst/N_419\, B => 
        \COMP_SM_inst/Latest_Update_9[1]\, C => \ADC_CHNUMBER[1]\, 
        Y => \COMP_SM_inst/Latest_Update_2_sqmuxa_0\);
    
    
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/hdxtpkktfvz_0_o3\ : 
        OR2B
      port map(A => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/N_310\, 
        B => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/N_262\, 
        Y => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/hdxtpkktfvz\);
    
    
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/address_gen/u_dxwqxgdccxc/kftxkfpnstb\ : 
        DFN1E1C0
      port map(D => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/address_gen/u_dxwqxgdccxc/un10_gnmdxrqrdgs_NE\, 
        CLK => SYSCLK_c, CLR => SYSRSTn_c, E => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/address_gen/u_dxwqxgdccxc/un2_tnjvgqqhdkd\, 
        Q => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/mhxwcfnvbgt\);
    
    
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/cpwfrthtnfr_10_sqmuxa_0_a3\ : 
        NOR3B
      port map(A => \AB_CM_inst/TR_RAM_DO_B_net_0[8]\, B => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/cpwfrthtnfr_10_sqmuxa_0_a3_0\, 
        C => \AB_CM_inst/TR_RAM_DO_B_net_net_1_0\, Y => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/cpwfrthtnfr_10_sqmuxa\);
    
    
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/address_gen/u_dxwqxgdccxc/jvbvzqvvxpc_gnmdxrqrdgs_3[3]\ : 
        XA1B
      port map(A => \INIT_ADDR[3]\, B => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/address_gen/u_dxwqxgdccxc/DWACT_ADD_CI_0_g_array_12[0]\, 
        C => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/wtjtwqjkqbd\, 
        Y => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/address_gen/u_dxwqxgdccxc/gnmdxrqrdgs_3[3]\);
    
    
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/jzzdfrmzwdj_ns_i_1[3]\ : 
        NOR2B
      port map(A => INIT_DONE, B => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/jzzdfrmzwdj[13]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/jzzdfrmzwdj_ns_i_1[3]_net_1\);
    
    \Diff4_pad[11]/U0/U1\ : IOTRI_OB_EB
      port map(D => \Diff4_c[11]\, E => SOC_VCC_NET, DOUT => 
        \Diff4_pad[11]/U0/NET1\, EOUT => \Diff4_pad[11]/U0/NET2\);
    
    
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/ptxbvztnpnf[3]\ : 
        DFN1E1C0
      port map(D => \AB_CM_inst/ASSC_RAM_DO_B_net_net_4\, CLK => 
        SYSCLK_c, CLR => SYSRSTn_c, E => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/jzzdfrmzwdj[11]_net_1\, 
        Q => \AB_CM_inst/ADC_STC_net_net_3\);
    
    \COMP_SM_inst/valid_8_0_0\ : OR3C
      port map(A => \COMP_SM_inst/N_403_i\, B => 
        \COMP_SM_inst/N_402_i\, C => \COMP_SM_inst/N_401\, Y => 
        \COMP_SM_inst/valid_8\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/gjkdbmpgrtc_3_i[4]\ : 
        NOR2B
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rdgwgtpkbgc_1[1]_net_1\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_540\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_884\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc_11_d[4]\ : 
        MX2B
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnvtvdkcnpp_0[2]_net_1\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc_11_d_d[4]_net_1\, 
        S => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc_11_d_s[4]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc_11_d[4]_net_1\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc_11[1]\ : 
        MX2
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_647\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ftbkrvpxdbp[1]_net_1\, 
        S => 
        \AB_CM_inst.AB_CM_smev_wrapper_inst.U0.u_nbnjbfrkqwq.rdgwgtpkbgc[3]\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_779\);
    
    
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/bksczsjcvgb\ : 
        DFN1E1C0
      port map(D => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/jdhgstfqkjm_2_i_net_1\, 
        CLK => SYSCLK_c, CLR => SYSRSTn_c, E => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/un4_wkpfnwqwgcb_net_1\, 
        Q => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/bksczsjcvgb_net_1\);
    
    
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/init_fsm/u_stnpfdkggvx/mwtvnzdkmwm[3]\ : 
        DFN1C0
      port map(D => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/init_fsm/u_stnpfdkggvx/mwtvnzdkmwm_ns[4]_net_1\, 
        CLK => SYSCLK_c, CLR => SYSRSTn_c, Q => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/xbkjkgdsbfh\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx_ns_i[7]\ : 
        NOR2B
      port map(A => INIT_DONE, B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx[11]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx_ns_i[7]_net_1\);
    
    \Diff0_pad[8]/U0/U1\ : IOTRI_OB_EB
      port map(D => \Diff0_c[8]\, E => SOC_VCC_NET, DOUT => 
        \Diff0_pad[8]/U0/NET1\, EOUT => \Diff0_pad[8]/U0/NET2\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ckghxwbsztp_m[0]\ : 
        OR2B
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx[0]_net_1\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ckghxwbsztp[0]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ckghxwbsztp_m[0]_net_1\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc_9[9]\ : 
        MX2
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnvtvdkcnpp[9]_net_1\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnvtvdkcnpp[10]_net_1\, 
        S => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rdgwgtpkbgc_2[0]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_753\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/un1_dhzrwbnrbpw_I_43\ : 
        NOR3C
      port map(A => \AB_CM_inst/EV_RAM_ADDR_B_net_net_5\, B => 
        \AB_CM_inst/EV_RAM_ADDR_B_net_net_4\, C => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/DWACT_ADD_CI_0_g_array_1[0]\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/DWACT_ADD_CI_0_g_array_2[0]\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/kkkmkxwwscv[3]\ : 
        DFN1E1C0
      port map(D => \AB_CM_inst/ASSC_SEQOUT_net_net_1\, CLK => 
        SYSCLK_c, CLR => SYSRSTn_c, E => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/qmmwhjxxxmv_net_1\, 
        Q => \AB_CM_inst/EV_ASSCADDR_net_net_1\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/gpjgkmhxbkn_2\ : 
        XNOR2
      port map(A => \AB_CM_inst/EV_RAM_DO_B_net_net_4\, B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rqrqhcwpqdn[3]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/gpjgkmhxbkn_2_i\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx_ns_a3[10]\ : 
        NOR2A
      port map(A => INIT_DONE, B => 
        \AB_CM_inst/bskrjhjvqpf_1_sqmuxa\, Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx_ns[10]\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/fqkdsnjfpdb_0_0_ADD_18x18_medium_I96_Y_0\ : 
        AX1D
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/G_103_0_net_1\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_260\, 
        C => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_262\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ADD_18x18_medium_I96_Y_0\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/mvnkctvqsgp\ : 
        NOR2
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rfrdbqfdrhx[1]_net_1\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rfrdbqfdrhx[0]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/mvnkctvqsgp_net_1\);
    
    \COMP_SM_inst/Diff_1[1]\ : DFN1E1C0
      port map(D => \COMP_SM_inst/Result[1]\, CLK => SYSCLK_c, 
        CLR => SYSRSTn_c, E => 
        \COMP_SM_inst/Latest_Update_1_sqmuxa\, Q => \Diff1_c[1]\);
    
    \AB_CM_inst/AV1_PAD\ : IOPAD_A_IN
      port map(PAD => AV1, Y => \AB_CM_inst/AV1_net\);
    
    
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/address_gen/u_dxwqxgdccxc/jvbvzqvvxpc_gnmdxrqrdgs_3[2]\ : 
        XA1B
      port map(A => \INIT_ADDR[2]\, B => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/address_gen/u_dxwqxgdccxc/DWACT_ADD_CI_0_g_array_1[0]\, 
        C => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/wtjtwqjkqbd\, 
        Y => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/address_gen/u_dxwqxgdccxc/gnmdxrqrdgs_3[2]\);
    
    
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/un1_qgnzcpmbksd_I_54\ : 
        AND2
      port map(A => \AB_CM_inst/TR_RAM_ADDR_B_net_net_1\, B => 
        \AB_CM_inst/Z\\\\TR_RAM_ADDR_B_net\\\\\, Y => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/DWACT_ADD_CI_0_pog_array_1_2[0]\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/pvtdpmmqdpp_un2_pbzxzjhqhwz_0_I_27\ : 
        OA1
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_37\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_36\, 
        C => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_35\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/DWACT_COMP0_E[0]\);
    
    \Diff4_pad[9]/U0/U1\ : IOTRI_OB_EB
      port map(D => \Diff4_c[9]\, E => SOC_VCC_NET, DOUT => 
        \Diff4_pad[9]/U0/NET1\, EOUT => \Diff4_pad[9]/U0/NET2\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnvtvdkcnpp_9[5]\ : 
        MX2
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnvtvdkcnpp_5[5]_net_1\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/fqkdsnjfpdb[11]\, 
        S => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx[4]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnvtvdkcnpp_9[5]_net_1\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/gpjgkmhxbkn_NE_2\ : 
        NOR3C
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/gpjgkmhxbkn_1_i\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/gpjgkmhxbkn_2_i\, 
        C => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/gpjgkmhxbkn_0_i\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/gpjgkmhxbkn_NE_2_net_1\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc_11[4]\ : 
        MX2C
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_748\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc_11_d[4]_net_1\, 
        S => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc_11_s[4]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc_11[4]_net_1\);
    
    
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/frcskdnwvmx_ns_i_a3[4]\ : 
        OA1B
      port map(A => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/N_235\, 
        B => \AB_CM_inst/TR_RAM_DO_B_net[8]\, C => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/frcskdnwvmx[8]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/N_271\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ckghxwbsztp_3_0_a3[3]\ : 
        XA1
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_9\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rqrqhcwpqdn[4]_net_1\, 
        C => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_923\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ckghxwbsztp_3[3]\);
    
    
        \COMP_SM_inst/Subtract_inst/sumAux_0_0_SUB_12x12_medium_area_I47_Y_1\ : 
        AO1
      port map(A => \COMP_SM_inst/Subtract_inst/N164\, B => 
        \COMP_SM_inst/Subtract_inst/N196\, C => 
        \COMP_SM_inst/Subtract_inst/SUB_12x12_medium_area_I47_Y_0\, 
        Y => 
        \COMP_SM_inst/Subtract_inst/SUB_12x12_medium_area_I47_Y_1\);
    
    
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/brxxctcvrmh_qgnzcpmbksd_7_0_iv[7]\ : 
        AO1B
      port map(A => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/N_230_i_0\, 
        B => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/I_34_0\, 
        C => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/tpxkpvnpvvn_m_0[7]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/qgnzcpmbksd_7[7]\);
    
    
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/address_gen/u_dxwqxgdccxc/gnmdxrqrdgs[1]\ : 
        DFN1C0
      port map(D => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/address_gen/u_dxwqxgdccxc/gnmdxrqrdgs_3[1]\, 
        CLK => SYSCLK_c, CLR => SYSRSTn_c, Q => \INIT_ADDR[1]\);
    
    \Diff0_pad[1]/U0/U0\ : IOPAD_TRI
      port map(D => \Diff0_pad[1]/U0/NET1\, E => 
        \Diff0_pad[1]/U0/NET2\, PAD => Diff0(1));
    
    \COMP_SM_inst/valid_8_0_0_a2_3\ : NOR3
      port map(A => \COMP_SM_inst/N_421_1\, B => 
        \COMP_SM_inst/valid_8_0_0_a2_3_0_net_1\, C => 
        \COMP_SM_inst/N_421_2\, Y => \COMP_SM_inst/N_421\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc_7[9]\ : 
        MX2
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_651\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_953\, 
        S => 
        \AB_CM_inst.AB_CM_smev_wrapper_inst.U0.u_nbnjbfrkqwq.rdgwgtpkbgc[3]\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_719\);
    
    
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/address_gen/u_dxwqxgdccxc/jvbvzqvvxpc_gnmdxrqrdgs_3[0]\ : 
        XA1B
      port map(A => \INIT_ADDR[0]\, B => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/qdgqbvgcnzn\, 
        C => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/wtjtwqjkqbd\, 
        Y => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/address_gen/u_dxwqxgdccxc/gnmdxrqrdgs_3[0]\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc_9[10]\ : 
        MX2
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnvtvdkcnpp[10]_net_1\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnvtvdkcnpp[11]_net_1\, 
        S => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rdgwgtpkbgc[0]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_754\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/zbqggxmnpbs_0_iv[2]\ : 
        AO1B
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/fqkdsnjfpdb[8]\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx[5]_net_1\, 
        C => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/zbqggxmnpbs_0_iv_0[2]_net_1\, 
        Y => \AB_CM_inst/EV_RAM_DI_B_net_net_5\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc_9[4]\ : 
        MX2
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnvtvdkcnpp[4]_net_1\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnvtvdkcnpp[5]_net_1\, 
        S => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rdgwgtpkbgc_2[0]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_748\);
    
    
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/frcskdnwvmx_ns_i_o2[3]\ : 
        NOR2
      port map(A => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/N_247\, 
        B => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/N_235\, 
        Y => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/N_248\);
    
    
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/rjhhzsggrtr[6]\ : 
        DFN1E1C0
      port map(D => \AB_CM_inst/TR_RAM_DO_B_net_net_1\, CLK => 
        SYSCLK_c, CLR => SYSRSTn_c, E => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/frcskdnwvmx[4]_net_1\, 
        Q => \AB_CM_inst/TR_EV_ADDR_net_net_1\);
    
    
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/brxxctcvrmh_qgnzcpmbksd_7_0_iv[8]\ : 
        AO1B
      port map(A => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/N_230_i_0\, 
        B => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/I_36_0\, 
        C => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/tpxkpvnpvvn_m[8]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/qgnzcpmbksd_7[8]\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ckghxwbsztp_3_0_a3[0]\ : 
        NOR2A
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_923\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rqrqhcwpqdn[1]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ckghxwbsztp_3[0]\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx_0[8]\ : 
        DFN1C0
      port map(D => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx_ns_i[9]_net_1\, 
        CLK => SYSCLK_c, CLR => SYSRSTn_c, Q => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx_0[8]_net_1\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc_12[12]\ : 
        MX2
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_956\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_790\, 
        S => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rdgwgtpkbgc[2]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc[12]\);
    
    
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/init_fsm/u_stnpfdkggvx/mwtvnzdkmwm_ns[2]\ : 
        AO1
      port map(A => \NVM_CM_inst/NVM_BUSY_net\, B => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/init_fsm/u_stnpfdkggvx/mwtvnzdkmwm[5]_net_1\, 
        C => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/init_fsm/u_stnpfdkggvx/mwtvnzdkmwm[6]_net_1\, 
        Y => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/init_fsm/u_stnpfdkggvx/mwtvnzdkmwm_ns[2]_net_1\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/qrbxknbdvjj[5]\ : 
        DFN1E1C0
      port map(D => \AB_CM_inst/EV_RAM_ADDR_B_net_net_2\, CLK => 
        SYSCLK_c, CLR => SYSRSTn_c, E => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx[11]_net_1\, 
        Q => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/qrbxknbdvjj[5]_net_1\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnvtvdkcnpp_9[9]\ : 
        MX2
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnvtvdkcnpp_8[9]_net_1\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/fqkdsnjfpdb[15]\, 
        S => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx_1[4]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnvtvdkcnpp_9[9]_net_1\);
    
    \Diff1_pad[3]/U0/U1\ : IOTRI_OB_EB
      port map(D => \Diff1_c[3]\, E => SOC_VCC_NET, DOUT => 
        \Diff1_pad[3]/U0/NET1\, EOUT => \Diff1_pad[3]/U0/NET2\);
    
    
        \COMP_SM_inst/Subtract_inst/sumAux_0_0_SUB_12x12_medium_area_I40_Y_0\ : 
        AO18
      port map(A => \COMP_SM_inst/R1[6]_net_1\, B => 
        \COMP_SM_inst/R2[6]_net_1\, C => 
        \COMP_SM_inst/Subtract_inst/N150\, Y => 
        \COMP_SM_inst/Subtract_inst/SUB_12x12_medium_area_I40_Y_0\);
    
    
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/bksnhfwfshc_6_sqmuxa_0_a3\ : 
        NOR2A
      port map(A => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/jzzdfrmzwdj[14]_net_1\, 
        B => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/N_251\, 
        Y => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/bksnhfwfshc_6_sqmuxa\);
    
    
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/save_fsm/u_wbsfnwwctpn/crpwsdfhcqq_ns_a3[8]\ : 
        NOR2A
      port map(A => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/save_fsm/u_wbsfnwwctpn/crpwsdfhcqq[1]_net_1\, 
        B => \NVM_CM_inst/NVM_BUSY_net\, Y => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/save_fsm/u_wbsfnwwctpn/crpwsdfhcqq_ns_a3[8]_net_1\);
    
    
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/jzzdfrmzwdj_ns_i_2[2]\ : 
        MX2
      port map(A => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/jzzdfrmzwdj[13]_net_1\, 
        B => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/jzzdfrmzwdj_0[14]_net_1\, 
        S => INIT_DONE, Y => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/jzzdfrmzwdj_ns_i_2[2]_net_1\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc_3[8]\ : 
        MX2
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_746\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_748\, 
        S => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rdgwgtpkbgc_2[1]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_650\);
    
    \Diff1_pad[1]/U0/U0\ : IOPAD_TRI
      port map(D => \Diff1_pad[1]/U0/NET1\, E => 
        \Diff1_pad[1]/U0/NET2\, PAD => Diff1(1));
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx[2]\ : 
        DFN1C0
      port map(D => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx_ns[15]\, 
        CLK => SYSCLK_c, CLR => SYSRSTn_c, Q => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx[2]_net_1\);
    
    \COMP_SM_inst/un1_completed_sync_7_i_a4_0_0\ : NOR2A
      port map(A => \ADC_CHNUMBER[1]\, B => \ADC_CHNUMBER[4]\, Y
         => \COMP_SM_inst/un1_completed_sync_7_i_a4_0_0_net_1\);
    
    
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/vnjtgtptszx_un1_xjrbtnwdszs_1_sqmuxa_1\ : 
        NOR3B
      port map(A => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/cpwfrthtnfr_11_sqmuxa\, 
        B => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/xjrbtnwdszs_1_sqmuxa_net_1\, 
        C => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/cpwfrthtnfr_10_sqmuxa\, 
        Y => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/un1_xjrbtnwdszs_1_sqmuxa_1\);
    
    \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/G_134\ : 
        XNOR3
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/gjkdbmpgrtc[10]\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnvtvdkcnpp[4]_net_1\, 
        C => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc[10]\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_292\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/zbqggxmnpbs_r[4]\ : 
        AND2
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_196\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/zbqggxmnpbs_0_iv[4]_net_1\, 
        Y => \AB_CM_inst/EV_RAM_DI_B_net_net_3\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx[13]\ : 
        DFN1C0
      port map(D => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx_ns[4]_net_1\, 
        CLK => SYSCLK_c, CLR => SYSRSTn_c, Q => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx[13]_net_1\);
    
    \COMP_SM_inst/Diff_4[8]\ : DFN1E1C0
      port map(D => \COMP_SM_inst/Result[8]\, CLK => SYSCLK_c, 
        CLR => SYSRSTn_c, E => 
        \COMP_SM_inst/Latest_Update_4_sqmuxa\, Q => \Diff4_c[8]\);
    
    
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/valid_client/u_gpbdjfttbjd/tdckqkwvkfk_un7_vcktjmvmkfg_i\ : 
        OA1B
      port map(A => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/npgnwznthhx\, 
        B => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/xbkjkgdsbfh\, 
        C => \NVM_CM_inst/NVM_BUSY_net\, Y => 
        \NVM_CM_inst.NVM_CM_init_wrapper_inst.U0.u_grwzcnqmqzm.valid_client.u_gpbdjfttbjd.N_12\);
    
    \Diff0_pad[3]/U0/U1\ : IOTRI_OB_EB
      port map(D => \Diff0_c[3]\, E => SOC_VCC_NET, DOUT => 
        \Diff0_pad[3]/U0/NET1\, EOUT => \Diff0_pad[3]/U0/NET2\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/pvtdpmmqdpp_un2_pbzxzjhqhwz_0_I_47\ : 
        AND2A
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rqrqhcwpqdn[6]_net_1\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnvtvdkcnpp[6]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ACT_LT3_E[5]\);
    
    
        \COMP_SM_inst/Subtract_inst/sumAux_0_0_SUB_12x12_medium_area_I25_Y\ : 
        XA1A
      port map(A => \COMP_SM_inst/R1[10]_net_1\, B => 
        \COMP_SM_inst/R2[10]_net_1\, C => 
        \COMP_SM_inst/Subtract_inst/N157\, Y => 
        \COMP_SM_inst/Subtract_inst/N164\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rfrdbqfdrhx[1]\ : 
        DFN1E1C0
      port map(D => \AB_CM_inst/EV_RAM_DO_B_net_net_2\, CLK => 
        SYSCLK_c, CLR => SYSRSTn_c, E => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bskrjhjvqpf_0_sqmuxa\, 
        Q => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rfrdbqfdrhx[1]_net_1\);
    
    \Diff4_pad[3]/U0/U1\ : IOTRI_OB_EB
      port map(D => \Diff4_c[3]\, E => SOC_VCC_NET, DOUT => 
        \Diff4_pad[3]/U0/NET1\, EOUT => \Diff4_pad[3]/U0/NET2\);
    
    
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/address_gen/u_dxwqxgdccxc/ggfvvjbkdws[5]\ : 
        MX2C
      port map(A => \INIT_ADDR[5]\, B => \INIT_ADDR[4]\, S => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/ggsxvgncrgz[0]\, 
        Y => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/ggfvvjbkdws[5]\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/wqpbnjzjqsx_4\ : 
        XNOR2
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rqrqhcwpqdn[5]_net_1\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnvtvdkcnpp[5]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/wqpbnjzjqsx_4_i\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/gjkdbmpgrtc_9[10]\ : 
        MX2
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rqrqhcwpqdn[10]_net_1\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rqrqhcwpqdn[11]_net_1\, 
        S => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rdgwgtpkbgc_1[0]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_550\);
    
    \COMP_SM_inst/R1[3]\ : DFN1E1C0
      port map(D => \ADC_RESULT[3]\, CLK => SYSCLK_c, CLR => 
        SYSRSTn_c, E => \COMP_SM_inst/pres_state_0[3]_net_1\, Q
         => \COMP_SM_inst/R1[3]_net_1\);
    
    \COMP_SM_inst/prev_channel[3]\ : DFN1E1C0
      port map(D => \ADC_CHNUMBER[3]\, CLK => SYSCLK_c, CLR => 
        SYSRSTn_c, E => ASSC_DONE, Q => 
        \COMP_SM_inst/prev_channel[3]_net_1\);
    
    \AB_CM_inst/AB_CM_smtr_ram_inst/AB_CM_smtr_ram_R0C0_0\ : BUFF
      port map(A => \AB_CM_inst/TR_RAM_DO_B_net[8]\, Y => 
        \AB_CM_inst/TR_RAM_DO_B_net_0[8]\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/qrbxknbdvjj[2]\ : 
        DFN1E1C0
      port map(D => \AB_CM_inst/EV_RAM_ADDR_B_net_net_5\, CLK => 
        SYSCLK_c, CLR => SYSRSTn_c, E => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx[11]_net_1\, 
        Q => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/qrbxknbdvjj[2]_net_1\);
    
    \AB_CM_inst/INIT_ACMWEN_OR\ : AOI1B
      port map(A => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/valid_client/u_gpbdjfttbjd/N_18\, 
        B => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/valid_client/u_gpbdjfttbjd/N_19\, 
        C => 
        \NVM_CM_inst.NVM_CM_init_wrapper_inst.U0.u_grwzcnqmqzm.valid_client.u_gpbdjfttbjd.N_12\, 
        Y => \AB_CM_inst/INIT_ACM_WEN_OR_net\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/fqkdsnjfpdb_0_0_ADD_18x18_medium_I93_Y\ : 
        XNOR2
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ADD_18x18_medium_I93_Y_0\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N300\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/fqkdsnjfpdb[1]\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc_9[3]\ : 
        MX2
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnvtvdkcnpp[3]_net_1\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnvtvdkcnpp[4]_net_1\, 
        S => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rdgwgtpkbgc_2[0]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_747\);
    
    \COMP_SM_inst/Latest_Update_0_sqmuxa_0_a2_1\ : OR2A
      port map(A => \ADC_CHNUMBER[1]\, B => \ADC_CHNUMBER[3]\, Y
         => \COMP_SM_inst/N_423\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/fqkdsnjfpdb_0_0_ADD_18x18_medium_I93_Y_0\ : 
        XOR3
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/gjkdbmpgrtc[1]\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/G_89_0_net_1\, 
        C => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc[1]\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ADD_18x18_medium_I93_Y_0\);
    
    
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/jzzdfrmzwdj_ns_i_1[11]\ : 
        NOR2B
      port map(A => INIT_DONE, B => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/jzzdfrmzwdj[5]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/jzzdfrmzwdj_ns_i_1[11]_net_1\);
    
    
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/hbxwhvjzqbt_iv\ : 
        OAI1
      port map(A => INIT_ASSC_WEN, B => INIT_DONE, C => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/un1_AB_CM_assc_wrapper_inst\, 
        Y => \AB_CM_inst/ASSC_RAM_CSN_A_net\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/fqkdsnjfpdb_0_0_ADD_18x18_medium_I99_Y\ : 
        XOR3
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_273\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_277\, 
        C => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N351\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/fqkdsnjfpdb[7]\);
    
    
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/brxxctcvrmh_qgnzcpmbksd_7_iv_0[0]\ : 
        OA1
      port map(A => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/N_288\, 
        B => \AB_CM_inst/EV_DONE_net_0\, C => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/tpxkpvnpvvn_m_0[0]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/qgnzcpmbksd_7_iv_0[0]\);
    
    
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/address_gen/u_dxwqxgdccxc/jvbvzqvvxpc_gnmdxrqrdgs_3[7]\ : 
        NOR2A
      port map(A => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/address_gen/u_dxwqxgdccxc/I_34_1\, 
        B => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/wtjtwqjkqbd\, 
        Y => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/address_gen/u_dxwqxgdccxc/gnmdxrqrdgs_3[7]\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/fqkdsnjfpdb_0_0_ADD_18x18_medium_I10_P0N\ : 
        OR3
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_292\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_290\, 
        C => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/G_133_0_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N262\);
    
    \Diff5_pad[1]/U0/U0\ : IOPAD_TRI
      port map(D => \Diff5_pad[1]/U0/NET1\, E => 
        \Diff5_pad[1]/U0/NET2\, PAD => Diff5(1));
    
    
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/hgqdwrxvgzm[0]\ : 
        DFN1E1C0
      port map(D => \AB_CM_inst/ASSC_RAM_DO_B_net_net_7\, CLK => 
        SYSCLK_c, CLR => SYSRSTn_c, E => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/jzzdfrmzwdj[14]_net_1\, 
        Q => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/hgqdwrxvgzm[0]_net_1\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/pvtdpmmqdpp_un2_pbzxzjhqhwz_0_I_64\ : 
        AOI1A
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ACT_LT4_E[7]\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ACT_LT4_E[8]\, 
        C => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ACT_LT4_E[5]\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ACT_LT4_E[10]\);
    
    
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/address_gen/u_dxwqxgdccxc/ggfvvjbkdws[2]\ : 
        MX2C
      port map(A => \INIT_ADDR[2]\, B => \INIT_ADDR[1]\, S => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/ggsxvgncrgz[0]\, 
        Y => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/ggfvvjbkdws[2]\);
    
    
        \COMP_SM_inst/Subtract_inst/sumAux_0_0_SUB_12x12_medium_area_I12_S\ : 
        XOR2
      port map(A => \COMP_SM_inst/R2[0]_net_1\, B => 
        \COMP_SM_inst/R1[0]_net_1\, Y => \COMP_SM_inst/N139\);
    
    \Diff5_pad[7]/U0/U0\ : IOPAD_TRI
      port map(D => \Diff5_pad[7]/U0/NET1\, E => 
        \Diff5_pad[7]/U0/NET2\, PAD => Diff5(7));
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/gjkdbmpgrtc_7_0_a3[14]\ : 
        NOR2A
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_452\, 
        B => 
        \AB_CM_inst.AB_CM_smev_wrapper_inst.U0.u_nbnjbfrkqwq.rdgwgtpkbgc[3]\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_944\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnvtvdkcnpp_9[1]\ : 
        MX2
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnvtvdkcnpp_5[1]_net_1\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/fqkdsnjfpdb[7]\, 
        S => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx[4]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnvtvdkcnpp_9[1]_net_1\);
    
    
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/mksbfqnmmgw[2]\ : 
        MX2
      port map(A => \ADC_RESULT[2]\, B => \ADC_RESULT[11]\, S => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/jzzdfrmzwdj[4]_net_1\, 
        Y => \AB_CM_inst/ASSC_RAM_DI_B_net_net_5\);
    
    \COMP_SM_inst/valid_8_0_0_a4_1_3\ : NOR3C
      port map(A => \ADC_CHNUMBER[0]\, B => 
        \COMP_SM_inst/valid_8_0_0_a4_1_1_net_1\, C => 
        \COMP_SM_inst/N_424\, Y => 
        \COMP_SM_inst/valid_8_0_0_a4_1_3_net_1\);
    
    \COMP_SM_inst/valid\ : DLN1C0
      port map(D => \COMP_SM_inst/valid_8\, G => ASSC_DONE, CLR
         => \COMP_SM_inst/un2_resetn\, Q => 
        \COMP_SM_inst/valid_net_1\);
    
    \Diff5_pad[10]/U0/U0\ : IOPAD_TRI
      port map(D => \Diff5_pad[10]/U0/NET1\, E => 
        \Diff5_pad[10]/U0/NET2\, PAD => Diff5(10));
    
    
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/fsrxhtjthgw_i_o3\ : 
        OR3C
      port map(A => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/N_317\, 
        B => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/znbkwkbspdc_net_1\, 
        C => INIT_DONE, Y => \AB_CM_inst/N_266\);
    
    \COMP_SM_inst/R2[1]\ : DFN1E1C0
      port map(D => \ADC_RESULT[1]\, CLK => SYSCLK_c, CLR => 
        SYSRSTn_c, E => \COMP_SM_inst/pres_state_0[2]_net_1\, Q
         => \COMP_SM_inst/R2[1]_net_1\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc_12_d_d[0]\ : 
        MX2
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_625\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc_12_d_d_d[0]_net_1\, 
        S => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc_11_s[2]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc_12_d_d[0]_net_1\);
    
    \COMP_SM_inst/Diff_4[2]\ : DFN1E1C0
      port map(D => \COMP_SM_inst/Result[2]\, CLK => SYSCLK_c, 
        CLR => SYSRSTn_c, E => 
        \COMP_SM_inst/Latest_Update_4_sqmuxa\, Q => \Diff4_c[2]\);
    
    \COMP_SM_inst/pres_state_ns_a5_0_o2_0[1]\ : AO15
      port map(A => \ADC_CHNUMBER[3]\, B => \ADC_CHNUMBER[1]\, C
         => \ADC_CHNUMBER[2]\, Y => \COMP_SM_inst/N_376\);
    
    \AB_CM_inst/AV0_PAD\ : IOPAD_A_IN
      port map(PAD => AV0, Y => \AB_CM_inst/AV0_net\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/pvtdpmmqdpp_un2_pbzxzjhqhwz_0_I_37\ : 
        AND3
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/DWACT_BL_EQUAL_0_E[2]\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/DWACT_BL_EQUAL_0_E[1]\, 
        C => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/DWACT_BL_EQUAL_0_E[0]\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/DWACT_CMPLE_PO2_DWACT_COMP0_E[1]\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/fqkdsnjfpdb_0_0_ADD_18x18_medium_I11_P0N_0\ : 
        NOR2
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_295\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_297\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ADD_18x18_medium_I11_P0N_0\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc_7_0_a3[15]\ : 
        NOR2A
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_657\, 
        B => 
        \AB_CM_inst.AB_CM_smev_wrapper_inst.U0.u_nbnjbfrkqwq.rdgwgtpkbgc[3]\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_959\);
    
    
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/save_fsm/u_wbsfnwwctpn/crpwsdfhcqq[4]\ : 
        DFN1C0
      port map(D => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/save_fsm/u_wbsfnwwctpn/crpwsdfhcqq_ns_a3[4]_net_1\, 
        CLK => SYSCLK_c, CLR => SYSRSTn_c, Q => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/save_fsm/u_wbsfnwwctpn/jspcghhzwmg\);
    
    \COMP_SM_inst/Diff_3[7]\ : DFN1E1C0
      port map(D => \COMP_SM_inst/Result[7]\, CLK => SYSCLK_c, 
        CLR => SYSRSTn_c, E => 
        \COMP_SM_inst/Latest_Update_3_sqmuxa\, Q => \Diff3_c[7]\);
    
    
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/bcmkdjqtngz_1\ : 
        NOR2A
      port map(A => INIT_DONE, B => ASSC_DONE, Y => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/bcmkdjqtngz_1_net_1\);
    
    \COMP_SM_inst/un1_completed_sync_7_i\ : AO1B
      port map(A => \COMP_SM_inst/N_372\, B => 
        \COMP_SM_inst/N_420\, C => 
        \COMP_SM_inst/un1_completed_sync_7_i_0_net_1\, Y => 
        \COMP_SM_inst/N_364\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/fqkdsnjfpdb_0_0_ADD_18x18_medium_I15_P0N\ : 
        AND3C
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_315\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_317\, 
        C => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/G_158_0_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N277\);
    
    
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/bnrsdrtmtsg_5[4]\ : 
        MX2
      port map(A => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/hgqdwrxvgzm_3[4]_net_1\, 
        B => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/trnwxjxxrbp[4]_net_1\, 
        S => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/N_345\, 
        Y => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/N_357\);
    
    
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/znjtscvsvcs_iv_0\ : 
        OR3C
      port map(A => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/N_434\, 
        B => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/qxzrwpjhcww_m[0]\, 
        C => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/N_433\, 
        Y => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/znjtscvsvcs\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/fqkdsnjfpdb_0_0_ADD_18x18_medium_I38_Y\ : 
        NOR2
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N289\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N287\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N305\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rdgwgtpkbgc_1[2]\ : 
        DFN1E0C0
      port map(D => \AB_CM_inst/EV_RAM_DO_B_net_net_5\, CLK => 
        SYSCLK_c, CLR => SYSRSTn_c, E => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bskrjhjvqpf_1_sqmuxa_0\, 
        Q => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rdgwgtpkbgc_1[2]_net_1\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/xwhwqsjfmgh\ : 
        DFN1C0
      port map(D => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bskrjhjvqpf_6_sqmuxa\, 
        CLK => SYSCLK_c, CLR => SYSRSTn_c, Q => 
        \AB_CM_inst/EV_DONE_net\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnvtvdkcnpp_9[8]\ : 
        MX2C
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnvtvdkcnpp_5[8]_net_1\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/fqkdsnjfpdb_i[14]\, 
        S => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx_1[4]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnvtvdkcnpp_9[8]_net_1\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/fqkdsnjfpdb_m[13]\ : 
        OR2B
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx[5]_net_1\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/fqkdsnjfpdb[13]\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/fqkdsnjfpdb_m[13]_net_1\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc_12_d_d[3]\ : 
        MX2C
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_645\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_747\, 
        S => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rdgwgtpkbgc_0[2]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc_12_d_d[3]_net_1\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc_11_d[9]\ : 
        MX2
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_751\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnvtvdkcnpp[3]_net_1\, 
        S => 
        \AB_CM_inst.AB_CM_smev_wrapper_inst.U0.u_nbnjbfrkqwq.rdgwgtpkbgc[3]\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc_11_d[9]_net_1\);
    
    
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/jzzdfrmzwdj[0]\ : 
        DFN1C0
      port map(D => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/N_228_i_0\, 
        CLK => SYSCLK_c, CLR => SYSRSTn_c, Q => 
        \AB_CM_inst/AB_CM_assc_wrapper_inst/U0/u_fmvgpwbdcxs/jzzdfrmzwdj[0]_net_1\);
    
    \AB_CM_inst/AC4_PAD\ : IOPAD_A_IN
      port map(PAD => AC4, Y => \AB_CM_inst/AC4_net\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/gjkdbmpgrtc_3[6]\ : 
        MX2
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_540\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_542\, 
        S => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rdgwgtpkbgc[1]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_444\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/dhzrwbnrbpw[6]\ : 
        DFN1C0
      port map(D => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/dhzrwbnrbpw_7[6]\, 
        CLK => SYSCLK_c, CLR => SYSRSTn_c, Q => 
        \AB_CM_inst/EV_RAM_ADDR_B_net_net_1\);
    
    \Diff3_pad[2]/U0/U1\ : IOTRI_OB_EB
      port map(D => \Diff3_c[2]\, E => SOC_VCC_NET, DOUT => 
        \Diff3_pad[2]/U0/NET1\, EOUT => \Diff3_pad[2]/U0/NET2\);
    
    
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/qgnzcpmbksd[2]\ : 
        DFN1C0
      port map(D => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/qgnzcpmbksd_7[2]\, 
        CLK => SYSCLK_c, CLR => SYSRSTn_c, Q => 
        \AB_CM_inst/TR_RAM_ADDR_B_net_net_5\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/un1_dhzrwbnrbpw_I_34\ : 
        AX1C
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/DWACT_ADD_CI_0_g_array_11[0]\, 
        B => \AB_CM_inst/EV_RAM_ADDR_B_net_net_1\, C => 
        \AB_CM_inst/Z\\\\EV_RAM_ADDR_B_net\\\\\, Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/I_34\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ftbkrvpxdbp_5[4]\ : 
        MX2
      port map(A => \AB_CM_inst/Z\\\\EV_RAM_DO_B_net\\\\\, B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/fqkdsnjfpdb[4]\, 
        S => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/tkcbxxqbtfx_1[4]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ftbkrvpxdbp_5[4]_net_1\);
    
    \COMP_SM_inst/Diff_1[4]\ : DFN1E1C0
      port map(D => \COMP_SM_inst/Result[4]\, CLK => SYSCLK_c, 
        CLR => SYSRSTn_c, E => 
        \COMP_SM_inst/Latest_Update_1_sqmuxa\, Q => \Diff1_c[4]\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/fqkdsnjfpdb_0_0_ADD_18x18_medium_I70_un1_Y\ : 
        OR3
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N297\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ADD_18x18_medium_I62_un1_Y_0\, 
        C => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N311\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ADD_18x18_medium_I70_un1_Y\);
    
    \SYSCLK_pad/U0/U1\ : CLKSRC
      port map(A => \SYSCLK_pad/U0/NET1\, Y => SYSCLK_c);
    
    
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/un1_frcskdnwvmx_3_0\ : 
        OR3B
      port map(A => INIT_DONE, B => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/N_243\, 
        C => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/frcskdnwvmx_0[0]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/un1_frcskdnwvmx_3\);
    
    
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/frcskdnwvmx[3]\ : 
        DFN1C0
      port map(D => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/frcskdnwvmx_ns_i[8]_net_1\, 
        CLK => SYSCLK_c, CLR => SYSRSTn_c, Q => 
        \AB_CM_inst/TR_EV_RD_net\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/fqkdsnjfpdb_0_0_ADD_18x18_medium_I42_Y\ : 
        NOR2A
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N293\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N291\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N309\);
    
    
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc_12_d_d_d[0]\ : 
        MX2
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_608\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ftbkrvpxdbp[0]_net_1\, 
        S => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/rdgwgtpkbgc_0[2]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc_12_d_d_d[0]_net_1\);
    
    
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/brxxctcvrmh_qgnzcpmbksd_7_0_iv[1]\ : 
        AO1B
      port map(A => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/N_230_i_0\, 
        B => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/I_32_0\, 
        C => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/qgnzcpmbksd_7_0_iv_0[1]\, 
        Y => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/qgnzcpmbksd_7[1]\);
    
    
        \COMP_SM_inst/Subtract_inst/sumAux_0_0_SUB_12x12_medium_area_I64_un1_Y\ : 
        OA1
      port map(A => \COMP_SM_inst/Subtract_inst/I61_un1_Y\, B => 
        \COMP_SM_inst/Subtract_inst/N206\, C => 
        \COMP_SM_inst/Subtract_inst/N149\, Y => 
        \COMP_SM_inst/Subtract_inst/I64_un1_Y\);
    
    
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/frcskdnwvmx_ns_i_a3_0[4]\ : 
        NOR3B
      port map(A => \AB_CM_inst/TR_RAM_DO_B_net_net_1_0\, B => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/N_233\, 
        C => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/frcskdnwvmx_0[8]_net_1\, 
        Y => 
        \AB_CM_inst/AB_CM_smtr_wrapper_inst/U0/u_ccfdxrhchsz/N_272\);
    
    \Diff4_pad[5]/U0/U0\ : IOPAD_TRI
      port map(D => \Diff4_pad[5]/U0/NET1\, E => 
        \Diff4_pad[5]/U0/NET2\, PAD => Diff4(5));
    
    \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/G_101\ : 
        NOR2A
      port map(A => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/ftbkrvpxdbp[3]_net_1\, 
        B => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/bnwcvzjbgtc[3]\, 
        Y => 
        \AB_CM_inst/AB_CM_smev_wrapper_inst/U0/u_nbnjbfrkqwq/N_260\);
    
    
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/user_control/u_ffppvfwnggt/twxmgvvpbgm_iv_0_a2_0\ : 
        OA1
      port map(A => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/mwtvnzdkmwm[4]\, 
        B => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/xbkjkgdsbfh\, 
        C => 
        \NVM_CM_inst/NVM_CM_init_wrapper_inst/U0/u_grwzcnqmqzm/user_control/u_ffppvfwnggt/un1_wxqqqsndpvg_i_0_0\, 
        Y => \NVM_CM_inst/twxmgvvpbgm_iv_0_a2_0\);
    
    \COMP_SM_inst/Diff_5[4]\ : DFN1E1C0
      port map(D => \COMP_SM_inst/Result[4]\, CLK => SYSCLK_c, 
        CLR => SYSRSTn_c, E => 
        \COMP_SM_inst/Latest_Update_5_sqmuxa\, Q => \Diff5_c[4]\);
    
    \Diff1_pad[10]/U0/U0\ : IOPAD_TRI
      port map(D => \Diff1_pad[10]/U0/NET1\, E => 
        \Diff1_pad[10]/U0/NET2\, PAD => Diff1(10));
    
    GND_power_inst1 : GND
      port map( Y => GND_power_net1);

    VCC_power_inst1 : VCC
      port map( Y => VCC_power_net1);


end DEF_ARCH; 
